/**
 * @file    C2SModuleApi.h
 
 * @brief   통합 모듈에서 지원하는 api를 정의한 파일
 
 * @author  Byeong Yeol Jeon
 * @ingroup iOS Android Cocos2d-x
 * @date    2014/04/30
 */
#ifndef _C2SMODULEAPI_H_
#define _C2SMODULEAPI_H_
/**
 * @brief 통합 모듈 api의 종류
 
 * @author Byeong Yeol Jeon
 * @ingroup iOS Android Cocos2d-x
 */
typedef enum _C2SModuleApi {
    /** 소셜 초기화 */
	C2SModuleApi_SocialInitialize,
    /** 소셜 뷰 출력 */
	C2SModuleApi_SocialShow,
    /** sns 세션 정보 */
	C2SModuleApi_SnsSession,
    /** sns 로그인 */
	C2SModuleApi_SnsLogin,
    /** sns 로그아웃 */
	C2SModuleApi_SnsLogout,
    /** sns 탈퇴 */
	C2SModuleApi_SnsUnregister,
    /** sns 유저 정보 요청 */
	C2SModuleApi_SnsUser,
    /** sns 친구 정보 요청 */
	C2SModuleApi_SnsFriends,
    /** sns 메시지 보내기 */
	C2SModuleApi_SnsMessage,
    /** sns 포스팅 */
	C2SModuleApi_SnsPost,
    /** sns 뷰 출력 */
	C2SModuleApi_SnsShow,
	/** inapp 마켓 타겟팅 */
	C2SModuleApi_InappPrepare,
    /** inapp 구매 복구 */
    C2SModuleApi_InappRestore,
    /** inapp 구매 요청 */
	C2SModuleApi_InappPurchase,
    /** inapp 구매 완료 */
	C2SModuleApi_InappFinish,
    /** inapp 상품 정보 */
	C2SModuleApi_InappDescription,
    /** push 푸쉬 등록 */
	C2SModuleApi_PushRegister,
    /** push 푸쉬 제거 */
	C2SModuleApi_PushUnregister,
    /** push 푸쉬 옵션 */
	C2SModuleApi_PushDescription,
    /** promotion 뷰 출력 */
	C2SModuleApi_PromotionShow,
	/** inapp purchase updated */
	C2SModuleApi_InappUpdated,
	/** PGS 로그인 */
	C2SModuleApi_SnsPGSLoginProc,
	/** Lebi 잔액 */
	C2SModuleApi_InappRequestBalance,
    /** 트래킹 이벤트 보내기 */
    C2SModuleApi_TrackingSendEvent,
    /** 트래킹 이벤트 SetEanble **/
    C2SModuleApi_TrackingSetEnable,
    /** promotion 웹뷰 정보 출력 **/
    C2SModuleApi_PromotionInfo,
    /** sns connect */
	C2SModuleApi_SnsConnect,
	/** interwork 시작 */
	C2SModuleApi_InterworkStart,
	/** interwork 끝 */
	C2SModuleApi_InterworkDelegate,
    /** User Acquisition 출력 */
    C2SModuleApi_PromotionAcquisition,
    /** HIVE IAP INIT **/
    C2SModuleApi_HiveIAPInitialize,
    /** HIVE IAP Info **/
    C2SModuleApi_HiveIAPInfo,
    /** HIVE IAP Show **/
    C2SModuleApi_HiveIAPShow,
    /** HIVE IAP Purchase **/
    C2SModuleApi_HiveIAPPurchase,
    /** HIVE IAP Restore **/
    C2SModuleApi_HiveIAPRestore,
    /** User Engagement Process Scheme */
    C2SModuleApi_EngagementProcessScheme,
    /** User Engagement Get Events */
    C2SModuleApi_EngagementGetEvents,
    /** User Engagement Consume Coupon */
    C2SModuleApi_EngagementConsumeCoupon,
    /** User Engagement Start */
    C2SModuleApi_EngagementStart,
    /** User Engagement End */
    C2SModuleApi_EngagementEnd,
    /** 공지 팝업 출력 */
    C2SModuleApi_SocialInfo,
    /** User Engagement Game scheme */
    C2SModuleApi_EngagementGameScheme,
    /** Promotion2.0 뷰 출력 */
    C2SModuleApi_HivePromotionShow,
    /** Promotion2.0 뷰 정보 출력 */
    C2SModuleApi_HivePromotionInfo,
    /** Promotion2.0 오퍼월 상태값 출력 */
    C2SModuleApi_HivePromotionGetOfferwallState,
    /** inapp 원격 구매 상품 정보 요청 */
    C2SModuleApi_InappCheckPromotePurchase,
    /** HIVE IAP 원격 구매 상품 정보 요청 */
    C2SModuleApi_HiveIAPCheckPromotePurchase,
	/** Promotion Companion 출력 */
	C2SModuleApi_PromotionCompanion,
	/** Promotion Youtube Playback */
	C2SModuleApi_PromotionPlayback,
	/** HivePromotion Youtube Playback */
	C2SModuleApi_HivePromotionPlayback,
	/** HIVEPromotion getBanner Info*/
	C2SModuleApi_PromotionGetBannerInfo,
	/** HIVEPromotion getBanner Info*/
	C2SModuleApi_HivePromotionGetBannerInfo,
	/** InappV4 초기화 */
	C2SModuleApi_InappV4Initialize,
    /** InappV4 아이템 정보 요청 */
	C2SModuleApi_InappV4ItemInfo,
	/** InappV4 아이템 구매 */
	C2SModuleApi_InappV4Purchase,
	/** InappV4 아이템 복구 */
	C2SModuleApi_InappV4Restore,
	/** InappV4 구매 종료 */
	C2SModuleApi_InappV4TransactionFinish,
	/** InappV4 구글/러비 결제 수단 선택 */
	C2SModuleApi_InappV4SelectMarket,
	/** InappV4 러비 잔액 조회 */
	C2SModuleApi_InappV4RequestBalance,
	/** InappV4 러비 충전 */
	C2SModuleApi_InappV4ChargeBalance,
	/** InappV4 원격 구매 상품 정보 요청 */
	C2SModuleApi_InappV4CheckPromotePurchase,
	/** InappV4 현재 타겟팅된 마켓 반환 */
	C2SModuleApi_InappV4GetSelectedMarket,
    /** Social SetGameInfo **/
    C2SModuleApi_SocialSetGameInfo,
	/** InappV4 마켓 커넥트 **/
	C2SModuleApi_InappV4MarketConnect,
    /** sns 계정 탈퇴 */
    C2SModuleApi_SnsUserDelete,
	/** InappV4 Hive Account UUID */
	C2SModuleApi_InappV4GetAccountUuid,
	/** InappV4 Show InApp Messages */
	C2SModuleApi_InappV4ShowInAppMessages,
} C2SModuleApi;

#endif
