/**
 * @file    C2SModuleArgKey.h
 
 * @brief   통합 모듈에서 사용하는 문자열의 정의
 
 * @author  Byeong Yeol Jeon
 * @ingroup iOS Android Cocos2d-x
 * @date    2014/04/30
 */
#ifndef _C2SMODULEARGKEY_H_
#define _C2SMODULEARGKEY_H_

#define C2SModuleArgKey_VID "vid"
#define C2SModuleArgKey_UID "uid"
#define C2SModuleArgKey_TRANSACTION_ID "transactionId"
#define C2SModuleArgKey_QUANTITY "quantity"
#define C2SModuleArgKey_TYPE "type"
#define C2SModuleArgKey_FORCED "forced"
#define C2SModuleArgKey_NOTICE "notice"
#define C2SModuleArgKey_EVENT "event"
#define C2SModuleArgKey_FULL_BANNER "fullBanner"
#define C2SModuleArgKey_NOTICE_ONLY "noticeOnly"
#define C2SModuleArgKey_BADGE_TYPE "badgeType"
#define C2SModuleArgKey_CUSTOM "custom"
#define C2SModuleArgKey_PUSH_ID "pushId"
#define C2SModuleArgKey_TITLE "title"
#define C2SModuleArgKey_MESSAGE "message"
#define C2SModuleArgKey_SOUND "sound"
#define C2SModuleArgKey_AFTER "after"
#define C2SModuleArgKey_DEVICE_TOKEN "deviceToken"
#define C2SModuleArgKey_REMOTEPUSH_OPEN "remotePushOpen"
#define C2SModuleArgKey_IS_AUTHORIZED "isAuthorized"
#define C2SModuleArgKey_PID "pid"
#define C2SModuleArgKey_FORMATTED_STRING "formattedString"
#define C2SModuleArgKey_LOCALIZED_DESCRIPTION "localizedDescription"
#define C2SModuleArgKey_LOCALIZED_TITLE "localizedTitle"
#define C2SModuleArgKey_LIST "list"
#define C2SModuleArgKey_RECEIPT "receipt"
#define C2SModuleArgKey_REMAIN "remain"
#define C2SModuleArgKey_LOCAL "local"
#define C2SModuleArgKey_GCM "GCM"
#define C2SModuleArgKey_TERMS "terms"
#define C2SModuleArgKey_DID "did"
#define C2SModuleArgKey_LAUNCH_OPTIONS "launchOptions"
#define C2SModuleArgKey_CHECK_AGREEMENT "checkAgreement"
#define C2SModuleArgKey_SHOW_LOG "showLog"
#define C2SModuleArgKey_AGREEMENT_COLOR_TYPE "agreementColorType"
#define C2SModuleArgKey_REDIRECT_URL "redirectURL"
#define C2SModuleArgKey_USE_STAGING "useStaging"
#define C2SModuleArgKey_INAPP "Inapp"
#define C2SModuleArgKey_SNS "Sns"
#define C2SModuleArgKey_PROMOTION "Promotion"
#define C2SModuleArgKey_Push "Push"
#define C2SModuleArgKey_PID_LIST "pidList"
#define C2SModuleArgKey_GUEST "guest"
#define C2SModuleArgKey_SESSION_TOKEN "sessionToken"
#define C2SModuleArgKey_NICKNAME "nickName"
#define C2SModuleArgKey_PROFILE_IMAGE_URL "profileImageURL"
#define C2SModuleArgKey_COUNTRY "country"
#define C2SModuleArgKey_BIRTHDAY "birthDay"
#define C2SModuleArgKey_COMMENT "comment"
#define C2SModuleArgKey_FACEBOOK_ID "facebookId"
#define C2SModuleArgKey_E_MAIL "e-mail"
#define C2SModuleArgKey_GENDER "gender"
#define C2SModuleArgKey_GAME "game"
#define C2SModuleArgKey_OTHER "other"
#define C2SModuleArgKey_MESSAGE_BLOCKED "messageBlocked"
#define C2SModuleArgKey_SERVICE "service"
#define C2SModuleArgKey_ALL "all"
#define C2SModuleArgKey_ALIAS "alias"
#define C2SModuleArgKey_IMAGE_URL "imageURL"
#define C2SModuleArgKey_IMAGE "image"
#define C2SModuleArgKey_THUMBNAIL_URL "thumbnailURL"
#define C2SModuleArgKey_USE_PUSH "usePush"
#define C2SModuleArgKey_INVITE "invite"
#define C2SModuleArgKey_VIDEO_URL "videoURL"
#define C2SModuleArgKey_APP_LINK_URL "appLinkURL"
#define C2SModuleArgKey_TEMPLATE_ID "templateId"
#define C2SModuleArgKey_JSON_META_DATA "jsonMetaData"
#define C2SModuleArgKey_FACEBOOK "facebook"
#define C2SModuleArgKey_FACEBOOK_DIALOG "inviteDialog"
#define C2SModuleArgKey_FACEBOOK_RECEIVED_INVITE "receivedInvite"
#define C2SModuleArgKey_FACEBOOK_LOGOUT "FBLogout"
#define C2SModuleArgKey_GOOGLEPLUS "googleplus"
#define C2SModuleArgKey_GOOGLEPLUS_ID "googleplusId"
#define C2SModuleArgKey_SINAWEIBO "sinaweibo"
#define C2SModuleArgKey_SINAWEIBO_ID "sinaweiboId"
#define C2SModuleArgKey_NEW_MESSAGE_COUNT "newMessageCount"
#define C2SModuleArgKey_NEW_FRIEND_COUNT "newFriendCount"
#define C2SModuleArgKey_NEW_REQUEST_COUNT "newRequestCount"
#define C2SModuleArgKey_ADDITIONAL_INFO "additionalInfo"

// added v1.0.0.3
#define C2SModuleArgKey_UID "uid"
#define C2SModuleArgKey_AUTO_LOGIN_TYPE "autoLoginType"
#define C2SModuleArgKey_SELECT "select"
#define C2SModuleArgKey_CURRENT_VID_DATA "currentVidData"
#define C2SModuleArgKey_USED_VID_DATA "usedVidData"
#define C2SModuleArgKey_CURRENT_VID "currentVid"
#define C2SModuleArgKey_USED_VID "usedVid"
#define C2SModuleArgKey_INAPP_ID "inappId"

// added v1.0.3
#define C2SModuleArgKey_AUTO_VERIFY "autoVerify"

// added v1.0.3.a
#define C2SModuleArgKey_SERVER_ID "serverId"

// added v1.0.4
#define C2SModuleArgKey_CURRENCY_CODE "currencyCode"
#define C2SModuleArgKey_AMOUNT_MICROS "amountMicros"

// added v1.0.6
#define C2SModuleArgKey_PUSH_TOKEN "pushToken"

// added v1.0.7
#define C2SModuleArgKey_PID_LIST_LEBI "pidList_lebi"

// added v1.0.8
#define C2SModuleArgKey_PGS_LOGIN_PROC "PGSLoginProc";
#define C2SModuleArgKey_PGS_IS_LOGIN "isPGSLogin";
#define C2SModuleArgKey_PGS_PLAYER_NAME "playername";
#define C2SModuleArgKey_PGS_PLAYER_ID "playerid";
#define C2SModuleArgKey_IS_DUPLICATE_LOGIN "isDuplicateLogin";

// android in promotion
#define C2SModuleArgKey_OFFERWALL "offerwall"
#define C2SModuleArgKey_ADDITIONALINFO "additionalInfo"

// android in push
#define C2SModuleArgKey_BIG_MESSAGE "bigMessage"
#define C2SModuleArgKey_TICKER "ticker"
#define C2SModuleArgKey_ICON "icon"
#define C2SModuleArgKey_ACTIVE "active"
#define C2SModuleArgKey_BROADCAST_ACTION "broadcastAction"
#define C2SModuleArgKey_BUCKET_TYPE "bucketType"
#define C2SModuleArgKey_BUCKET_SIZE "bucketSize"
#define C2SModuleArgKey_BIG_PICTURE "bigPicture"
#define C2SModuleArgKey_VIBRATE "vibrate"
#define C2SModuleArgKey_OPERATION_GCM "operationGCM"
#define C2SModuleArgKey_OPERATION_LOCAL "operationLocal"

// android in inapp
#define C2SModuleArgKey_MARKET_TARGET "marketTarget"
#define C2SModuleArgKey_AMAZON "amazon"
#define C2SModuleArgKey_GOOGLEPLAY "googleplay"
#define C2SModuleArgKey_KDDI "kddi"
#define C2SModuleArgKey_LEBI "lebi"
#define C2SModuleArgKey_MBIZ "mbiz"
#define C2SModuleArgKey_MM "mm"
#define C2SModuleArgKey_OLLEHMARKET "ollehmarket"
#define C2SModuleArgKey_OZSTORE "ozstore"
#define C2SModuleArgKey_SAMSUNGAPPS "samsungapps"
#define C2SModuleArgKey_THIRDPARTYBILLING "thirdpartybilling"
#define C2SModuleArgKey_TSTORE "tstore"
#define C2SModuleArgKey_GOOGLEPLAY_LEBI "googleplay_lebi"

//added v1.5.0
#define C2SModuleArgKey_TRACKING "Tracking"
#define C2SModuleArgKey_REVIEW "review"
#define C2SModuleArgKey_CUSTOMWEBVIEW "customWebview"
#define C2SModuleArgKey_VIEW "view"
#define C2SModuleArgKey_NOTICEONLY "noticeOnly"
#define C2SModuleArgKey_MAIN "main"
#define C2SModuleArgKey_BADGE "badge"
#define C2SModuleArgKey_VIEWID "viewId"
#define C2SModuleArgKey_BADGETYPE "badgeType"
#define C2SModuleArgKey_NEW "new"
#define C2SModuleArgKey_NONE "none"
#define C2SModuleArgKey_DATA "data"
#define C2SModuleArgKey_MORE_GAMES "moreGames"

//added v 1.6.0 bugfix_TrackingFinishBug
#define C2SModuleArgKey_IsPurchaseSuccess "isPurchaseSuccess"

//added v1.7.0
#define C2SModuleArgKey_GETINVITATIONS "getInvitations"
#define C2SModuleArgKey_USE_SANDBOX "useSandbox"
#define C2SModuleArgKey_USE_DEVELOP "useDevelop"
#define C2SModuleArgKey_APPID "appId"


//added v1.8.0
#define C2SModuleArgKey_MESSAGE_COUNT "messageCount"
#define C2SModuleArgKey_USE_NOTICE "useNotice"
#define C2SModuleArgKey_USE_NIGHT "useNight"


//added v1.9.0
#define C2SModuleArgKey_ACQUISITION "Acquisition"
#define C2SModuleArgKey_GAMEWORLD "gameWorld"
#define C2SModuleArgKey_GAMELANGUAGE "gameLanguage"
#define C2SModuleArgKey_INVITECOMMONLINK "inviteCommonLink"
#define C2SModuleArgKey_INVITEHIVEMSGLINK "inviteHivemsgLink"
#define C2SModuleArgKey_INVITEFACEBOOKLINK "inviteFacebookLink"
#define C2SModuleArgKey_QRCODE "qrcode"
#define C2SModuleArgKey_EACHCAMPAIGNS "eachCampaigns"
#define C2SModuleArgKey_STAGECAMPAIGNS "stageCampaigns"
#define C2SModuleArgKey_LINKSHARE "linkShare"
#define C2SModuleArgKey_QRCODESAVE "qrcodeSave"
#define C2SModuleArgKey_QRCODESHARE "qrcodeShare"
#define C2SModuleArgKey_URL "url"
#define C2SModuleArgKey_LINKSHARE "linkShare"
#define C2SModuleArgKey_LINKSHAREURL "linkShareURL"

// added v1.10.0
#define C2SModuleArgKey_SHOWNOTICE "showNotice"
#define C2SModuleArgKey_SHOWAGREEMENT "showAgreement"
#define C2SModuleArgKey_GETNOTICE "notice"
#define C2SModuleArgKey_SHOW "show"
#define C2SModuleArgKey_DATA "data"

// User Engagement
#define C2SModuleArgKey_EG_PROCESSSCHEME "scheme"
#define C2SModuleArgKey_EG_PROCESSIMMEDIATELY "immediately"
#define C2SModuleArgKey_EG_COUPONPLATFORM "platform"
#define C2SModuleArgKey_EG_COUPONCODE "couponId"
#define C2SModuleArgKey_EG_COUPONLANGUAGE "language"
#define C2SModuleArgKey_EG_COUPONADDITIONALINFO "additionalInfo"
#define C2SModuleArgKey_EG_COUPON_RESULTCODE "code"
#define C2SModuleArgKey_EG_COUPON_RESULTMESSAGE "message"

// added v1.10.1
#define C2SModuleArgKey_ISFACEBOOK "isFacebook"
#define C2SModuleArgKey_ISHIVE "isHive"
#define C2SModuleArgKey_ISGAME "isGame"
#define C2SModuleArgKey_ISCONTACT "isContact"
#define C2SModuleArgKey_CUSTOMSELECT "customSelect"
#define C2SModuleArgKey_SELECTVID "selectVid"

// added v1.10.2b
#define C2SModuleArgKey_FRIENDSLIST "friendsList"
#define C2SModuleArgKey_APPSCOPEDID "appScopedId"

// added v1.11.3
#define C2SModuleArgKey_FBUSERNAME "fbUserName"
#define C2SModuleArgKey_FBPROFILEIMAGEURL "fbProfileImageURL"

// added v1.12.0 - Promotion 2.0 (HivePromotion)
#define C2SModuleArgKey_HIVEPROMOTION "HivePromotion"
#define C2SModuleArgKey_CUSTOM_VIEW "customView"
#define C2SModuleArgKey_CUSTOM_BOARD "customBoard"
#define C2SModuleArgKey_SPOT "spot"
#define C2SModuleArgKey_DIRECT "direct"

#define C2SModuleArgKey_CONTENT_KEY "contentKey"
#define C2SModuleArgKey_NEWS "news"
#define C2SModuleArgKey_BANNER "banner"
#define C2SModuleArgKey_STATE "state"
#define C2SModuleArgKey_OPEN "open"
#define C2SModuleArgKey_CLOSE "close"
#define C2SModuleArgKey_EXIT "exit"
#define C2SModuleArgKey_OFFERWALLSTATE "offerwallState"

// added v1.13.0 - timeOut
#define C2SModuleArgKey_TIMEOUTSECONDS "timeoutSeconds"

// added v1.15.0 - push Operation
#define C2SModuleArgKey_OPERATION_REMOTE "operationRemote"

// added v1.16.0 - ReviewEx
#define C2SModuleArgKey_REVIEWEX "reviewEx"

// added v1.17.0 - custom Permission Data
#define C2SModuleArgKey_PERMISSION "permission"
#define C2SModuleArgKey_ENGAGEMENTQUERY "engagementQuery"

// added v1.17.2 - add initialize key, SendData
#define C2SModuleArgKey_SHOWHIVEPERMISSIONVIEW "showHivePermissionView"
#define C2SModuleArgKey_FUNNELSLOGS "funnelsLogs"
#define C2SModuleArgKey_FUNNELSID "funnelsId"
#define C2SModuleArgKey_OPTIONTAG "optionTag"

// added v1.18.1 - add fullBanner_regacy
#define C2SModuleArgKey_FULL_BANNER_LEGACY "fullBannerLegacy"

// added v1.18.3 - add goBackScheme Callback
#define C2SModuleArgKey_GO_BACK "goback"

// added v1.18.3 - add campaignType, bannerType
#define C2SModuleArgKey_CAMPAIGN_TYPE "campaignType"
#define C2SModuleArgKey_BANNER_TYPE "bannerType"

// added v1.19.1 - News default menu
#define C2SModuleArgKey_MENU "menu"

// added v1.19.1 - add useImageBanner
#define C2SModuleArgKey_USE_IMAGEBANNER "useImageBanner"

// added 1.19.2
#define C2SModuleArgKey_ANALYTICS_LOG "analyticsLog"
#define C2SModuleArgKey_ANALYTICS_LOG_DATA "analyticsLogData"
#define C2SModuleArgKey_ANALYTICS_SEND_LIMIT "analyticsSendLimit"
#define C2SModuleArgKey_ANALYTICS_QUEUE_LIMIT "analyticsQueueLimit"
#define C2SModuleArgKey_ANALYTICS_SEND_CYCLE_SECOND "analyticsSendCycleSecond"

// added 1.19.3
#define C2SModuleArgKey_UPDATE_HIVE_USER_REPAYMENT "updateHiveUserRepayment"

// added 1.19.4
#define C2SModuleArgKey_INAPP_V4_MARKET_OPPO_APPMARKET "oppo_appmarket"
#define C2SModuleArgKey_INAPP_V4_MARKET_VIVO_APPSTORE "vivo_appstore"
#define C2SModuleArgKey_INAPP_V4_MARKET_TENCENT_APPSTORE "tencent_appstore"
#define C2SModuleArgKey_INAPP_V4_MARKET_XIAOMI_APPSTORE "xiaomi_appstore"
#define C2SModuleArgKey_INAPP_V4_MARKET_HUAWAI_APPGALLERY_CHINA "huawei_appgallery_china"
#define C2SModuleArgKey_INAPP_V4_MARKET_FACEBOOK_CLOUD_GAME "facebook_cloud_game"
// added 1.19.4 (KS)
#define C2SModuleArgKey_EMERGENCY_MODE "emergencyMode"

// added 1.19.6
#define C2SModuleArgKey_ACQUISITION_SENDER_INFO "senderInfo"
#define C2SModuleArgKey_ACQUISITION_SENDER_VID "senderVid"
#define C2SModuleArgKey_SOCIAL_INITIALIZE_HIVE_ORIENTATION "hiveOrientation"
#define C2SModuleArgKey_SOCIAL_INITIALIZE_HIVE_ORIENTATION_ALL "all"
#define C2SModuleArgKey_SOCIAL_INITIALIZE_HIVE_ORIENTATION_PORTRAIT "portrait"
#define C2SModuleArgKey_SOCIAL_INITIALIZE_HIVE_ORIENTATION_LANDSCAPE "landscape"

// added 1.19.8
#define C2SModuleArgKey_SNS_FACEBOOK_PERMISSIONS "facebookPermissions"

// added 1.19.9
#define C2SModuleArgKey_ON_GAME_WINDOW "onGameWindow"

// added v1.19.5.2 - userExit
#define C2SModuleArgKey_USEREXIT "userExit"

// added v1.21.1.0
#define C2SModuleArgKey_PUSH_GROUP_ID "groupId"

// added v1.21.1.1
#define C2SModuleArgKey_INAPP_V4_CATEGORY_ID "categoryId"

#endif
