#ifndef  _APP_DELEGATE_H_
#define  _APP_DELEGATE_H_

#include "cocos2d.h"

/**
@brief    The cocos2d Application.

Private inheritance here hides part of interface from Director.
*/
class  AppDelegate : private cocos2d::Application
{
public:
    AppDelegate();
    virtual ~AppDelegate();

    virtual void initGLContextAttrs();

    /**
    @brief    Implement Director and Scene init code here.
    @return true    Initialize success, app continue.
    @return false   Initialize failed, app terminate.
    */
    virtual bool applicationDidFinishLaunching();

    /**
    @brief  Called when the application moves to the background
    @param  the pointer of the application
    */
    virtual void applicationDidEnterBackground();

    /**
    @brief  Called when the application reenters the foreground
    @param  the pointer of the application
    */
    virtual void applicationWillEnterForeground();
    
    virtual void applicationScreenSizeChanged(int newWidth, int newHeight);

    static void changeResolutionForSdkV1();

    static int sampleStateWithSDK;  // 0 : SDK v4, 1 : SDK v1, 2 : C2S
    static int sampleSdkV1WidthSettingValue;
    static int sampleSdkV1HeightSettingValue;
    static int sampleC2SWidthSettingValue;
    static int sampleC2SHeightSettingValue;
};

#endif // _APP_DELEGATE_H_

