//
//  ConfigurationView.hpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 27..
//
//

#ifndef ConfigurationView_hpp
#define ConfigurationView_hpp

#include "BaseView.hpp"

static const char* keyAppId = "sample.appId";
static const char* keyZone = "sample.zone";
static const char* keyLanguage = "sample.language";
static const char* keyServerId = "sample.serverId";
static const char* keyUseLog   = "sample.useLog";
static const char* keyUseRemoteLog = "sample.useRemoteLog";
static const char* keyUseRemoteDetailLog = "sample.useRemoteDetailLog";
static const char* keyRemoteLogId = "sample.remoteLogId";
static const char* keyCoppaAgeGateU13 = "sample.coppaAgeGateU13";
static const char* keyUseHercules = "sample.useHercules";
static const char* keyHiveTheme = "sample.hiveTheme";
static const char* keyHiveOrientation = "sample.hiveOrientation";
static const char* keyHiveMetaData = "sample.metaData";
class Configuration : public BaseView
{
public:
    CREATE_FUNC(Configuration);
    
    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
private:
    enum : int
    {
        LABEL_HIVE_SDK_VERSION,
        LABEL_SDK_VERSION,
        LABEL_IDFV,
        BUTTON_COPY_IDFV,
        LABEL_IDFA,
        BUTTON_COPY_IDFA,
        LIST_APP_ID,
        EDITBOX_APP_ID,
        EDITBOX_HIVE_CERTIFICATION_KEY,
        TOGGLE_BUTTON_ZONE,
        TOGGLE_BUTTON_THEME,
        TOGGLE_BUTTON_ORIENTATION,
        LIST_GAME_LANGUAGE,
        LIST_GAME_SERVER_ID,
        EDITBOX_GAME_SERVER_ID,
        LABEL_MARKET,
        BUTTON_GET_HIVE_COUNTRY,
        BUTTON_GET_HIVE_TIMEZONE,
        EDITBOX_CHANNEL,
        BUTTON_GET_CHANNEL,
        TOGGLE_BUTTON_USE_LOG,
        TOGGLE_BUTTON_RADIO_USE_PUSH,
        TOGGLE_BUTTON_USE_COPPA_AGE_GATE_U13,
        TOGGLE_BUTTON_USE_HERCULES,
        TOGGLE_BUTTON_IS_ON_HIVE,
        BUTTON_SET_HIVEPERMISSION_VIEW_ON,
        LIST_HIVE_LANGUAGE,
        BUTTON_GET_PERMISSION_VIEW_DATA,
        EDITBOX_GET_METADATAKEY,
        TOGGLE_BUTTON_RADIO_GET_METADATA_NETWORK,
        BUTTON_GET_METADATA,
        BUTTON_RESET,
        BUTTON_OK,
        BUTTON_SDK_V1,
        BUTTON_SDK_V4,
        BUTTON_SDK_C2S,
        BUTTON_SDK_V1_BETA,
        TOGGLE_BUTTON_LOG_TYPE,
        EDITBOX_HIVE_COMMUNITY_URL,
    };
    
    void reset();
    void apply();
    const char* getIDFV();
    const char* getIDFA();
    void copyIDFV();
    void copyIDFA();
    
    void startv4();
    void startv1();
    void startc2s();
    void startv1beta();
    
};

#endif /* ConfigurationView_hpp */
