//
//  ConfigurationAPIKey.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by daunjoung on 2021/04/13.
//

#include "ConfigurationAPIKey.hpp"

static std::string SAMPLEKEY_GoogleServerClientID         = "331526026701-42uadtkeght91f7saspdg92gtdill6mv.apps.googleusercontent.com";

#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
static std::string SAMPLEKEY_WeChatSecretKey             = "b5a73b0ee67d546bf876851944eda308";
static std::string SAMPLEKEY_WeChatPaymentKey            = "auILMZisSYHnEb4ISD58QYm7uETdVX6d";

std::string SAMPLEKEY_AdjustKey                     = "8szd9kddtt6o";
std::string SAMPLEKEY_AdjustSecretID             = "1";
std::string SAMPLEKEY_AdjustInfo1                 = "2071917595";
std::string SAMPLEKEY_AdjustInfo2                 = "254356864";
std::string SAMPLEKEY_AdjustInfo3                 = "427896519";
std::string SAMPLEKEY_AdjustInfo4                 = "820983601";

#else
static std::string SAMPLEKEY_WeChatSecretKey             = "26dcee99df49b6da27bc0fa160d15219";
static std::string SAMPLEKEY_WeChatPaymentKey            = "auILMZisSYHnEb4ISD58QYm7uETdVX6d";

std::string SAMPLEKEY_AdjustKey                     = "f02nseiur2m8";
std::string SAMPLEKEY_AdjustSecretID             = "1";
std::string SAMPLEKEY_AdjustInfo1                 = "1263786494";
std::string SAMPLEKEY_AdjustInfo2                 = "303424327";
std::string SAMPLEKEY_AdjustInfo3                 = "1829017077";
std::string SAMPLEKEY_AdjustInfo4                 = "1052886214";
#endif


std::string SAMPLEKEY_SingularKey                 = "9b7ff73a0fc13c6c9397a9881dba2673";
std::string SAMPLEKEY_AppsFlyerKey                 = "G6yEQjHw4CrEN8sEzF9onU";

bool ConfigurationAPIKey::init()
{
    
    if(!BaseView::init())
        return false;
    
    showSubTitle("Google");
    addEditBox_Numeric("serverClientID : ", SAMPLEKEY_GoogleServerClientID.c_str(), "", EDITBOX_GOOGLE_SERVERCLIENTID);
    
    showSubTitle("WeChat");
    addEditBox_Numeric("secretKey : ", SAMPLEKEY_WeChatSecretKey.c_str(), "", EDITBOX_WECHAT_SECRETKEY);
    addEditBox_Numeric("paymentKey : ", SAMPLEKEY_WeChatPaymentKey.c_str(), "", EDITBOX_WECHAT_PAYMENTKEY);
    
    showSubTitle("Adjust");
    addEditBox_Numeric("key : ", SAMPLEKEY_AdjustKey.c_str(), "", EDITBOX_ADJUST_KEY);
    addEditBox_Numeric("secretId : ", SAMPLEKEY_AdjustSecretID.c_str(), "", EDITBOX_ADJUST_SECRETID);
    addEditBox_Numeric("info1 : ", SAMPLEKEY_AdjustInfo1.c_str(), "", EDITBOX_ADJUST_INFO1);
    addEditBox_Numeric("info2 : ", SAMPLEKEY_AdjustInfo2.c_str(), "", EDITBOX_ADJUST_INFO2);
    addEditBox_Numeric("info3 : ", SAMPLEKEY_AdjustInfo3.c_str(), "", EDITBOX_ADJUST_INFO3);
    addEditBox_Numeric("info4 : ", SAMPLEKEY_AdjustInfo4.c_str(), "", EDITBOX_ADJUST_INFO4);
    
    showSubTitle("Singular");
    addEditBox_Numeric("key : ", SAMPLEKEY_SingularKey.c_str(), "", EDITBOX_SINGULAR_KEY);
    
    showSubTitle("AppsFlyer");
    addEditBox_Numeric("key : ", SAMPLEKEY_AppsFlyerKey.c_str(), "", EDITBOX_APPSFLYER_KEY);

    
    addButton("RESET DATA - 초기 값으로 되돌림", ConfigurationAPIKey::BUTTON_RESET);
    addButton("Clear Data - 모두 빈 값으로 설정", ConfigurationAPIKey::BUTTON_CLEAR);
    addButton("OK", {screenSize.width, DEFAULT_CONTENT_HEIGHT}, ConfigurationAPIKey::BUTTON_OK);
    addButton("API 키 저장하지 않고 페이지 이동하기", ConfigurationAPIKey::BUTTON_SKIP);
    
    return true;
}

void ConfigurationAPIKey::apply()
{
//    std::string appId = getEditboxValue(TEST_EDITBOX);    //< - 이런식으로 가져와서 사용..
    
    std::string googleServerClientID = getEditboxValue(EDITBOX_GOOGLE_SERVERCLIENTID);
    std::string wechatSecretKey = getEditboxValue(EDITBOX_WECHAT_SECRETKEY);
    std::string wechatPaymentKey = getEditboxValue(EDITBOX_WECHAT_PAYMENTKEY);
    std::string adjustKey = getEditboxValue(EDITBOX_ADJUST_KEY);
    std::string adjustSecretID = getEditboxValue(EDITBOX_ADJUST_SECRETID);
    std::string adjustInfo1 = getEditboxValue(EDITBOX_ADJUST_INFO1);
    std::string adjustInfo2 = getEditboxValue(EDITBOX_ADJUST_INFO2);
    std::string adjustInfo3 = getEditboxValue(EDITBOX_ADJUST_INFO3);
    std::string adjustInfo4 = getEditboxValue(EDITBOX_ADJUST_INFO4);
    std::string singularKey = getEditboxValue(EDITBOX_SINGULAR_KEY);
    std::string appsFlyerKey = getEditboxValue(EDITBOX_APPSFLYER_KEY);
    
    hive::Configuration::setConfigurations(hive::HiveConfigType::googleServerClientId, googleServerClientID);
    hive::Configuration::setConfigurations(hive::HiveConfigType::wechatSecret, wechatSecretKey);
    hive::Configuration::setConfigurations(hive::HiveConfigType::wechatPaymentKey, wechatPaymentKey);
    hive::Configuration::setConfigurations(hive::HiveConfigType::adjustKey, adjustKey);
    hive::Configuration::setConfigurations(hive::HiveConfigType::adjustSecretId, adjustSecretID);
    hive::Configuration::setConfigurations(hive::HiveConfigType::adjustInfo1, adjustInfo1);
    hive::Configuration::setConfigurations(hive::HiveConfigType::adjustInfo2, adjustInfo2);
    hive::Configuration::setConfigurations(hive::HiveConfigType::adjustInfo3, adjustInfo3);
    hive::Configuration::setConfigurations(hive::HiveConfigType::adjustInfo4, adjustInfo4);
    hive::Configuration::setConfigurations(hive::HiveConfigType::singularKey, singularKey);
    hive::Configuration::setConfigurations(hive::HiveConfigType::appsflyerKey, appsFlyerKey);
}



void ConfigurationAPIKey::onButtonEvent(int buttonTag)
{
    switch (buttonTag) {
        case ConfigurationAPIKey::BUTTON_RESET:
        {
            setEditboxValue(EDITBOX_GOOGLE_SERVERCLIENTID, SAMPLEKEY_GoogleServerClientID.c_str());
            setEditboxValue(EDITBOX_WECHAT_SECRETKEY, SAMPLEKEY_WeChatSecretKey.c_str());
            setEditboxValue(EDITBOX_WECHAT_PAYMENTKEY, SAMPLEKEY_WeChatPaymentKey.c_str());
            setEditboxValue(EDITBOX_ADJUST_KEY, SAMPLEKEY_AdjustKey.c_str());
            setEditboxValue(EDITBOX_ADJUST_SECRETID, SAMPLEKEY_AdjustSecretID.c_str());
            setEditboxValue(EDITBOX_ADJUST_INFO1, SAMPLEKEY_AdjustInfo1.c_str());
            setEditboxValue(EDITBOX_ADJUST_INFO2, SAMPLEKEY_AdjustInfo2.c_str());
            setEditboxValue(EDITBOX_ADJUST_INFO3, SAMPLEKEY_AdjustInfo3.c_str());
            setEditboxValue(EDITBOX_ADJUST_INFO4, SAMPLEKEY_AdjustInfo4.c_str());
            setEditboxValue(EDITBOX_SINGULAR_KEY, SAMPLEKEY_SingularKey.c_str());
            setEditboxValue(EDITBOX_APPSFLYER_KEY, SAMPLEKEY_AppsFlyerKey.c_str());
            break;
        }
        case ConfigurationAPIKey::BUTTON_CLEAR:
        {
            setEditboxValue(EDITBOX_GOOGLE_SERVERCLIENTID, "");
            setEditboxValue(EDITBOX_WECHAT_SECRETKEY, "");
            setEditboxValue(EDITBOX_WECHAT_PAYMENTKEY, "");
            setEditboxValue(EDITBOX_ADJUST_KEY, "");
            setEditboxValue(EDITBOX_ADJUST_SECRETID, "");
            setEditboxValue(EDITBOX_ADJUST_INFO1, "");
            setEditboxValue(EDITBOX_ADJUST_INFO2, "");
            setEditboxValue(EDITBOX_ADJUST_INFO3, "");
            setEditboxValue(EDITBOX_ADJUST_INFO4, "");
            setEditboxValue(EDITBOX_SINGULAR_KEY, "");
            setEditboxValue(EDITBOX_APPSFLYER_KEY, "");
            break;
        }
        case ConfigurationAPIKey::BUTTON_OK:
        {
            apply();
            popView();
            break;
        }
        case ConfigurationAPIKey::BUTTON_SKIP:
        {
            popView();
            break;
        }
    }
}

