//
//  IAPTest.hpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 28..
//
//

#ifndef IAPTest_hpp
#define IAPTest_hpp

#include "BaseView.hpp"
#include "Postbox.hpp"

class IAPTest : public BaseView
{
public:
    CREATE_FUNC(IAPTest);
    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
    
    enum : int
    {
        LABEL_SERVER,
        LABEL_GEM,
        LABEL_GOLD,
        EDITBOX_LOCATION_CODE,
        BUTTON_MARKET_SELECT,
        BUTTON_INITIALIZE,
        BUTTON_GET_SHOP_INFO,
        COMBO_PID,
        BUTTON_PURCHASE,
        BUTTON_RESTORE,
        BUTTON_RESTORE_RECEIPT,
        BUTTON_BALANCE_INFO,
        BUTTON_BALANCE_CHARGE,
        BUTTON_GET_BADGE_INFO,
        BUTTON_CHECK_PROMOTE_PURHCASE,
        COMBOBOX_POSTBOX,
        BUTTON_SHOW_POSTBOX,
        EDITBOX_CHARACTER_KEY,
    };
    
    // Apple, Google, OneStore 와 같은 마켓에 등록한 마켓 정보 통지 리스너 - IAP::initialize()
    void onIAPMarketInfoCB(hive::ResultAPI result, std::vector<hive::IAPType> marketId);
    
    // Hive IAP 백오피스에서 구성한 상점 정보 통지 리스너 - IAP::getShopInfo()
    void onIAPShopInfoCB(hive::ResultAPI result, hive::IAPShop iapShop, int balance);
    
    // 결제 시도 결과 통지 리스너 - IAP::purchase()
    void onIAPPurchaseCB(hive::ResultAPI result);
    
    // HIVE IAP 상품에 대한 미지급된 아이템 지급을 요청 결과 통지 리스너 - IAP::restore()
    void onIAPRestoreCB(hive::ResultAPI result);
    
    // 러비 잔액 확인 결과 통지 리스너 - IAP::balance()
    void onIAPBalanceInfoCB(hive::ResultAPI result, int balance);
};

#endif /* IAPTest_hpp */
