/**
 * IAPV4SubscriptionProductInfoView.hpp
 * HIVE_SDK_Cocos_Sample
 * 
 * Created by disker on 2020. 05. 27.
 * Copyright © 2020년 GCP. All rights reserved.
*/

#ifndef IAPV4SubscriptionProductInfoView_h
#define IAPV4SubscriptionProductInfoView_h

#include "BaseView.hpp"
#include "UICombobox.hpp"
#include "Postbox.hpp"
#include "PostBoxView.hpp"
#include <functional>
#include <vector>
#include <string>

class IAPV4SubscriptionProductInfoView : public BaseView
{
public:
    virtual bool init() override;
    virtual void onButtonEvent(int buttonTag) override;

    static IAPV4SubscriptionProductInfoView *create(std::vector<std::string> const pidList, std::string const &iapPayload);

private:
    std::vector<std::string> pidList;

    std::vector<std::string> pidList_group_1;
    std::vector<std::string> pidList_group_2;

    std::string group_1_item;
    std::string group_2_item;

    std::string strIapPayload;

    bool initialize(std::vector<std::string> const pidList, std::string const &iapPayload);
    void initGroupPidList();
    int getIndexFromVector(std::vector<std::string> v, std::string data);
    void receiptVerify(hive::IAPV4Receipt receipt, Postbox::ItemType itemType, std::function<void()> callback);
};

#endif /* IAPV4SubscriptionProductInfoView_h */