//
//  PostBoxView.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by paikjongman on 2018. 1. 15..
//  Copyright © 2018년 GCP. All rights reserved.
//

#ifndef PostBoxView_hpp
#define PostBoxView_hpp

#include "BaseView.hpp"
#include "Postbox.hpp"

void ShowPostboxErrorMessage(Postbox::Error error);

class PostBoxView : public BaseView {
public:
    CREATE_FUNC(PostBoxView);
    virtual bool init()override;
    virtual void onButtonEvent(int buttonTag)override;
    enum : int
    {
        COMBOBOX_POSTBOX,
        BUTTON_GET_POST,
        BUTTON_GET_ALL_POSTS,
        BUTTON_REFRESH_POSTS,
        EDITBOX_CHARACTER_KEY,
        COMBOBOX_SUBSCRIPTIONBOX,
        BUTTON_SHOW_SUBSCRIPTIONINFO,
    };
    
private:
    void loadGameData();
    void updatePosts();
    Postbox::PostList postboxlists;
    std::vector<std::string> postlist;
    
    Postbox::SubscriptionList subscriptionboxlists;
    std::vector<std::string> subscriptionlist;
    
    static std::vector<const char*> toCharlist(std::vector<std::string>& strlist);
};

#endif /* PostBoxView_hpp */
