//
//  TopMenuView.cpp
//  hivesdk
//
//  Created by paikjongman on 2017. 2. 27..
//
//

#include "TopMenu.hpp"

#include "Configuration.hpp"
#include "AuthTest.hpp"
#include "AuthV4Test.hpp"
#include "AuthV4HelperTest.hpp"
#include "ProviderTest.hpp"
#include "SocialV4Test.hpp"
#include "SocialHiveTest.hpp"
#include "SocialFacebookTest.hpp"
#include "PromotionTest.hpp"
#include "PushTest.hpp"
#include "IAPTest.hpp"
#include "IAPV4Test.hpp"
#include "AnalyticsTest.hpp"
#include "ConfigurationAPIKey.hpp"
#include "DataStoreTest.hpp"

#include <map>

using namespace::std;

#define MAKE_VIEW_CREATE(x) [](BaseView* view){ view->pushView(x::create()); }

std::function<void(BaseView* view)> TopMenuChange[] = {
    MAKE_VIEW_CREATE(ConfigurationAPIKey),
    MAKE_VIEW_CREATE(Configuration),
    MAKE_VIEW_CREATE(AuthTest),
    MAKE_VIEW_CREATE(AuthV4Test),
    MAKE_VIEW_CREATE(AuthV4HelperTest),
    MAKE_VIEW_CREATE(ProviderTest),
    MAKE_VIEW_CREATE(SocialV4Test),
    MAKE_VIEW_CREATE(SocialHiveTest),
    MAKE_VIEW_CREATE(SocialFacebookTest),
    MAKE_VIEW_CREATE(PromotionTest),
    MAKE_VIEW_CREATE(PushTest),
    MAKE_VIEW_CREATE(IAPTest),
    MAKE_VIEW_CREATE(IAPV4Test),
    MAKE_VIEW_CREATE(AnalyticsTest),
    MAKE_VIEW_CREATE(DataStoreTest)
};
bool TopMenu::init()
{
    if(!BaseView::init())
        return false;
    
    const char* buttons[]={
        "ConfigurationAPIKey",
        "Configuration",
        "Auth",
        "AuthV4",
        "AuthV4Helper",
        "ProviderTest",
        "SocialV4",
        "Social Hive",
        "Social Facebook",
        "Promotion",
        "Push",
        "IAP",
        "IAPV4",
        "Analytics",
        "DataStore"
    };
    
    for(int i=TopMenu::START_INDEX;i<TopMenu::MAX;++i)
    {
        addButton(buttons[i], {screenSize.width, DEFAULT_CONTENT_HEIGHT}, i);
    }
    
    scheduleUpdate();
    
    return true;
}
void TopMenu::update(float dt)
{
    BaseView::update(dt);
    
    static bool firstRun = true;
    if(firstRun) {
        firstRun = false;
        TopMenuChange[BUTTON_CONFIGURATION_API_KEY](this);
    }
}

void TopMenu::onButtonEvent(int buttonTag)
{
    TopMenuChange[buttonTag](this);
}
