//
//  C2SMainScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/09/27.
//

#include "C2SMainScene.h"
#include "C2SModuleListScene.hpp"

#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
#include "JNISample.h"
#endif

USING_NS_CC;

Scene* C2SMainScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = C2SMainScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool C2SMainScene::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !LayerColor::initWithColor(Color4B::BLACK) )
    {
        return false;
    }

    // Android Module Set : Java에서 객체 초기화
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
    activeuserInit("");
    mercuryInit("");
    offerwallInit("");
    inappv4Init("");
    hivepromotionInit("");
    pushInit("");
    peppermintInit("");
#endif

    this->addChild(C2SModuleListScene::create());

    return true;
}
