//
//  DefaultParameters.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/10/20.
//

#include "DefaultParameters.hpp"
#include <picojson.h>
#include <cocos2d.h>
#include <iostream>
#include <fstream>

#define FILE_NAME "C2SCommonParametres.txt"
#define KEY_UID "uid"
#define KEY_VID "vid"
#define KEY_DID "did"
#define KEY_SESSION_KEY "sessionKey"


void CommonParameters::writeCommonParametersToFile()
{
    string fileName = cocos2d::FileUtils::getInstance()->getWritablePath() + FILE_NAME;
    ofstream file(fileName);

    picojson::object commonParamsObject;
    commonParamsObject[KEY_UID] = picojson::value(this->getUid());
    commonParamsObject[KEY_VID] = picojson::value(this->getVid());
    commonParamsObject[KEY_DID] = picojson::value(this->getDid());
    commonParamsObject[KEY_SESSION_KEY] = picojson::value(this->getSessionKey());

    picojson::value commonParamsValue = picojson::value(commonParamsObject);
    string commonParamsString = commonParamsValue.serialize();

    if (file.is_open()) {
        file << commonParamsString;
        file.close();
    }
}

void CommonParameters::readCommonParametersFromFile()
{
    string fileName = cocos2d::FileUtils::getInstance()->getWritablePath() + FILE_NAME;
    ifstream file(fileName);

    if (file.is_open()) {
        string line;
        while (file) {
            getline(file, line);
        }

        picojson::value commonParamsValue;
        picojson::parse(commonParamsValue, line);

        string _uid = commonParamsValue.get(KEY_UID).to_str();
        string _vid = commonParamsValue.get(KEY_VID).to_str();
        string _did = commonParamsValue.get(KEY_DID).to_str();
        string _sessionKey = commonParamsValue.get(KEY_SESSION_KEY).to_str();

        this->setUid(_uid);
        this->setVid(_vid);
        this->setDid(_did);
        this->setSessionKey(_sessionKey);
        
        file.close();
    }
}
