//
//  HivePromotionParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/10/15.
//

#ifndef HivePromotionParamScene_hpp
#define HivePromotionParamScene_hpp

#include <stdio.h>
#include <functional>

#include "C2SModuleAPIList.hpp"
#include "BaseView.hpp"
#include "C2SHivePromotion.h"

using namespace std;

class HivePromotionParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        COMBOBOX_VIEW_TYPE,
        TOGGLE_BUTTON_IS_FORCED,
        EDITBOX_UID,
        EDITBOX_CONTENTS,
        COMBOBOX_CUSTOM_TYPE,
        EDITBOX_CAMPAIGN_TYPE,
        EDITBOX_BANNER_TYPE,
        EDITBOX_INVITE_MESSAGE,
        COMBOBOX_INVITE_LINK,
        EDITBOX_ADDITIONAL_INFO,
    };

    CREATE_FUNC(HivePromotionParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;

    void showParameters(int tag);
private:
    C2SModuleAPIList::HivePromotionAPI api;
    vector<const char*> viewTypeList;
    vector<const char*> customTypeList;

    function<void()> setCompletionHandler;

    void showPromotionShowParam(function<void()> completionHandler);
    void showPromotionShowCustomParam(function<void()> completionHandler);
    void showShowOfferwallParam(function<void()> completionHandler);
    void showShowReviewParam(function<void()> completionHandler);
    void showShowExitParam(function<void()> completionHandler);
    void showGetViewInfoParam(function<void()> completionHandler);
    void showGetBadgeInfoParam(function<void()> completionHandler);
    void showPromotionGetBannerInfoParam(function<void()> completionHandler);
    void showPromotionGetAppInvitationDataParam(function<void()> completionHandler);
    void showPromotionShowUAShareParam(function<void()> completionHandler);
    void showSetAdditionalInfoParam(function<void()> completionHandler);

    CSPromotionViewType stringToPromotionViewType(string value);
    CSPromotionCustomType stringToPromotionCustomType(string value);
};

#endif /* HivePromotionParamScene_hpp */
