//
//  InAppV4ParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/10/18.
//

#ifndef InAppV4ParamScene_hpp
#define InAppV4ParamScene_hpp

#include <stdio.h>
#include <functional>

#include "C2SModuleAPIList.hpp"
#include "BaseView.hpp"
#include "C2SInAppV4.h"

using namespace std;

class InAppV4ParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        COMBOBOX_MARKET_PID,
        EDITBOX_ADDITIONAL_INFO,
        COMBOBOX_OLD_MARKET_PID,
        EDITBOX_UID,
        EDITBOX_MARKET_PID_LIST,
        EDITBOX_OLD_MARKET_PID,
        EDITBOX_MARKET_PURCHASE_ADDITIONAL_INFO,
    };

    CREATE_FUNC(InAppV4ParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;

    void showParameters(int tag);
private:
    C2SModuleAPIList::InAppV4API api;

    function<void()> setCompletionHandler;

    void showMarketProductInfoParam(function<void()> completionHandler);
    void showPurchaseParam(function<void()> completionHandler);
    void showPurchaseSubscriptionParam(function<void()> completionHandler);
    void showTransactionFinishParam(function<void()> completionHandler);
    void showSetUidParam(function<void()> completionHandler);
};

#endif /* InAppV4ParamScene_hpp */
