//
//  InAppV4Scene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/09/27.
//

#ifndef InAppV4Scene_hpp
#define InAppV4Scene_hpp

#include <stdio.h>
#include "BaseView.hpp"
#include "C2SInAppV4.h"

using namespace std;

class InAppV4Scene: public BaseView
{
public:
    CREATE_FUNC(InAppV4Scene);

    virtual bool init() override;

    virtual void update(float dt) override;

    virtual void onButtonEvent(int buttonTag)  override;

    void registerCallback();

private:
    static string IapV4ProductInfoToString(CS_IapV4ProductInfo productInfo);
    static string IapV4ReceiptInfoToString(CS_IapV4ReceiptInfo receiptInfo);
    static string IapV4ResultToString(CS_IapV4Result result);
    static void verifyReceipt(CS_IapV4ReceiptInfo receiptInfo);

    static string getMarketNameWithIndex(int index);
};



#endif /* InAppV4Scene_hpp */
