//
//  MercuryParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/10/26.
//

#ifndef MercuryParamScene_hpp
#define MercuryParamScene_hpp

#include <stdio.h>
#include <functional>
#include <vector>

#include "C2SModuleAPIList.hpp"
#include "BaseView.hpp"
#include "C2SMercury.h"

using namespace std;

class MercuryParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        EDITBOX_UID,
        EDITBOX_VIEW_ID,
        COMBOBOX_SHOW_TYPE,
        EDITBOX_ADDITIONAL_INFO,
        COMBOBOX_VIEW_ID,
        EDITBOX_VID,
        EDITBOX_DID,
        TOGGLE_BUTTON_IS_USING_STAGING,
        TOGGLE_BUTTON_IS_LOG,
        COMBOBOX_BADGE_TARGET,
        EDITBOX_URL_LINK,
        EDITBOX_SHARE_MESSAGE,
        COMBOBOX_CAMPAIGN_TYPE,
        COMBOBOX_BANNER_TYPE
    };

    CREATE_FUNC(MercuryParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;

    void showParameters(int tag);

    string showTypeToString(MERCURY_SHOW_TYPE value);
    MERCURY_SHOW_TYPE stringToShowType(string value);
    string badgeTargetToString(MERCURY_BADGE_TARGET value);
    MERCURY_BADGE_TARGET stringToBadgeTarget(string value);
private:

    enum PopupType: int {
        POPUP_REVIEW,
        POPUP_NATIVE_REVIEW,
        POPUP_MORE_GAMES
    };

    C2SModuleAPIList::MercuryAPI api;

    function<void()> setCompletionHandler;

    void showShowExParam(function<void()> completionHandler);
    void showShowExCustomViewIdParam(function<void()> completionHandler);
    void showGetCustomViewInfoParam(function<void()> completionHandler);
    void showGetCustomViewInfoCustomViewIdParam(function<void()> completionHandler);
    void showShowPopupParam(PopupType type, function<void()> completionHandler);
    void showSetUidParam(function<void()> completionHandler);
    void showSetIsUsingStagingParam(function<void()> completionHandler);
    void showSetLogParam(function<void()> completionHandler);
    void showGetBadgeParam(function<void()> completionHandler);
    void showGetBadgeTypeParam(function<void()> completionHandler);
    void showRequestUAInfoParam(function<void()> completionHandler);
    void showRequestUALinkShareParam(function<void()> completionHandler);
    void showGetBannerInfoParam(function<void()> completionHandler);

    vector<const char*> showTypeList;
    vector<string> showTypeStringList;

    vector<const char*> badgeTargetList;
    vector<string> badgeTargetStringList;

    vector<const char*> campaignTypeList;
    vector<string> campaignTypeStringList;

    vector<const char*> bannerTypeList;
    vector<string> bannerTypeStringList;
};

#endif /* MercuryParamScene_hpp */
