//
//  ParameterDataManager.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/09/30.
//

#ifndef ParameterDataManager_hpp
#define ParameterDataManager_hpp

#include <stdio.h>
#include "BaseView.hpp"
#include "DefaultParameters.hpp"
#include "picojson.h"

using namespace std;

class ParameterDataManager
{
public:
    static ParameterDataManager* getInstance()
    {
        if (instance == NULL) instance = new ParameterDataManager();
        return instance;
    }

    ActiveUserParameters* activeUserParams;
    PeppermintParameters* peppermintParams;
    HivePromotionParameters* hivePromotionParams;
    OfferwallParameters* offerwallParams;
    InAppV4Parameters* inAppV4Params;
    PushParameters* pushParams;
    CommonParameters* commonParams;
    MercuryParameters* mercuryParams;

    picojson::value parseStringToJsonData(string value);
    // 로그인 성공시 전달 받았던 guestUid, uid, sessionKey 초기화
    void onLogOut();

private:
    ParameterDataManager() {
        activeUserParams = new ActiveUserParameters();
        peppermintParams = new PeppermintParameters();
        hivePromotionParams = new HivePromotionParameters();
        offerwallParams = new OfferwallParameters();
        inAppV4Params = new InAppV4Parameters();
        pushParams = new PushParameters();
        commonParams = new CommonParameters();
        mercuryParams = new MercuryParameters();
    };
    ParameterDataManager(const ParameterDataManager& other);
    ~ParameterDataManager() {
        activeUserParams = NULL;
        peppermintParams = NULL;
        hivePromotionParams = NULL;
        offerwallParams = NULL;
        inAppV4Params = NULL;
        pushParams = NULL;
        commonParams = NULL;
        mercuryParams = NULL;
    };

    static ParameterDataManager* instance;
};

#endif /* ParameterDataManager_hpp */
