//
//  PeppermintParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/10/14.
//

#ifndef PeppermintParamScene_hpp
#define PeppermintParamScene_hpp

#include <stdio.h>

#include <functional>
#include "C2SModuleAPIList.hpp"
#include "BaseView.hpp"
#include "C2SHub2.h"

using namespace std;

class PeppermintParamScene: public BaseView
{
public:

    enum ButtonParam: int {
        BUTTON_OK = 0,
        EDITBOX_REQUEST_NAME,
        EDITBOX_REQUEST_NAME_FOR_SOCIAL,
        EDITBOX_PARAMS,
        EDITBOX_GUEST_UID,
        EDITBOX_CANDIDATE_UID,
        EDITBOX_APPID,
        EDITBOX_GAME_INDEX,
        TOGGLE_BUTTON_USE_TEST_SERVER,
        COMBOBOX_SERVER_STATE,
        EDITBOX_KEY,
        EDITBOX_VALUE,
        EDITBOX_RELATIVE_PATH,
        EDITBOX_CHATBOT_PARAM,
        COMBOBOX_SOCIAL_SERVICE,
        EDITBOX_AUTH_WITH_PARAM_PARAMS,
    };

    CREATE_FUNC(PeppermintParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;

    void showParameters(int tag);
    static string getImageBase64();

private:

    C2SModuleAPIList::PeppermintAPI api;
    function<void()> setCompletionHandler;

    void showAsyncRequestDeviceRegisteredParam(function<void()> completionHandler);
    void showAsyncRequestFriendsGameParam(function<void()> completionHandler);
    void showAsyncRequestFriendsOtherParam(function<void()> completionHandler);
    void showAsyncRequestFriendsReceiveListParam(function<void()> completionHandler);
    void showAsyncRequestFriendsRejectRequestParam(function<void()> completionHandler);
    void showAsyncRequestFriendsRequestParam(function<void()> completionHandler);
    void showAsyncRequestFriendsParam(function<void()> completionHandler);
    void showAsyncRequestGuestAuthParam(function<void()> completionHandler);
    void showAsyncRequestGuestCreateParam(function<void()> completionHandler);
    void showAsyncRequestGuestStatusSaveDataParam(function<void()> completionHandler);
    void showAsyncRequestMessageWriteParam(function<void()> completionHandler);
    void showAsyncRequestMessageGetInvitationsParam(function<void()> completionHandler);
    void showAsyncRequestMessageNotiCountParam(function<void()> completionHandler);
    void showAsyncRequestUploadImageWithJsonParam(function<void()> completionHandler);
    void showAsyncRequestUserHubUidParam(function<void()> completionHandler);
    void showAsyncRequestUserMeNotificationsParam(function<void()> completionHandler);
    void showAsyncRequestUserMeParam(function<void()> completionHandler);
    void showAsyncRequestUserModifyInfoParam(function<void()> completionHandler);
    void showAsyncRequestUsersParam(function<void()> completionHandler);

    void showGuestBindParam(function<void()> completionHandler);
    void showInitializeParam(function<void()> completionHandler);
    void showInitializeExParam(function<void()> completionHandler);
    void showSetOptionParam(function<void()> completionHandler);
    void showShowDialogParam(function<void()> completionHandler);
    void showShowDialogForChatbotParam(function<void()> completionHandler);
    void showAuthWithParamParam(function<void()> completionHandler);

    void showSocialRequestRequestUserProfileParam(function<void()> completionHandler);
    void showSocialRequestInviteDialogParam(function<void()> completionHandler);
    void showSocialRequestReceivedInviteParam(function<void()> completionHandler);
    void showSocialRequestRequestFriendsParam(function<void()> completionHandler);
    void showSocialRequestUserProfileImageParam(function<void()> completionHandler);
    void showSocialRequestShareAppActivityParam(function<void()> completionHandler);
    void showSocialRequestIsAuthorizedParam(function<void()> completionHandler);
    void showSocialRequestLogoutParam(function<void()> completionHandler);
    void showSocialRequestConnectParam(function<void()> completionHandler);
    void showSocialRequestSetPermissionParam(function<void()> completionHandler);

    static HiveSocialServerState stringToHiveSocialServerState(std::string value);

    vector<const char*> socialRequestServiceTypeList;
    vector<string> socialRequestServiceTypeStringList;
};


#endif /* PeppermintParamScene_hpp */
