//
//  PeppermintScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by sjyong on 2021/09/27.
//

#ifndef PeppermintScene_hpp
#define PeppermintScene_hpp

#include <stdio.h>
#include "BaseView.hpp"
#include "C2SHub2.h"
#include "picojson.h"

using namespace std;

class PeppermintScene: public BaseView
{
public:
    CREATE_FUNC(PeppermintScene);

    virtual bool init() override;

    virtual void update(float dt) override;

    virtual void onButtonEvent(int buttonTag)  override;

    void registerCallback();

private:
    static void addLogHubCallbackWithJSON(const char* jsonString, void* param);
    static void addLogResultCode(const char* api, int resultCode);
    static void addLogParamData(const char* api, const char* param);
    static picojson::value parseStringToJson(string value);
    static void hubAsyncReqeust(string requestName, string params);
};


#endif /* PeppermintScene_hpp */
