/*************************************************************
 * Push Module 
 *
 * Created by Com2uS.DEV.OPLab.MI.Hife on December 2011		// Android
 * Created by thebeast thebeast on 11. 10. 12..				// iOS
 * 
 * Copyright (c) 2011 Com2uS Corporation. All rights reserved.
 *
 * Last Update : C2S.21.0.2
 *************************************************************/

#include <stdbool.h>

#ifndef _C2SPUSH_H_
#define _C2SPUSH_H_

#ifdef __cplusplus
extern "C" {
#endif

	// deprecated
	typedef enum Push_UserSetting_ {
		DEFAULT_FALSE 	= 0x00,		//deprecated, use Push_BoolType.Push_FALSE
		DEFAULT_TRUE 	= 0x01,		//deprecated, use Push_BoolType.Push_TRUE
		USER_FALSE 		= 0x02,		//deprecated, use Push_BoolType.Push_FALSE
		USER_TRUE 		= 0x03		//deprecated, use Push_BoolType.Push_TRUE
	} Push_UserSetting;

	typedef enum Push_BoolType_ {
		Push_FALSE = 0,
		Push_TRUE = 1
	} Push_BoolType;

	typedef enum Push_CallbackType_ {
		onReceivedGCMPush		= 0x01,			//onReceivedAPNSPush(iOS)
		onReceivedLocalPush		= 0x02
	} Push_CallbackType;

	//Local Notification CallBack Function
	typedef void (*PushCallback)(Push_CallbackType callbackType, int pushID, int remainPushCallback);


    // **** **** **** **** **** 
    // Push Main API
    // **** **** **** **** **** 

	//Remote Function
	const char* CS_PushGetVersion(void);

    //Notification On/Off
    void CS_pushSetAgree(Push_BoolType notice, Push_BoolType night);
    Push_BoolType CS_pushGetAgreeNotice(void);
    Push_BoolType CS_pushGetAgreeNight(void);

	//Foreground Notification On/Off
	void CS_pushSetForeground(Push_BoolType remote, Push_BoolType local);
	Push_BoolType CS_pushGetForegroundRemote(void);
	Push_BoolType CS_pushGetForegroundLocal(void);

	//use push on/off (Android Only)
	void CS_pushSetPush(Push_BoolType isPush);
	Push_BoolType CS_pushGetPush(void);

	//Local Notification Function
	void CS_pushRegisterLocalpush(int pushID, char* title, char* msg, char* ticker, char* type, char* icon, char* sound, char* active, long after);
	void CS_pushRegisterLocalpushEx(int pushID, char* title, char* msg, char* ticker, char* type, char* icon, char* sound, char* active, long after, char* broadcastAction);
	void CS_pushRegisterLocalpushBig(int pushID, char* title, char* msg, char* bigmsg, char* ticker, char* type, char* icon, char* sound, char* active, long after, char* broadcastAction);
	void CS_pushRegisterLocalpushData(char* jsonPushData);          
	void CS_pushUnRegisterLocalpush(int pushID);

	void CS_pushUnRegisterAllLocalpush(void);						// Android Only
	void CS_pushRegisterCallbackHandler(PushCallback pushCallback);
	void CS_pushRunCallback(void* notification);                    // iOS Only
	void CS_pushUnRegisterCallbackHandler(void);					// Android Only

	//Remote Notification Function
	void CS_pushSetOperationLocalPushOnRunning(int boolean);	    // Android Only
	void CS_pushSetOperationGCMPushOnRunning(int boolean);		    // Android Only
	int CS_pushGetOperationLocalPushOnRunning(void);				// Android Only
	int CS_pushGetOperationGCMPushOnRunning(void);					// Android Only

	char* CS_pushGetRegistrationId(void);			                // Android Only

	//Request push permission clearly
	void CS_pushRequestPermission(void);


    // +++++ +++++ +++++ +++++ +++++ 
    // Deprecated (removed)
    // +++++ +++++ +++++ +++++ +++++
	// void CS_pushStartEx();
	// Push_BoolType_ CS_pushGetSound();
	// Push_BoolType_ CS_pushGetVib();
	// void CS_pushSetSound(Push_BoolType_ isSound);
	// void CS_pushSetVib(Push_BoolType_ isVib);

	// bool CS_pushSetUid(const char* uid);				// added v3.5.0
	// void CS_pushSetOperationOnRunning(int boolean); 	// Deprecated

	// API from iOS

	// void CS_hlpPushSendPromoCodeEx(void* userInfo)__attribute__ ((deprecated));
    // void CS_hlpPushRegisterToken(const char* deviceToken)__attribute__ ((deprecated));
    // int CS_hlpPushLoadOption(void)__attribute__ ((deprecated));
    // void CS_hlpPushUseTestServer(const char* serverURL,const char* confirmURL,const char* localConfirmURL)__attribute__ ((deprecated));
    // unsigned int CS_hlpPushGetVersion(void)__attribute__ ((deprecated));

    // void CS_hlpPushDefaultActionOnLaunch(void* inData)__attribute__ ((deprecated));
    // void CS_hlpPushRegisterTokenEx(void* deviceToken)__attribute__ ((deprecated));
    // void CS_hlpPushUseTestServerEx(void)__attribute__ ((deprecated));
    // void CS_pushSetUNUserNotification(void)__attribute__ ((deprecated));
	// void CS_hlpPushSendOpen(void* userInfo)__attribute__ ((deprecated));

#ifdef __cplusplus
};
#endif

#endif
