/**
 * @file    HIVE_IAP.h
 *
 * @author  cocororo
 * Copyright 2017 GAMEVIL Inc. Com2uS Corp.
 * @defgroup IAP
 * @{
 * @brief JNI 환경변수와 JavaVM을 얻을 수 있는 클래스이다.<br/>
 * 안드로이드에서만 사용된다.<br/><br/>
 */

#ifndef __HIVE_JNIHELPER_H__
#define __HIVE_JNIHELPER_H__

#include "HIVE_CPP.h"
#if !defined(HIVE_PLUGIN_PLATFORM_WIN32) && !defined(HIVE_PLUGIN_PLATFORM_MAC_OSX)
#include <jni.h>

NS_HIVE_BEGIN

class HiveJniHelper {
public:
    static jint setJavaVM(JavaVM* vm);
    static JavaVM* getJavaVM();
    static JNIEnv* getEnv();
private:
    static JNIEnv* cacheEnv(JavaVM* jvm);

    static const jint JNI_VERSION;
    static JavaVM* s_JavaVM;
};

NS_HIVE_END
#endif
#endif //__HIVE_JNIHELPER_H__
