/****************************************************************************
Copyright (c) 2015 Chukong Technologies Inc.

http://www.cocos2d-x.org

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
****************************************************************************/
package org.cocos2dx.cpp;

import android.annotation.TargetApi;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.text.TextUtils;
import android.util.Log;
import android.view.SurfaceView;
import android.widget.Toast;

import androidx.appcompat.app.AlertDialog;
import androidx.core.content.FileProvider;

import com.adjust.sdk.Adjust;
import com.appsflyer.AppsFlyerLib;
import com.com2us.module.C2SModule;
import com.com2us.module.C2SModuleSocial;
import com.com2us.module.activeuser.ActiveUser;
import com.com2us.module.hivepromotion.Promotion;
import com.com2us.module.inappv4.InAppV4;
import com.com2us.module.mercury.Mercury;
import com.com2us.module.offerwall.Offerwall;
import com.com2us.module.push.Push;
import com.com2us.module.view.SurfaceViewWrapper;
import com.com2us.peppermint.HubBridge;
import com.com2us.peppermint.Peppermint;
import com.facebook.FacebookSdk;
import com.hive.HiveActivity;
import com.hive.base.Android;
import com.hive.plugin.HivePluginCpp;

import org.cocos2dx.lib.Cocos2dxActivity;
import org.json.JSONObject;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

public class AppActivity extends Cocos2dxActivity {
    static AppActivity instance;
    ProgressDialog progressDialog;

    public static Activity activity;

	static PostBoxTest postbox = null;
	
	// User Engagement
	private static String inScheme;

	/**
	 *
	 *  C2S -- begin
	 *
	 */
	static ViewEx viewEx = null;

	static ActiveUser activeuser;
	static Mercury mercury;
	static Offerwall offerwall;
	static Push push;
	static InAppV4 inappV4;
	static Peppermint peppermint;
	static HubBridge hubBridge;
	static boolean hubBridgeInitChecker = false;
	static com.com2us.module.hivepromotion.PromotionJNI promotionJNI;

//	static RequestNetworkForCocos requestNetworkFC;			// TODO : ModuleManager와 연결된 사항이 있어 사용 불가
	private static String uaToken = "";
	private static String uidFromCocos = "";

	// SurfaceViewWrapper 추상 클래스에 대한 재정의를 한다.
	class ViewEx extends SurfaceViewWrapper {

		public ViewEx(SurfaceView view) {
			super(view);
			// TODO Auto-generated constructor stub
			Log.d("cocos2d-x activity", "ViewEx setted");
		}

		@Override
		public void queueEvent(Runnable paramRunnable) {
			// TODO Auto-generated method stub
			Log.d("cocos2d-x activity", "queueEvent in Override");
			paramRunnable.run();		// 정의한 queueEvent에 수행할 쓰레드(run())가 있으면 실행한다.
		}

	}
	/**
	 *
	 *  C2S -- end
	 *
	 */

	static
	{
		System.loadLibrary("MyGame");
		try
		{
			C2SModule.VMInitialize();
		}
		catch(Exception e)
		{
		}
	}

    private void checkDeeplink() {
		// read intent for engagement call
		AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(AppActivity.this);
						
		alertDialogBuilder.setTitle("즉시 실행하시겠습니까?");
						
		alertDialogBuilder.setMessage("Yes or No")
		.setCancelable(false)
		.setPositiveButton("YES", new DialogInterface.OnClickListener() {
							
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
//				String sendargument = "{\"scheme\":\"" + inScheme + "\",\"immediately\":true}";
//
//				Log.d("jschoi", "AppActivity, sendargument : " + sendargument);		// TODO : jschoi
//				C2SModuleError result = C2SModuleEngagement.ProcessScheme(sendargument);
//				AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(AppActivity.this);
//
//				alertDialogBuilder.setTitle("Result");
//
//				alertDialogBuilder.setMessage("scheme : " + sendargument + " result : " + result)
//				.setCancelable(false)
//				.setPositiveButton("OK", null);
//
//
//				AlertDialog alertDialog = alertDialogBuilder.create();
//
//				alertDialog.show();
								
			}
		})
		.setNegativeButton("NO", new DialogInterface.OnClickListener() {
			
			@Override
			public void onClick(DialogInterface dialog, int which) {
				// TODO Auto-generated method stub
//				String sendargument = "{\"scheme\":\"" + inScheme + "\",\"immediately\":false}";
//
//				C2SModuleError result = C2SModuleEngagement.ProcessScheme(sendargument);
//				AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(AppActivity.this);
//
//				alertDialogBuilder.setTitle("Result");
//
//				alertDialogBuilder.setMessage("scheme : " + sendargument + " result : " + result)
//				.setCancelable(false)
//				.setPositiveButton("OK", null);
//
//
//				AlertDialog alertDialog = alertDialogBuilder.create();
//
//				alertDialog.show();
			}
		});
						
		AlertDialog alertDialog = alertDialogBuilder.create();
						
		alertDialog.show();
	}

    // Create Cocos2d
    @Override protected void onCreate (Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        instance = this;
        HivePluginCpp.getInstance().setActivity(this);
        HiveActivity.onCreate(this, savedInstanceState);

        activity = this;

	    // v4 이슈 #GCPHQ-2212
	    // v1 QA 검증 시, 정상동작 확인후 아래코드 제거 합의
        //engagementProcess(getIntent());

        // C2S -- begin
		SurfaceView sf = new SurfaceView(this);
		viewEx = new ViewEx(sf);
		// C2S -- end
	}

	@Override
	protected void onStart() {
		super.onStart();
		HiveActivity.onStart(this);
	}

	// Stop Cocos2d
    @Override
    protected void onStop() {
        HiveActivity.onStop(this);

        super.onStop();

    }

    // Destroy Cocos2d
    @Override protected void onDestroy ()
    {
        HiveActivity.onDestroy(this);

        super.onDestroy();
    }

    // Pause Cocos2d
    @Override protected void onPause()
    {
        super.onPause();

        HiveActivity.onPause(this);
    }

    // Resume Cocos2d
    @Override protected void onResume()
    {
        super.onResume();

        HiveActivity.onResume(this);

        if(activeuser != null) {
			activeuser.onCletResumed();
		}
    }

    // AttachBaseContext Cocos2d
    @Override protected void attachBaseContext(Context newBase) {

        super.attachBaseContext(HiveActivity.attachBaseContext(newBase));
    }

    // This ensures the layout will be correct.
    @Override public void onConfigurationChanged(Configuration newConfig)
    {
        HiveActivity.onConfigurationChanged(this, newConfig);
        super.onConfigurationChanged(newConfig);
    }

    // Notify Cocos2d of the focus change.
    @Override public void onWindowFocusChanged(boolean hasFocus)
    {
        super.onWindowFocusChanged(hasFocus);

        HiveActivity.onWindowFocusChanged(this, hasFocus);
    }

    @Override
    protected void onNewIntent(Intent intent)
    {
        super.onNewIntent(intent);

        HiveActivity.onNewIntent(this, intent);

        // v4 이슈 #GCPHQ-2212
	    // v1 QA 검증 시, 정상동작 확인후 아래코드 제거 합의

//        /**
//		 * onNewIntent에서 engagement scheme 실행 코드 주석 처리
//		 * :
//		 * onResume에서 수신이 되기 때문에 onNewIntent로 중복처리 되지 않도록 주석 처리
//		 */

		//engagementProcess(intent);
    }
    
    @TargetApi(23) @Override
    public void onRequestPermissionsResult(int requestCode,
                                           String[] permissions, int[] grantResults)
    {

        super.onRequestPermissionsResult(requestCode, permissions, grantResults);

        HiveActivity.onRequestPermissionsResult(this, requestCode, permissions, grantResults);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);

        HiveActivity.onActivityResult(this, requestCode, resultCode, data);
    }

	/**
	 * 공유하기 위한 미디어 파일 경로로부터 Uri를 얻는다.
	 * @param filePath 미디어 파일 경로
	 * @return 미디어 파일 Uri
	 */
	public static String getShareMediaPathFileUri(String filePath) {
		File f = new File(filePath);

		String fileUri;

		if (Build.VERSION.SDK_INT < Build.VERSION_CODES.M) {
			fileUri = Uri.fromFile(f).toString();
		} else {
			fileUri = FileProvider.getUriForFile(AppActivity.getContext(), AppActivity.getContext().getPackageName() + ".provider", f).toString();
		}

		return fileUri;
	}

    public static String getExternalStorage(){
        return AppActivity.getContext().getExternalFilesDir(null).getAbsolutePath();
    }

    public static synchronized void StartActivityIndicator(){
        AppActivity.instance.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if(AppActivity.instance != null && AppActivity.instance.progressDialog == null) {
                    ProgressDialog progressDialog = new ProgressDialog(AppActivity.instance);
                    progressDialog.setMessage("please wait...");
                    progressDialog.show();
                    progressDialog.setCanceledOnTouchOutside(false);
                    progressDialog.setCancelable(false);
                    AppActivity.instance.progressDialog = progressDialog;
                }
            }
        });

    }
    public static synchronized void EndActivityIndicator(){
        AppActivity.instance.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if(AppActivity.instance != null && AppActivity.instance.progressDialog != null) {
                    AppActivity.instance.progressDialog.dismiss();
                    AppActivity.instance.progressDialog = null;
                }
            }
        });

    }

    @Override
    public void onMultiWindowModeChanged(boolean isInMultiWindowMode, android.content.res.Configuration newConfig) {
        super.onMultiWindowModeChanged(isInMultiWindowMode,newConfig);
        HiveActivity.onMultiWindowModeChanged(this,isInMultiWindowMode,newConfig);
    }

    public static byte[] getDeviceModel()
	{
		System.out.println("====>>>> deviceModel : "+Android.INSTANCE.getDeviceModel());
		return Android.INSTANCE.getDeviceModel().getBytes();
	}
	
	public static byte[] getOSVersion()
	{
		System.out.println("====>>>> os version : "+Android.INSTANCE.getOSVersion());
		return Android.INSTANCE.getOSVersion().getBytes();
	}

    public static void showDialogMsg(String msg)
	{
//		showAppStorageInfo();		// TODO :
		final AlertDialog.Builder builder = new AlertDialog.Builder(activity);
    	System.out.println("dialog msg : "+msg);
		builder.setMessage(msg);

		activity.runOnUiThread(new Runnable()
		{

			@Override
			public void run()
			{
				builder.show();
			}
		});
	}

	public static void showToastMsg(String msg) {

		String message = "";
		if(TextUtils.isEmpty(msg)) {
			message = "=== empty msg ===";
		}

		if(activity != null) {
			activity.runOnUiThread(new Runnable() {
				@Override
				public void run() {
					Toast.makeText(activity, msg, Toast.LENGTH_LONG).show();
				}
			});
		}
	}

	public static String getCurrentTime() {
		Log.d("jschoi", "getCurrentTime");

		try {
			long now = System.currentTimeMillis();
			Date mDate = new Date(now);
			SimpleDateFormat simpleDate = new SimpleDateFormat("yy-MM-dd hh:mm a", Locale.ENGLISH);
			Log.d("jschoi", "getCurrentTime : " + simpleDate.format(mDate));
			return simpleDate.format(mDate);
		} catch (Exception e) {
			Log.d("jschoi", "getCurrentTime exception");
			return "00-00-00 00:00:00";
		}
	}

	public static String getAppVersion() {
		try {
			PackageInfo pInfo = activity.getPackageManager().getPackageInfo(activity.getPackageName(), 0);
			return pInfo.versionName;
		} catch (PackageManager.NameNotFoundException e) {
			e.printStackTrace();
			return "ver. ";
		}
	}

	public static String getHiveSdkVersion() {
		try {
			PackageInfo pInfo = activity.getPackageManager().getPackageInfo(activity.getPackageName(), 0);
			return pInfo.versionName;
		} catch (PackageManager.NameNotFoundException e) {
			e.printStackTrace();
			return "1.19.4";	// 혹여 못 찾았다면 고정된 값 사용
		}
	}

	private void engagementProcess(Intent intent)
	{
		if (intent != null) {
			// get data from deeplink
			String action = intent.getAction();
			Uri data = intent.getData();

			Bundle bundleData = intent.getExtras();
			if (data != null) {
				inScheme = data.toString();
				if(!TextUtils.isEmpty(inScheme)) {
					checkDeeplink();
					intent.setData(null);
				}
			} else if (bundleData != null) {
				// get data from push
				String pushAction = bundleData.getString("action");
				if (!TextUtils.isEmpty(pushAction)) {
					inScheme = pushAction;
					checkDeeplink();
					intent.getExtras().clear();
				}
			}
		}
	}

	public static void postBoxInit(String data) {
		Log.d("jschoi", "postBoxInit");
		try {
			JSONObject jsonData = new JSONObject(data);
			if(jsonData.has("useStaging") && jsonData.getBoolean("useStaging") == true) {
				postbox = new PostBoxTest(activity, PostBox.PostServerState.POST_SERVER_STATE_TEST_SERVER);
				Log.d("jschoi", "postBoxInit test server");
			} else if(jsonData.has("useSandbox") && jsonData.getBoolean("useSandbox") == true) {
				postbox = new PostBoxTest(activity, PostBox.PostServerState.POST_SERVER_STATE_SANDBOX_SERVER);
				Log.d("jschoi", "postBoxInit sandbox server");
			} else {
				postbox = new PostBoxTest(activity, PostBox.PostServerState.POST_SERVER_STATE_LIVE_SERVER);
				Log.d("jschoi", "postBoxInit live server");
			}
		} catch (Exception e) {
			e.printStackTrace();
			Log.d("jschoi", "postBoxInit exception");
		}
	}

	public static String getSampleBuildTime() {
		try {
			Date currentTime = new Date();

			SimpleDateFormat sampleShowingFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm");
			return "buildTime:"+sampleShowingFormat.format(currentTime);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return "buildTime:";
	}

	public static String getSampleVersionName() {
		try {
			if(activity != null)
				return "test String(getSampleVersionName)";
//				return "versionName:"+activity.getInstance(activity).getAppVersion();
		} catch (Exception e) {
			e.printStackTrace();
		}
		return "versionName:";
	}

	public static String getSampleVersionCode() {
		try {
			if (activity != null)
				return "test String(getSampleVersionCode)";
//				return "versionCode:"+String.valueOf(ModuleData.getInstance(activity).getAppVersionCode());
		} catch (Exception e) {
			e.printStackTrace();
		}
		return "versionCode:";
	}

	public static String getThirdPartyLibsVersions(int type) {
		String singularVersion = "";
		String adjustVersion = "";
		String facebookVersion = "";

		adjustVersion = Adjust.getSdkVersion();
		facebookVersion = FacebookSdk.getSdkVersion();
		singularVersion = com.singular.sdk.BuildConfig.VERSION_NAME;

		if(type == 1)
			return "Facebook SDK Ver : " + facebookVersion;

		return "";
	}

	public static String getHiveCountryCode() {
		return C2SModuleSocial.GetHiveCountry();
	}

	/**
	 *
	 *  C2S -- begin
	 *
 	 */
	public static void activeuserInit(String empty) {
		if(activeuser == null) {
			activeuser = new ActiveUser(activity, viewEx);    // ActiveUser 생성자
			activeuser.setLogged(true);
		}
	}

	public static void inappv4Init(String empty) { 
		if(inappV4 == null) {
			inappV4 = new InAppV4(viewEx);
		}
	}

	public static void hivepromotionInit(String empty) {
		if(promotionJNI == null) {
			Promotion.setLogged(true);      // HIVE Promotion
			promotionJNI = new com.com2us.module.hivepromotion.PromotionJNI(activity, viewEx);
		}
	}

	/**
	 * MERCURY init
	 * @param empty
	 */
	public static void mercuryInit(String empty) {
		Log.d("jschoi", "mercuryInit");
		if(mercury == null) {
			mercury = new Mercury(activity, viewEx);
			//mercury.setLogged(true);
		}
	}

	/**
	 * OFFERWALL init
	 * @param empty
	 */
	public static void offerwallInit(String empty) {
		Log.d("jschoi", "offerwallInit");
		if(offerwall == null) {
			offerwall = new Offerwall(activity, viewEx);
//		offerwall = new Offerwall(activity);
		}
	}

	/**
	 * PUSH init
	 * @param empty
	 */
	public static void pushInit(String empty) {
		Log.d("jschoi", "pushInit");
		if(push == null) {
			push = Push.getInstance(activity);
			push.setUseCLibrary(viewEx);
			//push.setLogged(true);
		}
	}

	/**
	 * INAPP init
	 * @param empty
	 */
	public static void inappInit(String empty) {
		Log.d("jschoi", "inappInit");
//		inapp = new InApp(activity, viewEx);
//		inapp.setLogged(true);
	}

	/**
	 * INAPP setLog
	 * @param empty
	 */
	public static void inappSetLog(String empty) {
		Log.d("jschoi", "inappSetLog");
	}

	/**
	 * PEPPERMINT init
	 * @param empty
	 */
	public static void peppermintInit(String empty) {
		Log.d("jschoi", "peppermintInit");
		if(hubBridgeInitChecker == false) {
//		peppermint = new Peppermint(activity);

//		hubBridge = new HubBridge();
//		hubBridge.hubInitializeJNI(activity);
			HubBridge.hubInitializeJNI(activity);

//		hubBridge.setGLSurfaceViewForCallback(get);

			hubBridgeInitChecker = true;
		}
	}

	/**
	 * UA 데이터 요청
	 * added 191018
	 * @param type
	 */
	public static void requestNetowrkMercuryUA(String type) {
		Log.d("jschoi", "requestNetowrkMercuryUA");

//		requestNetworkFC.settingData(uidFromCocos, "kr");
//
//		Object loginResponseObj = requestNetworkFC.processNetworkForUAGameServer("3", "");
//
//		Object responseObj = requestNetworkFC.processNetworkForUAGameServer(type, uaToken);
//		if(responseObj != null) {
//			Log.d("jschoi", "requestNetowrkMercuryUA response is not null");
//			showDialogMsg("UA Token 획득 성공 :\n" + ((String) responseObj));
//
//			try {
//				JSONObject jsonData = new JSONObject(((String) responseObj));
//				if(jsonData.has("result_data")) {
//					if(jsonData.getJSONObject("result_data").has("uatoken")) {
//						uaToken = jsonData.getJSONObject("result_data").getString("uatoken");
//						Log.d("jschoi", "requestNetowrkMercuryUA get uaToken : " + uaToken);
//					}
//				}
//			}
//			catch (Exception e) {
//				e.printStackTrace();
//			}
//		}
//		else {
//			Log.d("jschoi", "requestNetowrkMercuryUA response is null");
//			showDialogMsg("UA Token 획득 실패 :\n");
//		}

	}

	/**
	 * added 191018
	 * @return
	 */
	public static String getUaToken() {

		if(!TextUtils.isEmpty( uaToken)) {
			Log.d("jschoi", "getUaToken uaToken : " + uaToken);
		}

		JSONObject uaTokenJson = new JSONObject();
		try {
			uaTokenJson.put("uatoken", uaToken);
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		return uaTokenJson.toString();
	}

	public static void setUIDfromCocos(String uid) {
		Log.d("jschoi", "setUIDfromCocos");
		uidFromCocos = uid;
	}

	public static String getAndroidFacebookVer() {

		String version = "";
		try {
			version = com.facebook.FacebookSdk.getSdkVersion();
		} catch (Exception e) {

		}
		return version;
	}

	public static String getAndroidSingularVer() {

		String version = "";
		try {
			version = com.singular.sdk.BuildConfig.VERSION_NAME;
		} catch (Exception e) {

		}
		return version;
	}

	public static String getAndroidAdjustVer() {

		String version = "";
		try {
			version = Adjust.getSdkVersion();
		} catch (Exception e) {

		}
		return version;
	}

	public static String getAndroidAppsFlyerVer() {

		String version = "";
		try {
			version = AppsFlyerLib.getInstance().getSdkVersion();
		} catch (Exception e) {

		}
		return version;
	}

	/**
	 *
	 *  C2S -- end
	 *
	 */

	// end of class
}
