/**
 * 
 */
package org.cocos2dx.cpp;

import android.app.Activity;
import android.app.Dialog;
import android.content.Context;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.LinearLayout;

import com.com2us.hivesdk.normal.freefull.google.global.android.common.R;

import org.json.JSONArray;
import org.json.JSONObject;

/**
 * 구글 : com.com2us.hivesdk.normal.freefull.google.global.android.common
 * 화웨이 : com.com2us.hivesdk.android.huawei.global.normal.huawei
 * 아마존 : com.com2us.hivesdk.android.amazon.global.normal
 */

/**
 * @author user
 * 
 */
public class PostBoxDialog extends Dialog {

	private Context context = null;

	public int deviceWidth = 0;
	public int deviceHeight = 0;

	public PostBoxDialog(Activity activity, String data) {
		super(activity);

		if(activity != null)
			context = activity.getApplicationContext();

		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setCancelable(false);
		this.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
		this.getWindow().addFlags(WindowManager.LayoutParams.FLAG_DIM_BEHIND);

		// 다이얼로그의 뒤의 배경 투명도 설정.
		WindowManager.LayoutParams lp = getWindow().getAttributes();
		lp.dimAmount= 0.8f;  // dimAmount between 0.0f and 1.0f, 1.0f is completely dark
		this.getWindow().setAttributes(lp);

		// 디바이스의 가로 세로 해상도 값 가져오기.
		DisplayMetrics displayMetrics = new DisplayMetrics();
		activity.getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
		deviceWidth = displayMetrics.widthPixels;
		deviceHeight = displayMetrics.heightPixels;

		// TODO :
		setDialogLayout();
	}
	
	public void showPostBoxDialog() {

	}

	private void setDialogLayout() {
		setContentView(context.getResources().getIdentifier("postbox_iapv4", "layout",  context.getPackageName()));

		LinearLayout itemListLayout = (LinearLayout)findViewById(R.id.postbox_iapv4_linearlayout_itemlist);

		JSONObject postBoxData = PostBoxData.getInstance().getPostBoxData();


		if(postBoxData != null) {
			try {
				JSONArray postListJsonArr = null;
				JSONArray postSubListJsonArr = null;
				if(postBoxData.has("post_list"))
					postListJsonArr = postBoxData.getJSONArray("post_list");
				if(postBoxData.has("post_subscription_list"))
					postSubListJsonArr = postBoxData.getJSONArray("post_subscription_list");

				Button[] postboxItem = new Button[postListJsonArr.length()];
				Button[] postboxSubItem = new Button[postSubListJsonArr.length()];

				for(int i = 0; i < postListJsonArr.length(); i++) {
					postboxItem[i] = new Button(context);

					JSONObject itemInfo = postListJsonArr.getJSONObject(i);
					final JSONObject receiveData = postListJsonArr.getJSONObject(i);
					String buttonText = "[Consumable]\npost_id:";
					if(itemInfo.has("post_id"))
						buttonText += (itemInfo.getString("post_id")+ ",asset_code:");
					else
						buttonText += ",asset_code:";
					if(itemInfo.has("asset_code"))
						buttonText += (itemInfo.getString("asset_code")+",asset_amount:");
					else
						buttonText += ",asset_amount:";
					if(itemInfo.has("asset_amount"))
						buttonText += (itemInfo.getString("asset_amount")+",date_added:");
					else
						buttonText += ",date_added:";
					if(itemInfo.has("date_added"))
						buttonText += itemInfo.getString("date_added");
					else
						buttonText += "";

					postboxItem[i].setText(buttonText);
					itemListLayout.addView(postboxItem[i]);

					postboxItem[i].setOnClickListener(new Button.OnClickListener() {
						@Override
						public void onClick(View view) {
							// TODO : receive 프로토콜 요청
							JSONObject requestReceiveData = new JSONObject();
							try {
								requestReceiveData.put("type", "receive");
								requestReceiveData.put("vid", TextUtils.isEmpty(PostBoxTest.loginVid) ? "": PostBoxTest.loginVid);
								requestReceiveData.put("uid", PostBoxTest.loginUid);
								if (PostBox.getServerState() == PostBox.PostServerState.POST_SERVER_STATE_LIVE_SERVER) {
									requestReceiveData.put("useStaging", false);
									requestReceiveData.put("useSandbox", false);
								} else if (PostBox.getServerState() == PostBox.PostServerState.POST_SERVER_STATE_SANDBOX_SERVER) {
									requestReceiveData.put("useSandbox", true);
								} else if (PostBox.getServerState() == PostBox.PostServerState.POST_SERVER_STATE_TEST_SERVER) {
									requestReceiveData.put("useStaging", true);
								}

								JSONArray postList = new JSONArray();
								postList.put(receiveData.getString("post_id"));

								requestReceiveData.put("post_id_list", postList);

							} catch (Exception e) {
								e.printStackTrace();
							}

							if(requestReceiveData != null)
								AppActivity.postbox.Request(requestReceiveData.toString());
						}
					});
				}

				for(int i = 0; i < postSubListJsonArr.length(); i++) {
					postboxSubItem[i] = new Button(context);

					JSONObject itemInfo = postSubListJsonArr.getJSONObject(i);
					String buttonText = "[Subscription]\nproduct_id:";
					if(itemInfo.has("product_id"))
						buttonText += (itemInfo.getString("product_id")+",market_id:");
					else
						buttonText += ",market_id:";
					if(itemInfo.has("market_id"))
						buttonText += (itemInfo.getString("market_id")+",start_date:");
					else
						buttonText += ",start_date:";
					if(itemInfo.has("start_date"))
						buttonText += (itemInfo.getString("start_date")+",expire_date:");
					else
						buttonText += ",expire_date:";
					if(itemInfo.has("expire_date"))
						buttonText += itemInfo.getString("expire_date");
					else
						buttonText += "";

					postboxSubItem[i].setText(buttonText);
					itemListLayout.addView(postboxSubItem[i]);

					postboxSubItem[i].setOnClickListener(new Button.OnClickListener() {
						@Override
						public void onClick(View view) {
							// TODO : receive 프로토콜 요청
						}
					});
				}

			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	// TODO : test code
//		Button[] postboxItem = new Button[3];
//		for(int i = 0; i < 3; i++) {
//			postboxItem[i] = new Button(context);
//
//			postboxItem[i].setText("button info : " + String.valueOf(i));
//			itemListLayout.addView(postboxItem[i]);
//		}
	}

	public void show(){
		super.show();
	}

	public void dismiss() {
		super.dismiss();
	}

	@Override
	public void onBackPressed() {
		super.onBackPressed();
		dismiss();
	}

	// end of class	
}