/**
 * 
 */
package org.cocos2dx.cpp;

import android.app.Activity;
import android.content.Context;
import android.os.Handler;
import android.os.Looper;
import android.telephony.TelephonyManager;
import android.util.Log;

//import com.com2us.appinfo.ApplicationContextProvider;
//import com.com2us.module.manager.ModuleData;

import org.cocos2dx.cpp.PostBox.PostServerState;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.Iterator;

// PostBox API : https://docs.google.com/document/d/1YD8OW0vma6S4f3-TOsPVwbuGsqh_XbEeCXZ3UEV25Aw/edit

/**
 * @author user
 * 
 */
public class PostBoxTest
{		
	static String TAG = "PostBoxTest";

	static Activity mainActivity;
	public static Context context;
	static PostServerState currentPostServerState = PostServerState.POST_SERVER_STATE_TEST_SERVER;
	static boolean isPostBoxShow = false;
	public static String SESSION_TOKEN = "";
	public static String loginUid = "";
	public static String loginVid = "";

	PostBoxData postBoxData;
	static PostBoxDialog postBoxDialog;	

	public static boolean Request(String arg0)
	{
		Log.d(TAG, "PostBoxTest PostBoxTest : Request 01");

		try
		{
			Log.d(TAG, "PostBoxTest PostBoxTest : Request 02");

			JSONObject arg = new JSONObject(arg0);
			Log.d("PostBoxTest", "Request - arg : " + arg.toString());
			if(arg.has("isPostBoxShow"))
				isPostBoxShow = arg.getBoolean("isPostBoxShow");

			try {
				Log.d(TAG, "PostBoxTest PostBoxTest : Request 03");
				String type = arg.getString("type");

				if( type.equals("showPostBox")) {
					Handler mHandler = new Handler(Looper.getMainLooper());
					mHandler.postDelayed(new Runnable() {
						@Override
						public void run() {
							postBoxDialog = new	PostBoxDialog(mainActivity, "");
							postBoxDialog.show();
						}
					}, 0);

				} else {

					String appId = null;
					appId = mainActivity.getApplication().getPackageName();

					String vid = "";
					String vidSession = "";
					String uid = "";
					String uidSession = "";
					if (arg.has("vid")) {
						vid = arg.optString("vid");
						loginVid = vid;
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 03, vid set : " + vid);
					}
					if (arg.has("vidSession"))
						vidSession = arg.getString("vidSession");
					if (arg.has("uid")) {
						uid = arg.optString("uid");
						loginUid = uid;
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 03, uid set : " + uid);
					}
					if (arg.has("uidSession"))
						uidSession = arg.getString("uidSession");

					boolean useStaging = false;
					boolean useSandbox = false;
					if (arg.has("useStaging"))
						useStaging = arg.getBoolean("useStaging");
					if (arg.has("useSandbox"))
						useSandbox = arg.getBoolean("useSandbox");

					Log.d(TAG, "PostBoxTest PostBoxTest : Request 04");
					if (useSandbox) {
						libPostBox.setServerState(PostServerState.POST_SERVER_STATE_SANDBOX_SERVER);
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 04, set sandbox");
					} else {
						if (useStaging) {
							libPostBox.setServerState(PostServerState.POST_SERVER_STATE_TEST_SERVER);
							Log.d(TAG, "PostBoxTest PostBoxTest : Request 04, set test");
						} else {
							libPostBox.setServerState(PostServerState.POST_SERVER_STATE_LIVE_SERVER);
							Log.d(TAG, "PostBoxTest PostBoxTest : Request 04, set live");
						}
					}

					Log.d(TAG, "PostBoxTest PostBoxTest : Request 05");
					if (type.equals("login")) {
						String country = arg.getString("country");
						String language = arg.getString("gameLanguage");

						TelephonyManager teleManager = (TelephonyManager) mainActivity.getApplication().getSystemService(Context.TELEPHONY_SERVICE);
//					String systemDeviceId = teleManager.getDeviceId();		// TODO : crash, 접근 권한이 없을 경우 값을 받을 수 없음. (READ_PHONE_STATE)
//						ModuleData mmdd = ModuleData.getInstance(context);

						String systemDeviceId = "";
//						if(mmdd != null) {
							// TODO : Temp
//							systemDeviceId = "0";//mmdd.getDID();
//							Log.d("PostBoxTest", "systemDeviceId : " + systemDeviceId);
//						}

						String did = "";
						if (arg.has("did")) {
							did = arg.optString("did");
							Log.d(TAG, "PostBoxTest PostBoxTest : Request 05, parsed did");
						}
						String world = arg.getString("world");

						Log.d(TAG, "PostBoxTest PostBoxTest : Request 06");
						Log.d(TAG, "Request Login");
						libPostBox.requestLoginConnection(
								appId,
								"1.19.4",
								country,
								language,
								did,
								vid,
								uid,
								vidSession,
								world);
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 07");
					} else if (type.equals("receive")) {
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 08");
						Log.d(TAG, "Request Receive");
						JSONArray postIDList = (JSONArray) arg.get("post_id_list");

						libPostBox.requestReceivePostConnection(postIDList);
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 09");
					} else if (type.equals("refresh")) {
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 10");
						Log.d(TAG, "Request Refresh");
						libPostBox.requestRefreshPostConnection();
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 11");
					} else if (type.equals("userInfo")) {
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 12");
						Log.d(TAG, "Request UserInfo");
						libPostBox.requestUserInfoConnection(vid);
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 13");
					} else if (type.equals("verify")) {
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 13-2");
						Log.d(TAG, "Request Verify");
						libPostBox.requestVerifyConnection(arg0);
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 13-3");
					} else {
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 14");
						resultPostBox(arg, "type is invalid");
						Log.d(TAG, "PostBoxTest PostBoxTest : Request 15");
						return false;
					}
				}
			} catch (JSONException e) {
				// TODO: handle exception
				e.printStackTrace();
				Log.d(TAG, "PostBoxTest PostBoxTest : Request 16");
				return false;
			}
			Log.d(TAG, "PostBoxTest PostBoxTest : Request 17");


			return true;
		}
		catch(JSONException e)
		{
			e.printStackTrace();
			Log.d(TAG, "PostBoxTest PostBoxTest : Request 18");
			return false;
		}
	}

	// non-static variable & method
	private static PostBox libPostBox = null;
	
	public PostBoxTest(Activity activity, PostServerState serverState)
	{
		mainActivity = activity;
		context = activity;
		Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 01");

		libPostBox = new PostBox(serverState, new PostBoxListener() {

			@Override
			public void finishLoginProcess(JSONObject resultObjects) {
				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 02");
				Log.d(TAG, "finishLoginProcess");
				JSONObject arg = new JSONObject();
				try
				{
					Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 03");
					arg.put("type", "login");
				}
				catch (JSONException e)
				{
					Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 04");
					e.printStackTrace();
				}

				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 05");
				Iterator<?> keys = resultObjects.keys();

				try {
					Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 06");
					while( keys.hasNext() ) {
						Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 07");
					    String key = (String)keys.next();
					    arg.put(key, resultObjects.get(key));
					}
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 08");
					e.printStackTrace();
				}
				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 09");

				AppActivity.showDialogMsg("PostBox 로그인(login) Success");
				AppActivity.showToastMsg("PostBox 로그인(login) Success");

				if(isPostBoxShow == true) resultPostBox(arg, null);

			}

			@Override
			public void finishReceiveProcess(JSONObject resultObjects) {
				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 10");
				Log.d(TAG, "finishReceiveProcess");
				JSONObject arg = new JSONObject();
				try {
					arg.put("type", "receive");
				} catch (JSONException e) {
					// TODO: handle exception
				}

				Iterator<?> keys = resultObjects.keys();

				try {
					while( keys.hasNext() ) {
					    String key = (String)keys.next();
					    arg.put(key, resultObjects.get(key));
					}
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
//				AppActivity.showDialogMsg("PostBox 아이템 사용(receive) Success");
				AppActivity.showToastMsg("PostBox 아이템 사용(receive) Success");

				// PostBox 정보를 PostBoxData에 셋팅
				PostBoxData.getInstance().setPostBoxData(resultObjects);

				if(isPostBoxShow == true) resultPostBox(arg, null);
			}

			@Override
			public void finishRefreshProcess(JSONObject resultObjects) {
				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 11");
				Log.d(TAG, "finishRefreshProcess");
				JSONObject arg = new JSONObject();
				try {
					arg.put("type", "refresh");
				} catch (JSONException e) {
					// TODO: handle exception
				}

				Iterator<?> keys = resultObjects.keys();

				try {
					while( keys.hasNext() ) {
					    String key = (String)keys.next();
					    arg.put(key, resultObjects.get(key));
					}
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

//				AppActivity.showDialogMsg("PostBox 정보 갱신(refresh) Success");
				AppActivity.showToastMsg("PostBox 정보 갱신(refresh) Success");

				// PostBox 정보를 PostBoxData에 셋팅
				PostBoxData.getInstance().setPostBoxData(resultObjects);

				if(isPostBoxShow == true) resultPostBox(arg, null);
			}

			@Override
			public void finishUserInfoProcess(JSONObject resultObjects) {
				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 12");
				Log.d(TAG, "finishUserInfoProcess");
				JSONObject arg = new JSONObject();
				try {
					arg.put("type", "userInfo");
				} catch (JSONException e) {
					// TODO: handle exception
				}

				Iterator<?> keys = resultObjects.keys();

				try {
					while( keys.hasNext() ) {
					    String key = (String)keys.next();
					    arg.put(key, resultObjects.get(key));
					}
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				if(isPostBoxShow == true) resultPostBox(arg, null);
			}

			@Override
			public void finishNetworkFailProcess(JSONObject resultObjects) {
				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 13");
				Log.d(TAG, "finishNetworkFailProcess");
				String result_code = null;
				String result_msg = null;
				try {
					result_code = resultObjects.getString("result_code");
					result_msg = resultObjects.getString("result_msg");
				} catch (JSONException e) {
					e.printStackTrace();
					result_code = "";
					result_msg = "";
				}

				JSONObject arg = new JSONObject();

				resultPostBox(arg, result_msg + "(" + result_code + ")");
			}

			@Override
			public void finishVerifyProcess(JSONObject resultObjects) {
				Log.d(TAG, "PostBoxTest PostBoxTest : PostBoxTest 14");
				Log.d(TAG, "finishVerifyProcess");

				String result_code = null;
				String result_msg = null;
				try {
					result_code = resultObjects.getString("result_code");
					result_msg = resultObjects.getString("result_msg");
				} catch (JSONException e) {
					e.printStackTrace();
					result_code = "";
					result_msg = "";
				}
				Log.d(TAG, "finishVerifyProcess result_code : " + result_code + ", result_msg : " + result_msg);

				JSONObject arg = new JSONObject();
				try {
					arg.put("type", "verify");
				} catch (JSONException e) {
					// TODO: handle exception
				}

				Iterator<?> keys = resultObjects.keys();

				try {
					while( keys.hasNext() ) {
						String key = (String)keys.next();
						arg.put(key, resultObjects.get(key));
					}
				} catch (JSONException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

//				AppActivity.showDialogMsg("PostBox 아이템 검증(verify) Success");
				AppActivity.showToastMsg("PostBox 아이템 검증(verify) Success");

				if(isPostBoxShow == true) resultPostBox(arg, null);
			}

		});
	}	
	
	public static void resultPostBox(JSONObject jsonObj, String errorMsg)
	{
		Log.d("PostBoxTest", "resultPostBox");
		if(errorMsg != null)
		{
			System.out.println( "====>>>> resultPostBox error : " + errorMsg );
//			Toast.makeText(AppActivity.activity, errorMsg, Toast.LENGTH_LONG).show();
//			AppActivity.showDialogMsg(errorMsg);
			AppActivity.showToastMsg(errorMsg);
			return;
		}
		
		try
		{
			String type = jsonObj.getString("type");
			if( type.equals("login") ) {
				Log.d("PostBoxTest", "resultPostBox login json :" + jsonObj.toString());
				String nickname = jsonObj.getString("nickname");
				int gold = jsonObj.getInt("gold");
				int gem = jsonObj.getInt("gem");

				PostBoxData.getInstance().setPostBoxData(jsonObj);

//				txt_info.setText("nickname : " + nickname + ", gold : " + gold + ", gem : " + gem);
			}
			else if( type.equals("receive") ) {
				Log.d("PostBoxTest", "resultPostBox receive json :" + jsonObj.toString());
				String nickname = jsonObj.getString("nickname");
				int gold = jsonObj.getInt("gold");
				int gem = jsonObj.getInt("gem");

//				txt_info.setText("nickname : " + nickname + ", gold : " + gold + ", gem : " + gem);

				JSONObject testarg = new JSONObject();
				testarg.put("type", "receive");

//				C2SModulePostBox.Request(testarg);
				Request(testarg.toString());
			}
			else if( type.equals("refresh") ) {
				Log.d("PostBoxTest", "resultPostBox refresh json :" + jsonObj.toString());
				String nickname = jsonObj.getString("nickname");
				int gold = jsonObj.getInt("gold");
				int gem = jsonObj.getInt("gem");
				
//				txt_info.setText("nickname : " + nickname + ", gold : " + gold + ", gem : " + gem);
				
//				mPostboxAdapter.postboxDataArr.clear();
				
				JSONArray postList = (JSONArray)jsonObj.getJSONArray("post_list");
				if( postList != null )
					System.out.println( "====>>>> postList length : " + postList.length() );
				else
					System.out.println( "====>>>> postList null");
				
				if( postList == null || postList.length() == 0 )
				{
//					Toast.makeText(AppActivity.activity, "post list is null", Toast.LENGTH_SHORT).show();
//					AppActivity.showDialogMsg("post list is null.");
					AppActivity.showToastMsg("post list is null.");
					return;
				}
				
//				AppActivity.showDialogMsg(postList.toString());
				AppActivity.showToastMsg(postList.toString());
				
//				for( int i=0; i<postList.length(); ++i ) {
//					try {
//						JSONObject post = postList.getJSONObject(i);
//						
//						postboxDataArr.add(new PostboxData(
//								post.getString(C2SModuleArgKey.POST_ID), 
//								post.getString(C2SModuleArgKey.ASSET_CODE), 								
//								post.getString(C2SModuleArgKey.ASSET_AMOUNT), 
//								post.getString(C2SModuleArgKey.USER_MSG), 
//								post.getString(C2SModuleArgKey.DATE_ADDED)));
//					} catch( JSONException e ) {
//						e.printStackTrace();
//					}
//				}
//				
//				mPostboxAdapter.notifyDataSetChanged();
//				PostboxListView.hideLoadingDialog();
//				Intent intent = new Intent(this, PostboxListView.class);
//				startActivity(intent);
			}
			else if( type.equals("userInfo") ) {
				Log.d("PostBoxTest", "resultPostBox userinfo json :" + jsonObj.toString());
				String nickname = jsonObj.getString("nickname");
				int gold = jsonObj.getInt("gold");
				int gem = jsonObj.getInt("gem");
				
//				txt_info.setText("nickname : " + nickname + ", gold : " + gold + ", gem : " + gem);	
			}
			else {
				
			}
		}
		catch (JSONException e)
		{
			e.printStackTrace();
		}
	}
}