#ifndef __API_ACTION_H__
#define __API_ACTION_H__

#include "cocos2d.h"
#ifdef __ANDROID__
#include "cocos2d-x/Module_Cocos2d-x.h"
#else
#include "Module_Cocos2d-x.h";
#endif
#include "../external/json/rapidjson.h"
#include "../external/json/document.h"
#include "../external/json/writer.h"
#include "../external/json/stringbuffer.h"

USING_NS_CC;

using namespace cocos2d;
using namespace C2SModule_Cocos2dx;
using namespace rapidjson;

class ApiAction : public Menu
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	void menuCloseCallback(cocos2d::Ref* pSender);
	CREATE_FUNC(ApiAction);

	// variable
	static std::string selectLoginInfo;		// HIVE 1.10.1
	static int initPostBox;				// HIVE 1.18.4

	// function(CommonDelegate)
	static void initialize();
	static void login();
	static void logout();
	static void logoutUserExit();		// Hive 1.19.5.2, 1.20.0+
	static void getLoginType();
	static void pushRegister();
	static void pushUnregister();
	static void pushDescription();
	static void pushRegisterList();
	static void pushUnregisterList();
    static void pushRequestPermission();
	static void snsUser();
	static void snsUserDelete();
	static void snsPosting();
	static void promotionShow();
	static void promotionInfo();
	static void snsFriends();
	static void snsMessage();
	static void snsSession();
	static void snsShow();
	static void socialShow();
	static void inappPurchase();
	static void inappFinish();
	static void inappRestore();
	static void inappRequestBalance();
	static void inappPrepare();
	static void trackerSendEvent();
	static void trackerSetEnable();
	static void userAcquisition();			// HIVE 1.9.0 : promotion acquisition
	static void socialInfo();				// HIVE 1.10.0
	static void HiveIAP_Info();				// HIVE 1.10.0
	static void HiveIAP_Show();				// HIVE 1.10.0
	static void HiveIAP_Purchase();			// HIVE 1.10.0
	static void HiveIAP_Restore();			// HIVE 1.10.0
	static void engageConsumeCoupon();		// HIVE 1.10.0
	static void engageGetEventAct();		// HIVE 1.10.0
	static void HiveIAP_PostBox();			// HIVE 1.10.0
	static void login_select();				// HIVE 1.10.1
	static void login_customSelect();		// HIVE 1.10.1
	static void snsSetGuestUserInfo();		// HIVE 1.10.1
	static void engageSetReady();			// HIVE 1.11.0
	static void HivePromotion_Show();		// HIVE 1.12.0
	static void HivePromotion_Info();		// HIVE 1.12.0
	static void HivePromotion_SetAdditionalInfo();		// HIVE 1.12.0
	static void HivePromotion_GetOfferwallState();		// HIVE 1.12.0
	static void SetGameInfo_SetGameInfo();				// HIVE 1.12.0
	static void SetGameInfo_GetHiveCountryCode();
	static void SetGameInfo_GetChannel();	// Hive 1.20.3
	static void SetGameInfo_SetChannel();	// Hive 1.20.3
    static void SetGameInfo_SendData();
	static void SetGameInfo_UpdateServerId();
	static void SetGameInfo_UpdateGameLanguage();
	static void HivePromotion_UpdatePromotionData();	// HIVE 1.19.0
	static void promotionBannerInfo();		// HIVE 1.18.3
	static void HivePromotion_BannerInfo();	// HIVE 1.18.3

	static void InappV4_ItemInfo();			// HIVE 1.18.4
	static void InappV4_Purchase();			// HIVE 1.18.4
	static void InappV4_Restore();			// HIVE 1.18.4
	static void InappV4_TransactionFinish();// HIVE 1.18.4
	static void InappV4_GetSelectedMarket();// HIVE 1.18.4
	static void InappV4_GetAccountUuid();   // HIVE 1.20.3
	static void InappV4_MarketSelect();		// HIVE 1.18.4
	static void InappV4_RequestBalance();	// HIVE 1.18.4
	static void InappV4_ChargeBalance();	// HIVE 1.18.4
	static void InappV4_PostBox_Login();	// HIVE 1.18.4
	static void InappV4_PostBox_Show();		// HIVE 1.18.4
	static void InappV4_PostBox_Init();		// HIVE 1.18.4
    static void InappV4_CheckPromotePurchase();// Hive 1.19.1
    static void InappV4_MarketConnect();	// Hive 1.20.0
	static void InappV4_ShowInAppMessages();

	// 공용 함수
	static void callApiAndMakeLog(std::string apiName, std::string strJSON);
	static void callApiWithSelectionApi(std::string apiName, std::string intputArg);
	static void processAfterApiCalling(std::string apiName, int errorCode, std::string errorMsg);

	static std::string base64_encode(unsigned char const* bytes_to_encode, unsigned int in_len);		// HIVE 1.9.0

	static void HiveIAP_GameServerLoginConnection();			// HIVE 1.10.3
};

#endif // __API_ACTION_H__
