#include "DataManager.h"
#include "ApiAction.h"
#include "Parameter.h"
// UI Scene (view)
#include "InitListScene.h"
#include "LoginListScene.h"
#include "ModuleListScene.h"
#include "LogController.h"

#ifdef __ANDROID__
#include "JNISample.h"
#endif

bool DataManager::isWeChatTestSampleMode;

USING_NS_CC;

Scene* DataManager::createScene() {
	auto scene = Scene::create();
	auto layer = DataManager::create();
	scene->addChild(layer);
	return scene;
}

bool DataManager::init()
{
	if (!Layer::init()) {
		return false;
	}

	Size visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	log("### DataManager : init() ###");

	DataManager::isWeChatTestSampleMode = false;
	log("### DataMAnager : isWeChatTEstSampleMode = %d", DataManager::isWeChatTestSampleMode);

	return true;
}

void DataManager::getApiAction(int num)
{
	switch(num) {
		// social initialize
		case TAG_APIACTION_INITIALIZE : {
			ApiAction::initialize();
			break;
		}
		// snsLogin - snsLogout
		case TAG_APIACTION_LOGIN : {
			ApiAction::login();
//			ApiAction::login();
			break;
		}
		case TAG_APIACTION_LOGIN_SELECT : {			// HIVE 1.10.1
			ApiAction::login_select();
			break;
		}
		case TAG_APIACTION_LOGIN_CUSTOMSELECT : {	// HIVE 1.10.1
			ApiAction::login_customSelect();
			break;
		}
		case TAG_APIACTION_LOGOUT : {
			ApiAction::logout();
			break;
		}
		case TAG_APIACTION_LOGOUT_USEREXIT : {
			ApiAction::logoutUserExit();
			break;
		}
		// getloginstate
		case TAG_APIACTION_GETLOGINSTATE: {
			ApiAction::getLoginType();
			break;
		}
		// push
		case TAG_APIACTION_PUSHREGISTER : {
			ApiAction::pushRegister();
			break;
		}
		case TAG_APIACTION_PUSHUNREGISTER : {
			ApiAction::pushUnregister();
			break;
		}
		case TAG_APIACTION_PUSHDESCRIPTION : {
			ApiAction::pushDescription();
			break;
		}
		case TAG_APIACTION_PUSHREGISTER_LIST : {
			ApiAction::pushRegisterList();
			break;
		}
		case TAG_APIACTION_PUSHUNREGISTER_LIST : {
			ApiAction::pushUnregisterList();
			break;
		}
        case TAG_APIACTION_PUSH_REQUEST_PERMISSION : {
            ApiAction::pushRequestPermission();
            break;
        }
		// snsUser
		case TAG_APIACTION_SNSUSER : {
			ApiAction::snsUser();
			break;
		}
		case TAG_APIACTION_SNSUSER_DELETE : {
			ApiAction::snsUserDelete();
			break;
		}
		// snsPost
		case TAG_APIACTION_SNSPOSTING : {
			ApiAction::snsPosting();
			break;
		}
		// snsSetGuestUserInfo
		case TAG_APIACTION_SNSSETGUESTUSERINFO : {	// HIVE 1.10.1
			ApiAction::snsSetGuestUserInfo();
			break;
		}
		// promotionShow - promotionInfo
		case TAG_APIACTION_PROMOTIONSHOW : {
			ApiAction::promotionShow();
			break;
		}
		case TAG_APIACTION_PROMOTIONINFO : {
			ApiAction::promotionInfo();
			break;
		}
		// snsFriends - snsMessage - snsSession
		case TAG_APIACTION_SNSFRIENDS : {
			ApiAction::snsFriends();
			break;
		}
		case TAG_APIACTION_SNSMESSAGE : {
			ApiAction::snsMessage();
			break;
		}
		case TAG_APIACTION_SNSSESSION : {
			ApiAction::snsSession();
			break;
		}
		// snsShow - socialShow
		case TAG_APIACTION_SNSSHOW : {
			ApiAction::snsShow();
			break;
		}
		case TAG_APIACTION_SOCIALSHOW : {
			ApiAction::socialShow();
			break;
		}
		// inapp
		case TAG_APIACTION_PREPARE : {
			ApiAction::inappPrepare();
			break;
		}case TAG_APIACTION_REQUESTBALANCE : {
			ApiAction::inappRequestBalance();
			break;
		}case TAG_APIACTION_INAPPFINISH : {
			ApiAction::inappFinish();
			break;
		}case TAG_APIACTION_INAPPPURCHASE : {
			ApiAction::inappPurchase();
			break;
		}case TAG_APIACTION_INAPPRESTORE : {
			ApiAction::inappRestore();
			break;
		}
		// tracker
		case TAG_APIACTION_SENDEVENT : {
			ApiAction::trackerSendEvent();
			break;
		}case TAG_APIACTION_SETENABLE : {
			ApiAction::trackerSetEnable();
			break;
		}
		// userAcqusition(HIVE 1.9.0)
		case TAG_APIACTION_USERACQUISITION : {
			ApiAction::userAcquisition();
			break;
		}
		// social info(HIVE 1.10.0)
		case TAG_APIACTION_SOCIALINFO : {
			ApiAction::socialInfo();
			break;
		}
		// HIVE IAP(HIVE 1.10.0)
		case TAG_APIACTION_HIVEIAP_INFO : {
			ApiAction::HiveIAP_Info();
			break;
		}case TAG_APIACTION_HIVEIAP_SHOW : {
			ApiAction::HiveIAP_Show();
			break;
		}case TAG_APIACTION_HIVEIAP_PURCHASE : {
			ApiAction::HiveIAP_Purchase();
			break;
		}case TAG_APIACTION_HIVEIAP_RESTORE : {
			ApiAction::HiveIAP_Restore();
			break;
		}
		// ENGAGEMENT(HIVE 1.10.0)
		case TAG_APIACTION_ENGAGEMENT_GETEVENTS : {
//			ApiAction::engageGetEventAct();
			MessageBox("HIVE 1.11.0 부터 삭제된 기능입니다.", "Waring!");
			break;
		}case TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON : {
			ApiAction::engageConsumeCoupon();
			break;
		}case TAG_APIACTION_ENGAGEMENT_SETREADY : {
			ApiAction::engageSetReady();
			break;
		}
		// HIVE Promotion (HIVE 1.12.0)
		case TAG_APIACTION_HIVEPROMOTION_SHOW : {
			ApiAction::HivePromotion_Show();
			break;
		}case TAG_APIACTION_HIVEPROMOTION_INFO : {
			ApiAction::HivePromotion_Info();
			break;
		}case TAG_APIACTION_HIVEPROMOTION_SETADDITIONALINFO : {
			ApiAction::HivePromotion_SetAdditionalInfo();
			break;
		}case TAG_APIACTION_HIVEPROMOTION_GETOFFERWALLSTATE : {
			ApiAction::HivePromotion_GetOfferwallState();
			break;
		}case TAG_APIACTION_HIVEPROMOTION_UPDATEPROMOTIONDATA : {
			ApiAction::HivePromotion_UpdatePromotionData();
			break;
		}
		// SetGameInfo (HIVE 1.12.0)
		case TAG_APIACTION_SETGAMEINFO_SETGAMEINFO : {
			ApiAction::SetGameInfo_SetGameInfo();
			break;
		}
		case TAG_APIACTION_SETGAMEINFO_GETHIVECOUNTRYCODE : {
			ApiAction::SetGameInfo_GetHiveCountryCode();
			break;
		}
		case TAG_APIACTION_SETGAMEINFO_GETCHANNEL : {
			ApiAction::SetGameInfo_GetChannel();
			break;
		}
		case TAG_APIACTION_SETGAMEINFO_SETCHANNEL : {
			ApiAction::SetGameInfo_SetChannel();
			break;
		}
		case TAG_APIACTION_SETGAMEINFO_UPDATE_SERVERID : {
			ApiAction::SetGameInfo_UpdateServerId();
			break;
		}
		case TAG_APIACTION_SETGAMEINFO_UPDATE_GAMELANGUAGE : {
			ApiAction::SetGameInfo_UpdateGameLanguage();
			break;
		}
        case TAG_APIACTION_SETGAMEINFO_SEND_DATA : {
            ApiAction::SetGameInfo_SendData();
            break;
        }
		// InAppV4 (HIVE 1.18.4)
		case TAG_APIACTION_INAPPV4_ITEMINFO : {
			ApiAction::InappV4_ItemInfo();
			break;
		}
		case TAG_APIACTION_INAPPV4_PURCHASE : {
			ApiAction::InappV4_Purchase();
			break;
		}
		case TAG_APIACTION_INAPPV4_RESTORE : {
			ApiAction::InappV4_Restore();
			break;
		}
		case TAG_APIACTION_INAPPV4_TRANSACTION_FINISH : {
			ApiAction::InappV4_TransactionFinish();
			break;
		}
		case TAG_APIACTION_INAPPV4_GET_SELECTED_MARKET : {
			ApiAction::InappV4_GetSelectedMarket();
			break;
		}
		case TAG_APIACTION_INAPPV4_GET_ACCOUNT_UUID : {
			ApiAction::InappV4_GetAccountUuid();
			break;
		}
		case TAG_APIACTION_INAPPV4_MARKET_SELECT : {
			ApiAction::InappV4_MarketSelect();
			break;
		}
		case TAG_APIACTION_INAPPV4_REQUEST_BALANCE : {
			ApiAction::InappV4_RequestBalance();
			break;
		}
		case TAG_APIACTION_INAPPV4_CHARGE_BALANCE : {
			ApiAction::InappV4_ChargeBalance();
			break;
		}
		case TAG_APIACTION_INAPPV4_POSTBOX_LOGIN : {
			ApiAction::InappV4_PostBox_Login();
			break;
		}
		case TAG_APIACTION_INAPPV4_POSTBOX_SHOW : {
			ApiAction::InappV4_PostBox_Show();
			break;
		}
        case TAG_APIACTION_INAPPV4_CHECK_PROMOTE_PURCHASE : {
            ApiAction::InappV4_CheckPromotePurchase();
            break;
        }
		case TAG_APIACTION_INAPPV4_MARKETCONNECT : {
			ApiAction::InappV4_MarketConnect();
			break;
		}
		case TAG_APIACTION_INAPPV4_SHOW_INAPP_MESSAGES : {
			ApiAction::InappV4_ShowInAppMessages();
			break;
		}
		// POST BOX(HIVE 1.10.0)
		case TAG_APIACTION_HIVEIAP_POSTBOX : {
			ApiAction::HiveIAP_PostBox();
			break;
		}
		// GetBannerInfo (HIVE 1.18.3)
		case TAG_APIACTION_PROMOTION_GETBANNERINFO : {
			ApiAction::promotionBannerInfo();
			break;
		}
		case TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO : {
			ApiAction::HivePromotion_BannerInfo();
			break;
		}
		default : {
			log("### DataManager::getApiAction ---> error");
			break;
		}
	}
}

void DataManager::setParamValue_bool(int apiNum, std::string key, bool value)
{
	log("### DataManager::setParamValue_bool(..., ..., bool value)");
	switch(apiNum) {
		case TAG_APIACTION_INITIALIZE : {
			if(key == "useSandbox") {
				Parameter::paramInitialize.useSandbox = value;
			}else if(key == "useStaging") {
                Parameter::paramInitialize.useStaging = value;
            }else if(key == "useDevelop") {
                Parameter::paramInitialize.useDevelop = value;
            }else if(key == "showLog") {
				Parameter::paramInitialize.showLog = value;
			}else if(key == "permissionWriteExternalStorage") {
				Parameter::paramInitialize.permissionWriteExternalStorage = value;
			}else if(key == "loginState") {
				Parameter::paramInitialize.loginState = value;
			}else if(key == "showNotice") {
				Parameter::paramInitialize.showNotice = value;
			}else if(key == "HIVEIAP") {
				Parameter::paramInitialize.HIVEIAP = value;
			}else if(key == "useOneStore") {
				Parameter::paramInitialize.useOneStore = value;
			}else if(key == "HivePromotion") {			// HIVE 1.12.0
				Parameter::paramInitialize.hivePromotion = value;
			}else if(key == "useGalaxyStore") {			// HIVE 1.17.2
				Parameter::paramInitialize.useGalaxyStore = value;
			}else if(key == "showPermissionView") {		// HIVE 1.17.2
				Parameter::paramInitialize.showPermissionView = value;
			}else if(key == "useImageBanner") {			// HIVE 1.18.1
				Parameter::paramInitialize.useImageBanner = value;
			}else if(key == "useInappV4") {			// HIVE 1.18.4
				Parameter::paramInitialize.useInappV4 = value;
			}else if(key == "useHercules") {	// Hive 1.20.2
				Parameter::paramInitialize.useHercules = value;
			}
			break;
		}case TAG_APIACTION_LOGIN : {
			if(key == "callState") {
				Parameter::paramLogin.callState = value;
			}
			break;
		}
		// ParameterListScene
		case TAG_APIACTION_PUSHDESCRIPTION : {
			if(key == "usePush") {
				Parameter::paramPushDescription.usePush = value;
				log("setParamValue_bool usePush : %d", value);
			}else if(key == "sound") {
				Parameter::paramPushDescription.sound = value;
				log("setParamValue_bool sound : %d", value);
			}else if(key == "vibrate") {
				Parameter::paramPushDescription.vibrate = value;
				log("setParamValue_bool vibrate : %d", value);
			}else if(key == "operationGCM") {
				Parameter::paramPushDescription.operationGCM = value;
				log("setParamValue_bool operationGCM : %d", value);
			}else if(key == "operationLocal") {
				Parameter::paramPushDescription.operationLocal = value;
				log("setParamValue_bool operationLocal : %d", value);
			}else if(key == "useNotice") {
				Parameter::paramPushDescription.useNotice = value;
				log("setParamValue_bool useNotice : %d", value);
			}else if(key == "useNight") {
				Parameter::paramPushDescription.useNight = value;
				log("setParamValue_bool useNight : %d", value);
			}
			break;
		}case TAG_APIACTION_PROMOTIONSHOW : {
			if(key == "forced") {
				Parameter::paramPromotionShow.forced = value;
			}else if(key == "useLegacyBanner") {		// added v1.18.1
				Parameter::paramPromotionShow.useLegacyBanner = value;
			}
			break;
		}case TAG_APIACTION_SNSMESSAGE : {
			if(key == "viduid") {
				Parameter::paramSnsMessage.viduid = value;
			}else if(key == "usePush") {
				Parameter::paramSnsMessage.usePush = value;
			}else if(key == "invite") {
				Parameter::paramSnsMessage.invite = value;
			}
			break;
		}case TAG_APIACTION_PREPARE : {
			if(key == "showLog") {
				Parameter::paramInappPrepare.showLog = value;
			}else if(key == "autoVerify") {
				Parameter::paramInappPrepare.autoVerify = value;
			}
			break;
		}case TAG_APIACTION_INAPPPURCHASE : {
			if(key == "Restore") {
				Parameter::paramInappPurchase.Restore = value;
			}else if(key == "Finish") {
				Parameter::paramInappPurchase.Finish = value;
			}
			break;
		}case TAG_APIACTION_INAPPFINISH : {
			if(key == "isPurchaseSuccess") {
				Parameter::paramInappFinish.isPurchaseSuccess = value;
			}
			break;
		}case TAG_APIACTION_SETENABLE : {
			if(key == "MAT") {
				Parameter::paramTrackerSetEnable.MAT = value;
			} else if (key == "Adjust") {
				Parameter::paramTrackerSetEnable.Adjust = value;
			} else if(key == "Partytrack") {
				Parameter::paramTrackerSetEnable.Partytrack = value;
			} else if(key == "Singular") {
				Parameter::paramTrackerSetEnable.Singular = value;
			} else if(key == "AppsFlyer") {
                Parameter::paramTrackerSetEnable.AppsFlyer = value;
            }
			break;
		}case TAG_APIACTION_USERACQUISITION : {	// add(HIVE 1.9.0)
			if(key == "vidoruid") {
				Parameter::paramPromotionAcquisition.vidoruid = value;
			} else if (key == "usePush") {
				Parameter::paramPromotionAcquisition.usePush = value;
			} else if(key == "invite") {
				Parameter::paramPromotionAcquisition.invite = value;
			} else if(key == "linkShare") {
				Parameter::paramPromotionAcquisition.linkShare = value;
			}
			break;
		}case TAG_APIACTION_HIVEPROMOTION_SHOW : {	// add(HIVE 1.12.0)
			if(key == "forced") {
				Parameter::paramHivePromotion.forced = value;
			}
			break;
		}case TAG_APIACTION_SETGAMEINFO_SETGAMEINFO : {	// Hive KS 1.19.4
			if(key == "emergencyMode") {
				Parameter::paramInitialize.setGameInfo_emergencyMode = value;
			}
			break;
		}

		default : {
			log("### DataManager::setParamValue(bool) ---> error");
			break;
		}
	}
}

void DataManager::setParamValue_int(int apiNum, std::string key, int value)
{
	log("### DataManager::setParamValue_int(..., ..., int value)");
	switch(apiNum) {
		// ParameterListScene
		case TAG_APIACTION_PUSHREGISTER : {
			if(key == "pushId") {
				Parameter::paramPushRegister.pushId = value;
			}
			else if(key == "after") {
				Parameter::paramPushRegister.after = value;
			}
			break;
		}case TAG_APIACTION_PUSHUNREGISTER : {
			if(key == "pushId") {
				Parameter::paramPushUnregister.pushId = value;
			}
			break;
		}case TAG_APIACTION_PUSHDESCRIPTION : {
			if(key == "usePush") {
				Parameter::paramPushDescription.usePushInt = value;
			} else if(key == "sound") {
				Parameter::paramPushDescription.soundInt = value;
			} else if(key == "vib") {
				Parameter::paramPushDescription.vibInt = value;
			} else if(key == "operGcm") {
				Parameter::paramPushDescription.operGcmInt = value;
			} else if(key == "operLoc") {
				Parameter::paramPushDescription.operLocInt = value;
			} else if(key == "notice") {
				Parameter::paramPushDescription.noticeInt = value;
			} else if(key == "night") {
				Parameter::paramPushDescription.nightInt = value;
			}
			break;
		}case TAG_APIACTION_PROMOTIONINFO : {
			if(key == "viewId") {
				Parameter::paramPromotionInfo.viewId_int = value;
			}
			break;
		}case TAG_APIACTION_PROMOTIONSHOW : {
			if(key == "viewId") {
				Parameter::paramPromotionShow.viewId = value;
			}
			break;
		}case TAG_APIACTION_SNSFRIENDS : {
			if(key == "limit") {
				Parameter::paramSnsFriends.limit = value;
			}
			break;
		}case TAG_APIACTION_INAPPPURCHASE : {
			if(key == "quantity") {
				Parameter::paramInappPurchase.quantity = value;
			}
			break;
		}case TAG_APIACTION_SENDEVENT : {
			if(key == "itemCount") {
				Parameter::paramTrackerSendEvent.itemCount = value;
			}
			break;
		}case TAG_APIACTION_USERACQUISITION : {		// add (HIVE 1.9.0)
			if(key == "callState") {
				Parameter::paramPromotionAcquisition.callState = value;
			}
			break;
		}

		default : {
			log("### DataManager::setParamValue(int) ---> error");
			break;
		}
	}
}

void DataManager::setParamValue_string(int apiNum, std::string key, std::string value)
{
	log("### DataManager::setParamValue_string(..., ..., std::string value)");
	switch(apiNum) {
		// ParameterListScene
		case TAG_APIACTION_INITIALIZE : {
			if(key == "serverId") {
				Parameter::paramInitialize.serverId = value;
			}else if(key == "appId") {
				Parameter::paramInitialize.appId = value;
			}else if(key == "country") {
				Parameter::paramInitialize.country = value;
			}else if(key == "language") {
				Parameter::paramInitialize.language = value;
			}else if(key == "inquiry") {
				Parameter::paramInitialize.inquiry = value;
			}else if(key == "gameLanguage") {
				Parameter::paramInitialize.gameLanguage = value;
			}else if(key == "timeoutSeconds") {
				Parameter::paramInitialize.timeoutSeconds = value;
			}else if(key == "vid") {
				Parameter::paramInitialize.setGameInfo_vid = value;
			}else if(key == "hiveOrientation") {
				Parameter::paramInitialize.hiveOrientation = value;
			}else if(key == "facebookPermissions") {
				Parameter::paramInitialize.facebookPermissions = value;
			}else if(key == "channel") {
				Parameter::paramInitialize.channel = value;
			}
			break;
		}case TAG_APIACTION_LOGIN : {
			if(key == "selectedVid") {
				Parameter::paramLogin.selectedVid = value;
			}else if(key == "guestVid") {
				Parameter::paramLogin.hoolaiVid = value;
			}else if(key == "guestSessionToken") {
				Parameter::paramLogin.hoolaiSessionKey = value;
			}else if(key == "selectLoginInfo") {
				Parameter::paramLogin.selectLoginInfo = value;
			}else if(key == "uid") {
				Parameter::paramLogin.uid = value;
			}else if(key == "vid") {
				Parameter::paramLogin.vid = value;
			}else if(key == "getLoginType") {
				Parameter::paramLogin.getLoginType = value;
			}
			break;
		}case TAG_APIACTION_PUSHREGISTER : {
			if(key == "title") {
				Parameter::paramPushRegister.title = value;
			}else if(key == "message") {
				Parameter::paramPushRegister.message = value;
			}else if(key == "type") {
				Parameter::paramPushRegister.type = value;
			}else if(key == "groupId") {
				Parameter::paramPushRegister.groupId = value;
			}
			break;
		}case TAG_APIACTION_SNSUSER : {
			if(key == "vid") {
				Parameter::paramSnsUser.vid = value;
			}else if(key == "facebookId") {
				Parameter::paramSnsUser.facebookId = value;
			}else if(key == "callState") {
				Parameter::paramSnsUser.callState = value;
			}
			break;
//		}case TAG_APIACTION_SNSUSER_DELETE : {
//			//
//			break;
		}case TAG_APIACTION_SNSPOSTING : {
			if(key == "service") {
				Parameter::paramSnsPosting.service = value;
			}else if(key == "message") {
				Parameter::paramSnsPosting.message = value;
			}else if(key == "title") {
				Parameter::paramSnsPosting.title = value;
			}else if(key == "image") {
				Parameter::paramSnsPosting.image = value;
			}else if(key == "appLinkURL") {
				Parameter::paramSnsPosting.appLinkURL = value;
			}
			break;
		}case TAG_APIACTION_PROMOTIONSHOW : {
			if(key == "type") {
				Parameter::paramPromotionShow.type = value;
			}
			break;
		}case TAG_APIACTION_PROMOTIONINFO : {
			if(key == "type") {
				Parameter::paramPromotionInfo.type = value;
			}else if(key == "viewId") {
				Parameter::paramPromotionInfo.viewId_string = value;
			}else if(key == "callState") {
				Parameter::paramPromotionInfo.callState = value;
			}
			break;
		}case TAG_APIACTION_SNSFRIENDS : {
			if(key == "type") {
				Parameter::paramSnsFriends.type = value;
			}else if(key == "service") {
				Parameter::paramSnsFriends.service = value;
			}else if(key == "callState") {
				Parameter::paramSnsFriends.callState = value;
			}
			break;
		}case TAG_APIACTION_SNSMESSAGE : {
			if(key == "service") {
				Parameter::paramSnsMessage.service = value;
			}else if(key == "type") {
				Parameter::paramSnsMessage.type = value;
			}else if(key == "message") {
				Parameter::paramSnsMessage.message = value;
			}else if(key == "vid") {
				Parameter::paramSnsMessage.vid = value;
			}else if(key == "imageURL") {
				Parameter::paramSnsMessage.imageURL = value;
			}else if(key == "thumbnailURL") {
				Parameter::paramSnsMessage.thumbnailURL = value;
			}else if(key == "callState") {
				Parameter::paramSnsMessage.callState = value;
			}
			break;
		}case TAG_APIACTION_SNSSESSION : {
			if(key == "service") {
				Parameter::paramSnsSession.service = value;
			}
			break;
		}case TAG_APIACTION_SNSSHOW : {
			if(key == "type") {
				Parameter::paramSnsShow.type = value;
			}else if(key == "additionalInfo") {					// HIVE 1.18.1
				Parameter::paramSnsShow.additionalInfo = value;
			}
			break;
		}case TAG_APIACTION_SOCIALSHOW : {
			if(key == "type") {
				Parameter::paramSocialShow.type = value;
			}
			break;
		}case TAG_APIACTION_SOCIALINFO : {
			if(key == "type") {
				Parameter::paramSocialInfo.type = value;
			}
			break;
		}case TAG_APIACTION_PREPARE : {
			if(key == "pidList") {
				Parameter::paramInappPrepare.pidList = value;
			}else if(key == "inappId") {
				Parameter::paramInappPrepare.inappId = value;
			}
			break;
		}case TAG_APIACTION_REQUESTBALANCE : {
			if(key == "uid") {
				Parameter::paramInappRequestBalance.uid = value;
			}
			break;
		}case TAG_APIACTION_INAPPPURCHASE : {
			if(key == "pid") {
				Parameter::paramInappPurchase.pid = value;
			}else if(key == "additionalInfo") {
				Parameter::paramInappPurchase.additionalInfo = value;
			}
			break;
		}case TAG_APIACTION_SENDEVENT : {
			if(key == "event") {
				Parameter::paramTrackerSendEvent.event = value;
			}else if(key == "title") {
				Parameter::paramTrackerSendEvent.title = value;
			}else if(key == "description") {
				Parameter::paramTrackerSendEvent.description = value;
			}else if(key == "currency") {
				Parameter::paramTrackerSendEvent.currency = value;
			}else if(key == "price") {
				Parameter::paramTrackerSendEvent.price = value;
			}
			break;
		}case TAG_APIACTION_USERACQUISITION : {	// add(HIVE 1.9.0)
			if(key == "gameWorld") {
				Parameter::paramPromotionAcquisition.gameWorld = value;
			}else if(key == "gameLanguage") {
				Parameter::paramPromotionAcquisition.gameLanguage = value;
			}else if(key == "vid") {
				Parameter::paramPromotionAcquisition.vid = value;
			}else if(key == "message") {
				Parameter::paramPromotionAcquisition.message = value;
			}else if(key == "imageURL") {
				Parameter::paramPromotionAcquisition.imageURL = value;
			}else if(key == "thumbnailURL") {
				Parameter::paramPromotionAcquisition.thumbnailURL = value;
			}else if(key == "linkShareURL") {
				Parameter::paramPromotionAcquisition.linkShareURL = value;
			}else if(key == "additionalInfo") {
				Parameter::paramPromotionAcquisition.addtionalInfo = value;
			}
			break;
		}case TAG_APIACTION_HIVEIAP_INFO : {	// HIVE 1.10.0  ==== HIVE IAP
			if(key == "locationCode") {
				Parameter::paramHiveIAPInfo.locationCode = value;
			}else if(key == "worldName") {
				Parameter::paramHiveIAPInfo.worldName = value;
			}else if(key == "gameLanguage") {
				Parameter::paramHiveIAPInfo.gameLanguage = value;
			}else if(key == "type") {
				Parameter::paramHiveIAPInfo.type = value;
			}
			break;
		}case TAG_APIACTION_HIVEIAP_SHOW : {
			if(key == "gameLanguage") {
				Parameter::paramHiveIAPShow.gameLanguage = value;
			}else if(key == "type") {
				Parameter::paramHiveIAPShow.type = value;
			}
			break;
		}case TAG_APIACTION_HIVEIAP_PURCHASE : {
			if(key == "pid") {
				Parameter::paramHiveIAPPurchase.pid = value;
			}else if(key == "additionalInfo") {
				Parameter::paramHiveIAPPurchase.additionalInfo = value;
			}
			break;
		}
		// Engagement ===== HIVE 1.10.0
		case TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON : {
			if(key == "couponId") {
				Parameter::paramEngageComsumeCoupon.couponId = value;
			}else if(key == "language") {
				Parameter::paramEngageComsumeCoupon.language = value;
			}else if(key == "additionalInfo") {
				Parameter::paramEngageComsumeCoupon.additionalInfo = value;
			}
			break;
		}
		// HIVE Promotion, HIVE 1.12.0
		case TAG_APIACTION_HIVEPROMOTION_SHOW : {
			if(key == "contentKey_view") {
				Parameter::paramHivePromotion.contentKey_view = value;
			}else if(key == "contentKey_board") {
				Parameter::paramHivePromotion.contentKey_board = value;
			}else if(key == "contentKey_spot") {
				Parameter::paramHivePromotion.contentKey_spot = value;
			}else if(key == "contentKey_direct") {
				Parameter::paramHivePromotion.contentKey_direct = value;
			}else if(key == "type") {
				Parameter::paramHivePromotion.type = value;
			}else if(key == "addtionalInfo") {
				Parameter::paramHivePromotion.additionalInfo = value;
			}
			break;
		}
		case TAG_APIACTION_HIVEPROMOTION_INFO : {
			if(key == "contentKey_view") {
				Parameter::paramHivePromotion.contentKey_view = value;
			}else if(key == "contentKey_board") {
				Parameter::paramHivePromotion.contentKey_board = value;
			}else if(key == "contentKey_spot") {
				Parameter::paramHivePromotion.contentKey_spot = value;
			}else if(key == "contentKey_direct") {
				Parameter::paramHivePromotion.contentKey_direct = value;
			}else if(key == "addtionalInfo") {
				Parameter::paramHivePromotion.additionalInfo = value;
			}else if(key == "type") {
				Parameter::paramHivePromotion.type = value;
			}
			break;
		}
		case TAG_APIACTION_PROMOTION_GETBANNERINFO : {	// HIVE 1.18.3
			if(key == "campaignType") {
				if(value == "g" || value == "great")
					Parameter::paramPromotionBannerInfo.campaignType = "great";
				else if(value == "s" || value == "small")
					Parameter::paramPromotionBannerInfo.campaignType = "small";
				else if(value == "r" || value == "rolling")
					Parameter::paramPromotionBannerInfo.campaignType = "rolling";
				else
					Parameter::paramPromotionBannerInfo.campaignType = value;
			} else if (key == "bannerType") {
				if(value == "a" || value == "all")
					Parameter::paramPromotionBannerInfo.bannerType = "all";
				else if(value == "e" || value == "event")
					Parameter::paramPromotionBannerInfo.bannerType = "event";
				else if(value == "n" || value == "notice")
					Parameter::paramPromotionBannerInfo.bannerType = "notice";
				else
					Parameter::paramPromotionBannerInfo.bannerType = value;
			}
			break;
		}
		case TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO : {	// HIVE 1.18.3
			if(key == "campaignType") {
				if(value == "g" || value == "great")
					Parameter::paramHivePromotionBannerInfo.campaignType = "great";
				else if(value == "s" || value == "small")
					Parameter::paramHivePromotionBannerInfo.campaignType = "small";
				else if(value == "r" || value == "rolling")
					Parameter::paramHivePromotionBannerInfo.campaignType = "rolling";
				else
					Parameter::paramHivePromotionBannerInfo.campaignType = value;
			} else if (key == "bannerType") {
				if(value == "a" || value == "all")
					Parameter::paramHivePromotionBannerInfo.bannerType = "all";
				else if(value == "e" || value == "event")
					Parameter::paramHivePromotionBannerInfo.bannerType = "event";
				else if(value == "n" || value == "notice")
					Parameter::paramHivePromotionBannerInfo.bannerType = "notice";
				else
					Parameter::paramHivePromotionBannerInfo.bannerType = value;
			}
			break;
		}
		case TAG_APIACTION_INAPPV4_ITEMINFO :
		case TAG_APIACTION_INAPPV4_PURCHASE :
		case TAG_APIACTION_INAPPV4_RESTORE :
		case TAG_APIACTION_INAPPV4_TRANSACTION_FINISH : {
		    if(key == "type")
		        Parameter::paramInAppV4.type = value;
		    else if(key == "pid")
		        Parameter::paramInAppV4.pid = value;
			else if(key == "iapPayload")
				Parameter::paramInAppV4.iapPayload = value;
		    break;
		}
        case TAG_APIACTION_SETGAMEINFO_SEND_DATA : {
            if(key == "funnelsId")
                Parameter::paramSendData.funnelsId = value;
            else if(key == "optionTag")
                Parameter::paramSendData.optionTag = value;
            break;
        }

            

		default : {
			log("### DataManager::setParamValue(std::string) ---> error");
			break;
		}
	}
}

void DataManager::setState(int sceneNum, std::string key, bool value)
{
	switch(sceneNum) {
		case TAG_SCENENUM_LOGIN_LIST : {
			if(key == "isHiveLogin") {
				Parameter::paramUIState.isHiveLogin = value;
			}else if(key == "isSelection") {
				Parameter::paramUIState.isSelection = value;
			}
			break;
		}
		default : {
			log("### DataManager::setState(std::string) ---> error");
			break;
		}
	}
}

void DataManager::setState_int(int sceneNum, std::string key, int value)
{
	// nothing
}

void DataManager::setState_string(int sceneNum, std::string key, std::string value)
{
	// nothing
}

void DataManager::setCurrentModule(int currentModule)
{
	Parameter::paramUIState.currentModuleListScene = currentModule;
}

void DataManager::setCurrentParameter(int currentParameter)
{
	Parameter::paramUIState.currentParameterListScene = currentParameter;
}

std::string DataManager::getParamValue(int apiNum, std::string key)
{
	std::stringstream value;
	switch(apiNum) {
		case TAG_APIACTION_INITIALIZE : {
			if(key == "authLoginType") {
				value << Parameter::paramInitialize.authLoginType;
			}else if(key == "useSandbox") {
				value << Parameter::paramInitialize.useSandbox;
			}else if(key == "useStaging") {
                value << Parameter::paramInitialize.useStaging;
            }else if(key == "useDevelop") {
                value << Parameter::paramInitialize.useDevelop;
            }else if(key == "serverId") {
				value << Parameter::paramInitialize.serverId;
			}else if(key == "appId") {
				value << Parameter::paramInitialize.appId;
			}else if(key == "did") {
				value << Parameter::paramInitialize.did;
			}else if(key == "gameLanguage") {							// HIVE 1.12.0
				value << Parameter::paramInitialize.gameLanguage;
			}else if(key == "timeoutSeconds") {							// HIVE 1.13.0
				value << Parameter::paramInitialize.timeoutSeconds;
			}else if(key == "vid") {									// HIVE 1.16.1
				value << Parameter::paramInitialize.setGameInfo_vid;
			}else if(key == "hiveOrientation") {
				value << Parameter::paramInitialize.hiveOrientation;	// Hive 1.19.6
			}else if(key == "facebookPermissions") {
				value << Parameter::paramInitialize.facebookPermissions;	// Hive 1.19.8
			}else if(key == "channel") {
				value << Parameter::paramInitialize.channel;	// Hive 1.20.3
			}
			break;
		}
		case TAG_APIACTION_LOGIN : {
			if(key == "vid") {
				value << Parameter::paramLogin.vid;
			}else if(key == "sessionToken") {
				value << Parameter::paramLogin.sessionToken;
			}else if(key == "uid") {
				value << Parameter::paramLogin.uid;
			}else if(key == "currentVid") {
				value << Parameter::paramLogin.select_currentVid;		// HIVE 1.10.1
			}else if(key == "usedVid") {
				value << Parameter::paramLogin.select_usedVid;			// HIVE 1.10.1
			}else if(key == "getLoginType") {
				value << Parameter::paramLogin.getLoginType;
			}else if(key == "selectLoginInfo") {
				value << Parameter::paramLogin.selectLoginInfo;
			}
			break;
		}
		case TAG_APIACTION_PUSHREGISTER : {
			if(key == "pushId") {
				value << Parameter::paramPushRegister.pushId;
			}else if(key == "title") {
				value << Parameter::paramPushRegister.title;
			}else if(key == "message") {
				value << Parameter::paramPushRegister.message;
			}else if(key == "after") {
				value << Parameter::paramPushRegister.after;
			}else if(key == "groupId") {
				value << Parameter::paramPushRegister.groupId;
			}
			break;
		}
		case TAG_APIACTION_PUSHUNREGISTER : {
			if(key == "pushId") {
				value << Parameter::paramPushUnregister.pushId;
			}
			break;
		}
		case TAG_APIACTION_SNSUSER : {
			if(key == "vid") {
				value << Parameter::paramSnsUser.vid;
			}else if(key == "facebookId") {
				value << Parameter::paramSnsUser.facebookId;
			}
			break;
		}
//		case TAG_APIACTION_SNSUSER_DELETE : {
//			break;
//		}
		case TAG_APIACTION_SNSPOSTING : {
			if(key == "message") {
				value << Parameter::paramSnsPosting.message;
			}else if(key == "title") {
				value << Parameter::paramSnsPosting.title;
			}else if(key == "image") {
				value << Parameter::paramSnsPosting.image;
			}else if(key == "appLinkURL") {
				value << Parameter::paramSnsPosting.appLinkURL;
			}
			break;
		}
		case TAG_APIACTION_PROMOTIONINFO : {
			if(key == "viewId") {
				value << Parameter::paramPromotionInfo.viewId_int;
			}
			break;
		}
		case TAG_APIACTION_SNSFRIENDS : {
			if(key == "limit") {
				value << Parameter::paramSnsFriends.limit;
			}
			break;
		}
		case TAG_APIACTION_SNSMESSAGE : {
			if(key == "message") {
				value << Parameter::paramSnsMessage.message;
			}else if(key == "vid") {
				value << Parameter::paramSnsMessage.vid;
			}else if(key == "imageURL") {
				value << Parameter::paramSnsMessage.imageURL;
			}else if(key == "thumbnailURL") {
				value << Parameter::paramSnsMessage.thumbnailURL;
			}
			break;
		}
		case TAG_APIACTION_PROMOTIONSHOW : {
			if(key == "viewId") {
				value << Parameter::paramPromotionShow.viewId;
			}
			break;
		}
		case TAG_APIACTION_PREPARE : {
			if(key == "pidList") {
				value << Parameter::paramInappPrepare.pidList;
			}else if(key == "inappId") {
				value << Parameter::paramInappPrepare.inappId;
			}
			break;
		}
		case TAG_APIACTION_REQUESTBALANCE : {
			if(key == "uid") {
				value << Parameter::paramInappRequestBalance.uid;
			}
			break;
		}
		case TAG_APIACTION_INAPPPURCHASE : {
			if(key == "pid") {
				value << Parameter::paramInappPurchase.pid;
			}else if(key == "quantity") {
				value << Parameter::paramInappPurchase.quantity;
			}else if(key == "addtionalInfo") {
				value << Parameter::paramInappPurchase.additionalInfo;
			}
			break;
		}
		case TAG_APIACTION_SNSSHOW : {
			if(key == "uid") {
				value << Parameter::paramSnsShow.uid;
			}else if(key == "additionalInfo") {
				value << Parameter::paramSnsShow.additionalInfo;		// HIVe 1.18.1
			}
			break;
		}
		case TAG_APIACTION_SOCIALSHOW : {				// HIVE 1.10.0
			if(key == "gameLanguage") {
				value << Parameter::paramSocialShow.gameLanguage;
			}
			break;
		}
		case TAG_APIACTION_SOCIALINFO : {				// HIVE 1.10.0
			if(key == "type") {
			    value << Parameter::paramSocialInfo.type;
			}
			break;
		}
		case TAG_APIACTION_SENDEVENT : {
			if(key == "event") {
				value << Parameter::paramTrackerSendEvent.event;
			}else if(key == "title") {
				value << Parameter::paramTrackerSendEvent.title;
			}else if(key == "description") {
				value << Parameter::paramTrackerSendEvent.description;
			}else if(key == "currency") {
				value << Parameter::paramTrackerSendEvent.currency;
			}else if(key == "price") {
				value << Parameter::paramTrackerSendEvent.price;
			}else if(key == "itemCount") {
				value << Parameter::paramTrackerSendEvent.itemCount;
			}
			break;
		}
		case TAG_APIACTION_USERACQUISITION : {
			if(key == "qrcode") {
				value << Parameter::paramPromotionAcquisition.qrcode;
			} else if(key == "gameWorld") {
				value << Parameter::paramPromotionAcquisition.gameWorld;
			} else if(key == "gameLanguage") {
				value << Parameter::paramPromotionAcquisition.gameLanguage;
			} else if(key == "vid") {
				value << Parameter::paramPromotionAcquisition.vid;
			} else if(key == "message") {
				value << Parameter::paramPromotionAcquisition.message;
			} else if(key == "imageURL") {
				value << Parameter::paramPromotionAcquisition.imageURL;
			} else if(key == "thumbnailURL") {
				value << Parameter::paramPromotionAcquisition.thumbnailURL;
			} else if(key == "linkShareURL") {
				value << Parameter::paramPromotionAcquisition.linkShareURL;
			} else if(key == "additionalInfo") {		// HIVE 1.13.0
				value << Parameter::paramPromotionAcquisition.addtionalInfo;
			}
			break;
		}
		case TAG_APIACTION_HIVEIAP_INFO : {
			if(key == "locationCode") {
				value << Parameter::paramHiveIAPInfo.locationCode;
			}else if(key == "worldName") {
				value << Parameter::paramHiveIAPInfo.worldName;
			}else if(key == "gameLanguage") {
				value << Parameter::paramHiveIAPInfo.gameLanguage;
			}
			break;
		}
		case TAG_APIACTION_HIVEIAP_SHOW : {
			if(key == "gameLanguage") {
				value << Parameter::paramHiveIAPShow.gameLanguage;
			}
			break;
		}
		case TAG_APIACTION_HIVEIAP_PURCHASE : {
			if(key == "pid") {
				value << Parameter::paramHiveIAPPurchase.pid;
			}else if(key == "additionalInfo") {
				value << Parameter::paramHiveIAPPurchase.additionalInfo;
			}
			break;
		}
		case TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON : {
			if(key == "couponId") {
				value << Parameter::paramEngageComsumeCoupon.couponId;
			}else if(key == "language") {
				value << Parameter::paramEngageComsumeCoupon.language;
			}else if(key == "additionalInfo") {
				value << Parameter::paramEngageComsumeCoupon.additionalInfo;
			}
			break;
		}
		case TAG_APIACTION_HIVEPROMOTION_SHOW : {		// HIVE 1.12.0
			if(key == "contentKey_view") {
				value << Parameter::paramHivePromotion.contentKey_view;
			}else if(key == "contentKey_board") {
				value << Parameter::paramHivePromotion.contentKey_board;
			}else if(key == "contentKey_spot") {
				value << Parameter::paramHivePromotion.contentKey_spot;
			}else if(key == "contentKey_direct") {
				value << Parameter::paramHivePromotion.contentKey_direct;
			}else if(key == "addtionalInfo") {
				value << Parameter::paramHivePromotion.additionalInfo;
			}
			break;
		}
		case TAG_APIACTION_HIVEPROMOTION_INFO : {		// HIVE 1.12.0
			if(key == "contentKey_view") {
				value << Parameter::paramHivePromotion.contentKey_view;
			}else if(key == "contentKey_board") {
				value << Parameter::paramHivePromotion.contentKey_board;
			}else if(key == "contentKey_spot") {
				value << Parameter::paramHivePromotion.contentKey_spot;
			}else if(key == "contentKey_direct") {
				value << Parameter::paramHivePromotion.contentKey_direct;
			}else if(key == "additionalInfo") {
				value << Parameter::paramHivePromotion.additionalInfo;
			}
			break;
		}
		case TAG_APIACTION_PROMOTION_GETBANNERINFO : {	// HIVE 1.18.3
			if(key == "campaignType") {
				value << Parameter::paramPromotionBannerInfo.campaignType;
			} else if (key == "bannerType") {
				value << Parameter::paramPromotionBannerInfo.bannerType;
			}
			break;
		}
		case TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO : {	// HIVE 1.18.3
			if(key == "campaignType") {
				value << Parameter::paramHivePromotionBannerInfo.campaignType;
			} else if (key == "bannerType") {
				value << Parameter::paramHivePromotionBannerInfo.bannerType;
			}
			break;
		}
		case TAG_APIACTION_INAPPV4_ITEMINFO : {		// HIVE 1.18.4
			if(key == "type")
				value << Parameter::paramInAppV4.type;
			break;
		}
		case TAG_APIACTION_INAPPV4_PURCHASE : {		// HIVE 1.18.4
			if(key == "type")
				value << Parameter::paramInAppV4.type;
			else if(key == "pid")
				value << Parameter::paramInAppV4.pid;
			else if(key == "iapPayload")
				value << Parameter::paramInAppV4.iapPayload;
			break;
		}
		case TAG_APIACTION_INAPPV4_RESTORE : {		// HIVE 1.18.4
			if(key == "type")
				value << Parameter::paramInAppV4.type;
			break;
		}
		case TAG_APIACTION_INAPPV4_TRANSACTION_FINISH : {	// HIVE 1.18.4
			if(key == "pid")
				value << Parameter::paramInAppV4.pid;
			break;
		}
		case TAG_APIACTION_INAPPV4_SHOW_INAPP_MESSAGES : {
			if(key == "categoryId")
				value << Parameter::paramInAppV4.categoryId;
			break;
		}
        case TAG_APIACTION_SETGAMEINFO_SEND_DATA : {
            if (key == "funnelsId")
                value << Parameter::paramSendData.funnelsId;
            else if (key == "optionTag")
                value << Parameter::paramSendData.optionTag;
            break;
        }
		default : {
			log("### DataManager::getParamValue(std::string) ---> error");
			break;
		}
	}

	std::string returnValue = value.str();
	return returnValue;
}

bool DataManager::getParamValue_bool(int apiNum, std::string key)
{
	bool value;
	switch(apiNum) {
		case TAG_APIACTION_INITIALIZE : {
			if(key == "showLog") {
				value = Parameter::paramInitialize.showLog;
			}else if(key == "permissionWriteExternalStorage") {
				value = Parameter::paramInitialize.permissionWriteExternalStorage;
			}else if(key == "loginState") {
				value = Parameter::paramInitialize.loginState;
			}else if(key == "useSandbox") {
				value = Parameter::paramInitialize.useSandbox;
			}else if(key == "useStaging") {
				value = Parameter::paramInitialize.useStaging;
			}else if(key == "useDevelop") {
                value = Parameter::paramInitialize.useDevelop;
            }else if(key == "showNotice") {
				value = Parameter::paramInitialize.showNotice;
			}else if(key == "HIVEIAP") {
				value = Parameter::paramInitialize.HIVEIAP;
			}else if(key == "useOneStore") {
				value = Parameter::paramInitialize.useOneStore;
			}else if(key == "HivePromotion") {			// HIVE 1.12.0
				value = Parameter::paramInitialize.hivePromotion;
			}else if(key == "useGalaxyStore") {
				value = Parameter::paramInitialize.useGalaxyStore;
			}else if(key == "showPermissionView") {
				value = Parameter::paramInitialize.showPermissionView;
			}else if(key == "useImageBanner") {			// HIVE 1.18.1
				value = Parameter::paramInitialize.useImageBanner;
			}else if(key == "useInappV4") {				// HIVE 1.18.4
				value = Parameter::paramInitialize.useInappV4;
			}else if(key == "useHercules") {		// Hive 1.20.2
				value = Parameter::paramInitialize.useHercules;
			}
			break;
		}case TAG_APIACTION_LOGIN : {
			if(key == "callState") {
				value = Parameter::paramLogin.callState;
			}
			break;
		}case TAG_APIACTION_PUSHDESCRIPTION : {
			if(key == "usePush") {
				value = Parameter::paramPushDescription.usePush;
				log(" *** usePush value test : %d", value);
			}else if(key == "sound") {
				value = Parameter::paramPushDescription.sound;
//				log(" *** sound value test : %d", value);
			}else if(key == "vibrate") {
				value = Parameter::paramPushDescription.vibrate;
//				log(" *** vibrate value test : %d", value);
			}else if(key == "operationGCM") {
				value = Parameter::paramPushDescription.operationGCM;
//				log(" *** operationGCM value test : %d", value);
			}else if(key == "operationLocal") {
				value = Parameter::paramPushDescription.operationLocal;
//				log(" *** operationLocal value test : %d", value);
			}else if(key == "useNotice") {
				value = Parameter::paramPushDescription.useNotice;
//				log(" *** useNotice value test : %d", value);
			}else if(key == "useNight") {
				value = Parameter::paramPushDescription.useNight;
//				log(" *** useNight value test : %d", value);
			}
			break;
		}case TAG_APIACTION_SNSMESSAGE : {
			if(key == "viduid") {
				value = Parameter::paramSnsMessage.viduid;
			}else if(key == "usePush") {
				value = Parameter::paramSnsMessage.usePush;
			}else if(key == "invite") {
				value = Parameter::paramSnsMessage.invite;
			}
			break;
		}case TAG_APIACTION_PREPARE : {
			if(key == "showLog") {
				value = Parameter::paramInappPrepare.showLog;
			}else if(key == "autoVerify") {
				value = Parameter::paramInappPrepare.autoVerify;
			}
			break;
		}case TAG_APIACTION_INAPPPURCHASE : {
			if(key == "Restore") {
				value = Parameter::paramInappPurchase.Restore;
			}else if(key == "Finish") {
				value = Parameter::paramInappPurchase.Finish;
			}
			break;
		}case TAG_APIACTION_INAPPFINISH : {
			if(key == "isPurchaseSuccess") {
				value = Parameter::paramInappFinish.isPurchaseSuccess;
			}
			break;
		}
		case TAG_APIACTION_SETENABLE : {
			if(key == "MAT") {
				value = Parameter::paramTrackerSetEnable.MAT;
			}else if(key == "Adjust") {
				value = Parameter::paramTrackerSetEnable.Adjust;
			}else if(key == "Partytrack") {
				value = Parameter::paramTrackerSetEnable.Partytrack;
			}else if(key == "Singular") {
				value = Parameter::paramTrackerSetEnable.Singular;
			}else if(key == "AppsFlyer") {
                value = Parameter::paramTrackerSetEnable.AppsFlyer;
            }
			break;
		}
		case TAG_APIACTION_USERACQUISITION : {
			if(key == "vidoruid") {
				value = Parameter::paramPromotionAcquisition.vidoruid;
			}else if(key == "usePush") {
				value = Parameter::paramPromotionAcquisition.usePush;
			}else if(key == "invite") {
				value = Parameter::paramPromotionAcquisition.invite;
			}else if(key == "linkShare") {
				value = Parameter::paramPromotionAcquisition.linkShare;
			}
			break;
		}
		// API_ACTION과 관계없는 태그, TAG_SCENENUM_LOGIN_LIST 태그 활용
		case TAG_SCENENUM_LOGIN_LIST : {
			if(key == "isHiveLogin") {
				value = Parameter::paramUIState.isHiveLogin;
			}else if(key == "isSelection") {
				value = Parameter::paramUIState.isSelection;
			}
			break;
		}
		case TAG_APIACTION_HIVEPROMOTION_SHOW : {		// HIVE 1.12.0
			if(key == "forced") {
				value = Parameter::paramHivePromotion.forced;
			}
			break;
		}
		case TAG_APIACTION_PROMOTION_FULLBANNER_USE_LEGACY_BANNER : {		// HIVE 1.18.1
			if(key == "useLegacyBanner") {
				value = Parameter::paramHivePromotion.forced;
			}
			break;
		}
		case TAG_APIACTION_SETGAMEINFO_SETGAMEINFO : {	// Hive KS 1.19.4
			if(key == "emergencyMode") {
				value = Parameter::paramInitialize.setGameInfo_emergencyMode;
			}
			break;
		}
		default : {
			log("### DataManager::getParamValue(bool) ---> error");
			break;
		}
	}
	return value;
}

int DataManager::getCurrentModule()
{
	return Parameter::paramUIState.currentModuleListScene;
}

int DataManager::getCurrentParameter()
{
	return Parameter::paramUIState.currentParameterListScene;
}

std::string DataManager::getAppId(int appIdNum)
{
	std::string value = "";
	switch(appIdNum) {
		case 1 : {
			value = Parameter::paramAppId.appId_01;
			break;
		}case 2 : {
			value = Parameter::paramAppId.appId_02;
			break;
		}case 3 : {
			value = Parameter::paramAppId.appId_03;
			break;
		}
		default : {
			log("### DataManager::getAppId --> no appId");
			break;
		}
	}
	return value;
}

// string parsing : string split with string delimiter , HIVE 1.9.0
std::vector<std::string> DataManager::splitString(std::string input, std::string separator)
{
	std::vector<std::string> lst;

	while(true) {
		int index = input.find(separator);
		if(index != std::string::npos) {
			if(index == 0)
				continue;
			lst.push_back(input.substr(0, index));
		} else {
			lst.push_back(input);
			break;
		}
		input = input.substr(index+separator.size());
	}

	return lst;
}

// string parsing : connect string list , HIVE 1.9.0
std::string DataManager::connectString(std::vector<std::string> dataList)
{
	std::string str = "";
	for(int i = 0; i < dataList.size(); i++) {
		str += dataList[i];
	}
	return str;
}

// for QRcode : convert HexString to Bytes , HIVE 1.9.0
std::vector<unsigned char> DataManager::convertHexStringToBytes(std::string hexStr)
{
	std::stringstream ss;
	std::vector<unsigned char> hexCh;
	unsigned int buffer;
	int offset = 0;
	while (offset < hexStr.length()) {
	   ss.clear();
	   ss << std::hex << hexStr.substr(offset, 2);
	   ss >> buffer;
	   hexCh.push_back(static_cast<unsigned char>(buffer));
	   offset += 2;
	}
	return hexCh;
}

// HIVE 1.9.0
void DataManager::switchDisplayQRcode(bool displaySwitch)
{
	ModuleListScene::isDisplayedQRcode = displaySwitch;
}

