//#include "AppDelegate.h"
#include "InitListScene.h"
#include "InitParameterScene.h"
#include "LoginListScene.h"
#include "DataManager.h"
#include "AboutUsScene.h"
#include "Parameter.h"
#include "LogController.h"

#ifdef __ANDROID__
#include "JNISample.h"
#endif

USING_NS_CC;

float InitListScene::ui_mainBtnScale = 0.5f;
float InitListScene::ui_settingBtnScale = 0.45f;
float InitListScene::ui_paddingSize = 0.02;
float InitListScene::ui_mainBtns_x = 0.5;
float InitListScene::ui_mainBtns_y = 0.5;
float InitListScene::ui_cbTypeBtn_x = 0.5;
float InitListScene::ui_cbTypeBtn_y = 0.1;
float InitListScene::ui_settingBtn_x = 0.9;
float InitListScene::ui_settingBtn_y = 0.95;
float InitListScene::ui_paddingSize_y = 0.06;
float InitListScene::ui_paramLabel_y = 0.75;
float InitListScene::ui_textField_x = 0.75;
float InitListScene::ui_paramLabel_x = 0.3;
float InitListScene::ui_loginServerTypeLabel_x = 0.4;
float InitListScene::ui_loginServerTypeLabel_y = 0.95;

// static variable( textfield )
bool InitListScene::isFocusedTextField = false;
int InitListScene::focusedTextFieldState = 0;
CCRect InitListScene::tfArea_vid_sessionKey;

//extern "C" {
extern "C" const char* getHiveSdkVersion();
extern "C" const char* getAppVersion();
extern "C" const char* getCurrentTime();
//}

Scene* InitListScene::createScene() {
	auto scene = Scene::create();
	auto layer = InitListScene::create();
	scene->addChild(layer);
	return scene;
}

bool InitListScene::init()
{
	if (!LayerColor::initWithColor(Color4B(255, 255, 255, 255))) {
		return false;
	}

	Size visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	log("### InitListScene : init() ###");
	log("### Current ScreanSize ==>\nvisible.width : %f, visible.height : %f #####",
			visibleSize.width, visibleSize.height);

	// layer 생성
	this->setColor(Color3B(255, 255, 255));
	
	this->setContentSize(Size(visibleSize.width, visibleSize.height));
	this->setTag(TAG_LAYER_INIT_LIST); //-> 지워도 될듯
//	this->addChild(layer);

	// button 생성 ( 메인 버튼 )
	log("### InitListScene : create main buttons ###");
	auto btns_main = Menu::create(
			InitListScene::createButtons(TAG_BTN_INIT_LIST_SANDBOX),
			InitListScene::createButtons(TAG_BTN_INIT_LIST_LIVE_SERVER),
            InitListScene::createButtons(TAG_BTN_INIT_LIST_STAGING),
			InitListScene::createButtons(TAG_BTN_INIT_LIST_GUESTUSERINFOSET),
			InitListScene::createButtons(TAG_BTN_INIT_LIST_REQUESTPERMISSION),
			InitListScene::createButtons(TAG_BTN_INIT_LIST_REQUESTPERMISSIONDATA),
			NULL);
	btns_main->alignItemsVerticallyWithPadding(visibleSize.height * InitListScene::ui_paddingSize);
//	btns_main->setPosition(
//			visibleSize.width * InitListScene::ui_mainBtns_x,
//			visibleSize.height * InitListScene::ui_mainBtns_y);
	this->addChild(btns_main);

	// toggle 생성 ( 콜백 타입 버튼 )
//	log("### InitListScene : create callback type toggle buttons ###");
//	auto btn_cb = Menu::create(
//			InitListScene::createToggleButtons(TAG_BTN_INIT_LIST_CALLBACKTYPE),
//			NULL);
//	btn_cb->setPosition(
//			visibleSize.width * InitListScene::ui_cbTypeBtn_x,
//			visibleSize.height * InitListScene::ui_cbTypeBtn_y);
//	layer->addChild(btn_cb);

	// button 생성 ( 세팅 버튼 )
	log("### InitListScene : create setting button ###");
	auto btn_setting = Menu::create(
			InitListScene::createButtons(TAG_BTN_INIT_LIST_SETTING),
			NULL);
	btn_setting->setPosition(
			visibleSize.width * InitListScene::ui_settingBtn_x,
			visibleSize.height * InitListScene::ui_settingBtn_y);
	this->addChild(btn_setting);

	// label 생성 (훌라이 관련 vid, sessionKey), HIVE 1.10.1
	InitListScene::update_labels();

	// textfield 생성 (훌라이 관련 vid, sessionKey 활용), HIVE 1.10.1
	InitListScene::update_textFields();

	// 상단에 버전 표시.
	InitListScene::update_labels_appVersion();

	// SceneChecker
	Parameter::paramSceneChecker.sceneState = 0;

	return true;
}

MenuItemImage* InitListScene::createButtons(int tag)
{
	auto btn = MenuItemImage::create();

	switch(tag) {
		case TAG_BTN_INIT_LIST_SANDBOX : {
			btn = MenuItemImage::create(
					"btn_InitListScene_Sandbox_normal.png", "btn_InitListScene_Sandbox_clicked.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			btn->setScale(0.7f);
			//btn->setScale(InitListScene::ui_mainBtnScale);
			break;
		}
		case TAG_BTN_INIT_LIST_LIVE_SERVER : {
			btn = MenuItemImage::create(
					"btn_InitListScene_LiveServer_normal.png", "btn_InitListScene_LiveServer_clicked.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			btn->setScale(0.7f);
			//btn->setScale(InitListScene::ui_mainBtnScale);
			break;
		}
		case TAG_BTN_INIT_LIST_STAGING : {          // for staging
            btn = MenuItemImage::create(
                    "btn_InitListScene_Staging_normal.png", "btn_InitListScene_Staging_clicked.png",
                    CC_CALLBACK_1(InitListScene::buttonEvent, this));
            btn->setScale(0.7f);
            //btn->setScale(InitListScene::ui_mainBtnScale);
            break;
        }
		case TAG_BTN_INIT_LIST_SETTING : {
			btn = MenuItemImage::create(
					"btn_setting_normal.png", "btn_setting_clicked.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			btn->setScale(0.9f);
			break;
		}
		case TAG_BTN_INIT_LIST_GUESTUSERINFOSET : {
			btn = MenuItemImage::create(
					"btn_InitListScene_SetGuestUserInfo_normal.png", "btn_InitListScene_SetGuestUserInfo_clicked.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			btn->setScale(0.7f);
			break;
		}case TAG_BTN_INIT_LIST_REQUESTPERMISSION : {
			btn = MenuItemImage::create(
					"btn_InitListScene_requestPermission_normal.png", "btn_InitListScene_requestPermission_clicked.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			btn->setScale(0.7f);
			break;
		}case TAG_BTN_INIT_LIST_REQUESTPERMISSIONDATA : {		// added HIVE 1.17.0
			btn = MenuItemImage::create(
					"btn_MListScene_SocialInfo_PermissionData_normal.png", "btn_MListScene_SocialInfo_PermissionData_clicked.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			btn->setScale(0.7f);
			break;
		}case TAG_BTN_INIT_LIST_ABOUTUS : {
			btn = MenuItemImage::create(
					"aboutus_normal.png", "aboutus_clicked.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			btn->setScale(0.7f);
			break;
		}
		default : {
			btn = MenuItemImage::create(
					"btn_error.png", "btn_error.png",
					CC_CALLBACK_1(InitListScene::buttonEvent, this));
			break;
		}
	}
	btn->setTag(tag);
	return btn;
}

MenuItemToggle* InitListScene::createToggleButtons(int tag)
{
	auto tgBtn = MenuItemToggle::create();

	switch(tag) {
		case TAG_BTN_INIT_LIST_CALLBACKTYPE : {
			auto toggle_fore_1 = Sprite::create("btn_InitListScene_Delegate_normal.png");
			auto toggle_fore_2 = Sprite::create("btn_InitListScene_Delegate_clicked.png");
			auto toggle_fore = MenuItemSprite::create(toggle_fore_1, toggle_fore_2);

			// Completion Handler 반영 이전.
			//auto toggle_back_1 = Sprite::create("btn_InitListScene_Handler_normal.png");
			//auto toggle_back_2 = Sprite::create("btn_InitListScene_Handler_clicked.png");
			auto toggle_back_1 = Sprite::create("btn_InitListScene_Delegate_normal.png");
			auto toggle_back_2 = Sprite::create("btn_InitListScene_Delegate_clicked.png");

			auto toggle_back = MenuItemSprite::create(toggle_back_1, toggle_back_2);
			tgBtn = MenuItemToggle::createWithCallback(
						CC_CALLBACK_1(InitListScene::toggleButtonEvent, this), toggle_fore, toggle_back, NULL);
			//tgBtn->setSelectedIndex(C2SModulePush_Description_Scene::set_CheckBox(tag));
			//tgBtn->setScale(InitListScene::ui_mainBtnScale);
			tgBtn->setScale(0.7f);
			break;
		}
		default : {
			log("### InitListScene : create toggle button error... ###");
			break;
		}
	}

	tgBtn->setTag(tag);
	return tgBtn;
}

void InitListScene::buttonEvent(Ref *sender)
{
	auto btn = (MenuItem*) sender;

	switch(btn->getTag()) {
		case TAG_BTN_INIT_LIST_SANDBOX : {
			// 1) 서버 값 전달 ( 샌드박스로 수행 )
			DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useSandbox", true);
            DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useDevelop", false);			// for staging
            DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useStaging", false);			// for staging
			// 2) 초기화 실시
			DataManager::getApiAction(TAG_APIACTION_INITIALIZE);
			// 3) Scene 이동
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                auto scene = TransitionFadeTR::create(1.0, LoginListScene::createScene());
                Director::getInstance()->replaceScene(scene);
            });
			break;
		}
		case TAG_BTN_INIT_LIST_LIVE_SERVER : {
			// 1) 서버 값 전달 ( 라이브 서버로 수행 )
			DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useSandbox", false);
            DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useDevelop", false);			// for staging
            DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useStaging", false);			// for staging
			// 2) 초기화 실시
			DataManager::getApiAction(TAG_APIACTION_INITIALIZE);
			// 3) Scene 이동
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                auto scene = TransitionFadeTR::create(1.0, LoginListScene::createScene());
                Director::getInstance()->replaceScene(scene);
            });
			break;
		}
		case TAG_BTN_INIT_LIST_STAGING : {
            // 1) 서버 값 전달 ( 스테이징 서버로 수행 )
            DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useStaging", true);
            DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useDevelop", true);			// for staging
            DataManager::setParamValue_bool(TAG_APIACTION_INITIALIZE, "useSandbox", false);			// for staging
            // 2) 초기화 실시
            DataManager::getApiAction(TAG_APIACTION_INITIALIZE);
            // 3) Scene 이동
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                auto scene = TransitionFadeTR::create(1.0, LoginListScene::createScene());
                Director::getInstance()->replaceScene(scene);
            });
            break;
        }
		case TAG_BTN_INIT_LIST_SETTING : {
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                auto scene = TransitionFadeTR::create(1.0, InitParameterScene::createScene());
                Director::getInstance()->replaceScene(scene);
            });
			break;
		}
		case TAG_BTN_INIT_LIST_GUESTUSERINFOSET : {

			// 텍스트 박스에 있는 게스트의 vid, sessionkey(sessionToken) 값 가져오기
			std::string tfCurrentVid = "";
			std::string tfCurrentSessionKey = "";

			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_ILIST_VID_SESSIONKEY);
			std::string vidSessionKeyValue = temp_tf->getString();
			if(vidSessionKeyValue == "") {
				log("### textfield is ===> blank ###");
				return;
			} else {
				// '#' 구분자를 중심으로 정보 잘라내기.
				std::string delimiter = "#";

				size_t pos = 0;
				std::string token;
				while ((pos = vidSessionKeyValue.find(delimiter)) != std::string::npos) {
					token = vidSessionKeyValue.substr(0, pos);
					tfCurrentVid = token;
					DataManager::setParamValue_string(TAG_APIACTION_LOGIN, "guestVid", tfCurrentVid);
					log("### tfCurrentVid is ===> %s ###", tfCurrentVid.c_str());
					vidSessionKeyValue.erase(0, pos + delimiter.length());
				}
				tfCurrentSessionKey = vidSessionKeyValue;
				DataManager::setParamValue_string(TAG_APIACTION_LOGIN, "guestSessionToken", tfCurrentSessionKey);
				log("### tfCurrentSessionKey is ===> %s ###", tfCurrentSessionKey.c_str());
			}

			// 훌라이 관련 api 호출
			DataManager::getApiAction(TAG_APIACTION_SNSSETGUESTUSERINFO);

			break;
		}
		case TAG_BTN_INIT_LIST_REQUESTPERMISSION : {
			// ActiveUser에서 HIVE SDK의 안드로이드 권한 팝업 호출 (HIVE 1.11.0)
			DataManager::setParamValue_string(TAG_APIACTION_SOCIALSHOW, "type", "requestPermission");
			DataManager::getApiAction(TAG_APIACTION_SOCIALSHOW);
			break;
		}
		case TAG_BTN_INIT_LIST_REQUESTPERMISSIONDATA : {
			// ActiveUser에서 HIVE SDK의 안드로이드 권한 팝업 호출 (HIVE 1.11.0)
			DataManager::setParamValue_string(TAG_APIACTION_SOCIALINFO, "type", "permission");
//            DataManager::setParamValue_string(TAG_APIACTION_SOCIALINFO, "type", "notice");
//            DataManager::setParamValue_string(TAG_APIACTION_SOCIALINFO, "serverId", "server_001");
			DataManager::getApiAction(TAG_APIACTION_SOCIALINFO);
			break;
		}
		case TAG_BTN_INIT_LIST_ABOUTUS : {
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                auto scene = TransitionFadeTR::create(1.0, AboutUsScene::createScene());
                Director::getInstance()->replaceScene(scene);
            });
			break;
		}
		default : {
			log("### InitListScene : buttonEvent() error ###");
			break;
		}
	}
}

void InitListScene::toggleButtonEvent(Ref *sender)
{
	auto btn = (MenuItemToggle*) sender;

	switch(btn->getTag()) {
		case TAG_BTN_INIT_LIST_CALLBACKTYPE : {
			if(btn->getSelectedIndex() == 0) {
				// 현재 전역 델리게이트 상태
//				showDialogMsg("현 SampleApp 버전에서는 전역 Delegate 콜백만을 사용합니다.\nCompletionHandler 콜백은 추후 수정 예정입니다.");
				log("### InitListScene::buttonEvent() --> CommonDelegate Mode ###");
			}
			else if(btn->getSelectedIndex() == 1) {
				// 현재 핸들러 상태
//				showDialogMsg("현 SampleApp 버전에서는 전역 Delegate 콜백만을 사용합니다.\nCompletionHandler 콜백은 추후 수정 예정입니다.");
				log("### InitListScene::buttonEvent() --> CompletionHandler Mode ###");
			}
			break;
		}
		default : {
			log("### InitListScene : toggleButtonEvent() error ###");
			break;
		}
	}
}

void InitListScene::update_labels()
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
//	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_INIT_LIST);

	auto label = Label::createWithSystemFont("vid#sessionToken : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
	label->setColor(Color3B(0, 0, 0));
	auto item = MenuItemLabel::create(label, CC_CALLBACK_1(InitListScene::labelEvent, this));
	item->setTag(-999);

	auto labels = Menu::create();

	labels = Menu::create(item, NULL);
	labels->setPosition(visibleSize.width * InitListScene::ui_paramLabel_x,

    visibleSize.height * (InitListScene::ui_paramLabel_y - (InitListScene::ui_paddingSize_y * 10.0)));
	this->addChild(labels);
}

void InitListScene::labelEvent(Ref *sender)
{
	auto label = (MenuItem*) sender;

	switch(label->getTag()) {
		default : {
			// no event
			break;
		}
	}
}

void InitListScene::update_textFields()
{
	Size visibleSize = Director::getInstance()->getVisibleSize();

	log("### InitListScene::update_textFields() ###");
	InitListScene::createTextFields(TAG_TF_ILIST_VID_SESSIONKEY,
			InitListScene::ui_paramLabel_y - (InitListScene::ui_paddingSize_y * 11.0));
}

void InitListScene::createTextFields(int tag, float textFieldPos_y)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();

	TextFieldTTF* textField = cocos2d::TextFieldTTF::textFieldWithPlaceHolder("input here!",
			cocos2d::Size(130, 17), TextHAlignment::LEFT, "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
	textField->setPosition(
			Point(visibleSize.width * InitListScene::ui_textField_x,
					visibleSize.height * textFieldPos_y));
	textField->setColor(ccc3(0, 0, 255));
	textField->setColorSpaceHolder(Color3B::BLUE);
	textField->setTag(tag);
	textField->setDelegate(this);

	this->addChild(textField);

	auto touchListener = EventListenerTouchOneByOne::create();

	switch(tag) {
	case TAG_TF_ILIST_VID_SESSIONKEY : {	// (1)	vid and SessionKey
		InitListScene::tfArea_vid_sessionKey = textField->getBoundingBox();	// change this

		touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
			try {
				CCPoint point = touch->getLocationInView();
				point = Director::sharedDirector()->convertToGL(point);

				if(InitListScene::tfArea_vid_sessionKey.containsPoint(point)
				) {	// change this
					// Show the on screen keyboard
					InitListScene::focusedTextFieldState = TAG_TF_ILIST_VID_SESSIONKEY;	// change this
					auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
					textField_->attachWithIME();

				}
				return true;
			}
			catch(std::bad_cast * err) {
				return true;
			}
		};
		break;
	}
	default : {
		log("### InitListScene::createTextField(...) error ###");
		break;
	}
	}
	this->_eventDispatcher->addEventListenerWithSceneGraphPriority(touchListener, textField);
}

void InitListScene::update_labels_appVersion()
{
//	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_INIT_LIST);

	Size visibleSize = Director::getInstance()->getVisibleSize();

	// version(static)
	std::string version = "Cocos2d-x HIVE SDK " + std::string(getHiveSdkVersion())
			+ "\nAppVer " + std::string(getAppVersion()) + "(" + std::string(getCurrentTime()) + ")";

	auto label = LabelTTF::create(version, "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
	label->setPosition(
			visibleSize.width * InitListScene::ui_loginServerTypeLabel_x,
			visibleSize.height * InitListScene::ui_loginServerTypeLabel_y);
	label->setColor(Color3B(0, 0, 0));
	label->setTag(TAG_LABEL_INIT_LIST_APPVERSION);

	this->addChild(label);
}

void InitListScene::menuCloseCallback(Ref* pSender) {
#if(CC_TARGET_PLATFORM == CC_PLATFORM_WP8) || (CC_TARGET_PLATFORM == CC_PLATFORM_WINRT)
	MessageBox("You pressed the close button. Windows Store Apps do not implement a close button.", "Alert");
	return;
#endif

	Director::getInstance()->end();

#if (CC_TARGET_PLATFORM == CC_PLATFORM_IOS)
	exit(0);
#endif
}

// ********** Touch Event (TextField) ********** ********** ********** **********
bool InitListScene::onTextFieldAttachWithIME(TextFieldTTF *sender) {
	//log("### onTextFieldAttachWithIME  ###");
	//ParameterListScene::ui_isOpenedWindow = true;
	//ParameterListScene::isFocusedTextField = true;
	return TextFieldDelegate::onTextFieldAttachWithIME(sender);
}

bool InitListScene::onTextFieldDetachWithIME(TextFieldTTF *sender) {
	//log("### onTextFieldDetachWithIME  ###");
	//ParameterListScene::ui_isOpenedWindow = false;
	return TextFieldDelegate::onTextFieldDetachWithIME(sender);
}

bool InitListScene::onTextFieldInsertText(TextFieldTTF *sender,
		const char *text, size_t nLen) {
	return TextFieldDelegate::onTextFieldInsertText(sender, text, nLen);
}

bool InitListScene::onTextFieldDeleteBackward(
		TextFieldTTF *sender, const char *delText, size_t nLen) {
	return TextFieldDelegate::onTextFieldDeleteBackward(sender, delText, nLen);
}
// ********** ********** ********** ********** ********** ********** ********** ********** **********
