#ifndef __INIT_LIST_SCENE_H__
#define __INIT_LIST_SCENE_H__

#include "cocos2d.h"

//USING_NS_CC;

#define TAG_SCENENUM_INIT_LIST				10000

#define TAG_LAYER_INIT_LIST					10001
#define TAG_BTN_INIT_LIST_SANDBOX			10002
#define TAG_BTN_INIT_LIST_LIVE_SERVER		10003
#define TAG_BTN_INIT_LIST_STAGING			10004		// for staging
#define TAG_BTN_INIT_LIST_CALLBACKTYPE		10005
#define TAG_BTN_INIT_LIST_SETTING			10006
#define TAG_BTN_INIT_LIST_GUESTUSERINFOSET	10007
#define TAG_BTN_INIT_LIST_REQUESTPERMISSION		10008
#define TAG_BTN_INIT_LIST_ABOUTUS			10009
#define TAG_BTN_INIT_LIST_REQUESTPERMISSIONDATA	10010			// added HIVE 1.17.0

#define TAG_TF_ILIST_VID_SESSIONKEY			10100

#define TAG_LABEL_INIT_LIST_APPVERSION		10200

//using namespace cocos2d;

class InitListScene : public cocos2d::LayerColor, public cocos2d::TextFieldDelegate
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	void menuCloseCallback(cocos2d::Ref* pSender);
	CREATE_FUNC(InitListScene);

	// variable
	static float ui_mainBtnScale;			// 메인 버튼 스케일 (크기)
	static float ui_settingBtnScale;		// 셋팅 버튼 스케일 (크기)
	static float ui_paddingSize;			// UI 간격
	static float ui_mainBtns_x;				// 메인 버튼 그룹 x좌표
	static float ui_mainBtns_y;				// 메인 버튼 그룹 y좌표
	static float ui_cbTypeBtn_x;			// 델리게이트 토글 버튼 x좌표
	static float ui_cbTypeBtn_y;			// 델리게이트 토글 버튼 y좌표
 	static float ui_settingBtn_x;			// 셋팅 버튼 x좌표
	static float ui_settingBtn_y;			// 셋팅 버튼 y좌표
	static float ui_paddingSize_y;
	static float ui_paramLabel_y;
	static float ui_textField_x;
	static float ui_paramLabel_x;
	static float ui_loginServerTypeLabel_x;
	static float ui_loginServerTypeLabel_y;
	// variable (textfield)
	static bool isFocusedTextField;								// UI 중복 클릭 방지 (텍스트 필드)
	static int focusedTextFieldState;							// 텍스트 필드 영역 포커스 관련 저장 변수
	static cocos2d::CCRect tfArea_vid_sessionKey;				// 훌라이 관련. add HIVE 1.10.1

	// function
    cocos2d::MenuItemImage* createButtons(int tag);
    cocos2d::MenuItemToggle* createToggleButtons(int tag);
	void buttonEvent(Ref *sender);
	void toggleButtonEvent(Ref *sender);
	void update_textFields();
	void createTextFields(int tag, float textFieldPos_y);
	void update_labels();
	void labelEvent(Ref *sender);
	void update_labels_appVersion();

	virtual bool onTextFieldAttachWithIME(cocos2d::TextFieldTTF *sender) override;										// 텍스트 필드 관련 함수
	virtual bool onTextFieldDetachWithIME(cocos2d::TextFieldTTF *sender) override;										// 텍스트 필드 관련 함수
	virtual bool onTextFieldInsertText(cocos2d::TextFieldTTF *sender, const char *text, size_t nLen) override;			// 텍스트 필드 관련 함수
	virtual bool onTextFieldDeleteBackward(cocos2d::TextFieldTTF *sender, const char *delText, size_t nLen) override;	// 텍스트 필드 관련 함수
};

#endif // __INIT_LIST_SCENE_H__
