#ifndef __LOG_CONTROLLER_H__
#define __LOG_CONTROLLER_H__

#include "cocos2d.h"

#define TAG_LABEL_QALOG					90000
#define TAG_LABEL_QALOG_INITPARAMETER	90001

using namespace cocos2d;

struct LogData
{
	std::string logTime;
	std::string logTitle;
	std::string logText;
	LogData()
	{
		logTime = "";
		logTitle = "";
		logText = "";
	}
};

struct QALogData
{
	// state (ModuleListScene의 메인 버튼 클릭에 의한 상태 저장)
	int result_apiRequestState;

	// RESULT // // //
	std::string result_pushRegister;
	std::string result_pushUnregister;
	std::string result_pushDescription;

	std::string result_snsUser_HIVE;
	std::string result_snsUser_facebook;
	std::string result_snsUser_message;
	std::string result_snsUser_delete;

	std::string result_snsPost_facebook;
	std::string result_snsPost_googldplus;

	std::string result_promotionShow_notice;
	std::string result_promotionShow_forcedNotice;
	std::string result_promotionShow_event;
	std::string result_promotionShow_forcedEvent;
	std::string result_promotionShow_fullBanner;
	std::string result_promotionShow_offerwall;
	std::string result_promotionShow_noticeOnly;
	std::string result_promotionShow_customWebview;
	std::string result_promotionShow_review;
	std::string result_promotionShow_moreGames;

	std::string result_promotionInfo_badgeNotice;
	std::string result_promotionInfo_badgeEvent;
	std::string result_promotionInfo_badgeNoticeOnly;
	std::string result_promotionInfo_badgeCustomWebview;
	std::string result_promotionInfo_viewFullBanner;
	std::string result_promotionInfo_viewNotice;
	std::string result_promotionInfo_viewEvent;
	std::string result_promotionInfo_viewNoticeOnly;
	std::string result_promotionInfo_viewCustomWebview;
	std::string result_getOfferwallState;
	// HIVE 1.9.0
	std::string result_promotionAcquisition_info;
	std::string result_promotionAcquisition_qrcodeSave;
	std::string result_promotionAcquisition_qrcodeShare;
	std::string result_promotionAcquisition_linkShare;
	std::string result_promotionAcquisition_hiveLinkShare;

	std::string result_snsFriends_HIVE;
	std::string result_snsFriends_other;
	std::string result_snsFriends_all;
	std::string result_snsFriends_FB_receivedInvite;
	std::string result_snsMessage_FB_message;
	std::string result_snsMessage_HIVE_message;
	std::string result_snsSession_HIVE_session;
	std::string result_snsSession_FB_session;

	std::string result_inappPrepare;
	std::string result_inappRequestBalance;
	std::string result_inappPurchase;
	std::string result_inappRestore;
	std::string result_inappFinish;

	std::string result_snsShow_HIVEHome;
	std::string result_snsShow_profile;
	std::string result_snsShow_HIVECafe;
	std::string result_snsShow_editProfile;
	std::string result_snsShow_findFriends;
	std::string result_snsShow_inquiry;
	std::string result_socialShow_terms;
	std::string result_socialShow_message;

	std::string result_tracker_sendEvent;
	std::string result_tracker_setEnable;

	// HIVE 1.10.0
	std::string result_socialShow_adultAuth;
	std::string result_socialShow_notice;
	std::string result_socialInfo_notice;
	// HIVE 1.10.0
	std::string result_HiveIAP_info_item;
	std::string result_HiveIAP_info_badge;
	std::string result_HiveIAP_info_lebi;
	std::string result_HiveIAP_show_selelct;
	std::string result_HiveIAP_show_charge;
	std::string result_HiveIAP_purchase;
	std::string result_HiveIAP_restore;
	std::string result_HiveIAP_postbox;
	// HIVE 1.10.0
	std::string result_engagement_getEvents;
	std::string result_engagement_consumeCoupon;
	std::string result_engagement_setReady;			// HIVE 1.11.0

	// SETTING // // //
	std::string setting_pushRegister;
	std::string setting_pushUnregister;
	std::string setting_pushDescription;

	std::string setting_snsUser_HIVE;
	std::string setting_snsUser_facebook;
	std::string setting_snsUser_message;
	std::string setting_snsUser_delete;

	std::string setting_snsPost_facebook;
	std::string setting_snsPost_googldplus;

	std::string setting_promotionShow_notice;
	std::string setting_promotionShow_forcedNotice;
	std::string setting_promotionShow_event;
	std::string setting_promotionShow_forcedEvent;
	std::string setting_promotionShow_fullBanner;
	std::string setting_promotionShow_offerwall;
	std::string setting_promotionShow_noticeOnly;
	std::string setting_promotionShow_customWebview;
	std::string setting_promotionShow_review;
	std::string setting_promotionShow_moreGames;

	std::string setting_promotionInfo_badgeNotice;
	std::string setting_promotionInfo_badgeEvent;
	std::string setting_promotionInfo_badgeNoticeOnly;
	std::string setting_promotionInfo_badgeCustomWebview;
	std::string setting_promotionInfo_viewFullBanner;
	std::string setting_promotionInfo_viewNotice;
	std::string setting_promotionInfo_viewEvent;
	std::string setting_promotionInfo_viewNoticeOnly;
	std::string setting_promotionInfo_viewCustomWebview;
	std::string setting_getOfferwallState;
	// HIVE 1.9.0
	std::string setting_promotionAcquisition_info;
	std::string setting_promotionAcquisition_qrcodeSave;
	std::string setting_promotionAcquisition_qrcodeShare;
	std::string setting_promotionAcquisition_linkShare;
	std::string setting_promotionAcquisition_hiveLinkShare;

	std::string setting_snsFriends_HIVE;
	std::string setting_snsFriends_other;
	std::string setting_snsFriends_all;
	std::string setting_snsFriends_FB_receivedInvite;
	std::string setting_snsMessage_FB_message;
	std::string setting_snsMessage_HIVE_message;
	std::string setting_snsSession_HIVE_session;
	std::string setting_snsSession_FB_session;

	std::string setting_inappPrepare;
	std::string setting_inappRequestBalance;
	std::string setting_inappPurchase;
	std::string setting_inappRestore;
	std::string setting_inappFinish;

	std::string setting_snsShow_HIVEHome;
	std::string setting_snsShow_profile;
	std::string setting_snsShow_HIVECafe;
	std::string setting_snsShow_editProfile;
	std::string setting_snsShow_findFriends;
	std::string setting_snsShow_inquiry;
	std::string setting_socialShow_terms;
	std::string setting_socialShow_message;

	std::string setting_tracker_sendEvent;
	std::string setting_tracker_setEnable;

	// HIVE 1.10.0
	std::string setting_socialShow_adultAuth;
	std::string setting_socialShow_notice;
	std::string setting_socialInfo_notice;
	// HIVE 1.10.0
	std::string setting_HiveIAP_info_item;
	std::string setting_HiveIAP_info_badge;
	std::string setting_HiveIAP_info_lebi;
	std::string setting_HiveIAP_show_selelct;
	std::string setting_HiveIAP_show_charge;
	std::string setting_HiveIAP_purchase;
	std::string setting_HiveIAP_restore;
	std::string setting_HiveIAP_postbox;
	// HIVE 1.10.0
	std::string setting_engagement_getEvents;
	std::string setting_engagement_consumeCoupon;
	std::string setting_engagement_setReady;		// HIVE 1.11.0



	QALogData()
	{
		result_apiRequestState = 0;
		// RESULT // // //
		result_pushRegister = "푸시 등록 ";
		result_pushUnregister = "푸시 해제 ";
		result_pushDescription = "푸시 설정 ";

		result_snsUser_HIVE = "하이브 유저 정보 ";
		result_snsUser_facebook = "페이스북 유저 정보 ";
		result_snsUser_message = "신규 메시지 확인 ";

		result_snsPost_facebook = "페이스북 포스팅 ";
		result_snsPost_googldplus = "구글플러스 포스팅 ";

		result_promotionShow_notice = "공지 보기 ";
		result_promotionShow_forcedNotice = "강제 공지 보기 ";
		result_promotionShow_event = "이벤트 보기 ";
		result_promotionShow_forcedEvent = "강제 이벤트 보기 ";
		result_promotionShow_fullBanner = "전체 배너 ";
		result_promotionShow_offerwall = "오퍼월 ";
		result_promotionShow_noticeOnly = "공지만 보기 ";
		result_promotionShow_customWebview = "커스텀 웹뷰 ";
		result_promotionShow_review = "리뷰 ";
		result_promotionShow_moreGames = "게임 더보기 ";

		result_promotionInfo_badgeNotice = "뱃지(공지) ";
		result_promotionInfo_badgeEvent = "뱃지(이벤트) ";
		result_promotionInfo_badgeNoticeOnly = "뱃지(공지만) ";
		result_promotionInfo_badgeCustomWebview = "뱃지(커스텀 웹뷰) ";
		result_promotionInfo_viewFullBanner = "뱃지(전체 배너) ";
		result_promotionInfo_viewNotice = "뷰(공지) ";
		result_promotionInfo_viewEvent = "뷰(이벤트) ";
		result_promotionInfo_viewNoticeOnly = "뷰(공지만) ";
		result_promotionInfo_viewCustomWebview = "뷰(커스텀 웹뷰) ";
		result_getOfferwallState = "오퍼월 상태";
		// HIVE 1.9.0
//		result_promotionAcquisition_info = "프로모션 집객 정보 ";
//		result_promotionAcquisition_qrcodeSave = "Qrcode 저장 ";
//		result_promotionAcquisition_qrcodeShare = "Qrcode 공유 ";
//		result_promotionAcquisition_linkShare = "프로모션 집객 Link ";
//		result_promotionAcquisition_stageCampaign = "Stage 캠패인 보기 ";
//		result_pomotionAcquisition_eachCampaign = "Each 캠패인 보기 ";
		result_promotionAcquisition_info = "프로모션 집객 정보 ";
		result_promotionAcquisition_qrcodeSave = "QRcode 저장 ";
		result_promotionAcquisition_qrcodeShare = "QRcode 공유 ";
		result_promotionAcquisition_linkShare = "Link 공유 ";
		result_promotionAcquisition_hiveLinkShare = "HIVE Link 공유 ";

		result_snsFriends_HIVE = "HIVE 게임친구 ";
		result_snsFriends_other = "HIVE 게임X 친구 ";
		result_snsFriends_all = "HIVE 전체 친구 ";
		result_snsFriends_FB_receivedInvite = "페이스북 초대 유저 ";
		result_snsMessage_FB_message = "페이스북 메시지 전송 ";
		result_snsMessage_HIVE_message = "HIVE 메시지 전송 ";
		result_snsSession_HIVE_session = "HIVE 세션 확인 ";
		result_snsSession_FB_session = "패이스북 세션 확인 ";

		result_inappPrepare = "Lebi로 설정 ";
		result_inappRequestBalance = "Lebi 잔액 조회 ";
		result_inappPurchase = "구매하기 ";
		result_inappRestore = "구매 복구 ";
		result_inappFinish = "구매 종료 ";

		result_snsShow_HIVEHome = "HIVE Home ";
		result_snsShow_profile = "프로필 페이지 ";
		result_snsShow_HIVECafe = "HIVE Cafe ";
		result_snsShow_editProfile = "프로필 변경 ";
		result_snsShow_findFriends = "친구 추천 ";
		result_snsShow_inquiry = "1:1 문의 ";
		result_socialShow_terms = "약관 다시보기 ";
		result_socialShow_message = "쪽지보기 ";

		result_tracker_sendEvent = "이벤트 전송 ";
		result_tracker_setEnable = "이벤트 활성화 설정 ";

		// HIVE 1.10.0
		result_socialShow_adultAuth = "성인인증 ";
		result_socialShow_notice = "점검공지팝업보기 ";
		result_socialInfo_notice = "점검공지정보보기 ";
		// HIVE 1.10.0
		result_HiveIAP_info_item = "아이템 정보 ";
		result_HiveIAP_info_badge = "뱃지 정보 ";
		result_HiveIAP_info_lebi = "러비 잔액 정보 ";
		result_HiveIAP_show_selelct = "러비_구글플레이 선택 ";
		result_HiveIAP_show_charge = "러비 충전 ";
		result_HiveIAP_purchase = "구매하기 ";
		result_HiveIAP_restore = "구매복구 ";
		result_HiveIAP_postbox = "우편함 ";
		// HIVE 1.10.0
		result_engagement_getEvents = "GetEvents ";
		result_engagement_consumeCoupon = "ConsumeCoupon ";
		result_engagement_setReady = "SetReady";			// HIVE 1.11.0

		// SETTING // // //
		setting_pushRegister = "푸시 등록 설정 저장!";
		setting_pushUnregister = "푸시 해제 설정 저장!";
		setting_pushDescription = "푸시 설정 설정 저장!";

		setting_snsUser_HIVE = "하이브 유저 정보 설정 저장!";
		setting_snsUser_facebook = "페이스북 유저 정보 설정 저장!";
		setting_snsUser_message = "신규 메시지 확인 설정 저장!";
		setting_snsUser_delete = "계정 삭제 설정 저장!";

		setting_snsPost_facebook = "페이스북 포스팅 설정 저장!";
		setting_snsPost_googldplus = "구글플러스 포스팅 설정 저장!";

		setting_promotionShow_notice = "공지 보기 설정 저장!";
		setting_promotionShow_forcedNotice = "강제 공지 보기 설정 저장!";
		setting_promotionShow_event = "이벤트 보기 설정 저장!";
		setting_promotionShow_forcedEvent = "강제 이벤트 보기 설정 저장!";
		setting_promotionShow_fullBanner = "전체 배너 설정 저장!";
		setting_promotionShow_offerwall = "오퍼월 설정 저장!";
		setting_promotionShow_noticeOnly = "공지만 보기 설정 저장!";
		setting_promotionShow_customWebview = "커스텀 웹뷰 설정 저장!";
		setting_promotionShow_review = "리뷰 설정 저장!";
		setting_promotionShow_moreGames = "게임 더보기 설정 저장!";
		// add(HIVE 1.9.0)
//		setting_promotionAcquisition_info = "집객 정보 설정 저장!";
//		setting_promotionAcquisition_qrcodeSave= "Qrcode 저장 설정 저장!";
//		setting_promotionAcquisition_qrcodeShare = "Qrcode 공유 설정 저장!";
//		setting_promotionAcquisition_linkShare = "초대 LINK 공유 설정 저장!";
//		setting_promotionAcquisition_stageCampaign = "Stage 캠패인 보기 설정 저장!";
//		settingrpomotionAcquisition_eachCampaign = "Each 캠패인 보기 설정 저장!";
		setting_promotionAcquisition_info = "프로모션 집객 정보 설정 저장!";
		setting_promotionAcquisition_qrcodeSave= "QRCODE 저장 설정 저장!";
		setting_promotionAcquisition_qrcodeShare = "QRCODE 공유 설정 저장!";
		setting_promotionAcquisition_linkShare = "프로모션 집객 Link 설정 저장!";
		setting_promotionAcquisition_hiveLinkShare = "하이브 초대 Link 공유 설정 저장!";

		setting_promotionInfo_badgeNotice = "뱃지(공지) 설정 저장!";
		setting_promotionInfo_badgeEvent = "뱃지(이벤트) 설정 저장!";
		setting_promotionInfo_badgeNoticeOnly = "뱃지(이벤트) 설정 저장!";
		setting_promotionInfo_badgeCustomWebview = "뱃지(커스텀 웹뷰) 설정 저장!";
		setting_promotionInfo_viewFullBanner = "뱃지(전체 배너) 설정 저장!";
		setting_promotionInfo_viewNotice = "뷰(공지) 설정 저장!";
		setting_promotionInfo_viewEvent = "뷰(이벤트) 설정 저장!";
		setting_promotionInfo_viewNoticeOnly = "뷰(공지만) 설정 저장!";
		setting_promotionInfo_viewCustomWebview = "뷰(커스텀 웹뷰) 설정 저장!";
		setting_getOfferwallState = "오퍼월 상태설정 저장!";

		setting_snsFriends_HIVE = "HIVE 게임친구 설정 저장!";
		setting_snsFriends_other = "HIVE 게임X 친구 설정 저장!";
		setting_snsFriends_all = "HIVE 전체 친구 설정 저장!";
		setting_snsFriends_FB_receivedInvite = "페이스북 초대 유저 설정 저장!";
		setting_snsMessage_FB_message = "페이스북 메시지 전송 설정 저장!";
		setting_snsMessage_HIVE_message = "HIVE 메시지 전송 설정 저장!";
		setting_snsSession_HIVE_session = "HIVE 세션 확인 설정 저장!";
		setting_snsSession_FB_session = "패이스북 세션 확인 설정 저장!";

		setting_inappPrepare = "Lebi로 설정 설정 저장!";
		setting_inappRequestBalance = "Lebi 잔액 조회 설정 저장!";
		setting_inappPurchase = "구매하기 설정 저장!";
		setting_inappRestore = "구매 복구 설정 저장!";
		setting_inappFinish = "구매 종료 설정 저장!";

		setting_snsShow_HIVEHome = "HIVE Home 설정 저장!";
		setting_snsShow_profile = "프로필 페이지 설정 저장!";
		setting_snsShow_HIVECafe = "HIVE Cafe 설정 저장!";
		setting_snsShow_editProfile = "프로필 변경 설정 저장!";
		setting_snsShow_findFriends = "친구 추천 설정 저장!";
		setting_snsShow_inquiry = "1:1 문의 설정 저장!";
		setting_socialShow_terms = "약관 다시보기 설정 저장!";
		setting_socialShow_message = "쪽지보기 설정 저장!";

		setting_tracker_sendEvent = "이벤트 전송 설정 저장!";
		setting_tracker_setEnable = "이벤트 활성화 설정 설정 저장!";

		// HIVE 1.10.0
		setting_socialShow_adultAuth = "성인인증 설정 저장!";
		setting_socialShow_notice = "점검공지팝업보기 설정 저장!";
		setting_socialInfo_notice = "점검공지정보보기 설정 저장!";
		// HIVE 1.10.0
		setting_HiveIAP_info_item = "아이템 정보 설정 저장!";
		setting_HiveIAP_info_badge = "뱃지 정보 설정 저장!";
		setting_HiveIAP_info_lebi = "러비 잔액 정보 설정 저장!";
		setting_HiveIAP_show_selelct = "러비_구글플레이 선택 설정 저장!";
		setting_HiveIAP_show_charge = "러비 충전 설정 저장!";
		setting_HiveIAP_purchase = "구매하기 설정 저장!";
		setting_HiveIAP_restore = "구매복구 설정 저장!";
		setting_HiveIAP_postbox = "우편함 설정 저장!";
		// HIVE 1.10.0
		setting_engagement_getEvents = "GetEvents 설정 저장!";
		setting_engagement_consumeCoupon = "ConsumeCoupon 설정 저장!";
		setting_engagement_setReady = "SetReady 설정 저장!";

	}
};

class LogController : public Layer
{
public :
	static Scene* createScene();
	virtual bool init();
	void menuCloseCallback(Ref* pSender);
	CREATE_FUNC(LogController);

	// struct
	static QALogData qaLogData;

	// variable
	static std::vector<LogData> allLogDataList;		// 전체 로그 정보 리스트
	static std::vector<LogData> localLogDataList;	// 지역 로그 정보 리스트

	// function
	static std::string getLogTime();						// 현재 시간을 반환하는 함수
	static void addLog(std::string logData);		// 외부에서 로그를 추가시키기 위해 호출되는 함수
	static void clearAllLog();						// 전체 로그를 삭제하는 함수
	static void clearLocalLog();					// 지역 로그를 삭제하는 함수
	static void addLocalLog(std::string logData);			// 지역 로그를 추가하는 함수
	static void addAllLog(std::string logData);			// 전체 로그를 추가하는 함수
	static std::string getFormattedAllLogString();			// UI에 종합적인 로그 정보를 반환하기 위한 함수 (전체 로그)
	static std::string getFormattedLocalLogString();		// UI에 종합적인 로그 정보를 반환하기 위한 함수 (지역 로그)
	static void displayLog(std::string logString);			// 로그 다이얼로그를 띄우는 함수
	static void saveAllLog();						// 전체 로그를 저장하는 함수
	static void saveLocalLog();						// 지역 로그를 저장하는 함수

	static LabelTTF* createQALog(std::string log);			// QA 전용 로그를 생성하는 함수
	static std::string getQALog(int tag, bool isResult);	// ModuleListScene의 define값을 활용하여 QALog를 가져오는 함수

	static void setApiRequestState(int tag);		// ModuleListScene에서 메인 버튼 클릭에 따른 상태값 저장
	static void setApiResultState(bool isError, int errorNum);	// ModuleListScene의 std::string 값으로 log 값을 변경시켜주는 함수.

};

extern "C"
{
	extern void openURL(const char *URL);
}

#ifdef __ANDROID__

#else
// Temp Func
extern "C" void showDialogMsg(const char* message);
extern "C" void postBoxInit(const char* data);
extern "C" void PostBoxRequest(const char* pstrJson);
#endif

#endif //	__LOG_CONTROLLER_H__
