#ifndef __MODULE_GROUP_LIST_SCENE_H__
#define __MODULE_GROUP_LIST_SCENE_H__

#include "cocos2d.h"

#include "CCTableView.h"		// 스크롤뷰 사용

USING_NS_CC;

#define TAG_LAYER_MODULE_GROUP_LIST						30001
#define TAG_BTN_MODULE_GROUP_LIST_PUSHMESSAGE			30002
#define TAG_BTN_MODULE_GROUP_LIST_USERINFO				30003
#define TAG_BTN_MODULE_GROUP_LIST_SNSPOSTING			30004
#define TAG_BTN_MODULE_GROUP_LIST_PROMOTION				30005
#define TAG_BTN_MODULE_GROUP_LIST_PROMOTIONINFO			30006
#define TAG_BTN_MODULE_GROUP_LIST_INVITEFRIENDS			30007
#define TAG_BTN_MODULE_GROUP_LIST_INAPP					30008
#define TAG_BTN_MODULE_GROUP_LIST_HIVEWEBVIEW			30009
#define TAG_BTN_MODULE_GROUP_LIST_TRACKER				30010
#define TAG_BTN_MODULE_GROUP_LIST_PROMOTIONACQUISITION	30011		// HIVE 1.9.0
#define TAG_BTN_MODULE_GROUP_LIST_HIVEIAP				30012		// HIVE 1.10.0
#define TAG_BTN_MODULE_GROUP_LIST_ENGAGEMENT			30013		// HIVE 1.10.0
#define TAG_BTN_MODULE_GROUP_LIST_HIVEPROMOTION			30014		// HIVE 1.12.0
#define TAG_BTN_MODULE_GROUP_LIST_HIVEPROMOTIONINFO		30015		// HIVE 1.12.0
#define TAG_BTN_MODULE_GROUP_LIST_SETGAMEINFO			30016		// HIVE 1.12.0
#define TAG_BTN_MODULE_GROUP_LIST_INAPPV4				30017		// HIVE 1.18.4

#define TAG_BTN_MODULE_GROUP_LIST_INFO					30101
#define TAG_LABEL_MODULE_GROUP_LIST_APPID				30201
#define TAG_LABEL_MODULE_GROUP_LIST_LOGINSERVERTYPE		30202
#define TAG_SCLVIEW_MODULE_GROUP_LIST					30301

using namespace cocos2d;
class ModuleMenu : public Menu
{

public:
    virtual bool onTouchBegan(Touch* touch, Event* event);                                    // 스크롤뷰 관련 함수
    virtual void onTouchEnded(Touch* touch, Event* event);                                    // 스크롤뷰 관련 함수
    virtual void onTouchMoved(Touch* touch, Event* event);                                    // 스크롤뷰 관련 함수
    static ModuleMenu* createWithArray(const Vector<MenuItem*>& arrayOfItems);    // 스크롤뷰 관련 함수
    static ModuleMenu* createWithItem(MenuItem* item);                            // 스크롤뷰 관련 함수
    static ModuleMenu* createWithItems(MenuItem *firstItem, va_list args);        // 스크롤뷰 관련 함수
    static ModuleMenu* create(MenuItem* item, ...);                                // 스크롤뷰 관련 함수
    bool initWithArray(const Vector<MenuItem*>& arrayOfItems);                                // 스크롤뷰 관련 함수
    
private:
    bool isTouching;            // 스크롤뷰 관련 변수
    Vec2 m_touchesStart;        // 스크롤뷰 관련 변수
    Vec2 m_touchesEnd;            // 스크롤뷰 관련 변수
};

class ModuleGroupListScene : public Layer
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	CREATE_FUNC(ModuleGroupListScene);

	// variable
	static float ui_mainBtnScale;
	static float ui_paddingSize;
	static float ui_mainBtns_x;
	static float ui_mainBtns_y;
	static float ui_infoBtn_x;
	static float ui_infoBtn_y;
	static float ui_appIdLabel_x;
	static float ui_appIdLabel_y;
	static float ui_loginServerTypeLabel_x;
	static float ui_loginServerTypeLabel_y;
	static float ui_scrollViewHeight;
	static float ui_scrollView_y;
	static float ui_scrollViewConSize;
	static float ui_showLogBtn_x;
	static float ui_showLogBtn_y;
	static float ui_touchStart_y;

	// function
	void update_mainButtons(std::string loginType);

	MenuItem* createButtons(int tag);
	void buttonEvent(Ref *sender);
	LabelTTF* createLabels(int tag);
	bool allowClickAction();
	void update_server_loginState(float dt);



};

#endif	// __MODULE_GROUP_LIST_SCENE_H__
