#ifndef __MODULE_LIST_SCENE_H__
#define __MODULE_LIST_SCENE_H__

#include "cocos2d.h"

#include "CCTableView.h"		// 스크롤뷰 사용

// test
#include "network/HttpClient.h"
#include "network/HttpResponse.h"
// test
//#include "curl/curl.h"
//#include "curl/easy.h"

USING_NS_CC;

#define TAG_BTN_PREVIOUS_SCENE									101
#define TAG_BTN_SHOW_LOG										201

#define TAG_LAYER_MODULE_LIST									40001
#define TAG_BTN_MODULE_LIST_LOGOUT								40002
#define TAG_BTN_MODULE_LIST_SHOWINFO							40003
#define TAG_BTN_MODULE_LIST_LOGOUT_USEREXIT						40004		// Hive 1.19.5.2, 1.20.0+

#define TAG_TYPE_MODULE_LIST_PUSH								40100
#define TAG_BTN_MODULE_LIST_PUSH_REGISTER						40101
#define TAG_BTN_MODULE_LIST_PUSH_UNREGISTER						40102
#define TAG_BTN_MODULE_LIST_PUSH_DESCRIPTION					40103
#define TAG_BTN_MODULE_LIST_PUSH_REGISTER_LIST					40104
#define TAG_BTN_MODULE_LIST_PUSH_UNREGISTER_LIST				40105
#define TAG_BTN_MODULE_LIST_PUSH_REQUEST_PERMISSION             40106

#define TAG_TYPE_MODULE_LIST_SNS_USER							40200
#define TAG_BTN_MODULE_LIST_SNS_USER_HIVE						40201
#define TAG_BTN_MODULE_LIST_SNS_USER_FACEBOOK					40202
#define TAG_BTN_MODULE_LIST_SNS_USER_MESSAGE					40203
#define TAG_BTN_MODULE_LIST_SNS_USER_DELETE						40204

#define TAG_TYPE_MODULE_LIST_SNS_POST							40300
#define TAG_BTN_MODULE_LIST_SNS_POST_HIVE						40301
#define TAG_BTN_MODULE_LIST_SNS_POST_FACEBOOK					40302
#define TAG_BTN_MODULE_LIST_SNS_POST_GOOGLEPLUS					40303

#define TAG_TYPE_MODULE_LIST_PROMOTION							40400
#define TAG_BTN_MODULE_LIST_PROMOTION_NOTICE					40401
#define TAG_BTN_MODULE_LIST_PROMOTION_FOCRED_NOTICE				40402
#define TAG_BTN_MODULE_LIST_PROMOTION_EVENT						40403
#define TAG_BTN_MODULE_LIST_PROMOTION_FORCED_EVENT				40404
#define TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER				40405
#define TAG_BTN_MODULE_LIST_PROMOTION_OFFERWALL					40406
#define TAG_BTN_MODULE_LIST_PROMOTION_NOTICEONLY				40407
#define TAG_BTN_MODULE_LIST_PROMOTION_CUSTOMWEBVIEW				40408
#define TAG_BTN_MODULE_LIST_PROMOTION_REVIEW					40409
#define TAG_BTN_MODULE_LIST_PROMOTION_MOREGAMES					40410
#define TAG_BTN_MODULE_LIST_PROMOTION_REVIEW_EX					40411		// HIVE 1.16.0
#define TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER_IMAGE_BANNER	40412		// HIVE 1.18.1

#define TAG_TYPE_MODULE_LIST_PROMOTIONINFO							40500
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICE				40501
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_EVENT				40502
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICEONLY			40503
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_CUSTOMWEBVIEW		40504
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_FULLBANNER			40505
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICE				40506
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_EVENT				40507
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICEONLY			40508
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_CUSTOMWEBVIEW		40509
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETOFFERWALLSTATE			40510
#define TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETBANNERINFO				40511	// HIVE 1.18.3

#define TAG_TYPE_MODULE_LIST_INVITEFRIENDS								40600
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GAME						40601
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_OTHER					40602
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_ALL						40603
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_RECEIVEDINVITE		40604
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_MESSAGE				40605
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_MESSAGE					40606
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_SESSION					40607
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_SESSION				40608
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GETINVITATIONS			40609
#define TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_FRIENDSLIST			40610		// HIVE 1.10.2b

#define TAG_TYPE_MODULE_LIST_INAPP								40700
#define TAG_BTN_MODULE_LIST_INAPP_LEBI_PREPARE					40701
#define TAG_BTN_MODULE_LIST_INAPP_LEBI_REQUESTBALANCE			40702
#define TAG_BTN_MODULE_LIST_INAPP_PLATFORM_PURCHASE				40703
#define TAG_BTN_MODULE_LIST_INAPP_PLATFORM_RESTORE				40704
#define TAG_BTN_MODULE_LIST_INAPP_PLATFORM_FINISH				40705

#define TAG_TYPE_MOUDLE_LIST_HIVEWEBVIEW						40800
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEHOME				40801
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEUSER				40802
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVECAFE				40803
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_EDITPROFILE				40804
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_FINDFRIENDS				40805
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_INQUIRY					40806
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_CHATBOT					40814		// HIVE 1.18.1
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_TERMS					40807
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_MESSAGE					40808
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_ADULTAUTH				40809		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICE				40810		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICEINFO			40811		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETPERMISSIONINFO		40812		// HIVE 1.17.0
#define TAG_BTN_MODULE_LIST_HIVEWEBVIEW_REQUESTPERMISSIONLIST	40813		// HIVE 1.17.2

#define TAG_TYPE_MODULE_LIST_TRACKER							40900
#define TAG_BTN_MODULE_LIST_TRACKER_EVENT						40901
#define TAG_BTN_MODULE_LIST_TRACKER_SETENABLE					40902

#define TAG_BTN_MODULE_LIST_SETTING								41001

#define TAG_SCLVIEW_MODULE_LIST									41101
#define TAG_BTN_POPUP_CLOSE										41102		// HIVE 1.9.0 : QRcode 출력을 위한 팝업에 사용.
#define TAG_IMAGE_QRCODE										41103		// HIVE 1.9.0 : QRcode 출력을 위한 팝업에 사용.

#define TAG_TYPE_MODULE_LIST_PROMOTIONACQUISITION					41201		// HIVE 1.9.0
#define TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_INFO				41202		// HIVE 1.9.0
#define TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_QRCODESAVE			41203		// HIVE 1.9.0
#define TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_QRCODESHARE		41204		// HIVE 1.9.0
#define TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_LINKSHARE			41205		// HIVE 1.9.0
#define TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHARE		41206		// HIVE 1.9.0
#define TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHAREPLUSMESSAGE	41207		// HIVE 1.10.3
#define TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_SENDERINFO			41208		// HIVE 1.19.6

#define TAG_TYPE_MODULE_LIST_HIVEIAP								41300		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_INFO_ITEM						41301		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_INFO_BADGE						41302		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_INFO_LEBI						41303		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_GOOGLELEBISELECT			41304		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_LEBICHARGE					41305		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_PURCHASE						41306		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_RESTORE							41307		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_HIVEIAP_POSTBOX							41308		// HIVE 1.10.0

#define TAG_TYPE_MODULE_LIST_ENGAGEMENT								41400		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_ENGAGEMENT_GETEVENTS					41401		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_ENGAGEMENT_CONSUMECOUPON				41402		// HIVE 1.10.0
#define TAG_BTN_MODULE_LIST_ENGAGEMENT_SETREADY						41403		// HIVE 1.11.0

#define TAG_TYPE_MODULE_LIST_HIVEPROMOTION							41600		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_NEWS						41601		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_FULLBANNER				41602		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_NOTICE					41603		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMVIEW				41604		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMBOARD				41605		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_SPOT						41606		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_DIRECT					41607		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_OFFERWALL					41608		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_REVIEW					41610		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_EXIT						41611		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTION_REVIEW_EX					41612		// HIVE 1.16.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_GETBANNERINFO			41613		// HIVE 1.18.3

#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BADGEINFO					41700		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_VIEWINFO					41701		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BOARDINFO					41702		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SPOTINFO					41703		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_DIRECTINFO				41704		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SETADDITIONALINFO			41705		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_OFFERWALLSTATE			41706		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_UPDATEPROMOTIONDATA		41707		// HIVE 1.19.0

#define TAG_BTN_MODULE_LIST_SETGAMEINFO_SETGAMEINFO						41807		// HIVE 1.12.0
#define TAG_BTN_MODULE_LIST_SETGAMEINFO_GETHIVECOUNTRYCODE				41808
#define TAG_BTN_MODULE_LIST_SETGAMEINFO_GETCHANNEL						41809		// Hive 1.20.3
#define TAG_BTN_MODULE_LIST_SETGAMEINFO_SETCHANNEL						41810		// Hive 1.20.3
#define TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_SERVERID					41811
#define TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_GAMELANGUAGE				41812
#define TAG_BTN_MODULE_LIST_SETGAMEINFO_SEND_DATA                       41813

#define TAG_TYPE_MODULE_LIST_INAPPV4								41900		// HIVE 1.18.4
#define TAG_TYPE_MODULE_LIST_INAPPV4_ITEMINFO						41901
#define TAG_TYPE_MODULE_LIST_INAPPV4_PURCHASE						41902
#define TAG_TYPE_MODULE_LIST_INAPPV4_RESTORE						41903
#define TAG_TYPE_MODULE_LIST_INAPPV4_TRANSACTION_FINISH				41904
#define TAG_TYPE_MODULE_LIST_INAPPV4_SELECTMARKET					41905
#define TAG_TYPE_MODULE_LIST_INAPPV4_REQUEST_BALANCE				41906
#define TAG_TYPE_MODULE_LIST_INAPPV4_CHARGE_BALANCE					41907
#define TAG_TYPE_MODULE_LIST_INAPPV4_POSTBOX_LOGIN					41909
#define TAG_TYPE_MODULE_LIST_INAPPV4_POSTBOX_SHOW					41910
#define TAG_TYPE_MODULE_LIST_INAPPV4_GET_SELECTED_MARKET			41911
#define TAG_TYPE_MODULE_LIST_INAPPV4_CHECK_PROMOTE_PURCHASE         41912       // Hive 1.19.1
#define TAG_TYPE_MODULE_LIST_INAPPV4_MARKETCONNECT					41913		// Hive 1.20.0
#define TAG_TYPE_MODULE_LIST_INAPPV4_GET_ACCOUNT_UUID			    41914       // Hive 1.20.3
#define TAG_TYPE_MODULE_LIST_INAPPV4_SHOW_INAPP_MESSAGES		    41915

#define TAG_TF_MLIST_INFO_VID_SESSIONKEY							41500		// HIVE 1.10.1


using namespace cocos2d;
using namespace network;

class ModuleListScene : public Layer, public TextFieldDelegate
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	CREATE_FUNC(ModuleListScene);

	// variable (UI position)
	static float ui_paddingSize;
	static float ui_mainBtns_x;
	static float ui_mainBtns_y;
	static float ui_settingBtns_x;
	static float ui_settingBtns_y;
	static float ui_moduleListNameLabel_x;
	static float ui_moduleListNameLabel_y;
	static float ui_loginServerTypeLabel_x;
	static float ui_loginServerTypeLabel_y;
	static float ui_scrollViewHeight;
	static float ui_scrollView_y;
	static float ui_scrollViewConSize;
	static float ui_previousBtn_x;
	static float ui_previousBtn_y;
	static float ui_showLogBtn_x;
	static float ui_showLogBtn_y;
	static float ui_logoutBtn_x;
	static float ui_logoutBtn_y;
	static float ui_showInfoBtn_x;
	static float ui_showInfoBtn_y;
	static float ui_touchStart_y;
	static float ui_HiveIAPInfoItemImage_x;		// HIVE 1.10.0
	static float ui_HiveIAPInfoItemImage_y;		// HIVE 1.10.0
	static float ui_HiveIAPInfoItemImage_margin_y;	// HIVE 1.10.0
	static float ui_paramLabel_y;	// HIVE 1.10.1
	static float ui_paddingSize_y;	// HIVE 1.10.1
	static float ui_paramLabel_x; 	// HIVE 1.10.1
	// variable (QA Log Message)
	static std::string ui_qaLogMessage;
	static std::string ui_infoText;
	// variable (HIVE 1.9.0, QRcode)
	static bool isDisplayedQRcode;				// HIVE 1.9.0
	// variable (HIVE 1.10.0, HiveIAP Info Item)
	static bool isDisplayHiveIAPInfoItem;		// HIVE 1.10.0
	static int imageCntHiveIAPInfoItem;			// HIVE 1.10.0
	static bool isDisplayHiveIAPPurchaseItem;	// HIVE 1.10.0

	static bool ui_isOpenedWindow;				// ui 중복 클릭 방지, add(HIVE 1.9.0)

	// variable (textfield)
	static bool isFocusedTextField;				// HIVE 1.10.1
	static int focusedTextFieldState;			// HIVE 1.10.1
	static cocos2d::CCRect tfArea_info_vid_sesseionKey;		// HIVE 1.10.1

	// function
	MenuItemImage* createButtons(int tag);
	MenuItemImage* createSettingButtons(int tag);
	void mainButtonEvent(Ref *sender);
	void settingButtonEvent(Ref *sender);
	void update_mainButtons(int currentModuleList);
	void update_settingButtons(int currentModuleList);
	void update_otherButtons(int btnType);
	LabelTTF* createLabels(int tag);
	void buttonEvent(Ref *sender);
	void displayInfo(int tag);
	bool allowClickAction();
	void update_QALOG(float dt);
	void update_server_loginState(float dt);
	void update_info(float dt);
	void display_acquisitionQrcode();				// HIVE 1.9.0, display QRcode image(only Image)
	void closeQRcodePopup(Ref *sender);				// HIVE 1.9.0
	void displayQRcodePopup(float dt);				// HIVE 1.9.0, display QRcode PopUp
	void displayHiveIAPInfoItemPopup(float dt);		// HIVE 1.10.0
	void closeHiveIAPInfoItemPopup(Ref *sender);	// HIVE 1.10.0
	void displayHiveIAPPurchaseItemPopup(float dt);	// HIVE 1.10.0


	// test
//	void downLoadImage();
//	void onImageDownLoaded(HttpClient* pSender, HttpResponse* pResponse);
	void loadImage();
	void onRequestImgCompleted(HttpClient *sender, HttpResponse *response);
	void loadImageEx(std::string urlPath);
	void onRequestImgCompletedEx(HttpClient *sender, HttpResponse *response);
	void download();

	// function
	void update_textFields(int currentModuleList);
	void createTextFields(int tag, float textFieldPos_y);
	void update_labels(int currentModuleList);		// HIVE 1.10.1
	void labelEvent(Ref *sender);					// HIVE 1.10.1

	virtual bool onTextFieldAttachWithIME(cocos2d::TextFieldTTF *sender) override;										// 텍스트 필드 관련 함수
	virtual bool onTextFieldDetachWithIME(cocos2d::TextFieldTTF *sender) override;										// 텍스트 필드 관련 함수
	virtual bool onTextFieldInsertText(cocos2d::TextFieldTTF *sender, const char *text, size_t nLen) override;			// 텍스트 필드 관련 함수
	virtual bool onTextFieldDeleteBackward(cocos2d::TextFieldTTF *sender, const char *delText, size_t nLen) override;	// 텍스트 필드 관련 함수

private:
	bool isTouching;			// 스크롤뷰 관련 변수
	Vec2 m_touchesStart;		// 스크롤뷰 관련 변수
	Vec2 m_touchesEnd;			// 스크롤뷰 관련 변수

};

#endif	// __MODULE_GROUP_LIST_SCENE_H__
