#include "Parameter.h"

#ifdef __ANDROID__
#include "JNISample.h"
#endif
#include "../external/json/rapidjson.h"
#include "../external/json/document.h"
#include "../external/json/writer.h"
#include "../external/json/stringbuffer.h"

using namespace rapidjson;
USING_NS_CC;

Initialize Parameter::paramInitialize;
Login Parameter::paramLogin;
UIState Parameter::paramUIState;
PushRegister Parameter::paramPushRegister;
PushUnregister Parameter::paramPushUnregister;
PushDescription Parameter::paramPushDescription;
SnsUser Parameter::paramSnsUser;
SnsPosting Parameter::paramSnsPosting;
PromotionShow Parameter::paramPromotionShow;
PromotionInfo Parameter::paramPromotionInfo;
SnsShow Parameter::paramSnsShow;
SocialShow Parameter::paramSocialShow;
SnsFriends Parameter::paramSnsFriends;
SnsMessage Parameter::paramSnsMessage;
SnsSession Parameter::paramSnsSession;
InappPurchase Parameter::paramInappPurchase;
InappFinish Parameter::paramInappFinish;
InappRequestBalance Parameter::paramInappRequestBalance;
InappPrepare Parameter::paramInappPrepare;
TrackerSendEvent Parameter::paramTrackerSendEvent;
TrackerSetEnable Parameter::paramTrackerSetEnable;
PromotionAcquisition Parameter::paramPromotionAcquisition;		// HIVE 1.9.0
SocialInfo Parameter::paramSocialInfo;							// HIVE 1.10.0
HiveIAPInfo Parameter::paramHiveIAPInfo;						// HIVE 1.10.0
HiveIAPShow Parameter::paramHiveIAPShow;						// HIVE 1.10.0
HiveIAPPurchase Parameter::paramHiveIAPPurchase;				// HIVE 1.10.0
EngageConsumeCoupon Parameter::paramEngageComsumeCoupon;		// HIVE 1.10.0
HiveIAPInfoItem Parameter::paramHiveIAPInfoItem;				// HIVE 1.10.0
std::vector<HiveIAPInfoItem> Parameter::paramHiveIAPInfoItemList;	// HIVE 1.10.0
std::vector<HiveIAPInfoItem> Parameter::paramHiveIAPInfoItemPurchaseList;	// HIVE 1.10.0
HivePromotion Parameter::paramHivePromotion;					// HIVE 1.12.0
PromotionBannerInfo Parameter::paramPromotionBannerInfo;		// HIVE 1.18.3
PromotionBannerInfo Parameter::paramHivePromotionBannerInfo;	// HIVE 1.18.3
AppId Parameter::paramAppId;
InAppV4 Parameter::paramInAppV4;								// HIVE 1.18.4

SceneChecker Parameter::paramSceneChecker;
SampleSetting Parameter::paramSampleSetting;
SendData Parameter::paramSendData;

Scene* Parameter::createScene() {
	auto scene = Scene::create();
	auto layer = Parameter::create();
	scene->addChild(layer);
	return scene;
}

bool Parameter::init()
{
	if (!Layer::init()) {
		return false;
	}

	Size visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	log("### Parameter : init() ###");

	Document arg;
	arg.SetObject();

	arg.AddMember("server", "0", arg.GetAllocator());
	arg.AddMember("character", "0", arg.GetAllocator());

	StringBuffer buffer;
	Writer<StringBuffer> writer(buffer);
	arg.Accept(writer);

//	arg["server"] = "0";
//	arg["character"] = "0";
//	Json::FastWriter writer;
//	std::string strJson = writer.write(arg);
	Parameter::paramHivePromotion.additionalInfo = buffer.GetString();

	return true;
}
