#ifndef __PARAMETER_H__
#define __PARAMETER_H__

#include "cocos2d.h"

USING_NS_CC;

using namespace cocos2d;

struct Initialize
{
	bool loginState;
	bool useSandbox;
	bool isAuthorized;
	std::string did;
	std::string authLoginType;
	std::string isPGSLogin;
	std::string playername;
	std::string playerid;
	bool useStaging;
	bool useDevelop;
	// init setting
	bool showLog;
	bool permissionWriteExternalStorage;
	std::string serverId;
	std::string channel;		// Hive 1.20.3
	std::string appId;
	std::string country;
	std::string language;
	std::string inquiry;
	bool showNotice;			// HIVE 1.10.0
	bool HIVEIAP;				// HIVE 1.10.0
	bool hivePromotion;			// HIVE 1.12.0
	std::string gameLanguage;	// HIVE 1.12.0
	// other
	bool delegate;
	bool useOneStore;
	std::string timeoutSeconds;
	std::string setGameInfo_vid;			// HIVE 1.16.1
	bool setGameInfo_emergencyMode;			// Hive KS 1.19.4
	bool useGalaxyStore;					// HIVE 1.17.2
	bool showPermissionView;				// HIVE 1.17.2
	bool useImageBanner;						// HIVE 1.18.1 (v1.19.1 open)
	bool useInappV4;
	bool useHercules;
	bool postboxV4Login;
	bool usePostboxV4forAndroid;
	std::string hiveOrientation;			// Hive 1.19.6
	std::string facebookPermissions;		// Hive 1.19.8
	Initialize ()
	{
		loginState = false;						// default
		useSandbox = false;
		isAuthorized = false;
		did = "";
		authLoginType = "";
		isPGSLogin = "";
		playerid = "";
        useStaging = false;
        useDevelop = false;
		// init setting
		showLog = true;							// default
		permissionWriteExternalStorage = true;	// default
		serverId = "KR";
		channel = "C2S";						// default
#ifdef __ANDROID__
		appId = "com.com2us.hivesdk.normal.freefull.google.global.android.common";
			//appId = "com.com2us.misample.normal.freefull.google.global.android.common";			// mi 샘플
			//appId = "com.com2us.platformsample.normal.freefull.google.global.android.common";		// 플랫폼 샘플
			//appId = "com.com2us.misample.normal.freefull.onestore.kr.android.common";				// 원스토어 하이브 인앱 테스트용 앱아이디
#else
		appId = "com.com2us.hivesdk.normal.freefull.apple.global.ios.universal";
#endif
		country = "";
		language = "";
		inquiry = "";
		showNotice = true;						// default
		HIVEIAP = false;						// default is false
		// other
		delegate = true;
		useOneStore = false;
		hivePromotion = true;					// default
		gameLanguage = "ko";					// default
		timeoutSeconds = "5";
		setGameInfo_vid = "1111111";			// default(for test)
		setGameInfo_emergencyMode = false;		// default
		useGalaxyStore = false;					// default
		showPermissionView = true;				// default
		useImageBanner = true;					// default
		useInappV4 = true;						// default
		useHercules = true;					// default
		postboxV4Login = false;
		usePostboxV4forAndroid = false;
		hiveOrientation = "";					// default
		facebookPermissions = "";	// default (input ex : 'user_friends,user_gender' (sample code split with ,))
	}
};

struct Login
{
	std::string vid;
	std::string sessionToken;
	std::string type;
	std::string uid;
	std::string getLoginType;
	// other
	bool callState;
	std::string select_currentVid;		// added HIVE 1.10.1
	std::string select_usedVid;			// added HIVE 1.10.1
	std::string selectedVid;			// added HIVE 1.10.1
	std::string hoolaiVid;				// added HIVE 1.10.1
	std::string hoolaiSessionKey;		// added HIVE 1.10.1
	bool isSelection;
	std::string selectLoginInfo;
	Login ()
	{
		type = "";
		vid = "";
		sessionToken = "";
		type = "";
		uid = "";
		getLoginType = "";
		// other
		callState = false;
		select_currentVid = "";
		select_usedVid = "";
		selectedVid = "";
		hoolaiVid = "";
		hoolaiSessionKey = "";
		isSelection = false;
		selectLoginInfo = "";
	}
};

struct Logout
{

};

struct PushRegister
{
	int pushId;
	std::string title;
	std::string message;
	std::string sound;
	int after;
	std::string type;
	std::string groupId;
	std::string bigMessage;
	std::string ticker;
	std::string icon;
	std::string broadcastAction;
	std::string bucketType;
	std::string bucketSize;
	std::string bigPicture;
	PushRegister ()
	{
		pushId = 12345;								// default
		title = "titleTest";						// default
		message = "message test";					// default
		sound = "";
		after = 5;									// default
		type = "bar";								// default
		groupId = "";
		bigMessage = "";
		ticker = "";
		icon = "";
		broadcastAction = "";
		bucketType = "";
		bucketSize = "";
		bigPicture = "";
	}
};

struct PushUnregister
{
	int pushId;
	PushUnregister ()
	{
		pushId = 12345;								// default
	}
};

struct PushDescription
{
	bool usePush;
	bool sound;
	bool vibrate;
	bool operationGCM;		// operationRemote와 같은 값을 공유
	bool operationLocal;
	bool useNotice;
	bool useNight;
	int usePushInt;
	int soundInt;
	int vibInt;
	int operGcmInt;
	int operLocInt;
	int noticeInt;
	int nightInt;
	PushDescription ()
	{
		usePush = true;
		sound = true;
		vibrate = true;
		operationGCM = true;	// operationRemote와 같은 값을 공유 
		operationLocal = true;
		useNotice = true;
		useNight = true;
		usePushInt = 1;
		soundInt = 1;
		vibInt = 1;
		operGcmInt = 1;
		operLocInt = 1;
		noticeInt = 1;
		nightInt = 1;
	}
};

struct SnsUser
{
	std::string callState;
	std::string vid;
	std::string type;
	std::string facebookId;
	SnsUser ()
	{
		callState = "";				// Hive 자기 자신 정보 호출, Hive 대상의 정보 호출, facebook 정보 호출 분류
		vid = "";
		type = "";
		facebookId = "";
	}
};

struct SnsPosting
{
	std::string service;
	std::string message;
	std::string title;
	std::string image;
	std::string appLinkURL;
	SnsPosting ()
	{
		service = "";
		message = "messageTest";			// default
		title = "titleTest";				// default
		image = "";
		appLinkURL = "https://www.withhive.com";	// dedault
	}
};

struct PromotionShow
{
	std::string type;
	bool forced;
	int viewId;
	bool useLegacyBanner;
	PromotionShow ()
	{
		type = "";
		forced = false;			// default
		viewId = 310000;		// default
        useLegacyBanner = false;        // default, added v1.18.1
	}
};

struct PromotionInfo
{
	std::string callState;
	std::string type;
	std::string viewId_string;
	int viewId_int;
	PromotionInfo ()
	{
		callState = "";
		type = "";
		viewId_string = "";			// default
		viewId_int = 310000;		// default
	}
};

struct PromotionBannerInfo		// add (HIVE 1.18.3)
{
	std::string campaignType;
	std::string bannerType;

	PromotionBannerInfo()
	{
		campaignType = "all";		// default, all / event / notice
		bannerType = "great";		// default, great / small / rolling
	}
};

struct PromotionAcquisition		// add (HIVE 1.9.0)
{
	std::string gameWorld;
	std::string gameLanguage;
	std::string type;
	bool vidoruid;
	std::string vid;
	std::string message;
	std::string imageURL;
	std::string thumbnailURL;
	std::string linkShareURL;
	bool usePush;
	bool invite;
	bool linkShare;
	std::string addtionalInfo;	// HIVE 1.13.0
	// return data
	std::string qrcode;
	std::string inviteCommonLink;
	std::string inviteFacebookLink;
	std::string inviteHivemsgLink;
	std::string stageCampaigns;
	std::string eachCampaigns;
	// other
	int callState;
	bool isGetInfo;
	PromotionAcquisition ()
	{
		gameWorld = "kr";			// default
		gameLanguage = "";			// default
		type = "";
		vidoruid = true;			// default : true(use vid)
		vid = "";					// default : "", JS > mystic0707
		message = "messageTest";
		imageURL = "http://image-glb.qpyou.cn/hubweb/hive_img/U/P/122349090/20151028/82f610b6f4590863934cefb2b875c87a.jpg";			// default : JS > mystic0707
		thumbnailURL = "http://image-glb.qpyou.cn/hubweb/hive_img/U/P/122349090/20151028/82f610b6f4590863934cefb2b875c87a.jpg";		// default : JS > mystic0707
		linkShareURL = "";
		usePush = true;				// default : true
		invite = false;				// default : false
		linkShare = true;			// default : true
		addtionalInfo = "{\"server\":\"0\",\"character\":\"0\"}";
		//return data
		qrcode = "";
		inviteCommonLink = "";
		inviteFacebookLink = "";
		inviteHivemsgLink = "";
		stageCampaigns = "";
		eachCampaigns = "";
		//other
		callState = 0;			// default : 0
		isGetInfo = false;
	}
};

struct SnsFriends
{
	std::string type;
	std::string service;
	int limit;
	//
	std::string callState;
	SnsFriends ()
	{
		type = "";
		service = "";
		limit = 0;
		callState = "";
	}
};

struct SnsMessage
{
	std::string callState;
	std::string vid;
	std::string uid;
	std::string message;
	std::string imageURL;
	std::string thumbnailURL;
	bool viduid;
	bool usePush;
	bool invite;
	std::string service;
	std::string type;
	SnsMessage ()
	{
		callState = "";
		vid = "";								// default : mystic0707(JS) (61978454)
		uid = "";
		message = "messageTest";				// default : messageTest ( if (SnsMessage test) -> error! )
		imageURL = "http://image-glb.qpyou.cn/hubweb/hive_img/U/P/122349090/20151028/82f610b6f4590863934cefb2b875c87a.jpg";							// default
		thumbnailURL = "http://image-glb.qpyou.cn/hubweb/hive_img/U/P/122349090/20151028/82f610b6f4590863934cefb2b875c87a.jpg";						// default
		viduid = true;
		usePush = true;
		invite = true;
		std::string service = "";
		std::string type = "";
	}
};

struct SnsSession
{
	std::string service;
	SnsSession ()
	{
		service = "";
	}
};

struct SnsShow
{
	std::string type;
	std::string uid;
	std::string additionalInfo;			// HIVE 1.18.1
	SnsShow ()
	{
		type = "";
		uid = "";
		additionalInfo = "{\"server\":\"0\",\"character\":\"0\"}";		// default, etc : "{\"evt_code\":1000,\"p1\":\"random\"}";
	}
};

struct SocialShow
{
	std::string type;
	std::string serverId;
	std::string gameLanguage;
	SocialShow ()
	{
		type = "";
		serverId = "server_001";
		gameLanguage = "ko";
	}
};

struct SocialInfo
{
	std::string type;
	std::string serverId;

	SocialInfo ()
	{
		type = "";
		serverId = "server_001";
	}
};

struct InappPurchase
{
	std::string pid;
	int quantity;
	std::string additionalInfo;
	// option
	bool Restore;
	bool Finish;
	InappPurchase ()
	{
		pid = "item01";				// default : m1 or 050301010001
		quantity = 1;				// default
		additionalInfo = "{\"server\":\"0\",\"character\":\"0\"}";
		// option
		Restore = false;
		Finish = false;
	}
};

struct InappFinish
{
	bool isPurchaseSuccess;
	InappFinish ()
	{
		isPurchaseSuccess = true;
	}
};

struct InappRequestBalance
{
	std::string uid;
	InappRequestBalance ()
	{
		uid = "122349090";			// default : mystic707(JS)
	}
};

struct InappPrepare
{
	std::string pidList;
	bool showLog;
	std::string inappId;
	bool autoVerify;
	InappPrepare ()
	{
		pidList = "";
		showLog = true;
		inappId = "";
		autoVerify = false;			// default
	}
};

struct TrackerSendEvent
{
	std::string event;
	std::string title;
	std::string description;
	std::string currency;
	std::string price;
	int itemCount;
	TrackerSendEvent ()
	{
		event = "TutorialComplete";				// default
		title = "healing potion";				// default
		description = "healing potion desc";	// default
		price = "1000";							// default
		itemCount = 1;							// default
		currency = "KRW";						// default
	}
};

struct SendData
{
    std::string funnelsId;
    std::string optionTag;
    SendData()
    {
        funnelsId = "700";
        optionTag = "";
    }
};

struct TrackerSetEnable
{
	bool MAT;
	bool Adjust;
	bool Partytrack;
	bool Singular;
    bool AppsFlyer;
	TrackerSetEnable ()
	{
		MAT = true;
		Adjust = true;
		Partytrack = true;
		Singular = true;
        AppsFlyer = true;
	}
};

struct HiveIAPInfo
{
	std::string type;
	std::string locationCode;
	std::string worldName;
	std::string gameLanguage;
	HiveIAPInfo ()
	{
		type = "";
		locationCode = "MAIN";			// default
		worldName = "KR";				// default
		gameLanguage = "ko";			// default
	}
};

struct HiveIAPInfoItem
{
	std::string description;
	std::string displayPrice;
	std::string marketPid;
	std::string pid;
	std::string productImageUrl;
	std::string title;
	int imageCnt;
	HiveIAPInfoItem ()
	{
		description = "";
		displayPrice = "";
		marketPid = "";
		pid = "";
		productImageUrl = "";
		title = "";
		imageCnt = 0;
	}
};

struct HiveIAPShow
{
	std::string type;
	std::string gameLanguage;
	HiveIAPShow ()
	{
		type = "";
		gameLanguage = "ko";			// default
	}
};

struct HiveIAPPurchase
{
	std::string pid;
	std::string additionalInfo;			// HIVE SDK 1.12.1
	HiveIAPPurchase ()
	{
		pid = "";
		additionalInfo = "{\"server\":\"0\",\"character\":\"0\"}";		// using HIVEIAP_Purchase, HIVEIAP_Restore
	}
};


struct EngageConsumeCoupon
{
	std::string couponId;
	std::string language;
	std::string additionalInfo;
	EngageConsumeCoupon ()
	{
		couponId = "COUPONTEST";
		language = "ko";
		additionalInfo = "{\"server\":\"0\",\"character\":\"0\"}";
	}
};

struct HivePromotion
{
	bool forced;
	std::string type;
	std::string contentKey_view;
	std::string contentKey_board;
	std::string contentKey_spot;
	std::string contentKey_direct;
	std::string additionalInfo;
	HivePromotion()
	{
		forced = false;
		type = "";							// default
		contentKey_view = "310000";			// default
		contentKey_board = "200007";		// default
		contentKey_spot = "1004";			// default
		contentKey_direct = "209019";		// default
		additionalInfo = "{\"server\":\"0\",\"character\":\"0\"}";
	}
};

struct InAppV4
{
	std::string type;
	std::string pid;
	std::string oldMarketPid;
	std::string iapPayload;
	int categoryId;

	// Google GroupTest
	bool google_sub_sub01;
	bool google_sub_sub10;
	bool google_sub_sub11;
	bool google_sub_sub30;
	bool google_sub_sub013;
	bool google_sub_sub103;
	bool google_sub_sub113;
	bool google_sub_sub303;

	InAppV4()
	{
		type = "consumable";
#ifdef __ANDROID__
		pid = "item01";
#else
		pid = "cs01";
#endif
		oldMarketPid = "";
		iapPayload = "";
		categoryId = 3;

		// Google GroupTest
		google_sub_sub01 = false;
		google_sub_sub10 = false;
		google_sub_sub11 = false;
		google_sub_sub30 = false;
		google_sub_sub013 = false;
		google_sub_sub103 = false;
		google_sub_sub113 = false;
		google_sub_sub303 = false;
	}
};

struct AppId
{
	std::string appId_01;
	std::string appId_02;
	std::string appId_03;
	AppId ()
	{
//		appId_01 = "com.com2us.misample.normal.freefull.google.global.android.common";			// MI 샘플.
//		appId_02 = "com.com2us.platformsample.normal.freefull.google.global.android.common";	// platform 샘플.
		appId_03 = "com.gamevil.cartoonwars3.android.google.global.normal";						// 카툰워즈.
		appId_01 = "com.gamevil.kritikamobile.android.google.global.normal";					// 크리티카
		appId_02 = "com.com2us.ninepb3d.normal.freefull.google.global.android.common";			// MLB 9이닝스
	}
};

struct UIState
{
	bool isHiveLogin;
	int currentModuleListScene;
	int currentParameterListScene;
	bool isSelection;
	UIState ()
	{
		isHiveLogin = false;
		currentModuleListScene = 0;
		currentParameterListScene = 0;
		isSelection = false;
	}
};

struct SceneChecker
{
	int sceneState;
	SceneChecker() {
		sceneState = 0;
		// initListScene = 0;
		// LoginListScene = 1;
		// ModuleGroupListScene = 2;
		// ModuleListScene = 3;
	}
};

struct SampleSetting
{
	int normalFontSize;
	SampleSetting() {
		normalFontSize = 10;
	}
};

class Parameter : public Menu
{
public:
	static cocos2d::Scene* createScene();
	virtual bool init();
	void menuCloseCallback(cocos2d::Ref* pSender);
	CREATE_FUNC(Parameter);

	// struct
	static Initialize paramInitialize;
	static Login paramLogin;
	static UIState paramUIState;
	static PushRegister paramPushRegister;
	static PushUnregister paramPushUnregister;
	static PushDescription paramPushDescription;
	static SnsUser paramSnsUser;
	static SnsPosting paramSnsPosting;
	static PromotionShow paramPromotionShow;
	static PromotionInfo paramPromotionInfo;
	static SnsShow paramSnsShow;
	static SocialShow paramSocialShow;
	static SnsFriends paramSnsFriends;
	static SnsMessage paramSnsMessage;
	static SnsSession paramSnsSession;
	static InappPurchase paramInappPurchase;
	static InappFinish paramInappFinish;
	static InappRequestBalance paramInappRequestBalance;
	static InappPrepare paramInappPrepare;
	static TrackerSendEvent paramTrackerSendEvent;
	static TrackerSetEnable paramTrackerSetEnable;
	static PromotionAcquisition paramPromotionAcquisition;		// add (HIVE 1.9.0)
	static SocialInfo paramSocialInfo;							// HIVE 1.10.0
	static HiveIAPInfo paramHiveIAPInfo;						// HIVE 1.10.0
	static HiveIAPShow paramHiveIAPShow;						// HIVE 1.10.0
	static HiveIAPPurchase paramHiveIAPPurchase;				// HIVE 1.10.0
	static EngageConsumeCoupon paramEngageComsumeCoupon;			// HIVE 1.10.0
	static HiveIAPInfoItem paramHiveIAPInfoItem;					// HIVE 1.10.0
	static std::vector<HiveIAPInfoItem> paramHiveIAPInfoItemList;	// HIVE 1.10.0
	static std::vector<HiveIAPInfoItem> paramHiveIAPInfoItemPurchaseList;	// HIVE 1.10.0
	static HivePromotion paramHivePromotion;					// HIVE 1.12.0
	static PromotionBannerInfo paramPromotionBannerInfo;		// HIVE 1.18.3
	static PromotionBannerInfo paramHivePromotionBannerInfo;	// HIVE 1.18.3
	static InAppV4 paramInAppV4;		// HIVE 1.18.4

	static SceneChecker paramSceneChecker;
	static SampleSetting paramSampleSetting;

	static AppId paramAppId;
    static SendData paramSendData;

	// variable

	// function

};

#endif // __PARAMETER_H__
