//
//  FriendsParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/19.
//

#ifndef FriendsParamScene_hpp
#define FriendsParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class FriendsParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_FACEBOOK_INVITATION_USER_LIMIT,
        //
        EDITBOX_FACEBOOK_FRIENDS_MESSAGE,
        //
        TOGGLE_BUTTON_USE_VID_OR_UID,
        EDITBOX_FRIENDS_VID_OR_UID,
        // EDITBOX_FRIENDS_MESSAGE
        EDITBOX_FRIENDS_IMAGE_URL,
        EDITBOX_FRIENDS_THUMBNAIL_URL,
        TOGGLE_BUTTON_FRIENDS_USEPUSH,
        TOGGLE_BUTTON_FRIENDS_INVITE,
    };

    CREATE_FUNC(FriendsParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::FriendsSceneFunc api;
    function<void()> setCompletionHandler;

    void showFacebookInvitationUserParam(function<void()> completionHandler);
    void showFacebookMessageParam(function<void()> completionHandler);
    void showHiveMessageParam(function<void()> completionHandler);
};


#endif /* FriendsParamScene_hpp */
