//
//  HiveWebviewParamScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/19.
//

#include "HiveWebviewParamScene.hpp"
#include "ParameterSDKv1DataManager.hpp"
#include "ui/CocosGUI.h"
#include <map>

using namespace::std;
using namespace cocos2d;
using namespace cocos2d::ui;
using namespace hive;


bool HiveWebviewParamScene::init()
{
    if(!BaseView::init())
        return false;

    addButton("OK", BUTTON_OK);

    scheduleUpdate();

    return true;
}

void HiveWebviewParamScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if (firstRun) {
        firstRun = false;
    }
}

void HiveWebviewParamScene::onButtonEvent(int buttonTag)
{
    if (buttonTag != BUTTON_OK) {
        return;
    }

    setCompletionHandler();
    this->popView();
}

void HiveWebviewParamScene::showParameters(int tag)
{
    api = static_cast<SDKv1FuncList::HiveWebviewSceneFunc>(tag);
    switch (api) {
        case SDKv1FuncList::HIVE_WEBVIEW_SCENE_CHATBOT: {
            showChatbotParam([=]() {
                // limit
                string additionalInfo = getEditboxValue(EDITBOX_CHATBOT_ADDITIONAL_INFO);
                ParameterSDKv1DataManager::getInstance()->hiveWebviewParameters->setAdditionalInfo(additionalInfo);
            });
            break;
        }
        case SDKv1FuncList::HIVE_WEBVIEW_SCENE_MESSAGE: {
            showHiveMessageParam([=]() {
                // uid
                string uid = getEditboxValue(EDITBOX_HIVE_MESSAGE_UID);
                ParameterSDKv1DataManager::getInstance()->hiveWebviewParameters->setUid(uid);
            });
            break;
        }
        default:
            break;
    }
}

void HiveWebviewParamScene::showChatbotParam(function<void()> completionHandler)
{
    setUseBackButton(true, "- 챗봇 -");
    setCompletionHandler = completionHandler;

    // additionalInfo
    string additionalInfo = ParameterSDKv1DataManager::getInstance()->hiveWebviewParameters->getAdditionalInfo();
    addEditBox("additionalInfo : ", additionalInfo.c_str(), "", EDITBOX_CHATBOT_ADDITIONAL_INFO);
}

void HiveWebviewParamScene::showHiveMessageParam(function<void()> completionHandler)
{
    setUseBackButton(true, "- 쪽지보기 -");
    setCompletionHandler = completionHandler;

    // uid
    string uid = ParameterSDKv1DataManager::getInstance()->hiveWebviewParameters->getUid();
    addEditBox("uid : ", uid.c_str(), "", EDITBOX_HIVE_MESSAGE_UID);
}
