//
//  HiveWebviewParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/19.
//

#ifndef HiveWebviewParamScene_hpp
#define HiveWebviewParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class HiveWebviewParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_CHATBOT_ADDITIONAL_INFO,
        //
        EDITBOX_HIVE_MESSAGE_UID,
    };

    CREATE_FUNC(HiveWebviewParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::HiveWebviewSceneFunc api;
    function<void()> setCompletionHandler;

    void showChatbotParam(function<void()> completionHandler);
    void showHiveMessageParam(function<void()> completionHandler);
};


#endif /* HiveWebviewParamScene_hpp */
