//
//  IAPV4ParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/28.
//

#ifndef IAPV4ParamScene_hpp
#define IAPV4ParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class IAPV4ParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        COMBOBOX_TYPE,
        EDITBOX_MARKET_PID_LIST,
        EDITBOX_PID,
        COMBOBOX_PID,
        EDITBOX_IAPPAYLOAD,
        //
        EDITBOX_POST_ID,
        //
        EDITBOX_CATEGORY_ID
    };

    CREATE_FUNC(IAPV4ParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::InAppV4SceneFunc api;
    function<void()> setCompletionHandler;

    void showItemInfoParam(function<void()> completionHandler);
    void showPurchaseParam(function<void()> completionHandler);
    void showRestoreParam(function<void()> completionHandler);
    void showTransactionFinishParam(function<void()> completionHandler);
    void showPostBoxReceiveParam(function<void()> completionHandler);
    void showShowInAppMessagesParam(function<void()> completionHandler);
};


#endif /* IAPV4ParamScene_hpp */
