//
//  InitializeParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/06.
//

#ifndef InitializeParamScene_hpp
#define InitializeParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class InitializeParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        COMBOBOX_SERVER,
        TOGGLE_BUTTON_SHOW_LOG,
        COMBOBOX_APPID,
        EDITBOX_APPID,
        EDITBOX_FACEBOOK_PERMISSIONS,
        EDITBOX_SERVER_ID,
        TOGGLE_BUTTON_PERMISSION_WRITE_EXTERNAL_STORAGE,
        TOGGLE_BUTTON_SHOW_NOTICE,
        TOGGLE_BUTTON_USE_HIVEPROMOTION,
        EDITBOX_GAME_LANGUAGE,
        EDITBOX_TIMEOUT_SECONDS,
        TOGGLE_BUTTON_SHOW_PERMISSION,
        TOGGLE_BUTTON_USE_IMAGE_BANNER,
        TOGGLE_BUTTON_USE_HERCULES,
        COMBOBOX_HIVE_ORIENTATION,
        EDITBOX_CHANNEL,
        //
        EDITBOX_GUEST_VID,
        EDITBOX_GUEST_SESSION_TOKEN,
        //
        EDITBOX_REQUEST_PERMISSION,
    };

    CREATE_FUNC(InitializeParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::InitializeSceneFunc api;
    function<void()> setCompletionHandler;
    
    void showInitializeParam(function<void()> completionHandler);
    void showSetGuestUserInfoParam(function<void()> completionHandler);
};



#endif /* InitializeParamScene_hpp */
