//
//  LoginParamScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/10.
//

#include "LoginParamScene.hpp"
#include "ParameterSDKv1DataManager.hpp"
#include "ui/CocosGUI.h"
#include <map>

using namespace::std;
using namespace cocos2d;
using namespace cocos2d::ui;
using namespace hive;


bool LoginParamScene::init()
{
    if(!BaseView::init())
        return false;

    addButton("OK", BUTTON_OK);

    scheduleUpdate();

    return true;
}

void LoginParamScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if (firstRun) {
        firstRun = false;
    }
}

void LoginParamScene::onButtonEvent(int buttonTag)
{
    if (buttonTag != BUTTON_OK) {
        return;
    }

    setCompletionHandler();
    this->popView();
}

void LoginParamScene::showParameters(int tag)
{
    api = static_cast<SDKv1FuncList::LoginSceneFunc>(tag);
    switch (api) {
        case SDKv1FuncList::LOGIN_SCENE_CUSTOM_SELECT: {
            showCustomSelectParam([=]() {
                // customSelectTarget
                string customSelectTarget = getComboboxValue(COMBOBOX_CUSTOM_SELECT);
                ParameterSDKv1DataManager::getInstance()->loginParameters->setCustomSelectTarget(customSelectTarget);
            });
            break;
        }
        default:
            break;
    }
}

void LoginParamScene::showCustomSelectParam(function<void()> completionHandler)
{
    setUseBackButton(true, "- Custom Select -");
    setCompletionHandler = completionHandler;

    // 게스트 or Hive 유저 선택
    vector<const char*> customSelectTargetList = { "use_hive_user_info",
                                            "use_guest_user_info"};
    string customSelectTarget = ParameterSDKv1DataManager::getInstance()->loginParameters->getCustomSelectTarget();
    int findIndex = static_cast<int>(find(customSelectTargetList.begin(), customSelectTargetList.end(),
                                          customSelectTarget) - customSelectTargetList.begin());

    addCombobox("CustomSelectTarget : ", customSelectTargetList, findIndex, COMBOBOX_CUSTOM_SELECT);
}
