//
//  ParameterSDKv1DataManager.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/07.
//

#ifndef ParameterSDKv1DataManager_hpp
#define ParameterSDKv1DataManager_hpp

#include "../../../Classes/BaseView.hpp"
#include "DefaultSDKv1Parameters.hpp"
#include "ResultDelegate.hpp"
#include "picojson.h"
#include <stdio.h>

using namespace std;


class ParameterSDKv1DataManager
{
public:
    static ParameterSDKv1DataManager* getInstance()
    {
        if (instance == NULL) instance = new ParameterSDKv1DataManager();
        return instance;
    }

    ResultDelegate* resultDelegate;
    LogManager* logManager;
    CurrentValue* currentValue;
    InitializeParameters* initializeParameters;
    LoginParameters* loginParameters;
    PushMessageParameters* pushMessageParameters;
    UserInfoParameters* userInfoParameters;
    SnsPostParameters* snsPostParameters;
    PromotionV1Parameters* promotionV1Parameters;
    PromotionV1InfoParameters* promotionV1InfoParameters;
    UserAcquisitionParameters* userAcquisitionParameters;
    FriendsParameters* friendsParameters;
    HiveWebviewParameters* hiveWebviewParameters;
    TrackingParameters* trackingParameters;
    UserEngagementParameters* userEngagementParameters;
    PromotionV2Parameters* promotionV2Parameters;
    PromotionV2InfoParameters* promotionV2InfoParameters;
    SetGameInfoParameters* setGameInfoParameters;
    IAPV4Parameters* iapv4Parameters;

    picojson::value parseStringToJsonData(string value);
    // 로그인 성공시 전달 받았던 guestUid, uid, sessionKey 초기화
    void onLogOut();

private:
    ParameterSDKv1DataManager() {
        resultDelegate = new ResultDelegate();
        logManager = new LogManager();
        currentValue = new CurrentValue();
        initializeParameters = new InitializeParameters();
        loginParameters = new LoginParameters();
        pushMessageParameters = new PushMessageParameters();
        userInfoParameters = new UserInfoParameters();
        snsPostParameters = new SnsPostParameters();
        promotionV1Parameters = new PromotionV1Parameters();
        promotionV1InfoParameters = new PromotionV1InfoParameters();
        userAcquisitionParameters = new UserAcquisitionParameters();
        friendsParameters = new FriendsParameters();
        hiveWebviewParameters = new HiveWebviewParameters();
        trackingParameters = new TrackingParameters();
        userEngagementParameters = new UserEngagementParameters();
        promotionV2Parameters = new PromotionV2Parameters();
        promotionV2InfoParameters = new PromotionV2InfoParameters();
        setGameInfoParameters = new SetGameInfoParameters();
        iapv4Parameters = new IAPV4Parameters();
    };
    ParameterSDKv1DataManager(const ParameterSDKv1DataManager& other);
    ~ParameterSDKv1DataManager() {
        resultDelegate = NULL;
        logManager = NULL;
        currentValue = NULL;
        initializeParameters = NULL;
        loginParameters = NULL;
        pushMessageParameters = NULL;
        userInfoParameters = NULL;
        snsPostParameters = NULL;
        promotionV1Parameters = NULL;
        promotionV1InfoParameters = NULL;
        userAcquisitionParameters = NULL;
        friendsParameters = NULL;
        hiveWebviewParameters = NULL;
        trackingParameters = NULL;
        userEngagementParameters = NULL;
        promotionV2Parameters = NULL;
        promotionV2InfoParameters = NULL;
        setGameInfoParameters = NULL;
        iapv4Parameters = NULL;
    };

    static ParameterSDKv1DataManager* instance;
};

#endif /* ParameterSDKv1DataManager_hpp */
