//
//  PromotionV1InfoParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/17.
//

#ifndef PromotionV1InfoParamScene_hpp
#define PromotionV1InfoParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class PromotionV1InfoParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_VIEWINFO_VIEW_ID,
        //
        COMBOBOX_BANNERINFO_CAMPAIGN_TYPE,
        COMBOBOX_BANNERINFO_BANNER_TYPE,
        EDITBOX_BANNERINFO_CAMPAIGN_TYPE,
        EDITBOX_BANNERINFO_BANNER_TYPE,
    };

    CREATE_FUNC(PromotionV1InfoParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::PromotionInfoSceneFunc api;
    function<void()> setCompletionHandler;

    void showBadgeCustomViewParam(function<void()> completionHandler);
    void showViewCustomViewParam(function<void()> completionHandler);
    void showBannerInfoParam(function<void()> completionHandler);
};


#endif /* PromotionV1InfoParamScene_hpp */
