//
//  PromotionV1ParamScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/17.
//

#include "PromotionV1ParamScene.hpp"
#include "ParameterSDKv1DataManager.hpp"
#include "ui/CocosGUI.h"
#include <map>

using namespace::std;
using namespace cocos2d;
using namespace cocos2d::ui;
using namespace hive;


bool PromotionV1ParamScene::init()
{
    if(!BaseView::init())
        return false;

    addButton("OK", BUTTON_OK);

    scheduleUpdate();

    return true;
}

void PromotionV1ParamScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if (firstRun) {
        firstRun = false;
    }
}

void PromotionV1ParamScene::onButtonEvent(int buttonTag)
{
    if (buttonTag != BUTTON_OK) {
        return;
    }

    setCompletionHandler();
    this->popView();
}

void PromotionV1ParamScene::showParameters(int tag)
{
    api = static_cast<SDKv1FuncList::PromotionSceneFunc>(tag);
    switch (api) {
        case SDKv1FuncList::PROMOTION_SCENE_CUSTOM_WEBVIEW: {
            showCustomWebviewParam([=]() {
                // viewId
                string viewId = getEditboxValue(EDITBOX_PROMOTION_CUSTOM_WEBVIEW_ID);
                ParameterSDKv1DataManager::getInstance()->promotionV1Parameters->setViewId(viewId);
            });
            break;
        }
        default:
            break;
    }
}

void PromotionV1ParamScene::showCustomWebviewParam(function<void()> completionHandler)
{
    setUseBackButton(true, "- CustomWebview -");
    setCompletionHandler = completionHandler;

    // viewId
    string viewId = ParameterSDKv1DataManager::getInstance()->promotionV1Parameters->getViewId();
    addEditBox("viewId : ", viewId.c_str(), "", EDITBOX_PROMOTION_CUSTOM_WEBVIEW_ID);
}
