//
//  PromotionV2InfoParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/20.
//

#ifndef PromotionV2InfoParamScene_hpp
#define PromotionV2InfoParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class PromotionV2InfoParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_CUSTOM_VIEW_CONTENT_KEY,
        EDITBOX_CUSTOM_BOARD_CONTENT_KEY,
        EDITBOX_SPOT_CONTENT_KEY,
        EDITBOX_DIRECT_CONTENT_KEY,
        //
        EDITBOX_ADDITIONAL_INFO,
        //
        COMBOBOX_BANNERINFO_CAMPAIGN_TYPE,
        COMBOBOX_BANNERINFO_BANNER_TYPE,
        EDITBOX_BANNERINFO_CAMPAIGN_TYPE,
        EDITBOX_BANNERINFO_BANNER_TYPE,
    };

    CREATE_FUNC(PromotionV2InfoParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::HivePromotionInfoSceneFunc api;
    function<void()> setCompletionHandler;

    void showCustomViewParam(function<void()> completionHandler);
    void showCustomBoardParam(function<void()> completionHandler);
    void showSpotParam(function<void()> completionHandler);
    void showDirectParam(function<void()> completionHandler);
    void showAdditionalInfoParam(function<void()> completionHandler);
    void showBannerInfoParam(function<void()> completionHandler);
};


#endif /* PromotionV2InfoParamScene_hpp */
