//
//  PromotionV2ParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/20.
//

#ifndef PromotionV2ParamScene_hpp
#define PromotionV2ParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class PromotionV2ParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        TOGGLE_BUTTON_NEWS_FORCED,
        TOGGLE_BUTTON_BANNER_FORCED,
        TOGGLE_BUTTON_NOTICE_FORCED,
        EDITBOX_CUSTOM_VIEW_CONTENT_KEY,
        EDITBOX_CUSTOM_BOARD_CONTENT_KEY,
        EDITBOX_SPOT_CONTENT_KEY,
        EDITBOX_DIRECT_CONTENT_KEY,
    };

    CREATE_FUNC(PromotionV2ParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::HivePromotionSceneFunc api;
    function<void()> setCompletionHandler;

    void showNewsParam(function<void()> completionHandler);
    void showBannerParam(function<void()> completionHandler);
    void showNoticeParam(function<void()> completionHandler);
    void showCustomViewParam(function<void()> completionHandler);
    void showCustomBoardParam(function<void()> completionHandler);
    void showSpotParam(function<void()> completionHandler);
    void showDirectParam(function<void()> completionHandler);
};


#endif /* PromotionV2ParamScene_hpp */
