//
//  PushMessageParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/12.
//

#ifndef PushMessageParamScene_hpp
#define PushMessageParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class PushMessageParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_PUSH_ID,
        EDITBOX_PUSH_TITLE,
        EDITBOX_PUSH_MESSAGE,
        EDITBOX_PUSH_AFTER,
        COMBOBOX_PUSH_TYPE,
        EDITBOX_PUSH_GROUPID,
        //
        // EDITBOX_PUSH_ID      // push unregister
        //
        COMBOBOX_DESC_USE_PUSH,
        COMBOBOX_DESC_SOUND,
        COMBOBOX_DESC_VIBRATE,
        COMBOBOX_DESC_OPERATION_GCM,
        COMBOBOX_DESC_OPERATION_LOCAL,
        COMBOBOX_DESC_USE_NOTICE,
        COMBOBOX_DESC_USE_NIGHT,
    };

    CREATE_FUNC(PushMessageParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::PushSceneFunc api;
    function<void()> setCompletionHandler;

    void showPushRegisterParam(function<void()> completionHandler);
    void showPushUnRegisterParam(function<void()> completionHandler);
    void showPushDescriptionParam(function<void()> completionHandler);
};


#endif /* PushMessageParamScene_hpp */
