//
//  ResultDelegate.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/10.
//

#ifndef ResultDelegate_hpp
#define ResultDelegate_hpp

#include "../../src/C2SModuleApi.h"
#include "../../src/C2SModuleErrorCode.h"
#include "../../../Classes/BaseView.hpp"
#include "../../src/cocos2d-x/Module_Cocos2d-x.h"
#include "../../src/C2SModule.h"
#include "../../../Classes/Postbox.hpp"
#include <stdio.h>
#include <string>

using namespace std;


class ResultDelegate {
public:
    //
    static void SDKv1ResultDelegate(C2SModuleApi api, const char* json, C2SModuleErrorCode code, const char* message);
    string getApiName(C2SModuleApi api);
    string getBoolToString(bool value);
    void postBoxV1Login();
    void postBoxV1Refresh();
    void postBoxV1UserInfo();
    void postBoxV1VerifyReceipt(string byPassInfo, string productType);
    void postBoxV1Receive(string postId);
};

class LogManager: public BaseView {
public:
    CREATE_FUNC(LogManager);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag)  override;

    //
    void addAPICallLog(string apiName, string argument);
    void addErrorLog(string apiName, C2SModule_Cocos2dx::C2SModuleError error);
    void addCallbackLog(string apiName, const char* argument, C2SModuleErrorCode code, const char* message);
};
#endif /* ResultDelegate_hpp */
