//
//  SDKv1FuncList.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/06.
//

#ifndef SDKv1APIList_hpp
#define SDKv1APIList_hpp

#include <stdio.h>


class SDKv1FuncList
{
public:
    enum InitializeSceneFunc: int {
        INITIALIZE_SCENE_INITIALIZE = 0,
        INITIALIZE_SCENE_SET_GUESTUSER_INFO,
        INITIALIZE_SCENE_REQUEST_PERMISSION,
        INITIALIZE_SCENE_PERMISSION_DATA,
    };

    enum LoginSceneFunc: int {
        LOGIN_SCENE_HIVE = 0,
        LOGIN_SCENE_GUEST,
        LOGIN_SCENE_LOGIN_TYPE,
        LOGIN_SCENE_SELECT,
        LOGIN_SCENE_CUSTOM_SELECT,
        LOGIN_SCENE_EMERGENCY_MODE,
        LOGIN_SCENE_GET_GOOGLE_PLAY_GAMES_SESSION,
    };

    enum InfoSceneFunc: int {
        INFO_SCENE_SAMPLE_INFO = 0,
    };

    enum PushSceneFunc: int {
        PUSH_SCENE_REGISTER = 0,
        PUSH_SCENE_UNREGISTER,
        PUSH_SCENE_DESCRIPTION,
        PUSH_SCENE_REGISTER_MULTI,
        PUSH_SCENE_UNREGISTER_MULTI,
        PUSH_SCENE_REQUEST_PUSH_PERMISSION,
    };

    enum UserInfoSceneFunc: int {
        USERINFO_SCENE_HIVE_USER = 0,
        USERINFO_SCENE_FACEBOOK_USER,
        USERINFO_SCENE_CHECK_NEW_MESSAGE,
        USERINFO_SCENE_DELETE_ID,
    };

    enum SnsPostSceneFunc: int {
        SNSPOST_SCENE_FACEBOOK = 0,
        SNSPOST_SCENE_GOOGLEPLUS,
    };

    enum PromotionSceneFunc: int {
        PROMOTION_SCENE_NOTICE = 0,
        PROMOTION_SCENE_NOTICE_FORCED,
        PROMOTION_SCENE_EVENT,
        PROMOTION_SCENE_EVENT_FORCED,
        PROMOTION_SCENE_FULLBANNER,
        PROMOTION_SCENE_FULLBANNER_LEGACY,
        PROMOTION_SCENE_OFFERWALL,
        PROMOTION_SCENE_NOTICE_ONLY,
        PROMOTION_SCENE_CUSTOM_WEBVIEW,
        PROMOTION_SCENE_REVIEW,
        PROMOTION_SCENE_MOREGAMES,
        PROMOTION_SCENE_REVIEW_NATIVE,
    };

    enum PromotionInfoSceneFunc: int {
        PROMOTION_INFO_SCENE_BADGE_NOTICE = 0,
        PROMOTION_INFO_SCENE_BADGE_EVENT,
        PROMOTION_INFO_SCENE_BADGE_NOTICE_ONLY,
        PROMOTION_INFO_SCENE_BADGE_CUSTOM_WEBVIEW,
        PROMOTION_INFO_SCENE_VIEW_FULLBANNER,
        PROMOTION_INFO_SCENE_VIEW_NOTICE,
        PROMOTION_INFO_SCENE_VIEW_EVENT,
        PROMOTION_INFO_SCENE_VIEW_NOTICE_ONLY,
        PROMOTION_INFO_SCENE_VIEW_CUSTOM_WEBVIEW,
        PROMOTION_INFO_SCENE_GET_OFFERWALL_STATE,
        PROMOTION_INFO_SCENE_BANNERINFO,
    };

    enum UserAcquisitionSceneFunc: int {
        UA_SCENE_INFO = 0,
        UA_SCENE_QRCODE_SHARE,
        UA_SCENE_UA_LINK_SHARE,
        UA_SCENE_LINK_AND_MESSAGE_SHARE,
        UA_SCENE_HIVE_MESSAGE_WITH_UA_INFO,
        UA_SCENE_UA_SENDER_INFO,
    };

    enum FriendsSceneFunc: int {
        FRIENDS_SCENE_GAME_FRIENDS = 0,
        FRIENDS_SCENE_NOT_GAME_FRIENDS,
        FRIENDS_SCENE_ALL_FRIENDS,
        FRIENDS_SCENE_FACEBOOK_INVITATION_USER,
        FRIENDS_SCENE_FACEBOOK_SEND_MESSAGE,
        FRIENDS_SCENE_HIVE_SEND_MESSAGE,
        FRIENDS_SCENE_HIVE_SESSION,
        FRIENDS_SCENE_FACEBOOK_SESSION,
        FRIENDS_SCENE_FACEBOOK_FRIENDS_LIST
    };

    enum HiveWebviewSceneFunc: int {
        HIVE_WEBVIEW_SCENE_HOME = 0,
        HIVE_WEBVIEW_SCENE_PROFILE,
        HIVE_WEBVIEW_SCENE_EDIT_PROFILE,
        HIVE_WEBVIEW_SCENE_INQUIRY,
        HIVE_WEBVIEW_SCENE_CHATBOT,
        HIVE_WEBVIEW_SCENE_TERMS,
        HIVE_WEBVIEW_SCENE_MESSAGE,
        HIVE_WEBVIEW_SCENE_ADULT_AUTH,
        HIVE_WEBVIEW_SCENE_NOTICE_SHOW,
        HIVE_WEBVIEW_SCENE_NOTICE_INFO,
        HIVE_WEBVIEW_SCENE_PERMISSION_INFO,
        HIVE_WEBVIEW_SCENE_REQUEST_ANDROID_PERMISSION,
    };

    enum TrackingSceneFunc: int {
        TRACKER_SCENE_SEND_EVENT = 0,
        TRACKER_SCENE_ENABLE,
    };

    enum EngagementSceneFunc: int {
        UE_SCENE_GET_EVENT = 0,
        UE_SCENE_CONSUME_COUPON,
        UE_SCENE_SET_READY,
    };

    enum HivePromotionSceneFunc: int {
        HIVE_PROMOTION_SCENE_NEWS = 0,
        HIVE_PROMOTION_SCENE_BANNER,
        HIVE_PROMOTION_SCENE_NOTICE,
        HIVE_PROMOTION_SCENE_CUSTOM_VIEW,
        HIVE_PROMOTION_SCENE_CUSTOM_BOARD,
        HIVE_PROMOTION_SCENE_SPOT_BANNER,
        HIVE_PROMOTION_SCENE_DIRECT_BANNER,
        HIVE_PROMOTION_SCENE_OFFERWALL,
        HIVE_PROMOTION_SCENE_REVIEW,
        HIVE_PROMOTION_SCENE_MOREGAMES,
        HIVE_PROMOTION_SCENE_REVIEW_NATIVE,
    };

    enum HivePromotionInfoSceneFunc: int {
        HIVE_PROMOTION_INFO_SCENE_BADGE = 0,
        HIVE_PROMOTION_INFO_SCENE_CUSTOM_VIEW,
        HIVE_PROMOTION_INFO_SCENE_CUSTOM_BOARD,
        HIVE_PROMOTION_INFO_SCENE_SPOT,
        HIVE_PROMOTION_INFO_SCENE_DIRECT,
        HIVE_PROMOTION_INFO_SCENE_SET_ADDITIONALINFO,
        HIVE_PROMOTION_INFO_SCENE_GET_OFFERWALL_STATE,
        HIVE_PROMOTION_INFO_SCENE_BANNERINFO,
        HIVE_PROMOTION_INFO_SCENE_UPDATE_PROMOTION_DATA,
    };

    enum SetGameInfoSceneFunc: int {
        SET_GAME_INFO_SCENE_SET_GAME_INFO = 0,
        SET_GAME_INFO_SCENE_GET_HIVE_COUNTRY,
        SET_GAME_INFO_SCENE_GET_CHANNEL,
        SET_GAME_INFO_SCENE_SET_CHANNEL,
        SET_GAME_INFO_SCENE_UPDATE_SERVER_ID,
        SET_GAME_INFO_SCENE_UPDATE_GAMELANGUAGE,
        SET_GAME_INFO_SCENE_SEND_DATA_FUNNELS,
    };

    enum InAppV4SceneFunc: int {
        INAPPV4_SCENE_ITEM_INFO = 0,
        INAPPV4_SCENE_PURCHASE,
        INAPPV4_SCENE_RESTORE,
        INAPPV4_SCENE_TRANSACTION_FINISH,
        INAPPV4_SCENE_GET_SELECTED_MARKET,
        INAPPV4_SCENE_MARKET_CONNECT,
        INAPPV4_SCENE_HIVE_ACCOUNT_UUID,
        INAPPV4_SCENE_SELECT_MARKET,
        INAPPV4_SCENE_LEBI_BALANCE,
        INAPPV4_SCENE_LEBI_CHARGE,
        INAPPV4_SCENE_POSTBOX_STATE,
        INAPPV4_SCENE_POSTBOX_RECEIVE,
        INAPPV4_SCENE_IOS_CHECKREMOTE,
        INAPPV4_SCENE_ANDROID_SHOW_INAPP_MESSAGES,
    };

};

#endif /* SDKv1FuncList_hpp */
