//
//  SDKv1MainScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/10.
//

#include "SDKv1MainScene.h"
#include "SDKv1ModuleListScene.hpp"
#include "ParameterSDKv1DataManager.hpp"
#include "../../src/C2SModuleApi.h"
#include "../../src/C2SModuleErrorCode.h"
#include "C2SModule.h"
#include "ResultDelegate.hpp"

#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
#include "../../../proj.android/app/jni/hellocpp/JNISample.h"
#endif

USING_NS_CC;


Scene* SDKv1MainScene::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();

    // 'layer' is an autorelease object
    auto layer = SDKv1MainScene::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool SDKv1MainScene::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !LayerColor::initWithColor(Color4B::BLACK) )
    {
        return false;
    }


    /**
     * SDK v1 전역 콜백 설정
     */
    ::CommonResultDelegate resultDelegate = ParameterSDKv1DataManager::getInstance()->resultDelegate->SDKv1ResultDelegate;
    ::C2SModuleSocial_SetCommonResultDelegate(resultDelegate);


    this->addChild(SDKv1ModuleListScene::create());

    return true;
}
