//
//  SDKv1ModuleListScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/10.
//

#include "SDKv1ModuleListScene.hpp"
#include "InitializeScene.hpp"
#include "LoginScene.hpp"
#include "InfoScene.hpp"
#include "PushMessageScene.hpp"
#include "UserInfoScene.hpp"
#include "SnsPostScene.hpp"
#include "PromotionV1Scene.hpp"
#include "PromotionV1InfoScene.hpp"
#include "UserAcquisitionScene.hpp"
#include "FriendsScene.hpp"
#include "HiveWebviewScene.hpp"
#include "TrackingScene.hpp"
#include "UserEngagementScene.hpp"
#include "PromotionV2Scene.hpp"
#include "PromotionV2InfoScene.hpp"
#include "SetGameInfoScene.hpp"
#include "IAPV4Scene.hpp"
#include <map>
#include <iostream>

using namespace::std;


#define MAKE_VIEW_CREATE_2(x) [](BaseView* view){ view->pushView(x::create());  }

std::function<void(BaseView* view)> SDKv1ModuleListSceneChange[] = {
    MAKE_VIEW_CREATE_2(InitializeScene),
    MAKE_VIEW_CREATE_2(LoginScene),
    MAKE_VIEW_CREATE_2(InfoScene),
    MAKE_VIEW_CREATE_2(PushMessageScene),
    MAKE_VIEW_CREATE_2(UserInfoScene),
    MAKE_VIEW_CREATE_2(SnsPostScene),
    MAKE_VIEW_CREATE_2(PromotionV1Scene),
    MAKE_VIEW_CREATE_2(PromotionV1InfoScene),
    MAKE_VIEW_CREATE_2(UserAcquisitionScene),
    MAKE_VIEW_CREATE_2(FriendsScene),
    MAKE_VIEW_CREATE_2(HiveWebviewScene),
    MAKE_VIEW_CREATE_2(TrackingScene),
    MAKE_VIEW_CREATE_2(UserEngagementScene),
    MAKE_VIEW_CREATE_2(PromotionV2Scene),
    MAKE_VIEW_CREATE_2(PromotionV2InfoScene),
    MAKE_VIEW_CREATE_2(SetGameInfoScene),
    MAKE_VIEW_CREATE_2(IAPV4Scene),
};

bool SDKv1ModuleListScene::init()
{
    if(!BaseView::init())
        return false;

    const char* buttons[]={
        "1. 초기화",
        "2. 로그인",
        "[샘플 정보 보기]",
        "3. Push 메시지",
        "4. 유저 정보",
        "5. Sns 포스팅",
        "6. 프로모션",
        "7. 프로모션 정보",
        "8. 프로모션 집객",
        "9. 친구 초대",
        "10. Hive 웹뷰, 팝업",
        "11. 마케팅 트래킹툴",
        "12. 유저 인게이지먼트",
        "13. Hive 프로모션",
        "14. Hive 프로모션 정보",
        "15. SetGameInfo",
        "16. InAppV4",
    };


    for (int i=0; i<sizeof(buttons)/sizeof(*buttons); i++) {
        addButton(buttons[i], i);
    }

    scheduleUpdate();

    /**
     * SDK v1의 메인 기능 호출 버튼의 높이 조정
     * (갱행 후 API 이름을 추가하게 되어서 높이를 조정함)
     */
    setSDKv1NormalButtonHeight();

    return true;
}

void SDKv1ModuleListScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if(firstRun) {
        firstRun = false;
    }
}

void SDKv1ModuleListScene::onButtonEvent(int buttonTag)
{
    SDKv1ModuleListSceneChange[buttonTag](this);
}

void SDKv1ModuleListScene::setSDKv1NormalButtonHeight()
{
    setButtonHeight(DEFAULT_CONTENT_HEIGHT + 20);
}
