//
//  SetGameInfoParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/24.
//

#ifndef SetGameInfoParamScene_hpp
#define SetGameInfoParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class SetGameInfoParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_SERVER_ID,
        EDITBOX_GAME_LANGUAGE,
        TOGGLE_BUTTON_EMERGENCY_MODE,
        EDITBOX_CHANNEL,
        //
        EDITBOX_FUNNELS_ID,
        EDITBOX_OPTION_TAG,
    };

    CREATE_FUNC(SetGameInfoParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::SetGameInfoSceneFunc api;
    function<void()> setCompletionHandler;

    void showSetGameInfoParam(function<void()> completionHandler);
    void showSetChannelParam(function<void()> completionHandler);
    void showUpdateServerIdParam(function<void()> completionHandler);
    void showUpdateGameLanguageParam(function<void()> completionHandler);
    void showSendDataParam(function<void()> completionHandler);
};


#endif /* SetGameInfoParamScene_hpp */
