//
//  SnsPostParamScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/17.
//

#include "SnsPostParamScene.hpp"
#include "ParameterSDKv1DataManager.hpp"
#include "ui/CocosGUI.h"
#include <map>

using namespace::std;
using namespace cocos2d;
using namespace cocos2d::ui;
using namespace hive;


bool SnsPostParamScene::init()
{
    if(!BaseView::init())
        return false;

    addButton("OK", BUTTON_OK);

    scheduleUpdate();

    return true;
}

void SnsPostParamScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if (firstRun) {
        firstRun = false;
    }
}

void SnsPostParamScene::onButtonEvent(int buttonTag)
{
    if (buttonTag != BUTTON_OK) {
        return;
    }

    setCompletionHandler();
    this->popView();
}

void SnsPostParamScene::showParameters(int tag)
{
    api = static_cast<SDKv1FuncList::SnsPostSceneFunc>(tag);
    switch (api) {
        case SDKv1FuncList::SNSPOST_SCENE_FACEBOOK: {
            showFacebookPostParam([=]() {
                // appLinkURL
                string appLinkURL = getEditboxValue(EDITBOX_FACEBOOK_APPLINKURL);
                ParameterSDKv1DataManager::getInstance()->snsPostParameters->setFacebookAppLinkUrl(appLinkURL);
            });
            break;
        }
        case SDKv1FuncList::SNSPOST_SCENE_GOOGLEPLUS: {
            showGooglePlusPostParam([=]() {
                // message
                string message = getEditboxValue(EDITBOX_GOOGLEPLUS_MESSAGE);
                ParameterSDKv1DataManager::getInstance()->snsPostParameters->setGooglePlusMessage(message);
            });
            break;
        }
        default:
            break;
    }
}

void SnsPostParamScene::showFacebookPostParam(function<void()> completionHandler)
{
    setUseBackButton(true, "- Facebook 포스팅 -");
    setCompletionHandler = completionHandler;

    // appLinkURL
    string appLinkURL = ParameterSDKv1DataManager::getInstance()->snsPostParameters->getFacebookAppLinkUrl();
    addEditBox("appLinkURL : ", appLinkURL.c_str(), "", EDITBOX_FACEBOOK_APPLINKURL);
}

void SnsPostParamScene::showGooglePlusPostParam(function<void()> completionHandler)
{
    setUseBackButton(true, "- GooglePlus 포스팅-");
    setCompletionHandler = completionHandler;

    // message
    string message = ParameterSDKv1DataManager::getInstance()->snsPostParameters->getGooglePlusMessage();
    addEditBox("message : ", message.c_str(), "", EDITBOX_GOOGLEPLUS_MESSAGE);
}
