//
//  SnsPostParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/17.
//

#ifndef SnsPostParamScene_hpp
#define SnsPostParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class SnsPostParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_FACEBOOK_APPLINKURL,
        //
        EDITBOX_GOOGLEPLUS_MESSAGE,
    };

    CREATE_FUNC(SnsPostParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::SnsPostSceneFunc api;
    function<void()> setCompletionHandler;

    void showFacebookPostParam(function<void()> completionHandler);
    void showGooglePlusPostParam(function<void()> completionHandler);
};


#endif /* SnsPostParamScene_hpp */
