//
//  TrackingParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/19.
//

#ifndef TrackingParamScene_hpp
#define TrackingParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class TrackingParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_EVENT,
        //
        TOGGLE_BUTTON_ENABLE_ADJUST,
        TOGGLE_BUTTON_ENABLE_SINGULAR,
        TOGGLE_BUTTON_ENABLE_APPSFLYER,
    };

    CREATE_FUNC(TrackingParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::TrackingSceneFunc api;
    function<void()> setCompletionHandler;

    void showEventParam(function<void()> completionHandler);
    void showEnableParam(function<void()> completionHandler);
};


#endif /* TrackingParamScene_hpp */
