//
//  UserAcquisitionParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/18.
//

#ifndef UserAcquisitionParamScene_hpp
#define UserAcquisitionParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class UserAcquisitionParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        EDITBOX_UA_ADDITIONAL_INFO,
        //
        EDITBOX_UA_MESSAGE,
        EDITBOX_UA_LINK_SHARE_URL,
        //
        TOGGLE_BUTTON_USE_VID_OR_UID,
        EDITBOX_UA_VID_OR_UID,
        // EDITBOX_UA_MESSAGE
        EDITBOX_UA_IMAGE_URL,
        EDITBOX_UA_THUMBNAIL_URL,
        TOGGLE_BUTTON_UA_USEPUSH,
        TOGGLE_BUTTON_UA_INVITE,
        TOGGLE_BUTTON_UA_LINKSHARE,
        // EDITBOX_UA_LINK_SHARE_URL
    };

    CREATE_FUNC(UserAcquisitionParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::UserAcquisitionSceneFunc api;
    function<void()> setCompletionHandler;

    void showUAInfoParam(function<void()> completionHandler);
    void showUAHiveLinkMessageShareParam(function<void()> completionHandler);
    void showUAHiveInviteLinkShareParam(function<void()> completionHandler);
};


#endif /* UserAcquisitionParamScene_hpp */
