//
//  UserEngagementParamScene.cpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/19.
//

#include "UserEngagementParamScene.hpp"
#include "ParameterSDKv1DataManager.hpp"
#include "ui/CocosGUI.h"
#include <map>

using namespace::std;
using namespace cocos2d;
using namespace cocos2d::ui;
using namespace hive;


bool UserEngagementParamScene::init()
{
    if(!BaseView::init())
        return false;

    addButton("OK", BUTTON_OK);

    scheduleUpdate();

    return true;
}

void UserEngagementParamScene::update(float dt)
{
    BaseView::update(dt);

    static bool firstRun = true;
    if (firstRun) {
        firstRun = false;
    }
}

void UserEngagementParamScene::onButtonEvent(int buttonTag)
{
    if (buttonTag != BUTTON_OK) {
        return;
    }

    setCompletionHandler();
    this->popView();
}

void UserEngagementParamScene::showParameters(int tag)
{
    api = static_cast<SDKv1FuncList::EngagementSceneFunc>(tag);
    switch (api) {
        case SDKv1FuncList::UE_SCENE_CONSUME_COUPON: {
            showConsumeCouponParam([=]() {
                // couponId
                string couponId = getEditboxValue(EDITBOX_COUPON_ID);
                ParameterSDKv1DataManager::getInstance()->userEngagementParameters->setCouponId(couponId);

                // additionalInfo
                string additionalInfo = getEditboxValue(EDITBOX_ADDITIONAL_INFO);
                ParameterSDKv1DataManager::getInstance()->userEngagementParameters->setAdditionalInfo(additionalInfo);
            });
            break;
        }
        default:
            break;
    }
}

void UserEngagementParamScene::showConsumeCouponParam(function<void()> completionHandler)
{
    setUseBackButton(true, "- Consume Coupon -");
    setCompletionHandler = completionHandler;

    // couponId
    string couponId = ParameterSDKv1DataManager::getInstance()->userEngagementParameters->getCouponId();
    addEditBox("couponId : ", couponId.c_str(), "", EDITBOX_COUPON_ID);

    // additionalInfo
    string additionalInfo = ParameterSDKv1DataManager::getInstance()->userEngagementParameters->getAdditionalInfo();
    addEditBox("additionalInfo : ", additionalInfo.c_str(), "", EDITBOX_ADDITIONAL_INFO);
}
