//
//  UserInfoParamScene.hpp
//  HIVE_SDK_Cocos_Sample
//
//  Created by jschoi on 2023/04/14.
//

#ifndef UserInfoParamScene_hpp
#define UserInfoParamScene_hpp

#include "SDKv1FuncList.hpp"
#include "../../../Classes/BaseView.hpp"
#include <stdio.h>
#include <functional>

using namespace std; 


class UserInfoParamScene: public BaseView
{
public:
    enum ButtonParam: int {
        BUTTON_OK = 0,
        //
        COMBOBOX_MY_INFO,
        EDITBOX_OTHER_VID,
        //
        EDITBOX_FACEBOOK_ID,
    };

    CREATE_FUNC(UserInfoParamScene);

    virtual bool init() override;
    virtual void update(float dt) override;
    virtual void onButtonEvent(int buttonTag) override;
    
    void showParameters(int tag);

private:
    SDKv1FuncList::UserInfoSceneFunc api;
    function<void()> setCompletionHandler;

    void showHiveUserInfoParam(function<void()> completionHandler);
    void showFacebookUserInfoParam(function<void()> completionHandler);
};


#endif /* UserInfoParamScene_hpp */
