#include "ParameterListScene.h"
#include "ModuleGroupListScene.h"
#include "ModuleListScene.h"
#include "LogScene.h"
#include "DataManager.h"
#include "LogController.h"
#include "Parameter.h"
#include "Postbox.hpp"
#ifdef __ANDROID__
#include "JNISample.h"
#endif
USING_NS_CC;

// static variable ( UI 위치 )
float ParameterListScene::ui_paddingSize = 0.02;
float ParameterListScene::ui_previousBtn_x = 0.1;
float ParameterListScene::ui_previousBtn_y = 0.85;
float ParameterListScene::ui_moduleListNameLabel_x = 0.5;
float ParameterListScene::ui_moduleListNameLabel_y = 0.85;
float ParameterListScene::ui_loginServerTypeLabel_x = 0.3;
float ParameterListScene::ui_loginServerTypeLabel_y = 0.95;
float ParameterListScene::ui_paramLabel_x = 0.2;
float ParameterListScene::ui_paramLabel_y = 0.75;
float ParameterListScene::ui_textField_x = 0.75;
float ParameterListScene::ui_textField_y = 0.5;
float ParameterListScene::ui_saveParamBtn_x = 0.5;
float ParameterListScene::ui_saveParamBtn_y = 0.2;
float ParameterListScene::ui_showLogBtn_x = 0.85;
float ParameterListScene::ui_showLogBtn_y = 0.05;
float ParameterListScene::ui_paddingSize_y = 0.06;
// static variable ( duplex click variable )
bool ParameterListScene::ui_isOpenedWindow = false;
// static variable ( checkbox )
bool ParameterListScene::ui_checkbox_pushDescription_usePush;
bool ParameterListScene::ui_checkbox_pushDescription_sound;
bool ParameterListScene::ui_checkbox_pushDescription_vibrate;
bool ParameterListScene::ui_checkbox_pushDescription_operationGCM;
bool ParameterListScene::ui_checkbox_pushDescription_operationLocal;
bool ParameterListScene::ui_checkbox_pushDescription_useNotice;
bool ParameterListScene::ui_checkbox_pushDescription_useNight;
bool ParameterListScene::ui_checkbox_snsMessage_viduid;
bool ParameterListScene::ui_checkbox_snsMessage_usePush;
bool ParameterListScene::ui_checkbox_snsMessage_invite;
bool ParameterListScene::ui_checkbox_inappPrepare_showLog;
bool ParameterListScene::ui_checkbox_inappPrepare_autoVerify;
bool ParameterListScene::ui_checkbox_inappPurchase_Restore = false;		// 현재 사용하지 않는 기능.
bool ParameterListScene::ui_checkbox_inappPurchase_Finish = false;		// 현재 사용하지 않는 기능.
bool ParameterListScene::ui_checkbox_inappFinish_isPurchaseSuccess;
bool ParameterListScene::ui_checkbox_trackerSetEnable_MAT;
bool ParameterListScene::ui_checkbox_trackerSetEnable_Adjust;
bool ParameterListScene::ui_checkbox_trackerSetEnable_Partytrack;
bool ParameterListScene::ui_checkbox_trackerSetEnable_Singular;			// added 1.14.1
bool ParameterListScene::ui_checkbox_trackerSetEnable_AppsFlyer;		// added 1.19.8
bool ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_viduid;
bool ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_usePush;
bool ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_invite;
bool ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_linkShare;
bool ParameterListScene::ui_checkbox_hivePromotion_news_forced;
bool ParameterListScene::ui_checkbox_hivePromotion_banner_forced;
bool ParameterListScene::ui_checkbox_hivePromotion_notice_forced;
bool ParameterListScene::ui_checkbox_setGameInfo_emergencyMode;
// static variable ( textfield )
bool ParameterListScene::isFocusedTextField = false;
int ParameterListScene::focusedTextFieldState = 0;
CCRect ParameterListScene::tfArea_pushRegister_pushId;			// (1)
CCRect ParameterListScene::tfArea_pushRegister_title;			// (2)
CCRect ParameterListScene::tfArea_pushRegister_message;			// (3)
CCRect ParameterListScene::tfArea_pushRegister_after;			// (4)
CCRect ParameterListScene::tfArea_pushRegister_groupId;
CCRect ParameterListScene::tfArea_pushUnregister_pushId;		// (6)
CCRect ParameterListScene::tfArea_snsuser_vid;					// (14)
CCRect ParameterListScene::tfArea_snsuser_facebookId;			// (15)
	//CCRect ParameterListScene::tfArea_snsPost_message;			// (16)  -----> 하이브 포스팅 ( 없어진 기능 )
	//CCRect ParameterListScene::tfArea_snsPost_image;				// (17)  -----> 하이브 포스팅 ( 없어진 기능 )
	//CCRect ParameterListScene::tfArea_snsPost_imageUrl;			// (18)  -----> 하이브 포스팅 ( 없어진 기능 )
	//CCRect ParameterListScene::tfArea_snsPost_videoUrl;			// (19)  -----> 하이브 포스팅 ( 없어진 기능 )
//CCRect ParameterListScene::tfArea_snsPost_FB_message;			// (20)
//CCRect ParameterListScene::tfArea_snsPost_FB_title;				// (21)
//CCRect ParameterListScene::tfArea_snsPost_FB_image;				// (22)
CCRect ParameterListScene::tfArea_snsPost_FB_appLinkUrl;		// (23)
CCRect ParameterListScene::tfArea_snsPost_GPlus_message;		// (23.5)
CCRect ParameterListScene::tfArea_promoShow_custom_viewId;		// (23.75)
CCRect ParameterListScene::tfArea_promoInfo_badge_custom;		// (24)
CCRect ParameterListScene::tfArea_promoInfo_view_custom;		// (25)
CCRect ParameterListScene::tfArea_snsFriends_FBReceived_limit;	// (26)
CCRect ParameterListScene::tfArea_snsMessage_FBMessage_message;	// (27)
CCRect ParameterListScene::tfArea_snsMessage_HiveMessage_vid;	// (29)
CCRect ParameterListScene::tfArea_snsMessage_HiveMessage_message;	// (30)
CCRect ParameterListScene::tfArea_snsMessage_HiveMessage_imageUrl;	// (31)
CCRect ParameterListScene::tfArea_snsMessage_HiveMessage_thumbUrl;	// (32)
CCRect ParameterListScene::tfArea_inApp_Lebi_prepare_pidList;	// (37)
CCRect ParameterListScene::tfArea_inApp_Lebi_prepare_inappid;	// (39)
CCRect ParameterListScene::tfArea_inApp_Lebi_requestBal_uid;	// (41)
CCRect ParameterListScene::tfArea_inApp_purchase_pid;			// (44)
CCRect ParameterListScene::tfArea_inApp_purchase_qunantity;		// (45)
CCRect ParameterListScene::tfArea_inApp_purchase_addInfo;		// (46)
CCRect ParameterListScene::tfArea_snsShow_message_uid;			// (48)
CCRect ParameterListScene::tfArea_snsShow_chatbot_additionalInfo;			// (HIVE 1.18.1)
CCRect ParameterListScene::tfArea_tracker_sendEvent_event;		// (49)
CCRect ParameterListScene::tfArea_tracker_sendEvent_title;		// (50)
CCRect ParameterListScene::tfArea_tracker_sendEvent_description;// (51)
CCRect ParameterListScene::tfArea_tracker_sendEvent_currency;	// (52)
CCRect ParameterListScene::tfArea_tracker_sendEvent_price;		// (53)
CCRect ParameterListScene::tfArea_tracker_sendEvent_itemCount;	// (54)
CCRect ParameterListScene::tfArea_promoAcquisition_info_additionalInfo;				// HIVE 1.13.0
//CCRect ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_gameworld;		// (55)		// deprecated HIVE 1.12.0
//CCRect ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_gameLanguage;	// (56)		// deprecated HIVE 1.12.0
CCRect ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_vid;				// (57)
CCRect ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_message;			// (58)
CCRect ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_imageURL;			// (59)
CCRect ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_thumbnailURL;		// (60)
CCRect ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_linkShareURL;		// (65)
//CCRect ParameterListScene::tfArea_socialShow_getNotice_serverId;					// HIVE 1.10.0		// deprecated HIVE 1.12.0
//CCRect ParameterListScene::tfArea_socialInfo_getNoticeInfo_serverId;				// HIVE 1.10.0		// deprecated HIVE 1.12.0
CCRect ParameterListScene::tfArea_HiveIAP_info_item_locationCode;					// HIVE 1.10.0 (HIVE IAP)
//CCRect ParameterListScene::tfArea_HiveIAP_info_item_worldName;					// HIVE 1.10.0 (HIVE IAP)	// deprecated HIVE 1.12.0
//CCRect ParameterListScene::tfArea_HiveIAP_info_item_gameLanguage;					// HIVE 1.10.0 (HIVE IAP)	// deprecated HIVE 1.12.0
CCRect ParameterListScene::tfArea_HiveIAP_info_badge_locationCode;					// HIVE 1.10.0 (HIVE IAP)
//CCRect ParameterListScene::tfArea_HiveIAP_info_badge_worldName;					// HIVE 1.10.0 (HIVE IAP)	// deprecated HIVE 1.12.0
//CCRect ParameterListScene::tfArea_HiveIAP_info_badge_gameLanguage;				// HIVE 1.10.0 (HIVE IAP)	// deprecated HIVE 1.12.0
//CCRect ParameterListScene::tfArea_HiveIAP_show_googleLebiSelect_gameLanguage;		// HIVE 1.10.0 (HIVE IAP)	// deprecated HIVE 1.12.0
//CCRect ParameterListScene::tfArea_HiveIAP_show_lebiCharge_gameLanguage;			// HIVE 1.10.0 (HIVE IAP)	// deprecated HIVE 1.12.0
CCRect ParameterListScene::tfArea_HiveIAP_purchase_pid;								// HIVE 1.10.0 (HIVE IAP)
CCRect ParameterListScene::tfArea_HiveIAP_purchase_additionalInfo;					// HIVE 1.12.1 (HIVE IAP)
CCRect ParameterListScene::tfArea_HiveIAP_restore_additionalInfo;					// HIVE 1.12.1 (HIVE IAP)
CCRect ParameterListScene::tfArea_Engagement_consumeCoupon_couponId;				// HIVE 1.10.0 (Engagement)
//CCRect ParameterListScene::tfArea_Engagement_consumeCoupon_language;				// HIVE 1.10.0 (Engagement) // deprecated HIVE 1.12.0
CCRect ParameterListScene::tfArea_Engagement_consumeCoupon_additionalInfo;			// HIVE 1.10.0 (Engagement)
//CCRect ParameterListScene::tfArea_socialShow_adultAuth_gameLanguage;				// HIVE 1.10.0				// deprecated HIVE 1.12.0
CCRect ParameterListScene::tfArea_hivePromotion_show_customView_contentKey;			// HIVE 1.12.0
CCRect ParameterListScene::tfArea_hivePromotion_show_customBoard_contentKey;		// HIVE 1.12.0
CCRect ParameterListScene::tfArea_hivePromotion_show_spot_contentKey;				// HIVE 1.12.0
CCRect ParameterListScene::tfArea_hivePromotion_show_direct_contentKey;				// HIVE 1.12.0
CCRect ParameterListScene::tfArea_hivePromotion_info_addtionalInfo;					// HIVE 1.12.0
CCRect ParameterListScene::tfArea_setGameInfo_setGameInfo_serverId;					// HIVE 1.12.0
CCRect ParameterListScene::tfArea_setGameInfo_setGameInfo_gameLanguage;				// HIVE 1.12.0
CCRect ParameterListScene::tfArea_setGameInfo_setGameInfo_channel;					// HIVE 1.20.3
//CCRect ParameterListScene::tfArea_setGameInfo_setGameInfo_vid;						// HIVE 1.16.1
CCRect ParameterListScene::tfArea_setGameInfo_setChannel_channel;					// HIVE 1.20.3
CCRect ParameterListScene::tfArea_setGameInfo_updateServerId_serverId;				// HIVE 1.12.0
CCRect ParameterListScene::tfArea_setGameInfo_updateGameLanguage_gameLanguage;
CCRect ParameterListScene::tfArea_setGameInfo_sendData_funnelsId;
CCRect ParameterListScene::tfArea_setGameInfo_sendData_optionTag;
CCRect ParameterListScene::tfArea_promotion_GetbannerInfo_campaignType;				// HIVE 1.18.3
CCRect ParameterListScene::tfArea_promotion_GetbannerInfo_bannerType;				// HIVE 1.18.3
CCRect ParameterListScene::tfArea_hivePromotion_GetbannerInfo_campaignType;			// HIVE 1.18.3
CCRect ParameterListScene::tfArea_hivePromotion_GetbannerInfo_bannerType;			// HIVE 1.18.3
CCRect ParameterListScene::tfArea_inappv4_iteminfo_type;			// HIVE 1.18.4
CCRect ParameterListScene::tfArea_inappv4_purchase_type;			// HIVE 1.18.4
CCRect ParameterListScene::tfArea_inappv4_purchase_pid;				// HIVE 1.18.4
CCRect ParameterListScene::tfArea_inappv4_purchase_iapPayload;
CCRect ParameterListScene::tfArea_inappv4_restore_type;				// HIVE 1.18.4
CCRect ParameterListScene::tfArea_inappv4_transaction_finish_pid;	// HIVE 1.18.4
CCRect ParameterListScene::tfArea_inappv4_showInAppMessages_categoryId;

// static variable ( popup )
int ParameterListScene::popValue_pushRegister_type = TAG_POP_PLIST_PUSHREGISTER_TYPE_BAR;			// (5)
int ParameterListScene::popValue_snsSession_service = TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_NA;	// (35)
int ParameterListScene::popValue_pushDescription_usePush = TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_TRUE;
int ParameterListScene::popValue_pushDescription_sound = TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_TRUE;
int ParameterListScene::popValue_pushDescription_vib = TAG_POP_PLIST_PUSHDESCRIPTION_VIB_TRUE;
int ParameterListScene::popValue_pushDescription_operGcm = TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_TRUE;
int ParameterListScene::popValue_pushDescription_operLoc = TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_TRUE;
int ParameterListScene::popValue_pushDescription_notice = TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_TRUE;
int ParameterListScene::popValue_pushDescription_night = TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_TRUE;

Scene* ParameterListScene::createScene() {
	auto scene = Scene::create();
	auto layer = ParameterListScene::create();
	scene->addChild(layer);
	return scene;
}

bool ParameterListScene::init()
{
	if (!Layer::init()) {
		return false;
	}

	Size visibleSize = Director::getInstance()->getVisibleSize();
	Vec2 origin = Director::getInstance()->getVisibleOrigin();

	log("### ParameterListScene : init() ###");

	// layer 생성
	auto layer = LayerColor::create(Color4B(255, 255, 255, 255));
	layer->setContentSize(Size(visibleSize.width, visibleSize.height));
	layer->setTag(TAG_LAYER_PARAMETER_LIST);
	this->addChild(layer);

	// checkbox ui 초기값 설정을 위한 변수값 설정 --> 변수 선언시에 DataManager로부터 값을 받는것이 반영안되는 이슈를 확인.
	ParameterListScene::ui_checkbox_pushDescription_usePush = DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "usePush");
	ParameterListScene::ui_checkbox_pushDescription_sound = DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "sound");
	ParameterListScene::ui_checkbox_pushDescription_vibrate = DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "vibrate");
	ParameterListScene::ui_checkbox_pushDescription_operationGCM = DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "operationGCM");
	ParameterListScene::ui_checkbox_pushDescription_operationLocal = DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "operationLocal");
	ParameterListScene::ui_checkbox_pushDescription_useNotice = DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "useNotice");
	ParameterListScene::ui_checkbox_pushDescription_useNight = DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "useNight");
	ParameterListScene::ui_checkbox_snsMessage_viduid = DataManager::getParamValue_bool(TAG_APIACTION_SNSMESSAGE, "viduid");
	ParameterListScene::ui_checkbox_snsMessage_usePush = DataManager::getParamValue_bool(TAG_APIACTION_SNSMESSAGE, "usePush");
	ParameterListScene::ui_checkbox_snsMessage_invite = DataManager::getParamValue_bool(TAG_APIACTION_SNSMESSAGE, "invite");
	ParameterListScene::ui_checkbox_inappPrepare_showLog = DataManager::getParamValue_bool(TAG_APIACTION_PREPARE, "showLog");
	ParameterListScene::ui_checkbox_inappPrepare_autoVerify = DataManager::getParamValue_bool(TAG_APIACTION_PREPARE, "autoVerify");
	ParameterListScene::ui_checkbox_inappFinish_isPurchaseSuccess = DataManager::getParamValue_bool(TAG_APIACTION_INAPPFINISH, "isPurchaseSuccess");
	ParameterListScene::ui_checkbox_trackerSetEnable_MAT = DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "MAT");
	ParameterListScene::ui_checkbox_trackerSetEnable_Adjust = DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "Adjust");
	ParameterListScene::ui_checkbox_trackerSetEnable_Partytrack = DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "Partytrack");
	ParameterListScene::ui_checkbox_trackerSetEnable_Singular = DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "Singular");					// added 1.14.1
	ParameterListScene::ui_checkbox_trackerSetEnable_AppsFlyer = DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "AppsFlyer");						// added 1.19.8
	ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_viduid = DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "vidoruid");
	ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_usePush = DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "usePush");
	ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_invite = DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "invite");
	ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_linkShare = DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "linkShare");
	ParameterListScene::ui_checkbox_hivePromotion_news_forced = DataManager::getParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced");
	ParameterListScene::ui_checkbox_hivePromotion_banner_forced = DataManager::getParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced");
	ParameterListScene::ui_checkbox_hivePromotion_notice_forced = DataManager::getParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced");
	ParameterListScene::ui_checkbox_setGameInfo_emergencyMode = DataManager::getParamValue_bool(TAG_APIACTION_SETGAMEINFO_SETGAMEINFO, "emergencyMode");

	////// UI 그리기 시작 //////

	// label 생성 ( 로그인 및 서버 상태 )
	log("### ParameterListScene : create loginType & serverType label ###");
	layer->addChild(ParameterListScene::createLabels(TAG_LABEL_MODULE_GROUP_LIST_LOGINSERVERTYPE));

	// label 생성 ( 현재 모듈 리스트의 파라미터 리스트 이름 )
	log("### ParameterListScene : create parameter list name label ###");
	layer->addChild(ParameterListScene::createLabels(DataManager::getCurrentParameter()));

	// button 생성 ( 돌아가기 버튼 )
	ParameterListScene::update_otherButtons(TAG_BTN_PREVIOUS_SCENE);
	// button 생성 ( 설정저장 버튼 )
	ParameterListScene::update_otherButtons(TAG_BTN_PARAMETER_LIST_SAVEPARAMETER);
	// button 생성 ( 로그 버튼 )
	ParameterListScene::update_otherButtons(TAG_BTN_SHOW_LOG);


	// label 생성 ( CurrentParameter에 따른 label들 표시 )
	log("### ParameterListScene : create parameter(option) labels ###");
	ParameterListScene::update_labels(DataManager::getCurrentParameter());

	// TextField 생성
	ParameterListScene::update_textFields(DataManager::getCurrentParameter());

	// Popup Button 생성
	ParameterListScene::update_popupButtons(DataManager::getCurrentParameter());

	// Checkbox 생성
	ParameterListScene::update_checkboxes(DataManager::getCurrentParameter());

	// PostBox Show 설정 (PostboxV4 사용)
	if(DataManager::getCurrentParameter() == TAG_TYPE_MODULE_LIST_INAPPV4_POSTBOX_SHOW) {
#ifdef __ANDROID__
		if (Parameter::paramInitialize.usePostboxV4forAndroid == true) {
			if (Parameter::paramInitialize.postboxV4Login == true) {
				ParameterListScene::update_postbox_show();
			}
		}
#else
        if(Parameter::paramInitialize.postboxV4Login == true) {
            ParameterListScene::update_postbox_show();
        }
#endif
	}

	// android back button 작동을 위함
	this->setKeypadEnabled( true );

	return true;
}

LabelTTF* ParameterListScene::createLabels(int tag)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	LabelTTF* label = LabelTTF::create();
	std::string temp = "";

	switch(tag) {
		case TAG_BTN_MODULE_LIST_PUSH_REGISTER : {			// push
			temp = "푸시 등록";
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_UNREGISTER : {
			temp = "푸시 해제";
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_DESCRIPTION : {
			temp = "푸시 설정";
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_HIVE : {			// sns_user
			temp = "HIVE 유저 정보";
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_FACEBOOK : {
			temp = "Facebook 유저";
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_MESSAGE : {
			temp = "신규 메시지 확인";
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_DELETE : {
			temp = "계정 삭제";
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_HIVE : {			// sns_post
			temp = "HIVE 포스팅";
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_FACEBOOK : {
			temp = "Facebook 포스팅";
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_GOOGLEPLUS : {
			temp = "Google+ 포스팅";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICE : {		// promotion
			temp = "공지보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FOCRED_NOTICE : {
			temp = "강제 공지보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_EVENT : {
			temp = "이벤트 보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FORCED_EVENT : {
			temp = "강제 이벤트 보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER : {
			temp = "전체 배너";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER_IMAGE_BANNER : {
			temp = "전체 배너(이미지)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_OFFERWALL : {
			temp = "오퍼월";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICEONLY : {
			temp = "공지만 보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_CUSTOMWEBVIEW : {
			temp = "커스텀 웹뷰";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_REVIEW : {
			temp = "리뷰";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_MOREGAMES : {
			temp = "게임 더보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICE : {		// promotion_info
			temp = "뱃지(공지)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_EVENT : {
			temp = "뱃지(이벤트)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICEONLY : {
			temp = "뱃지(공지만)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_CUSTOMWEBVIEW : {
			temp = "뱃지(커스텀 웹뷰)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_FULLBANNER : {
			temp = "뷰(전체 배너)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICE : {
			temp = "뷰(공지)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_EVENT : {
			temp = "뷰(이벤트)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICEONLY : {
			temp = "뷰(공지만)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_CUSTOMWEBVIEW : {
			temp = "뷰(커스텀 웹뷰)";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETOFFERWALLSTATE : {
			temp = "오퍼월 상태 보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_INFO : {		// promotion_acquisition , add(HIVE 1.9.0)
			temp = "프로모션 집객 정보";										// (1)
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_QRCODESAVE : {	// (2)
			temp = "QRCODE 저장";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_QRCODESHARE : {	// (3)
			temp = "QRCODE 공유";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_LINKSHARE : {		// (4)
			temp = "프로모션 집객 LINK";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHARE : {	// (5)
			temp = "하이브Link + 메시지 공유";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHAREPLUSMESSAGE : {
			temp = "하이브 초대 LINK 공유";
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_SENDERINFO : {
			temp = "UA 초대자 정보";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GAME : {		// invite_friends
			temp = "HIVE게임친구";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_OTHER : {
			temp = "HIVE게임x친구";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_ALL : {
			temp = "HIVE전체친구";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_RECEIVEDINVITE : {
			temp = "FB 초대 유저";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_MESSAGE : {
			temp = "FB 메시지 전송";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_MESSAGE : {
			temp = "HIVE메시지 전송";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_SESSION : {
			temp = "HIVE 세션확인";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_SESSION : {
			temp = "FB 세션확인";
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_FRIENDSLIST : {		// HIVE 1.10.2b
			temp = "FB 친구 리스트";
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_PREPARE : {				// inapp
			temp = "Lebi로 설정";
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_REQUESTBALANCE : {
			temp = "Lebi 잔액조회";
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_PURCHASE : {
			temp = "구매하기";
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_RESTORE : {
			temp = "구매 복구";
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_FINISH : {
			temp = "구매 종료";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEHOME : {			// Hive webview
			temp = "HIVE Home";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEUSER : {
			temp = "프로필 페이지";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVECAFE : {
			temp = "HIVE Cafe";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_EDITPROFILE : {
			temp = "프로필 변경";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_FINDFRIENDS : {
			temp = "친구 추천";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_INQUIRY : {
			temp = "1:1 문의";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_CHATBOT : {			// HIVE 1.18.1
			temp = "챗봇";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_TERMS : {
			temp = "약관 다시보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_MESSAGE : {
			temp = "쪽지보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_ADULTAUTH : {			// HIVE 1.10.0
			temp = "성인인증";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICE : {			// HIVE 1.10.0
			temp = "점검공지팝업보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICEINFO : {		// HIVE 1.10.0
			temp = "점검공지정보보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETPERMISSIONINFO : {	// HIVE 1.17.0
            temp = "권한고지정보보기";
            break;
        }
		case TAG_BTN_MODULE_LIST_TRACKER_EVENT : {					// Tracker
			temp = "이벤트 전송";
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_SETENABLE : {
			temp = "활성화 설정";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_ITEM : {				// HIVE IAP (HIVE 1.10.0)
			temp = "아이템 정보";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_BADGE : {				// HIVE IAP (HIVE 1.10.0)
			temp = "뱃지 정보";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_LEBI : {				// HIVE IAP (HIVE 1.10.0)
			temp = "러비 잔액 정보";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_GOOGLELEBISELECT : {	// HIVE IAP (HIVE 1.10.0)
			temp = "러비/구글플레이 선택";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_LEBICHARGE : {		// HIVE IAP (HIVE 1.10.0)
			temp = "러비 충전";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_PURCHASE : {				// HIVE IAP (HIVE 1.10.0)
			temp = "구매하기";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_RESTORE : {				// HIVE IAP (HIVE 1.10.0)
			temp = "구매복구";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_POSTBOX : {				// HIVE IAP (HIVE 1.10.0)
			temp = "우편함";
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_GETEVENTS : {			// ENGAGEMENT (HIVE 1.10.0)
			temp = "GetEvetns";
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_CONSUMECOUPON : {		// ENGAGEMENT (HIVE 1.10.0)
			temp = "ConsumeCoupon";
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_SETREADY : {			// ENGAGEMENT (HIVE 1.11.0)
			temp = "SetReady";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NEWS : {				// HIVE Promotion (HIVE 1.12.0)
			temp = "뉴스";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_FULLBANNER : {		// HIVE Promotion (HIVE 1.12.0)
			temp = "배너";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NOTICE : {			// HIVE Promotion (HIVE 1.12.0)
			temp = "공지";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMVIEW : {		// HIVE Promotion (HIVE 1.12.0)
			temp = "커스텀 뷰";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMBOARD : {		// HIVE Promotion (HIVE 1.12.0)
			temp = "커스텀 보드";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_SPOT : {				// HIVE Promotion (HIVE 1.12.0)
			temp = "스팟";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_DIRECT : {			// HIVE Promotion (HIVE 1.12.0)
			temp = "다이렉트";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_OFFERWALL : {		// HIVE Promotion (HIVE 1.12.0)
			temp = "오퍼월";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_REVIEW : {			// HIVE Promotion (HIVE 1.12.0)
			temp = "리뷰(팝업)";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_EXIT : {				// HIVE Promotion (HIVE 1.12.0)
			temp = "종료(팝업)";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BADGEINFO : {			// HIVE Promotion Info (HIVE 1.12.0)
			temp = "뱃지 정보보기";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_VIEWINFO : {				// HIVE Promotion Info (HIVE 1.12.0)
			temp = "커스텀 뷰";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BOARDINFO : {			// HIVE Promotion Info (HIVE 1.12.0)
			temp = "커스텀 보드";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SPOTINFO : {				// HIVE Promotion Info (HIVE 1.12.0)
			temp = "스팟 배너";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_DIRECTINFO : {			// HIVE Promotion Info (HIVE 1.12.0)
			temp = "다이렉트 배너";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SETADDITIONALINFO : {	// HIVE Promotion Info (HIVE 1.12.0)
			temp = "AdditionalInfo 셋팅";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_OFFERWALLSTATE : {		// HIVE Promotion Info (HIVE 1.12.0)
			temp = "OfferwallState 정보";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_UPDATEPROMOTIONDATA : {		// HIVE Promotion Info (HIVE 1.19.0)
			temp = "UpdatePromotionData";
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETGAMEINFO : {				// (HIVE 1.12.0)
			temp = "SetGameInfo";
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_GETHIVECOUNTRYCODE : {				// (HIVE 1.12.0)
			temp = "GetHiveCountryCode";
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_GETCHANNEL : {						// (HIVE 1.20.3)
			temp = "GetChannel";
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETCHANNEL : {						// (HIVE 1.20.3)
			temp = "SetChannel";
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_SERVERID : {				// (HIVE 1.19.1)
			temp = "UpdateServerId";
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_GAMELANGUAGE : {				// (HIVE 1.19.1)
			temp = "UpdateGameLanguage";
			break;
		}
        case TAG_BTN_MODULE_LIST_SETGAMEINFO_SEND_DATA : {
            temp = "SendData";
            break;
        }
        case TAG_TYPE_MODULE_LIST_INAPPV4_POSTBOX_SHOW : {
			temp = "PostBox Show";
			break;
        }
		//
		case TAG_LABEL_MODULE_GROUP_LIST_LOGINSERVERTYPE : {
			std::string temp_loginType = DataManager::getParamValue(TAG_APIACTION_LOGIN, "getLoginType");
			std::string temp_serverType = DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "useSandbox");
			std::string temp = "Login Type : " + temp_loginType;

			// (1) Live Server 혹은 Sandbox로 설정
			std::string temp_serverType_select = "";
			if(temp_serverType == "0") {
				temp_serverType_select = "\nServer Type : Live Server";
			} else if (temp_serverType == "1") {
				temp_serverType_select = "\nServer Type : Sandbox";
			}

			temp = temp + temp_serverType_select;	// label 종합하기

			label = LabelTTF::create(temp, "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			label->setPosition(
					visibleSize.width * ParameterListScene::ui_loginServerTypeLabel_x,
					visibleSize.height * ParameterListScene::ui_loginServerTypeLabel_y);
			label->setColor(Color3B(0, 0, 0));
			return label;
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETBANNERINFO : {
			temp = "GetBannerInfo";
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_GETBANNERINFO : {
			temp = "GetBannerInfo";
			break;
		}
		default : {
			log("### ParameterListScene::createLabels(int tag) error ###");
			break;
		}
	}
	label = LabelTTF::create(temp, "arial.ttf", 20);
	label->setPosition(
			visibleSize.width * ParameterListScene::ui_moduleListNameLabel_x,
			visibleSize.height * ParameterListScene::ui_moduleListNameLabel_y);
	label->setColor(Color3B(0, 0, 0));
	return label;
}

void ParameterListScene::update_otherButtons(int btnType)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);
	switch(btnType) {
		case TAG_BTN_PREVIOUS_SCENE : {
			// previous
			log("### ParameterListScene : create other buttons(previous) ###");
			auto btn = Menu::create(
					ParameterListScene::createButtons(TAG_BTN_PREVIOUS_SCENE),
					NULL);
			btn->setPosition(
					visibleSize.width * ParameterListScene::ui_previousBtn_x,
					visibleSize.height * ParameterListScene::ui_previousBtn_y);
			layer->addChild(btn);
			return;
			break;
		}case TAG_BTN_SHOW_LOG : {
			// show_log
			log("### ParameterListScene : create other buttons(show_log) ###");
			log("### ModuleListScene : create other buttons(show_log) ###");
			auto btn_log = Menu::create(
					ParameterListScene::createButtons(TAG_BTN_SHOW_LOG), NULL);
			btn_log->setPosition(
					visibleSize.width * ParameterListScene::ui_showLogBtn_x,
					visibleSize.height * ParameterListScene::ui_showLogBtn_y);
			layer->addChild(btn_log);
			break;
		}case TAG_BTN_PARAMETER_LIST_SAVEPARAMETER : {
			// close_log
			log("### ParameterListScene : create other buttons(close_log) ###");
			log("### ParameterListScene : create other buttons(previous) ###");
			auto btn = Menu::create(
					ParameterListScene::createButtons(TAG_BTN_PARAMETER_LIST_SAVEPARAMETER),
					NULL);
			btn->setPosition(
					visibleSize.width * ParameterListScene::ui_saveParamBtn_x,
					visibleSize.height * ParameterListScene::ui_saveParamBtn_y);
			layer->addChild(btn);
			break;
		}
		default : {
			// error
			log("### ParameterListScene : create other buttons(error) ###");
			break;
		}
	}
}

MenuItemImage* ParameterListScene::createButtons(int tag)
{
	auto btn = MenuItemImage::create();

	switch(tag) {
		// previous
		case TAG_BTN_PREVIOUS_SCENE : {
			btn = MenuItemImage::create(
					"btn_previous_normal.png", "btn_previous_clicked.png",
					CC_CALLBACK_1(ParameterListScene::buttonEvent, this));
			btn->setScale(0.3f);
			btn->setTag(tag);
			return btn;
			break;
		}case TAG_BTN_PARAMETER_LIST_SAVEPARAMETER : {
			btn = MenuItemImage::create(
					"btn_saveParameter_normal.png", "btn_saveParameter_clicked.png",
					CC_CALLBACK_1(ParameterListScene::buttonEvent, this));
			//btn->setScale(0.3f);
			btn->setTag(tag);
			btn->setScale(0.7f);
			return btn;
			break;
		}case TAG_BTN_SHOW_LOG : {
			btn = MenuItemImage::create(
					"btn_displayLog_normal.png", "btn_displayLog_clicked.png",
					CC_CALLBACK_1(ParameterListScene::buttonEvent, this));
			btn->setScale(0.8f);
			break;
		}
		default : {
			btn = MenuItemImage::create(
					"btn_error.png", "btn_error.png",
					CC_CALLBACK_1(ParameterListScene::buttonEvent, this));
			break;
		}
	}
	btn->setTag(tag);
	return btn;
}

void ParameterListScene::buttonEvent(Ref *sender)
{
	if(ParameterListScene::ui_isOpenedWindow == true)	// ui 중복 클릭 방지
		return;

	auto btn = (MenuItem*) sender;

	switch(btn->getTag()) {
		case TAG_BTN_PREVIOUS_SCENE : {
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                auto scene = TransitionFadeTR::create(1.0, ModuleListScene::createScene());
                Director::getInstance()->replaceScene(scene);
            });
			break;
		}case TAG_BTN_PARAMETER_LIST_SAVEPARAMETER : {
			log("### SaveParameter Button!!! ###");
			ParameterListScene::saveParamValue(DataManager::getCurrentParameter());
			// QA 로그 출력
			Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);
			layer->removeChildByTag(TAG_LABEL_QALOG, true);
			layer->addChild(LogController::createQALog(
					LogController::getQALog(
							DataManager::getCurrentParameter(), false)));
			break;
		}case TAG_BTN_SHOW_LOG : {		// 로그 보기
			// log scene
            Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                Director::getInstance()->pushScene(LogScene::createScene());
            });
			break;
		}
		default : {
			break;
		}
	}
}

void ParameterListScene::update_labels(int tag)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);

	auto labels = Menu::create();

	switch(tag) {
		case TAG_BTN_MODULE_LIST_PUSH_REGISTER : {			// push
			log("### ParameterListScene::update_labels --> push_register) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHREGISTER_PUSHID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHREGISTER_TITLE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHREGISTER_MESSAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHREGISTER_AFTER), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHREGISTER_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4)));
			layer->addChild(labels);
			// (6)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHREGISTER_GROUP_ID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_UNREGISTER : {
			log("### ParameterListScene::update_labels --> push_unregister) ###");
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHUNREGISTER_PUSHID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_DESCRIPTION : {
			log("### ParameterListScene::update_labels --> push_description) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHDESCRITPTION_USEPUSH), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHDESCRITPTION_SOUND), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHDESCRITPTION_VIBRATE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHDESCRITPTION_OPERATIONGCM), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHDESCRITPTION_OPERATIONLOCAL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4)));
			layer->addChild(labels);
			// (6)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHDESCRITPTION_USENOTICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5)));
			layer->addChild(labels);
			// (7)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PUSHDESCRITPTION_USENIGHT), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 6)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_HIVE : {			// sns_user
			log("### ParameterListScene::update_labels --> sns_user hive) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSUSER_TYPE_NA), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSUSER_VID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_FACEBOOK : {
			log("### ParameterListScene::update_labels --> sns_user FB) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSUSER_TYPE_FACEBOOK), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSUSER_FACEBOOKID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_MESSAGE : {
			log("### ParameterListScene::update_labels --> sns_user message) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSUSER_TYPE_MESSAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_DELETE : {
			log("### ParameterListScene::update_labels --> sns_user delete) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSUSER_TYPE_NA), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_HIVE : {			// sns_post
			// 보류한 기능.
			/*
			log("### ParameterListScene::update_labels --> sns_post hive) ###");
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_HIVE_MESSAGE),
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_HIVE_IMAGE),
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_HIVE_IMAGEURL),
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_HIVE_VIDEOURL),
					NULL);
			 	 	 */
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_FACEBOOK : {
			log("### ParameterListScene::update_labels --> sns_post FB) ###");
			// HIVE SDK 1.12.1 부터 Facebook 포스팅시 메시지, 타이틀, 이미지url 파라미터 삭제
//			// (1)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_FB_MESSAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
//			layer->addChild(labels);
//			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_FB_TITLE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
//			// (3)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_FB_IMAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
//			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_FB_APPLINKURL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_GOOGLEPLUS : {
			log("### ParameterListScene::update_labels --> sns_post Google+) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSPOST_GPLUS_MESSAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICE : {		// promotion
			log("### ParameterListScene::update_labels --> promotion_show notice) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_NOTICE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_NOTICE_FORCED), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FOCRED_NOTICE : {
			log("### ParameterListScene::update_labels --> promotion_show forced notice) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_FORCEDNOTICE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_FORCEDNOTICE_FORCED), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_EVENT : {
			log("### ParameterListScene::update_labels --> promotion_show event) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_EVENT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_EVENT_FORCED), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FORCED_EVENT : {
			log("### ParameterListScene::update_labels --> promotion_show forced event) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_FORCEDEVENT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_FORCEDEVENT_FORCED), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER : {
			log("### ParameterListScene::update_labels --> promotion_show fullBanner) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_FULLBANNER), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER_IMAGE_BANNER : {
			log("### ParameterListScene::update_labels --> promotion_show fullBanner using ImageBanner) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_FULLBANNER_IMAGE_BANNER), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_OFFERWALL : {
			log("### ParameterListScene::update_labels --> promotion_show offerwall) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_OFFERWALL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICEONLY : {
			log("### ParameterListScene::update_labels --> promotion_show noticeOnly) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_NOTICEONLY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_CUSTOMWEBVIEW : {
			log("### ParameterListScene::update_labels --> promotion_show customwebview) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_CUSTOM), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_CUSTOM_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_REVIEW : {
			log("### ParameterListScene::update_labels --> promotion_show review) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_REVIEW), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_MOREGAMES : {
			log("### ParameterListScene::update_labels --> promotion_show moreGames) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOSHOW_MOREGAMES), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICE : {		// promotion_info
			log("### ParameterListScene::update_labels --> promotion_info badge notice) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICE_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_EVENT : {
			log("### ParameterListScene::update_labels --> promotion_info badge event) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_EVENT_TYPE),NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_EVENT_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICEONLY : {
			log("### ParameterListScene::update_labels --> promotion_info badge noticeOnly) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICEONLY_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICEONLY_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_CUSTOMWEBVIEW : {
			log("### ParameterListScene::update_labels --> promotion_info badge customwebview) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_CUSTOM_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_BADGE_CUSTOM_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_FULLBANNER : {
			log("### ParameterListScene::update_labels --> promotion_info view fullBanner) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_FULLBANNER_TYPE),NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_FULLBANNER_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICE : {
			log("### ParameterListScene::update_labels --> promotion_info view notice) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICE_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_EVENT : {
			log("### ParameterListScene::update_labels --> promotion_info view event) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_EVENT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_EVENT_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICEONLY : {
			log("### ParameterListScene::update_labels --> promotion_info view noticeOnly) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICEONLY_TYPE),NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICEONLY_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_CUSTOMWEBVIEW : {
			log("### ParameterListScene::update_labels --> promotion_info view customwebview) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_CUSTOM_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_VIEW_CUSTOM_VIEWID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETOFFERWALLSTATE : {
			log("### ParameterListScene::update_labels --> promotion_info offerwallState) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOINFO_OFFERWALLSTATE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		// PROMOTION ACQUISITION (add (HIVE 1.9.0))
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_INFO : { // (1)
			log("### ParameterListScene::update_labels --> promotion_acquisition info) ###");
			// (1)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INFO_GAMEWORLD), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
//			layer->addChild(labels);
			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INFO_GAMELANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			// (3) addtionalInfo
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INFO_ADDITIONALINFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_QRCODESAVE : {	// (2)
			log("### ParameterListScene::update_labels --> promotion_acquisition QRcode Save) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_QRCODESAVE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_QRCODESHARE : {	// (3)
			log("### ParameterListScene::update_labels --> promotion_acquisition QRcode Share) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_QRCODESHARE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_LINKSHARE : {	// (4)
			log("### ParameterListScene::update_labels --> promotion_acquisition QRcode Share) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_COMMONINVITELINK_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHARE : {    // (5)
			log("### ParameterListScene::update_labels --> promotion_acquisition HIVE Link Share) ###");
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
													  - ((ParameterListScene::ui_paddingSize_y - 0.01) * 4)));
			layer->addChild(labels);
			// (11)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
													  - ((ParameterListScene::ui_paddingSize_y - 0.01) * 10)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHAREPLUSMESSAGE : {
			log("### ParameterListScene::update_labels --> promotion_acquisition HIVE Link Share and Message) ###");
			// (1)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_GAMEWORLD), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
//							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 0)));
//			layer->addChild(labels);
			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_GAMELANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
//							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 1)));
//			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_VIDUID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_VID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 4)));
			layer->addChild(labels);
			// (6)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_IMAGEURL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 5)));
			layer->addChild(labels);
			// (7)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_THUMBNAILURL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 6)));
			layer->addChild(labels);
			// (8)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_USEPUSH), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 7)));
			layer->addChild(labels);
			// (9)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_INVITE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 8)));
			layer->addChild(labels);
			// (10)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_LINKSHARE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 9)));
			layer->addChild(labels);
			// (11)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 10)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_SENDERINFO : {
			log("### ParameterListScene::update_labels --> promotion_useracquisition senderInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_USERACQUISITION_TYPE_SENDER_INFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GAME : {		// invite_friends
			log("### ParameterListScene::update_labels --> sns_friends hive game) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_HIVEGAME_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_HIVEGAME_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_OTHER : {
			log("### ParameterListScene::update_labels --> sns_friends hive other) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_HIVEOTHER_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_HIVEOTHER_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_ALL : {
			log("### ParameterListScene::update_labels --> sns_friends hive all) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_HIVEALL_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_HIVEALL_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_RECEIVEDINVITE : {
			log("### ParameterListScene::update_labels --> sns_friends FB receivedInvite) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_FBRECEIVED_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_FBRECEIVED_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_FBRECEIVED_LIMIT), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_MESSAGE : {
			log("### ParameterListScene::update_labels --> sns_message FB message) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_FBMESSAGE_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_FBMESSAGE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_FBMESSAGE_MESSAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_MESSAGE : {
			log("### ParameterListScene::update_labels --> sns_message Hive message) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_VIDUID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_VID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_MESSAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_IMAGEURL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_THUMBNAILURL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4)));
			layer->addChild(labels);
			// (6)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_USEPUSH), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5)));
			layer->addChild(labels);
			// (7)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_INVITE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 6)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_SESSION : {
			log("### ParameterListScene::update_labels --> sns_session service Hive) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSESSION_SESSION_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_SESSION : {
			log("### ParameterListScene::update_labels --> sns_session service FB) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSESSION_FBSESSION_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_FRIENDSLIST : {		// HIVE 1.10.2b
			log("### ParameterListScene::update_labels --> sns_friends FB friends) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_FBFRIENDS_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSFRIENDS_FBFRIENDS_SERVICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_PREPARE : {				// inapp
			log("### ParameterListScene::update_labels --> inapp Lebi prepare) ###");

			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_PIDLIST), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_SHOWLOG), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_INAPPID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_AUTOVERIFY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_REQUESTBALANCE : {
			log("### ParameterListScene::update_labels --> inapp Lebi requestBalance) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_LEBI_REQUEST_UID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_PURCHASE : {
			log("### ParameterListScene::update_labels --> inapp purchase) ###");
			/*
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_PURCHASE_RESTORE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_PURCHASE_FINISH),NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			*/
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_PURCHASE_PID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_PURCHASE_QUANTITY),NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_PURCHASE_ADDINFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_RESTORE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_FINISH : {
			log("### ParameterListScene::update_labels --> inapp finish) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPP_FINISH_PURCHASESUCCESS), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEHOME : {			// Hive webview
			log("### ParameterListScene::update_labels --> sns show hive home) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_HIVEHOME_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEUSER : {
			log("### ParameterListScene::update_labels --> sns show hive user) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_HIVEUSER_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVECAFE : {
			log("### ParameterListScene::update_labels --> sns show hive cafe) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_HIVECAFE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_EDITPROFILE : {
			log("### ParameterListScene::update_labels --> sns show editProfile) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_EDITPROFILE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_FINDFRIENDS : {
			log("### ParameterListScene::update_labels --> sns show fint friends) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_FINDFRIENDS_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_INQUIRY : {
			log("### ParameterListScene::update_labels --> sns show inquiry) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_INQUARY_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_CHATBOT : {
			log("### ParameterListScene::update_labels --> sns show chatbot) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_CHATBOT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_CHATBOT_ADDITIONALINFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_TERMS : {
			log("### ParameterListScene::update_labels --> social show terms) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_TERMS_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_MESSAGE : {
			log("### ParameterListScene::update_labels --> sns show message) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_MESSAGE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SNSSHOW_MESSAGE_UID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_ADULTAUTH : {			// HIVE 1.10.0
			log("### ParameterListScene::update_labels --> social show adultAhuth) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALSHOW_ADULTAUTH_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALSHOW_ADULTAUTH_GAMELANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICE : {			// HIVE 1.10.0
			log("### ParameterListScene::update_labels --> social show getNotice) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALSHOW_GETNOTICE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALSHOW_GETNOTICE_SERVERID), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICEINFO : {		// HIVE 1.10.0
			log("### ParameterListScene::update_labels --> social show getNoticeInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALINFO_GETNOTICEINFO_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (1)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALINFO_GETNOTICEINFO_SERVERID), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETPERMISSIONINFO : {		// HIVE 1.10.0
			log("### ParameterListScene::update_labels --> social Info getPermissionInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALINFO_GETNOTICEINFO_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (1)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SOCIALINFO_GETNOTICEINFO_SERVERID), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_EVENT : {					// Tracker
			log("### ParameterListScene::update_labels --> tracker sendEvent) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SENDEVENT_EVENT), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			/*
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SENDEVENT_TITLE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SENDEVENT_DESCRIPTION), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SENDEVENT_CURRENCY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SENDEVENT_PRICE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4)));
			layer->addChild(labels);
			// (6)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SENDEVENT_ITEMCOUNT), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5)));
			layer->addChild(labels);
			*/
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_SETENABLE : {
			log("### ParameterListScene::update_labels --> tracker setEnable) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SETENABLE_MAT), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SETENABLE_ADJUST), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SETENABLE_PARTYTRACK), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SETENABLE_SINGULAR), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			// (5)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_TRACKER_SETENABLE_APPSFLYER), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4)));
			layer->addChild(labels);
			break;
		}
		// HIVE IAP (HIVE 1.10.0)
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_ITEM : {
			log("### ParameterListScene::update_labels --> HIVEIAP INFO ITEM) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_LOCATIONCODE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
//			// (3)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_WORLDNAME), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
//			layer->addChild(labels);
//			// (4)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_GAMELANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
//			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_BADGE : {
			log("### ParameterListScene::update_labels --> HIVEIAP INFO BADGE) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_LOCATIONCODE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
//			// (3)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_WORLDNAME), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
//			layer->addChild(labels);
//			// (4)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_GAMELANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
//			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_LEBI : {
			log("### ParameterListScene::update_labels --> HIVEIAP INFO LEBI) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_INFO_LEBI_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);

			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_GOOGLELEBISELECT : {
			log("### ParameterListScene::update_labels --> HIVEIAP SHOW GOOGLELEBI SELECT) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_GAMELANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_LEBICHARGE : {
			log("### ParameterListScene::update_labels --> HIVEIAP SHOW LEBI CHARGE) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_SHOW_LEBICHARGE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_SHOW_LEBICHARGE_GAMELANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_PURCHASE : {
			log("### ParameterListScene::update_labels --> HIVEIAP PURCHASE) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_PURCHASE_PID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_PURCHASE_ADDITIONALINFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_RESTORE : {
			log("### ParameterListScene::update_labels --> HIVEIAP RESTORE) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEIAP_RESTORE_ADDITIONALINFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_POSTBOX : {
			log("### ParameterListScene::update_labels --> HIVEIAP POSTBOX) ###");
			break;
		}
		// Engagement (HIVE 1.10.0)
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_GETEVENTS : {
			log("### ParameterListScene::update_labels --> Engagement GetEvents) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_CONSUMECOUPON : {
			log("### ParameterListScene::update_labels --> Engagement GetEvents) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_ENGAGEMENT_CONSUMECOUPON_COUPONID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
//			labels = Menu::create(
//					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_ENGAGEMENT_CONSUMECOUPON_LANGUAGE), NULL);
//			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
//			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_ENGAGEMENT_CONSUMECOUPON_ADDITIONALINFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_SETREADY : {
			log("### ParameterListScene::update_labels --> Engagement SetReady) ###");
			break;
		}
		// HIVE Promotion Show
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NEWS : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion News) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_NEWS_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_NEWS_FORCED), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_FULLBANNER : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion FullBanner) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_BANNER_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_BANNER_FORCED), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NOTICE : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Notice) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_NOTICE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_NOTICE_FORCED), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMVIEW : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion CustomView) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMVIEW_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMBOARD : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion CustomBoard) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMBOARD_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_SPOT : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Spot) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_SPOT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_DIRECT : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Direct) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_DIRECT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_OFFERWALL : {	// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Offerwall) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_OFFERWALL_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_REVIEW : {	// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Review Popup) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_REVIEW_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_EXIT : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Exit Popup(Moregames)) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTION_EXIT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		// HIVE Promotion Info
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BADGEINFO : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info Badge) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_BADGEINFO_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_VIEWINFO : {			// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info CustomView) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMVIEW_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMVIEW_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BOARDINFO : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info CustomBoard) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMBOARD_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMBOARD_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SPOTINFO : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info Spot) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_SPOT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_SPOT_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_DIRECTINFO : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info Direct) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_DIRECT_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_DIRECT_CONTENTKEY), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SETADDITIONALINFO : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info SetAdditionalInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_ADDITIONALINFO_INFO), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_OFFERWALLSTATE : {		// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info OfferwallState) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_UPDATEPROMOTIONDATA : {		// HIVE 1.10.0
			log("### ParameterListScene::update_labels --> HIVE Promotion Info OfferwallState) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETGAMEINFO : {				// HIVE 1.12.0
			log("### ParameterListScene::update_labels --> SetGameInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_SERVERID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_GAMELANGUAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_EMERGENCY_MODE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			// (4)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_CHANNEL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETCHANNEL : {                // HIVE 1.20.3
			log("### ParameterListScene::update_labels --> SetChannel) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_SETCHANNEL_CHANNEL), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_SERVERID : {
			log("### ParameterListScene::update_labels --> updateServerId) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_UPDATE_SERVERID_SERVERID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_GAMELANGUAGE : {
			log("### ParameterListScene::update_labels --> gameLanguage) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_UPDATE_GAMELANGUAGE_GAMELANGUAGE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
        case TAG_BTN_MODULE_LIST_SETGAMEINFO_SEND_DATA : {
            log("### ParameterListScene::update_labels --> sendData) ###");
            // funnelsId
            labels = Menu::create(
                    ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_SEND_DATA_FUNNELS_ID), NULL);
            labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
                                visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
            layer->addChild(labels);

            // optionTag
            labels = Menu::create(
                    ParameterListScene::createParamLabels(TAG_LABEL_PLIST_SETGAMEINFO_SEND_DATA_OPTION_TAG), NULL);
            labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
                                visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
            layer->addChild(labels);
            break;
        }

		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETBANNERINFO : {		// HIVE 1.18.3

			log("### ParameterListScene::update_labels --> Promotion Info GetBannerInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOTIONINFO_CAMPAIGN_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LBAEL_PLIST_PROMOTIONINFO_BANNER_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_PROMOTIONINFO_PARAM_GUIDE), NULL);
			labels->setPosition(visibleSize.width * 0.4,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_GETBANNERINFO : {	// HIVE 1.18.3

			log("### ParameterListScene::update_labels --> HIVE Promotion Info GetBannerInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CAMPAIGN_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LBAEL_PLIST_HIVEPROMOTIONINFO_BANNER_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_HIVEPROMOTIONINFO_PARAM_GUIDE), NULL);
			labels->setPosition(visibleSize.width * 0.4,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_ITEMINFO : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 ItemInfo) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPPV4_ITEMINFO_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_PURCHASE : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 Purchase) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPPV4_PURCHASE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			// (2)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPPV4_PURCHASE_PID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1)));
			layer->addChild(labels);
			// (3)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPPV4_PURCHASE_IAPPAYLOAD), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2)));
			layer->addChild(labels);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_RESTORE : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 Restore) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPPV4_RESTORE_TYPE), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_TRANSACTION_FINISH : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 Transaction Finish) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPPV4_TRANSACTION_FINISH_PID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_SHOW_INAPP_MESSAGES : {

			log("### ParameterListScene::update_labels --> InAppV4 ShowInAppMessages) ###");
			// (1)
			labels = Menu::create(
					ParameterListScene::createParamLabels(TAG_LABEL_PLIST_INAPPV4_SHOW_INAPP_MESSAGES_CATEGORY_ID), NULL);
			labels->setPosition(visibleSize.width * ParameterListScene::ui_paramLabel_x,
								visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0)));
			layer->addChild(labels);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_SELECTMARKET : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 Select Market) ###");
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_REQUEST_BALANCE : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 Request Balance) ###");
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_CHARGE_BALANCE : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 Charge Balance) ###");
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_POSTBOX_LOGIN : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 PostBox Login) ###");
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_POSTBOX_SHOW : {	// HIVE 1.18.4

			log("### ParameterListScene::update_labels --> InAppV4 PostBox Show) ###");
			break;
		}
        case TAG_TYPE_MODULE_LIST_INAPPV4_CHECK_PROMOTE_PURCHASE : { // Hive 1.19.1
            
            log("### ParameterListScene::update_labels --> InAppV4 Check Promote Purchase) ###");
            break;
        }
            //TODO (disker)
		//
		default : {
			log("### ParameterListScene::update_labels(int tag) error ###");
			break;
		}
	}

}

MenuItemLabel* ParameterListScene::createParamLabels(int tag)
{
	auto label = Label::create();

	switch(tag) {
		case TAG_LABEL_PLIST_PUSHREGISTER_PUSHID : {
			label = Label::createWithSystemFont("pushId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);			// push register
			break;
		}case TAG_LABEL_PLIST_PUSHREGISTER_TITLE : {
			label = Label::createWithSystemFont("title :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHREGISTER_MESSAGE : {
			label = Label::createWithSystemFont("message :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHREGISTER_AFTER : {
			label = Label::createWithSystemFont("after :", "arial.ttf",
												Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHREGISTER_TYPE : {
			label = Label::createWithSystemFont("type :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHREGISTER_GROUP_ID : {
			label = Label::createWithSystemFont("groupId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHUNREGISTER_PUSHID : {
			label = Label::createWithSystemFont("pushId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);			// push unregister
			break;
		}case TAG_LABEL_PLIST_PUSHDESCRITPTION_USEPUSH : {
			label = Label::createWithSystemFont("usePush :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);			// push description
			break;
		}case TAG_LABEL_PLIST_PUSHDESCRITPTION_SOUND : {
			label = Label::createWithSystemFont("sound :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHDESCRITPTION_VIBRATE : {
			label = Label::createWithSystemFont("vibrate :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHDESCRITPTION_OPERATIONGCM : {
#ifdef __ANDROID__
			label = Label::createWithSystemFont("operationGCM :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
#else
			label = Label::createWithSystemFont("operationRemote :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
#endif
			break;
		}case TAG_LABEL_PLIST_PUSHDESCRITPTION_OPERATIONLOCAL : {
			label = Label::createWithSystemFont("operationLocal :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHDESCRITPTION_USENOTICE : {
			label = Label::createWithSystemFont("useNotice :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PUSHDESCRITPTION_USENIGHT : {
			label = Label::createWithSystemFont("useNight :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSUSER_TYPE_NA : {
			label = Label::createWithSystemFont("type : N/A", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);		// sns user hive
			break;
		}case TAG_LABEL_PLIST_SNSUSER_VID : {
			label = Label::createWithSystemFont("vid :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSUSER_TYPE_FACEBOOK : {
			label = Label::createWithSystemFont("type : facebook", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);	// sns user facebook
			break;
		}case TAG_LABEL_PLIST_SNSUSER_FACEBOOKID : {
			label = Label::createWithSystemFont("facebookId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSUSER_TYPE_MESSAGE : {
			label = Label::createWithSystemFont("type : message", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);	// sns user message
			break;
		}case TAG_LABEL_PLIST_SNSPOST_HIVE_MESSAGE : {
			label = Label::createWithSystemFont("message :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);		// sns post hive
			break;
		}case TAG_LABEL_PLIST_SNSPOST_HIVE_IMAGE : {
			label = Label::createWithSystemFont("image :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSPOST_HIVE_IMAGEURL : {
			label = Label::createWithSystemFont("imageURL :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSPOST_HIVE_VIDEOURL : {
			label = Label::createWithSystemFont("videoURL :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSPOST_FB_MESSAGE : {
			label = Label::createWithSystemFont("message :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);		// sns post FB
			break;
		}case TAG_LABEL_PLIST_SNSPOST_FB_TITLE : {
			label = Label::createWithSystemFont("title :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSPOST_FB_IMAGE : {
			label = Label::createWithSystemFont("image :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSPOST_FB_APPLINKURL : {
			label = Label::createWithSystemFont("appLinkURL :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSPOST_GPLUS_MESSAGE : {
			label = Label::createWithSystemFont("message :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);		// sns post google+
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_NOTICE_TYPE : {
			label = Label::createWithSystemFont("type : notice", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);	// promotion show
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_NOTICE_FORCED : {
			label = Label::createWithSystemFont("forced : false", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_FORCEDNOTICE_TYPE : {
			label = Label::createWithSystemFont("type : notice", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_FORCEDNOTICE_FORCED : {
			label = Label::createWithSystemFont("forced : true", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_EVENT_TYPE : {
			label = Label::createWithSystemFont("type : event", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_EVENT_FORCED : {
			label = Label::createWithSystemFont("forced : false", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_FORCEDEVENT_TYPE : {
			label = Label::createWithSystemFont("type : event", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_FORCEDEVENT_FORCED : {
			label = Label::createWithSystemFont("forced : true", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_FULLBANNER : {//
			label = Label::createWithSystemFont("type : fullbanner", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_FULLBANNER_IMAGE_BANNER : {
			label = Label::createWithSystemFont("type : fullbanner(image)", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_OFFERWALL : {
			label = Label::createWithSystemFont("type : offerwall", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_NOTICEONLY : {
			label = Label::createWithSystemFont("type : noticeOnly", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_CUSTOM : {
			label = Label::createWithSystemFont("type : customWebview", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_CUSTOM_VIEWID : {
			label = Label::createWithSystemFont("viewId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_REVIEW : {
			label = Label::createWithSystemFont("type : review", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOSHOW_MOREGAMES : {
			label = Label::createWithSystemFont("type : moreGames", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_USERACQUISITION_TYPE : {	// add(HIVE 1.9.0)
			label = Label::createWithSystemFont("type : userAcquisition", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_USERACQUISITION_TYPE_SENDER_INFO : {
			label = Label::createWithSystemFont("type : senderInfo", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICE_TYPE : {
			label = Label::createWithSystemFont("type : badge", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);		// promotion info
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICE_VIEWID : {
			label = Label::createWithSystemFont("viewId : notice", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_BADGE_EVENT_TYPE : {
			label = Label::createWithSystemFont("type : badge", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_BADGE_EVENT_VIEWID : {
			label = Label::createWithSystemFont("viewId : event", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICEONLY_TYPE : {
			label = Label::createWithSystemFont("type : badge", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_BADGE_NOTICEONLY_VIEWID : {
			label = Label::createWithSystemFont("viewId : noticeOnly", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_BADGE_CUSTOM_TYPE : {
			label = Label::createWithSystemFont("type : badge", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_BADGE_CUSTOM_VIEWID : {
			label = Label::createWithSystemFont("viewId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_FULLBANNER_TYPE : {
			label = Label::createWithSystemFont("type : view", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_FULLBANNER_VIEWID : {
			label = Label::createWithSystemFont("viewId : fullBanner", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICE_TYPE : {
			label = Label::createWithSystemFont("type : view", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICE_VIEWID : {
			label = Label::createWithSystemFont("viewId : notice", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_EVENT_TYPE : {
			label = Label::createWithSystemFont("type : view", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_EVENT_VIEWID : {
			label = Label::createWithSystemFont("viewId : event", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICEONLY_TYPE : {
			label = Label::createWithSystemFont("type : view", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_NOTICEONLY_VIEWID : {
			label = Label::createWithSystemFont("viewId : noticeOnly", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_CUSTOM_TYPE : {
			label = Label::createWithSystemFont("type : view", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_VIEW_CUSTOM_VIEWID : {
			label = Label::createWithSystemFont("viewId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOINFO_OFFERWALLSTATE : {
			label = Label::createWithSystemFont("offerwallState", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INFO_GAMEWORLD : {								// promotion acquisition, add(HIVE 1.9.0)
			label = Label::createWithSystemFont("gameWorld : kr", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INFO_GAMELANGUAGE : {
			label = Label::createWithSystemFont("gameLanguage : ko", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INFO_ADDITIONALINFO : {							// HIVE 1.13.0
			label = Label::createWithSystemFont("additionalInfo : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_QRCODESAVE_TYPE : {
			label = Label::createWithSystemFont("type : qrcodeSave", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_QRCODESHARE_TYPE : {
			label = Label::createWithSystemFont("type : qrcodeShare", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_COMMONINVITELINK_TYPE : {
			label = Label::createWithSystemFont("type : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_GAMEWORLD : {						// ***** acquisition
			label = Label::createWithSystemFont("gameWorld : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_GAMELANGUAGE : {					// ***** acquisition
			label = Label::createWithSystemFont("gameLanguage : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_VIDUID : {						// ***** acquisition
			label = Label::createWithSystemFont("vid or uid", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_VID : {							// ***** acquisition
			label = Label::createWithSystemFont("vid : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE : {						// ***** acquisition
			label = Label::createWithSystemFont("message : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_IMAGEURL : {						// ***** acquisition
			label = Label::createWithSystemFont("imageURL : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_THUMBNAILURL : {					// ***** acquisition
			label = Label::createWithSystemFont("thumbnailURL : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_USEPUSH : {						// ***** acquisition
			label = Label::createWithSystemFont("usePush : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_INVITE : {						// ***** acquisition
			label = Label::createWithSystemFont("invite : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_LINKSHARE : {						// ***** acquisition
			label = Label::createWithSystemFont("linkShare : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL : {					// ***** acquisition
			label = Label::createWithSystemFont("linkShareURL : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_HIVEGAME_TYPE : {
			label = Label::createWithSystemFont("type : game", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);				// sns friends
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_HIVEGAME_SERVICE : {
			label = Label::createWithSystemFont("service : N/A", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_HIVEOTHER_TYPE : {
			label = Label::createWithSystemFont("type : other", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_HIVEOTHER_SERVICE : {
			label = Label::createWithSystemFont("service : N/A", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_HIVEALL_TYPE : {
			label = Label::createWithSystemFont("type : all or N/A", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_HIVEALL_SERVICE : {
			label = Label::createWithSystemFont("service : N/A", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_FBRECEIVED_TYPE : {
			label = Label::createWithSystemFont("type : receivedInvite", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_FBRECEIVED_SERVICE : {
			label = Label::createWithSystemFont("serivce : facebook", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_FBRECEIVED_LIMIT : {
			label = Label::createWithSystemFont("limit :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_FBMESSAGE_SERVICE : {
			label = Label::createWithSystemFont("service : facebook", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);		// sns message
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_FBMESSAGE_TYPE : {
			label = Label::createWithSystemFont("type : inviteDialog", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_FBMESSAGE_MESSAGE : {
			label = Label::createWithSystemFont("message :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_VIDUID : {
			label = Label::createWithSystemFont("VID or UID", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_VID : {
			label = Label::createWithSystemFont("VID :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_MESSAGE : {
			label = Label::createWithSystemFont("message :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_IMAGEURL : {
			label = Label::createWithSystemFont("imageUrl :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_THUMBNAILURL : {
			label = Label::createWithSystemFont("thumbnailUrl :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_USEPUSH : {
			label = Label::createWithSystemFont("usePush :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSMESSAGE_HIVEMESSAGE_INVITE : {
			label = Label::createWithSystemFont("invite :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSESSION_SESSION_SERVICE : {									// sns session
			label = Label::createWithSystemFont("service : N/A", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSESSION_FBSESSION_SERVICE : {									// sns session
			label = Label::createWithSystemFont("service : facebook", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_FBFRIENDS_TYPE : {										// sns friends, HIVE 1.10.2b
			label = Label::createWithSystemFont("type : friendsList", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSFRIENDS_FBFRIENDS_SERVICE : {									// sns friends, HIVE 1.10.2b
			label = Label::createWithSystemFont("service : facebook", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_PIDLIST : {
			label = Label::createWithSystemFont("pidList :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_SHOWLOG : {
			label = Label::createWithSystemFont("showLog :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_INAPPID : {
			label = Label::createWithSystemFont("inappId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_LEBI_PREPARE_AUTOVERIFY : {
			label = Label::createWithSystemFont("autoVerify :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_LEBI_REQUEST_UID : {
			label = Label::createWithSystemFont("uid :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_PURCHASE_RESTORE : {
			label = Label::createWithSystemFont("Restore :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);				// inapp
			break;
		}case TAG_LABEL_PLIST_INAPP_PURCHASE_FINISH : {
			label = Label::createWithSystemFont("Finish :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_PURCHASE_PID : {
			label = Label::createWithSystemFont("pid :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_PURCHASE_QUANTITY : {
			label = Label::createWithSystemFont("quantity :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_PURCHASE_ADDINFO : {
			label = Label::createWithSystemFont("additionalInfo :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_INAPP_FINISH_PURCHASESUCCESS : {
			label = Label::createWithSystemFont("isPurchase\nSuccess :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_HIVEHOME_TYPE : {
			label = Label::createWithSystemFont("type : home", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);				// sns show
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_HIVEUSER_TYPE : {
			label = Label::createWithSystemFont("type : user", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_HIVECAFE_TYPE : {
			label = Label::createWithSystemFont("type : cafe", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_EDITPROFILE_TYPE : {
			label = Label::createWithSystemFont("type : edit/profile/picture", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_FINDFRIENDS_TYPE : {
			label = Label::createWithSystemFont("type : find_friends", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_INQUARY_TYPE : {
			label = Label::createWithSystemFont("type : inquary", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_CHATBOT_TYPE : {													// HIVE 1.18.1
			label = Label::createWithSystemFont("type : chatbot", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_CHATBOT_ADDITIONALINFO : {										// HIVE 1.18.1
			label = Label::createWithSystemFont("additionalInfo : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_TERMS_TYPE : {
			label = Label::createWithSystemFont("type : terms", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_MESSAGE_TYPE : {
			label = Label::createWithSystemFont("type : message", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SOCIALSHOW_ADULTAUTH_TYPE : {												// HIVE 1.10.0
			label = Label::createWithSystemFont("type : adultAuth", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SOCIALSHOW_ADULTAUTH_GAMELANGUAGE : {										// HIVE 1.10.0
			label = Label::createWithSystemFont("gameLanguage :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SOCIALSHOW_GETNOTICE_TYPE : {												// HIVE 1.10.0
			label = Label::createWithSystemFont("type : notice", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SOCIALSHOW_GETNOTICE_SERVERID : {											// HIVE 1.10.0
			label = Label::createWithSystemFont("serverId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SOCIALINFO_GETNOTICEINFO_TYPE : {											// HIVE 1.10.0
			label = Label::createWithSystemFont("type : notice", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SOCIALINFO_GETNOTICEINFO_SERVERID : {										// HIVE 1.10.0
			label = Label::createWithSystemFont("serverId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SOCIALINFO_GETPERMISSION_TYPE : {										// HIVE 1.17.0
			label = Label::createWithSystemFont("type : permission", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SNSSHOW_MESSAGE_UID : {
			label = Label::createWithSystemFont("uid :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SENDEVENT_EVENT : {
			label = Label::createWithSystemFont("event :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);					// tracker
			break;
		}case TAG_LABEL_PLIST_TRACKER_SENDEVENT_TITLE : {
			label = Label::createWithSystemFont("title :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SENDEVENT_DESCRIPTION : {
			label = Label::createWithSystemFont("description :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SENDEVENT_CURRENCY : {
			label = Label::createWithSystemFont("currency :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SENDEVENT_PRICE : {
			label = Label::createWithSystemFont("price :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SENDEVENT_ITEMCOUNT : {
			label = Label::createWithSystemFont("itemCount :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SETENABLE_MAT : {
			label = Label::createWithSystemFont("MAT :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SETENABLE_ADJUST : {
			label = Label::createWithSystemFont("Adjust :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SETENABLE_PARTYTRACK : {
			label = Label::createWithSystemFont("PartyTrack :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SETENABLE_SINGULAR : {
			label = Label::createWithSystemFont("Singular :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_TRACKER_SETENABLE_APPSFLYER : {
			label = Label::createWithSystemFont("AppsFlyer :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		// HIVE IAP (HIVE 1.10.0)
		case TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_TYPE : {				// (1) 아이템 구매.
			label = Label::createWithSystemFont("type : shopInfo", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_LOCATIONCODE : {
			label = Label::createWithSystemFont("locationCode :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_WORLDNAME : {
			label = Label::createWithSystemFont("worldName :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_ITEM_GAMELANGUAGE : {
			label = Label::createWithSystemFont("gameLanguage :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_TYPE : {			// (2) 뱃지 정보.
			label = Label::createWithSystemFont("type : badge", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_LOCATIONCODE : {
			label = Label::createWithSystemFont("locationCode :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_WORLDNAME : {
			label = Label::createWithSystemFont("worldName :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_BADGE_GAMELANGUAGE : {
			label = Label::createWithSystemFont("gameLanguage :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_INFO_LEBI_TYPE : {			// (3) 러비 잔액 정보.
			label = Label::createWithSystemFont("type : balance", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_TYPE : {// (4) 러비/구글플레이 선택.
			label = Label::createWithSystemFont("type : payment", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_GAMELANGUAGE : {
			label = Label::createWithSystemFont("gameLanguage :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_SHOW_LEBICHARGE_TYPE : {		// (5) 러비 충전.
			label = Label::createWithSystemFont("type : charge", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_SHOW_LEBICHARGE_GAMELANGUAGE : {
			label = Label::createWithSystemFont("gameLanguage :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_PURCHASE_PID : {				// (6) 구매하기.
			label = Label::createWithSystemFont("pid :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_PURCHASE_ADDITIONALINFO : {	// (6) 구매하기 (addtionalInfo, HIVE SDK 1.12.1)
			label = Label::createWithSystemFont("additionalInfo : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEIAP_RESTORE_ADDITIONALINFO : {	// (7) 구매복 (addtionalInfo, HIVE SDK 1.12.1)
			label = Label::createWithSystemFont("additionalInfo : ", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		// Engagement (HIVE 1.10.0)
		case TAG_LABEL_PLIST_ENGAGEMENT_CONSUMECOUPON_COUPONID : {				//
			label = Label::createWithSystemFont("coupomeId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_ENGAGEMENT_CONSUMECOUPON_LANGUAGE : {
			label = Label::createWithSystemFont("language :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_ENGAGEMENT_CONSUMECOUPON_ADDITIONALINFO : {		//
			label = Label::createWithSystemFont("addtionalInfo :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		// HIVE Promotion (HIVE 1.12.0)
		case TAG_LABEL_PLIST_HIVEPROMOTION_NEWS_TYPE : {
			label = Label::createWithSystemFont("type : news", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_NEWS_FORCED : {
			label = Label::createWithSystemFont("forced :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_BANNER_TYPE : {
			label = Label::createWithSystemFont("type : banner", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_BANNER_FORCED : {
			label = Label::createWithSystemFont("forced :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_NOTICE_TYPE : {
			label = Label::createWithSystemFont("type : notice", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_NOTICE_FORCED : {
			label = Label::createWithSystemFont("forced :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMVIEW_TYPE : {
			label = Label::createWithSystemFont("type : customView", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMBOARD_TYPE : {
			label = Label::createWithSystemFont("type : customBoard", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_SPOT_TYPE : {
			label = Label::createWithSystemFont("type : spot", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_DIRECT_TYPE : {
			label = Label::createWithSystemFont("type : direct", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_OFFERWALL_TYPE : {
			label = Label::createWithSystemFont("type : offerwall", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_REVIEW_TYPE : {
			label = Label::createWithSystemFont("type : review", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTION_EXIT_TYPE : {
			label = Label::createWithSystemFont("type : exit", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		// HIVE Promotion Info (HIVE 1.12.0)
		case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_BADGEINFO_TYPE : {
			label = Label::createWithSystemFont("type : badge", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMVIEW_TYPE : {
			label = Label::createWithSystemFont("type : customView", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMVIEW_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMBOARD_TYPE : {
			label = Label::createWithSystemFont("type : customBoard", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CUSTOMBOARD_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_SPOT_TYPE : {
			label = Label::createWithSystemFont("type : spot", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_SPOT_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_DIRECT_TYPE : {
			label = Label::createWithSystemFont("type : spot", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_DIRECT_CONTENTKEY : {
			label = Label::createWithSystemFont("contentKey :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_ADDITIONALINFO_INFO : {
			label = Label::createWithSystemFont("additionalInfo :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		// Set Game Info (HIVE 1.12.0)
		case TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_SERVERID : {
			label = Label::createWithSystemFont("serverId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_GAMELANGUAGE : {
			label = Label::createWithSystemFont("gameLanguage :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_EMERGENCY_MODE : {		// modified 1.19.4, HIVE 1.16.1
			label = Label::createWithSystemFont("emergencyMode :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}case TAG_LABEL_PLIST_SETGAMEINFO_SETGAMEINFO_CHANNEL : {
			label = Label::createWithSystemFont("channel :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_SETGAMEINFO_SETCHANNEL_CHANNEL : {
			label = Label::createWithSystemFont("channel :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		// UpdateServerId (HIVE 1.19.1)
		case TAG_LABEL_PLIST_SETGAMEINFO_UPDATE_SERVERID_SERVERID : {
			label = Label::createWithSystemFont("serverId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		// UpdateGameLanguage (HIVE 1.19.1)
		case TAG_LABEL_PLIST_SETGAMEINFO_UPDATE_GAMELANGUAGE_GAMELANGUAGE: {
			label = Label::createWithSystemFont("gameLanguage :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
        // Send Data (Funnel logs)
        case TAG_LABEL_PLIST_SETGAMEINFO_SEND_DATA_FUNNELS_ID: {
            label = Label::createWithSystemFont("funnelsId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
            break;
        }
        case TAG_LABEL_PLIST_SETGAMEINFO_SEND_DATA_OPTION_TAG: {
            label = Label::createWithSystemFont("optionTag :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
            break;
        }
		// Get Banner Info (HIVE 1.18.3)
		case TAG_LABEL_PLIST_PROMOTIONINFO_CAMPAIGN_TYPE : {
			label = Label::createWithSystemFont("campaignType :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LBAEL_PLIST_PROMOTIONINFO_BANNER_TYPE : {
			label = Label::createWithSystemFont("bannerType :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_PROMOTIONINFO_PARAM_GUIDE : {
			label = Label::createWithSystemFont("(campaginType : all(a), event(e), notice(n), etc)\n(bannerType : great(g), small(s), rolling(r), etc)", "arial.ttf", 10);
			break;
		}
		case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_CAMPAIGN_TYPE : {
			label = Label::createWithSystemFont("campaignType :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LBAEL_PLIST_HIVEPROMOTIONINFO_BANNER_TYPE : {
			label = Label::createWithSystemFont("bannerType :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_HIVEPROMOTIONINFO_PARAM_GUIDE : {
			label = Label::createWithSystemFont("(campaginType : all(a), event(e), notice(n), etc)\n(bannerType : great(g), small(s), rolling(r), etc)", "arial.ttf", 10);
			break;
		}
		// InAppV4 (HIVE 1.18.4)
		case TAG_LABEL_PLIST_INAPPV4_ITEMINFO_TYPE : {
			label = Label::createWithSystemFont("type :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_INAPPV4_PURCHASE_TYPE : {
			label = Label::createWithSystemFont("type :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_INAPPV4_PURCHASE_PID : {
			label = Label::createWithSystemFont("pid :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_INAPPV4_PURCHASE_IAPPAYLOAD : {
			label = Label::createWithSystemFont("iapPayload :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_INAPPV4_RESTORE_TYPE : {
			label = Label::createWithSystemFont("type :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_INAPPV4_TRANSACTION_FINISH_PID : {
			label = Label::createWithSystemFont("pid :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}
		case TAG_LABEL_PLIST_INAPPV4_SHOW_INAPP_MESSAGES_CATEGORY_ID : {
			label = Label::createWithSystemFont("categoryId :", "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
			break;
		}

		default : {
			log("### ParameterListScene::createParamLabels(int tag) error ###");
			break;
		}
	}
	label->setColor(Color3B(0, 0, 0));

	auto item = MenuItemLabel::create(label, CC_CALLBACK_1(ParameterListScene::labelEvent, this));
	item->setTag(tag);
	return item;
}

void ParameterListScene::labelEvent(Ref *sender)
{
	auto label = (MenuItem*) sender;

	switch(label->getTag()) {
		default : {
			// no event
			break;
		}
	}
}

void ParameterListScene::update_textFields(int tag)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	switch(tag) {
		case TAG_BTN_MODULE_LIST_PUSH_REGISTER : {			// push
			log("### ParameterListScene::update_textFields(push_register) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PUSHREGISTER_PUSHID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PUSHREGISTER_TITLE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PUSHREGISTER_MESSAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PUSHREGISTER_AFTER,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PUSHREGISTER_GROUP_ID,
					 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5));
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_UNREGISTER : {
			log("### ParameterListScene::update_textFields(push_unregister) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PUSHUNREGISTER_PUSHID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_DESCRIPTION : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_HIVE : {			// sns_user
			log("### ParameterListScene::update_textFields(sns_user HIVE) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSUSER_VID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_FACEBOOK : {
			log("### ParameterListScene::update_textFields(sns_user Facebook) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSUSER_FACEBOOKID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_DELETE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_HIVE : {			// sns_post ---> HIVE Post (보류된 기능)
			log("### ParameterListScene::update_textFields(sns_post HIVE) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_HIVE_MESSAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_HIVE_IMAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_HIVE_IMAGEURL,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_HIVE_VIDEOURL,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_FACEBOOK : {
			log("### ParameterListScene::update_textFields(sns_post Facebook) ###");
			// HIVE SDK 1.12.1부터 message, title, imageUrl을 파라미터로 사용하지 않음.
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_FB_MESSAGE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_FB_TITLE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_FB_IMAGE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_FB_APPLINKURL,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_GOOGLEPLUS : {
			log("### ParameterListScene::update_textFields(sns_post Google+) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSPOST_GPLUS_MESSAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICE : {		// promotion
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FOCRED_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FORCED_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER_IMAGE_BANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_OFFERWALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_CUSTOMWEBVIEW : {
			log("### ParameterListScene::update_textFields(promoShow customwebview) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOSHOW_CUSTOM_VIEWID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_REVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_MOREGAMES : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICE : {		// promotion_info
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_CUSTOMWEBVIEW : {
			log("### ParameterListScene::update_textFields(promoInfo badge customwebview) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOINFO_BADGE_CUSTOM_VIEWID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_CUSTOMWEBVIEW : {
			log("### ParameterListScene::update_textFields(promoInfo view customwebview) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOINFO_VIEW_CUSTOM_VIEWID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETOFFERWALLSTATE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GAME : {		// invite_friends
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_OTHER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_ALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_RECEIVEDINVITE : {
			log("### ParameterListScene::update_textFields(sns friends FB receivedInvite) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSFRIENDS_FBRECEIVED_LIMIT,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_MESSAGE : {
			log("### ParameterListScene::update_textFields(sns message FB messgae) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSMESSAGE_FBMESSAGE_MESSAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_MESSAGE : {
			log("### ParameterListScene::update_textFields(sns message Hive messgae) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_VID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_MESSAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_IMAGEURL,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_THUMBNAILURL,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4));
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_SESSION : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_PREPARE : {				// inapp
			log("### ParameterListScene::update_textFields(inapp Lebi prepare) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPP_LEBI_PREPARE_PIDLIST,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPP_LEBI_PREPARE_INAPPID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_REQUESTBALANCE : {
			log("### ParameterListScene::update_textFields(inapp Lebi requestBalance) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPP_LEBI_REQUEST_UID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_PURCHASE : {
			log("### ParameterListScene::update_textFields(sns message Hive messgae) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPP_PURCHASE_PID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPP_PURCHASE_QUANTITY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPP_PURCHASE_ADDINFO,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4));
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_RESTORE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_FINISH : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEHOME : {			// Hive webview
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEUSER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVECAFE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_EDITPROFILE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_FINDFRIENDS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_INQUIRY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_CHATBOT : {				// HIVE 1.18.1
			log("### ParameterListScene::update_textFields(sns show chatbot) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSSHOW_CHATBOT_ADDITIONALINFO,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_TERMS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_ADULTAUTH : {				// HIVE 1.10.0
			log("### ParameterListScene::update_textFields(social show adultAuth) ###");
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SOCIALSHOW_ADULTAUTH_GAMELANGUAGE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICE : {				// HIVE 1.10.0
			log("### ParameterListScene::update_textFields(social show getNotice) ###");
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SOCIALSHOW_GETNOTICE_SERVERID,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICEINFO : {			// HIVE 1.10.0
			log("### ParameterListScene::update_textFields(social info getNoticeInfo) ###");
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SOCIALINFO_GETNOTICEINFO_SERVERID,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETPERMISSIONINFO : {			// HIVE 1.17.0
			log("### ParameterListScene::update_textFields(social info getNoticeInfo) ###");
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SOCIALINFO_GETNOTICEINFO_SERVERID,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_MESSAGE : {
			log("### ParameterListScene::update_textFields(sns show message) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SNSSHOW_MESSAGE_UID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_EVENT : {					// Tracker
			log("### ParameterListScene::update_textFields(tracker sendEvent) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_TRACKER_SENDEVENT_EVENT,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			/*
			ParameterListScene::createTextFields(TAG_TF_PLIST_TRACKER_SENDEVENT_TITLE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_TRACKER_SENDEVENT_DESCRIPTION,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			ParameterListScene::createTextFields(TAG_TF_PLIST_TRACKER_SENDEVENT_CURRENCY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			ParameterListScene::createTextFields(TAG_TF_PLIST_TRACKER_SENDEVENT_PRICE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4));
			ParameterListScene::createTextFields(TAG_TF_PLIST_TRACKER_SENDEVENT_ITEMCOUNT,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5));
					*/
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_SETENABLE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_INFO : {
			log("### ParameterListScene::update_textFields(Acquisition Info) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INFO_ADDITIONALINFO,
					(ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHARE : {
			log("### ParameterListScene::update_textFields(Acquisition HIVELinkShare) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE,
												 (ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 4));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL,
												 (ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 10));
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHAREPLUSMESSAGE : {
			log("### ParameterListScene::update_textFields(Acquisition HIVELinkShare and Message) ###");
			//			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_GAMEWORLD,
//					(ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 0));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_GAMELANGUAGE,
//					(ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_VID,
												 (ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 3));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE,
												 (ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 4));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_IMAGEURL,
												 (ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 5));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_THUMBNAILURL,
												 (ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 6));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL,
												 (ParameterListScene::ui_paramLabel_y + 0.05) - ((ParameterListScene::ui_paddingSize_y - 0.01) * 10));
			break;
		}
		// HIVE IAP (HIVE 1.10.0)
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_ITEM : {
			log("### ParameterListScene::update_textFields(HIVEIAP INFO ITEM) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_INFO_ITEM_LOCATIONCODE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_INFO_ITEM_WORLDNAME,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_INFO_ITEM_GAMELANGUAGE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_BADGE : {
			log("### ParameterListScene::update_textFields(HIVEIAP INFO BADGE) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_INFO_BADGE_LOCATIONCODE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_INFO_BADGE_WORLDNAME,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_INFO_BADGE_GAMELANGUAGE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_LEBI : {
			log("### ParameterListScene::update_textFields(HIVEIAP INFO LEBI) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_GOOGLELEBISELECT : {
			log("### ParameterListScene::update_textFields(HIVEIAP SHOW GOOGLELEBISELECT) ###");
//			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_GAMELANGUAGE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_LEBICHARGE : {
			log("### ParameterListScene::update_textFields(HIVEIAP SHOW LEBICHARGE) ###");
//			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_SHOW_LEBICHARGE_GAMELANGUAGE,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_PURCHASE : {
			log("### ParameterListScene::update_textFields(HIVEIAP PURCHASE) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_PURCHASE_PID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_PURCHASE_ADDITIONALINFO,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));		// HIVE SDK 1.12.1
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_RESTORE : {
			log("### ParameterListScene::update_textFields(HIVEIAP RESTORE) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEIAP_RESTORE_ADDITIONALINFO,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));		// HIVE SDK 1.12.1
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_POSTBOX : {
			log("### ParameterListScene::update_textFields(HIVEIAP POSTBOX) ###");
			break;
		}
		// Engagement (HIVE 1.10.0)
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_GETEVENTS : {
			log("### ParameterListScene::update_textFields(Engagement GetEvents) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_CONSUMECOUPON : {
			log("### ParameterListScene::update_textFields(Engagement ConsumeCoupon) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_COUPONID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_LANGUAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_ADDITIONALINFO,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_SETREADY : {
			log("### ParameterListScene::update_textFields(Engagement SetReady) ###");
			break;
		}
		// HIVE Promotion Show
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMVIEW : {
			log("### ParameterListScene::update_textFields(HIVE Promotion customView) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMBOARD : {
			log("### ParameterListScene::update_textFields(HIVE Promotion customBoard) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_SPOT : {
			log("### ParameterListScene::update_textFields(HIVE Promotion SpotBanner) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_DIRECT : {
			log("### ParameterListScene::update_textFields(HIVE Promotion DirectBanner) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		// HIVE Promotion Info
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_VIEWINFO : {
			log("### ParameterListScene::update_textFields(HIVE Promotion Info customView) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BOARDINFO : {
			log("### ParameterListScene::update_textFields(HIVE Promotion Info customBoard) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SPOTINFO : {
			log("### ParameterListScene::update_textFields(HIVE Promotion Info SpotBanner) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_DIRECTINFO : {
			log("### ParameterListScene::update_textFields(HIVE Promotion Info DirectBanner) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SETADDITIONALINFO : {
			log("### ParameterListScene::update_textFields(HIVE Promotion Info DirectBanner) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTIONINFO_ADDITIONALINFO,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETGAMEINFO : {
			log("### ParameterListScene::update_textFields(SetGameInfo) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_SERVERID,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_GAMELANGUAGE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_CHANNEL,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3));
//			ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_VID,
//					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4));
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETCHANNEL : {
			log("### ParameterListScene::update_textFields(SetChannel) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_SETCHANNEL_CHANNEL,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_SERVERID : {
			log("### ParameterListScene::update_textFields(updatrGameInfo) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_UPDATE_SERVERID_SERVERID,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_GAMELANGUAGE: {
			log("### ParameterListScene::update_textFields(gameLanguage) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_UPDATE_GAMELANGUAGE_GAMELANGUAGE,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
        case TAG_BTN_MODULE_LIST_SETGAMEINFO_SEND_DATA : {
            log("### ParameterListScene::update_textFields(sendData) ###");
            ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_FUNNELS_ID,
                    ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
            ParameterListScene::createTextFields(TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_OPTION_TAG,
                    ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
            break;
        }
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETBANNERINFO : {
			log("### ParameterListScene::update_textFields(Promotion Info GetBannerInfo) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOTIONINFO_CAMPAIGN_TYPE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_PROMOTIONINFO_BANNER_TYPE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;	
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_GETBANNERINFO : {
			log("### ParameterListScene::update_textFields(HIVE Promotion Info GetBannerInfo) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTIONINFO_CAMPAIGN_TYPE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_HIVEPROMOTIONINFO_BANNER_TYPE,
					ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			break;
		}
		// InAppV4
		case TAG_TYPE_MODULE_LIST_INAPPV4_ITEMINFO : {
			log("### ParameterListScene::update_textFields(InAppV4 GetBannerInfo) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPPV4_ITEMINFO_TYPE,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_PURCHASE : {
			log("### ParameterListScene::update_textFields(InAppV4 Purchase) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPPV4_PURCHASE_TYPE,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPPV4_PURCHASE_PID,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1));
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPPV4_PURCHASE_IAPPAYLOAD,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2));
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_RESTORE : {
			log("### ParameterListScene::update_textFields(InAppV4 Restore) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPPV4_RESTORE_TYPE,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_TRANSACTION_FINISH : {
			log("### ParameterListScene::update_textFields(InAppV4 Transaction Finish) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPPV4_TRANSACTION_FINISH_PID,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_SHOW_INAPP_MESSAGES : {
			log("### ParameterListScene::update_textFields(InAppV4 ShowInAppMessages) ###");
			ParameterListScene::createTextFields(TAG_TF_PLIST_INAPPV4_SHOW_INAPP_MESSAGES_CATEGORY_ID,
												 ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0));
			break;
		}
		default : {
			log("### ParameterListScene::update_textFields(int tag) error ###");
			break;
		}
	}
	// function 'createTextField' End
}

// 텍스트 필드와 터치 이벤트를 생성해주는 함수 --> 객체화하여 리펙토링 필요
void ParameterListScene::createTextFields(int tag, float textFieldPos_y)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();

	TextFieldTTF* textField = cocos2d::TextFieldTTF::textFieldWithPlaceHolder("input here!",
			cocos2d::Size(130, 17), TextHAlignment::LEFT, "arial.ttf", Parameter::paramSampleSetting.normalFontSize);
	textField->setPosition(
			Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * textFieldPos_y));
	textField->setColor(ccc3(0, 0, 255));
	textField->setColorSpaceHolder(Color3B::BLUE);
	textField->setTag(tag);
	textField->setDelegate(this);

	this->addChild(textField);
	//Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);
	//layer->addChild(textField);

	auto touchListener = EventListenerTouchOneByOne::create();

	switch(tag) {
		case TAG_TF_PLIST_PUSHREGISTER_PUSHID : {	// (1)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PUSHREGISTER, "pushId"));	// set default or saved text
			ParameterListScene::tfArea_pushRegister_pushId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_pushRegister_pushId.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PUSHREGISTER_PUSHID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PUSHREGISTER_TITLE : {	// (2)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PUSHREGISTER, "title"));	// set default or saved text
			ParameterListScene::tfArea_pushRegister_title = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_pushRegister_title.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PUSHREGISTER_TITLE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PUSHREGISTER_MESSAGE : {	// (3)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PUSHREGISTER, "message"));	// set default or saved text
			ParameterListScene::tfArea_pushRegister_message = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_pushRegister_message.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PUSHREGISTER_MESSAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PUSHREGISTER_AFTER : {	// (4)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PUSHREGISTER, "after"));	// set default or saved text
			ParameterListScene::tfArea_pushRegister_after = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_pushRegister_after.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PUSHREGISTER_AFTER;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PUSHREGISTER_GROUP_ID : {	// (6)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PUSHREGISTER, "groupId"));	// set default or saved text
			ParameterListScene::tfArea_pushRegister_groupId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_pushRegister_groupId.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PUSHREGISTER_GROUP_ID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PUSHUNREGISTER_PUSHID : {	// (6)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PUSHUNREGISTER, "pushId"));	// set default or saved text
			ParameterListScene::tfArea_pushUnregister_pushId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_pushUnregister_pushId.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PUSHUNREGISTER_PUSHID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_PUSHDESCRITPTION_USEPUSH : {     // Description UsePush
//            textField->setString(DataManager::getParamValue(TAG_APIACTION_PUSHUNREGISTER, "pushId"));	// set default or saved text
//            ParameterListScene::tfArea_pushUnregister_pushId = textField->getBoundingBox();	// change this
//
//            touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//                try {
//                    CCPoint point = touch->getLocationInView();
//                    point = Director::sharedDirector()->convertToGL(point);
//
//                    if(ParameterListScene::tfArea_pushUnregister_pushId.containsPoint(point)
//                            ) {	// change this
//                        // Show the on screen keyboard
//                        ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PUSHUNREGISTER_PUSHID;	// change this
//                        auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//                        textField_->attachWithIME();
//
//                    }
//                    return true;
//                }
//                catch(std::bad_cast * err) {
//                    return true;
//                }
//            };
//            break;
//        }
        case TAG_TF_PLIST_SNSUSER_VID : {	// (14)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSUSER, "vid"));	// set default or saved text
			ParameterListScene::tfArea_snsuser_vid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsuser_vid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSUSER_VID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSUSER_FACEBOOKID : {	// (15)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSUSER, "facebookId"));	// set default or saved text
			ParameterListScene::tfArea_snsuser_facebookId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsuser_facebookId.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSUSER_FACEBOOKID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		/*
		case TAG_TF_PLIST_SNSPOST_HIVE_MESSAGE : {	// (16)  ----> HIVE 포스팅 (사용하지 않는 기능)
			ParameterListScene::tfArea_snsPost_message = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsPost_message.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_HIVE_MESSAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSPOST_HIVE_IMAGE : {	// (17)  ----> HIVE 포스팅 (사용하지 않는 기능)
			ParameterListScene::tfArea_snsPost_image = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsPost_image.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_HIVE_IMAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSPOST_HIVE_IMAGEURL : {	// (18)  ----> HIVE 포스팅 (사용하지 않는 기능)
			ParameterListScene::tfArea_snsPost_imageUrl = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsPost_imageUrl.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_HIVE_IMAGEURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSPOST_HIVE_VIDEOURL : {	// (19)  ----> HIVE 포스팅 (사용하지 않는 기능)
			ParameterListScene::tfArea_snsPost_videoUrl = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsPost_videoUrl.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_HIVE_VIDEOURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		*/
		// HIVE SDK 1.12.1부터 Facebook 포스팅시 message, title, imageUrl을 사용하지 않음.
//		case TAG_TF_PLIST_SNSPOST_FB_MESSAGE : {	// (20)
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSPOSTING, "message"));	// set default or saved text
//			ParameterListScene::tfArea_snsPost_FB_message = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_snsPost_FB_message.containsPoint(point)
//							) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_FB_MESSAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}case TAG_TF_PLIST_SNSPOST_FB_TITLE : {	// (21)
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSPOSTING, "title"));	// set default or saved text
//			ParameterListScene::tfArea_snsPost_FB_title = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_snsPost_FB_title.containsPoint(point)
//							) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_FB_TITLE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}case TAG_TF_PLIST_SNSPOST_FB_IMAGE : {	// (22)
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSPOSTING, "image"));	// set default or saved text
//			ParameterListScene::tfArea_snsPost_FB_image = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_snsPost_FB_image.containsPoint(point)
//							) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_FB_IMAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_SNSPOST_FB_APPLINKURL : {	// (23)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSPOSTING, "appLinkURL"));	// set default or saved text
			ParameterListScene::tfArea_snsPost_FB_appLinkUrl = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsPost_FB_appLinkUrl.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_FB_APPLINKURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSPOST_GPLUS_MESSAGE : {	// (23.5)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSPOSTING, "message"));	// set default or saved text
			ParameterListScene::tfArea_snsPost_GPlus_message = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsPost_GPlus_message.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSPOST_GPLUS_MESSAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PROMOSHOW_CUSTOM_VIEWID : {	// (23.75)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PROMOTIONSHOW, "viewId"));	// set default or saved text
			ParameterListScene::tfArea_promoShow_custom_viewId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoShow_custom_viewId.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOSHOW_CUSTOM_VIEWID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PROMOINFO_BADGE_CUSTOM_VIEWID : {	// (24)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PROMOTIONINFO, "viewId"));	// set default or saved text
			ParameterListScene::tfArea_promoInfo_badge_custom = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoInfo_badge_custom.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOINFO_BADGE_CUSTOM_VIEWID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PROMOINFO_VIEW_CUSTOM_VIEWID : {	// (25)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PROMOTIONINFO, "viewId"));	// set default or saved text
			ParameterListScene::tfArea_promoInfo_view_custom = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoInfo_view_custom.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOINFO_VIEW_CUSTOM_VIEWID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSFRIENDS_FBRECEIVED_LIMIT : {	// (26)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSFRIENDS, "limit"));	// set default or saved text
			ParameterListScene::tfArea_snsFriends_FBReceived_limit = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsFriends_FBReceived_limit.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSFRIENDS_FBRECEIVED_LIMIT;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSMESSAGE_FBMESSAGE_MESSAGE : {	// (27)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSMESSAGE, "message"));	// set default or saved text
			ParameterListScene::tfArea_snsMessage_FBMessage_message = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsMessage_FBMessage_message.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSMESSAGE_FBMESSAGE_MESSAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_VID : {	// (29)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSMESSAGE, "vid"));	// set default or saved text
			//textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSMESSAGE, "uid"));	// set default or saved text
			ParameterListScene::tfArea_snsMessage_HiveMessage_vid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsMessage_HiveMessage_vid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_VID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_MESSAGE : {	// (30)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSMESSAGE, "message"));	// set default or saved text
			ParameterListScene::tfArea_snsMessage_HiveMessage_message = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsMessage_HiveMessage_message.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_MESSAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_IMAGEURL : {	// (31)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSMESSAGE, "imageURL"));	// set default or saved text
			ParameterListScene::tfArea_snsMessage_HiveMessage_imageUrl = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsMessage_HiveMessage_imageUrl.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_IMAGEURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_THUMBNAILURL : {	// (32)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSMESSAGE, "thumbnailURL"));	// set default or saved text
			ParameterListScene::tfArea_snsMessage_HiveMessage_thumbUrl = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsMessage_HiveMessage_thumbUrl.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_THUMBNAILURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_INAPP_LEBI_PREPARE_PIDLIST : {	// (37)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PREPARE, "pidList"));	// set default or saved text
			ParameterListScene::tfArea_inApp_Lebi_prepare_pidList = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inApp_Lebi_prepare_pidList.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPP_LEBI_PREPARE_PIDLIST;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_INAPP_LEBI_PREPARE_INAPPID : {	// (39)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PREPARE, "inappId"));	// set default or saved text
			ParameterListScene::tfArea_inApp_Lebi_prepare_inappid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inApp_Lebi_prepare_inappid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPP_LEBI_PREPARE_INAPPID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_INAPP_LEBI_REQUEST_UID : {	// (41)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_REQUESTBALANCE, "uid"));	// set default or saved text
			ParameterListScene::tfArea_inApp_Lebi_requestBal_uid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inApp_Lebi_requestBal_uid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPP_LEBI_REQUEST_UID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_INAPP_PURCHASE_PID : {	// (44)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPPURCHASE, "pid"));	// set default or saved text
			ParameterListScene::tfArea_inApp_purchase_pid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inApp_purchase_pid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPP_PURCHASE_PID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_INAPP_PURCHASE_QUANTITY : {	// (45)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPPURCHASE, "quantity"));	// set default or saved text
			ParameterListScene::tfArea_inApp_purchase_qunantity = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inApp_purchase_qunantity.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPP_PURCHASE_QUANTITY;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_INAPP_PURCHASE_ADDINFO : {	// (46)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPPURCHASE, "addtionalInfo"));	// set default or saved text
			ParameterListScene::tfArea_inApp_purchase_addInfo = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inApp_purchase_addInfo.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPP_PURCHASE_ADDINFO;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SNSSHOW_CHATBOT_ADDITIONALINFO : {	// (HIVE 1.18.1)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSSHOW, "additionalInfo"));	// set default or saved text
			ParameterListScene::tfArea_snsShow_chatbot_additionalInfo = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsShow_chatbot_additionalInfo.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSSHOW_CHATBOT_ADDITIONALINFO;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_SNSSHOW_MESSAGE_UID : {	// (48)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SNSSHOW, "uid"));	// set default or saved text
			ParameterListScene::tfArea_snsShow_message_uid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_snsShow_message_uid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SNSSHOW_MESSAGE_UID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_TRACKER_SENDEVENT_EVENT : {	// (49)
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SENDEVENT, "event"));	// set default or saved text
			ParameterListScene::tfArea_tracker_sendEvent_event = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_tracker_sendEvent_event.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_TRACKER_SENDEVENT_EVENT;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_TRACKER_SENDEVENT_TITLE : {	// (50) ----> Unity에서만 사용하는 기능.
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SENDEVENT, "title"));	// set default or saved text
			ParameterListScene::tfArea_tracker_sendEvent_title = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_tracker_sendEvent_title.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_TRACKER_SENDEVENT_TITLE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_TRACKER_SENDEVENT_DESCRIPTION : {	// (51) ----> Unity에서만 사용하는 기능.
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SENDEVENT, "description"));	// set default or saved text
			ParameterListScene::tfArea_tracker_sendEvent_description = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_tracker_sendEvent_description.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_TRACKER_SENDEVENT_DESCRIPTION;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_TRACKER_SENDEVENT_CURRENCY : {	// (52) ----> Unity에서만 사용하는 기능.
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SENDEVENT, "currency"));	// set default or saved text
			ParameterListScene::tfArea_tracker_sendEvent_currency = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_tracker_sendEvent_currency.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_TRACKER_SENDEVENT_CURRENCY;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_TRACKER_SENDEVENT_PRICE : {	// (53) ----> Unity에서만 사용하는 기능.
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SENDEVENT, "price"));	// set default or saved text
			ParameterListScene::tfArea_tracker_sendEvent_price = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_tracker_sendEvent_price.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_TRACKER_SENDEVENT_PRICE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();

					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_TRACKER_SENDEVENT_ITEMCOUNT : {	// (54) ----> Unity에서만 사용하는 기능.
			textField->setString(DataManager::getParamValue(TAG_APIACTION_SENDEVENT, "itemCount"));	// set default or saved text
			ParameterListScene::tfArea_tracker_sendEvent_itemCount = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_tracker_sendEvent_itemCount.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_TRACKER_SENDEVENT_ITEMCOUNT;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_PROMOACQUISITION_INFO_ADDITIONALINFO : {	// HIVE 1.13.0
			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "additionalInfo"));	// set default or saved text
			ParameterListScene::tfArea_promoAcquisition_info_additionalInfo = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoAcquisition_info_additionalInfo.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INFO_ADDITIONALINFO;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_GAMEWORLD : {	// (55) acquisition invite_link gameworld
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "gameWorld"));	// set default or saved text
//			ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_gameworld = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_gameworld.containsPoint(point)
//							) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_GAMEWORLD;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
//		case TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_GAMELANGUAGE : {	// (56) acquisition invite_link gamelanguage
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "gameLanguage"));	// set default or saved text
//			ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_gameLanguage = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_gameLanguage.containsPoint(point)
//							) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_GAMELANGUAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_VID : {	// (57) acquisition invite_link vid
			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "vid"));	// set default or saved text
			ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_vid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_vid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_VID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE : {	// (58) acquisition invite_link message
			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "message"));	// set default or saved text
			ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_message = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_message.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_IMAGEURL : {	// (59) acquisition invite_link imageurl
			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "imageURL"));	// set default or saved text
			ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_imageURL = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_imageURL.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_IMAGEURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_THUMBNAILURL : {	// (60) acquisition invite_link thumbnailurl
			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "thumbnailURL"));	// set default or saved text
			ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_thumbnailURL = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_thumbnailURL.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_THUMBNAILURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL : {	// (65) acquisition invite_link linkShareURL
			textField->setString(DataManager::getParamValue(TAG_APIACTION_USERACQUISITION, "linkShareURL"));	// set default or saved text
			ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_linkShareURL = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promoAcquisition_hiveInviteLink_linkShareURL.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_SOCIALSHOW_GETNOTICE_SERVERID : {	// HIVE 1.10.0 : social show getNotice serverId
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_SOCIALSHOW, "serverId"));	// set default or saved text
//			ParameterListScene::tfArea_socialShow_getNotice_serverId = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_socialShow_getNotice_serverId.containsPoint(point)
//							) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SOCIALSHOW_GETNOTICE_SERVERID;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
//		case TAG_TF_PLIST_SOCIALINFO_GETNOTICEINFO_SERVERID : {	// HIVE 1.10.0 : social info getNoticeInfo serverId
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_SOCIALINFO, "serverId"));	// set default or saved text
//			ParameterListScene::tfArea_socialInfo_getNoticeInfo_serverId = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_socialInfo_getNoticeInfo_serverId.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SOCIALINFO_GETNOTICEINFO_SERVERID;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_HIVEIAP_INFO_ITEM_LOCATIONCODE : {	// HIVE 1.10.0 : HIVE IAP INFO ITEM LOCATIONCODE
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_INFO, "locationCode"));	// set default or saved text
			ParameterListScene::tfArea_HiveIAP_info_item_locationCode = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_HiveIAP_info_item_locationCode.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_INFO_ITEM_LOCATIONCODE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_HIVEIAP_INFO_ITEM_WORLDNAME : {		// HIVE 1.10.0 : HIVE IAP INFO ITEM WORLDNAME
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_INFO, "worldName"));	// set default or saved text
//			ParameterListScene::tfArea_HiveIAP_info_item_worldName = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_HiveIAP_info_item_worldName.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_INFO_ITEM_WORLDNAME;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
//		case TAG_TF_PLIST_HIVEIAP_INFO_ITEM_GAMELANGUAGE : {		// HIVE 1.10.0 : HIVE IAP INFO ITEM gameLanguage
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_INFO, "gameLanguage"));	// set default or saved text
//			ParameterListScene::tfArea_HiveIAP_info_item_gameLanguage = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_HiveIAP_info_item_gameLanguage.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_INFO_ITEM_GAMELANGUAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_HIVEIAP_INFO_BADGE_LOCATIONCODE : {		// HIVE 1.10.0 : HIVE IAP INFO ITEM gameLanguage
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_INFO, "locationCode"));	// set default or saved text
			ParameterListScene::tfArea_HiveIAP_info_badge_locationCode = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_HiveIAP_info_badge_locationCode.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_INFO_BADGE_LOCATIONCODE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_HIVEIAP_INFO_BADGE_WORLDNAME : {		// HIVE 1.10.0 : HIVE IAP INFO ITEM gameLanguage
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_INFO, "worldName"));	// set default or saved text
//			ParameterListScene::tfArea_HiveIAP_info_badge_worldName = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_HiveIAP_info_badge_worldName.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_INFO_BADGE_WORLDNAME;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
//		case TAG_TF_PLIST_HIVEIAP_INFO_BADGE_GAMELANGUAGE : {		// HIVE 1.10.0 : HIVE IAP INFO ITEM gameLanguage
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_INFO, "gameLanguage"));	// set default or saved text
//			ParameterListScene::tfArea_HiveIAP_info_badge_gameLanguage = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_HiveIAP_info_badge_gameLanguage.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_INFO_BADGE_GAMELANGUAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
//		case TAG_TF_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_GAMELANGUAGE : {		// HIVE 1.10.0 : HIVE IAP SHOW google_lebi_select gameLanguage
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_SHOW, "gameLanguage"));	// set default or saved text
//			ParameterListScene::tfArea_HiveIAP_show_googleLebiSelect_gameLanguage = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_HiveIAP_show_googleLebiSelect_gameLanguage.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_GAMELANGUAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
//		case TAG_TF_PLIST_HIVEIAP_SHOW_LEBICHARGE_GAMELANGUAGE : {		// HIVE 1.10.0 : HIVE IAP SHOW lebi charge gameLanguage
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_SHOW, "gameLanguage"));	// set default or saved text
//			ParameterListScene::tfArea_HiveIAP_show_lebiCharge_gameLanguage = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_HiveIAP_show_lebiCharge_gameLanguage.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_SHOW_LEBICHARGE_GAMELANGUAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_HIVEIAP_PURCHASE_PID : {		// HIVE 1.10.0 : HIVE IAP Purchase pid
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_PURCHASE, "pid"));	// set default or saved text
			ParameterListScene::tfArea_HiveIAP_purchase_pid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_HiveIAP_purchase_pid.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_PURCHASE_PID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_HIVEIAP_PURCHASE_ADDITIONALINFO : {		// HIVE 1.12.1 : HIVE IAP Purchase additionalInfo
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_PURCHASE, "additionalInfo"));	// set default or saved text
			ParameterListScene::tfArea_HiveIAP_purchase_additionalInfo = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_HiveIAP_purchase_additionalInfo.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_PURCHASE_ADDITIONALINFO;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_HIVEIAP_RESTORE_ADDITIONALINFO : {		// HIVE 1.12.1 : HIVE IAP Restore additionalInfo
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEIAP_PURCHASE, "addtionalInfo"));	// set default or saved text
			ParameterListScene::tfArea_HiveIAP_restore_additionalInfo = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_HiveIAP_restore_additionalInfo.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEIAP_RESTORE_ADDITIONALINFO;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_COUPONID : {		// HIVE 1.10.0 : Engagement ConsumeCoupon couponId
			textField->setString(DataManager::getParamValue(TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON, "couponId"));	// set default or saved text
			ParameterListScene::tfArea_Engagement_consumeCoupon_couponId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_Engagement_consumeCoupon_couponId.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_COUPONID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_LANGUAGE : {		// HIVE 1.10.0 : Engagement ConsumeCoupon language
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON, "language"));	// set default or saved text
//			ParameterListScene::tfArea_Engagement_consumeCoupon_language = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_Engagement_consumeCoupon_language.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_LANGUAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_ADDITIONALINFO : {		// HIVE 1.10.0 : Engagement ConsumeCoupon additionalInfo
			textField->setString(DataManager::getParamValue(TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON, "additionalInfo"));	// set default or saved text
			ParameterListScene::tfArea_Engagement_consumeCoupon_additionalInfo = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_Engagement_consumeCoupon_additionalInfo.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_ADDITIONALINFO;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_SOCIALSHOW_ADULTAUTH_GAMELANGUAGE : {		// HIVE 1.10.0 : socialShow adultAuth
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_SOCIALSHOW, "gameLanguage"));	// set default or saved text
//			ParameterListScene::tfArea_socialShow_adultAuth_gameLanguage = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_socialShow_adultAuth_gameLanguage.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SOCIALSHOW_ADULTAUTH_GAMELANGUAGE;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY :
		case TAG_TF_PLIST_HIVEPROMOTIONINFO_CUSTOMVIEW_CONTENTKEY: {		// HIVE 1.12.0 : HivePromotion show(+info) customView
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_view"));	// set default or saved text
			ParameterListScene::tfArea_hivePromotion_show_customView_contentKey = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_hivePromotion_show_customView_contentKey.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY :
		case TAG_TF_PLIST_HIVEPROMOTIONINFO_CUSTOMBOARD_CONTENTKEY: {		// HIVE 1.12.0 : HivePromotion show(+info) customBoard
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_board"));	// set default or saved text
			ParameterListScene::tfArea_hivePromotion_show_customBoard_contentKey = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_hivePromotion_show_customBoard_contentKey.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY :
		case TAG_TF_PLIST_HIVEPROMOTIONINFO_SPOT_CONTENTKEY: {		// HIVE 1.12.0 : HivePromotion show(+info) spot
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_spot"));	// set default or saved text
			ParameterListScene::tfArea_hivePromotion_show_spot_contentKey = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_hivePromotion_show_spot_contentKey.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY :
		case TAG_TF_PLIST_HIVEPROMOTIONINFO_DIRECT_CONTENTKEY: {		// HIVE 1.12.0 : HivePromotion show(+info) direct
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_direct"));	// set default or saved text
			ParameterListScene::tfArea_hivePromotion_show_direct_contentKey = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_hivePromotion_show_direct_contentKey.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_HIVEPROMOTIONINFO_ADDITIONALINFO: {		// HIVE 1.12.0 : HivePromotion info setAdditionalInfo
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEPROMOTION_SHOW, "addtionalInfo"));	// set default or saved text
			ParameterListScene::tfArea_hivePromotion_info_addtionalInfo = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_hivePromotion_info_addtionalInfo.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEPROMOTIONINFO_ADDITIONALINFO;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_SERVERID: {		// HIVE 1.12.0 : SetGameInfo
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "serverId"));	// set default or saved text
			ParameterListScene::tfArea_setGameInfo_setGameInfo_serverId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_setGameInfo_setGameInfo_serverId.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_SERVERID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_GAMELANGUAGE: {		// HIVE 1.12.0 : SetGameInfo
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "gameLanguage"));	// set default or saved text
			ParameterListScene::tfArea_setGameInfo_setGameInfo_gameLanguage = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_setGameInfo_setGameInfo_gameLanguage.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_GAMELANGUAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_CHANNEL: {		// HIVE 1.20.3 : SetGameInfo
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "channel"));	// set default or saved text
			ParameterListScene::tfArea_setGameInfo_setGameInfo_channel = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_setGameInfo_setGameInfo_channel.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_CHANNEL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
//		case TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_VID: {		// HIVE 1.16.1 : SetGameInfo - VID
//			textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "vid"));	// set default or saved text
//			ParameterListScene::tfArea_setGameInfo_setGameInfo_vid = textField->getBoundingBox();	// change this
//
//			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
//				try {
//					CCPoint point = touch->getLocationInView();
//					point = Director::sharedDirector()->convertToGL(point);
//
//					if(ParameterListScene::tfArea_setGameInfo_setGameInfo_vid.containsPoint(point)
//					) {	// change this
//						// Show the on screen keyboard
//						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_VID;	// change this
//						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
//						textField_->attachWithIME();
//					}
//					return true;
//				}
//				catch(std::bad_cast * err) {
//					return true;
//				}
//			};
//			break;
//		}
		case TAG_TF_PLIST_SETGAMEINFO_SETCHANNEL_CHANNEL: {		// HIVE 1.20.3 : SetChannel
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "channel"));	// set default or saved text
			ParameterListScene::tfArea_setGameInfo_setChannel_channel = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_setGameInfo_setChannel_channel.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_SETCHANNEL_CHANNEL;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_SETGAMEINFO_UPDATE_SERVERID_SERVERID: {		// Hive 1.19.1
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "serverId"));	// set default or saved text
			ParameterListScene::tfArea_setGameInfo_updateServerId_serverId= textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_setGameInfo_updateServerId_serverId.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_UPDATE_SERVERID_SERVERID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}case TAG_TF_PLIST_SETGAMEINFO_UPDATE_GAMELANGUAGE_GAMELANGUAGE: {		// HIVE 1.19.1
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INITIALIZE, "gameLanguage"));	// set default or saved text
			ParameterListScene::tfArea_setGameInfo_updateGameLanguage_gameLanguage = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_setGameInfo_updateGameLanguage_gameLanguage.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_UPDATE_GAMELANGUAGE_GAMELANGUAGE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
        }case TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_FUNNELS_ID: {
            textField->setString(DataManager::getParamValue(TAG_APIACTION_SETGAMEINFO_SEND_DATA, "funnelsId"));    // set default or saved text
            ParameterListScene::tfArea_setGameInfo_sendData_funnelsId = textField->getBoundingBox();    // change this

            touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
                try {
                    CCPoint point = touch->getLocationInView();
                    point = Director::sharedDirector()->convertToGL(point);

                    if(ParameterListScene::tfArea_setGameInfo_sendData_funnelsId.containsPoint(point)
                            ) {    // change this
                        // Show the on screen keyboard
                        ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_FUNNELS_ID;    // change this
                        auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
                        textField_->attachWithIME();
                    }
                    return true;
                }
                catch(std::bad_cast * err) {
                    return true;
                }
            };
            break;
        }case TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_OPTION_TAG: {
            textField->setString(DataManager::getParamValue(TAG_APIACTION_SETGAMEINFO_SEND_DATA, "optionTag"));    // set default or saved text
            ParameterListScene::tfArea_setGameInfo_sendData_optionTag = textField->getBoundingBox();    // change this

            touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
                try {
                    CCPoint point = touch->getLocationInView();
                    point = Director::sharedDirector()->convertToGL(point);

                    if(ParameterListScene::tfArea_setGameInfo_sendData_optionTag.containsPoint(point)
                            ) {    // change this
                        // Show the on screen keyboard
                        ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_OPTION_TAG;    // change this
                        auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
                        textField_->attachWithIME();
                    }
                    return true;
                }
                catch(std::bad_cast * err) {
                    return true;
                }
            };
            break;
        }case TAG_TF_PLIST_PROMOTIONINFO_CAMPAIGN_TYPE : { // HIVE 1.18.3
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PROMOTION_GETBANNERINFO, "campaignType"));	// set default or saved text
			ParameterListScene::tfArea_promotion_GetbannerInfo_campaignType = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promotion_GetbannerInfo_campaignType.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOTIONINFO_CAMPAIGN_TYPE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_PROMOTIONINFO_BANNER_TYPE : { // HIVE 1.18.3
			textField->setString(DataManager::getParamValue(TAG_APIACTION_PROMOTION_GETBANNERINFO, "bannerType"));	// set default or saved text
			ParameterListScene::tfArea_promotion_GetbannerInfo_bannerType = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_promotion_GetbannerInfo_bannerType.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_PROMOTIONINFO_BANNER_TYPE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_HIVEPROMOTIONINFO_CAMPAIGN_TYPE : { // HIVE 1.18.3
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO, "campaignType"));	// set default or saved text
			ParameterListScene::tfArea_hivePromotion_GetbannerInfo_campaignType = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_hivePromotion_GetbannerInfo_campaignType.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEPROMOTIONINFO_CAMPAIGN_TYPE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_HIVEPROMOTIONINFO_BANNER_TYPE : { // HIVE 1.18.3
			textField->setString(DataManager::getParamValue(TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO, "bannerType"));	// set default or saved text
			ParameterListScene::tfArea_hivePromotion_GetbannerInfo_bannerType = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_hivePromotion_GetbannerInfo_bannerType.containsPoint(point)
					) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_HIVEPROMOTIONINFO_BANNER_TYPE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		/**
		 * [[[[[ INAPP V4 ]]]]]
		 */
		case TAG_TF_PLIST_INAPPV4_ITEMINFO_TYPE : { // HIVE 1.18.4
            textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPV4_ITEMINFO, "type"));	// set default or saved text
            ParameterListScene::tfArea_inappv4_iteminfo_type = textField->getBoundingBox();	// change this

            touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
                try {
                    CCPoint point = touch->getLocationInView();
                    point = Director::sharedDirector()->convertToGL(point);

                    if(ParameterListScene::tfArea_inappv4_iteminfo_type.containsPoint(point)
                            ) {	// change this
                        // Show the on screen keyboard
                        ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPPV4_ITEMINFO_TYPE;	// change this
                        auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
                        textField_->attachWithIME();
                    }
                    return true;
                }
                catch(std::bad_cast * err) {
                    return true;
                }
            };
            break;
        }
        case TAG_TF_PLIST_INAPPV4_PURCHASE_TYPE : { // HIVE 1.18.4
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPV4_PURCHASE, "type"));	// set default or saved text
			ParameterListScene::tfArea_inappv4_purchase_type = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inappv4_purchase_type.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPPV4_PURCHASE_TYPE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_INAPPV4_PURCHASE_PID : { // HIVE 1.18.4
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPV4_PURCHASE, "pid"));	// set default or saved text
			ParameterListScene::tfArea_inappv4_purchase_pid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inappv4_purchase_pid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPPV4_PURCHASE_PID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_INAPPV4_PURCHASE_IAPPAYLOAD : {
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPV4_PURCHASE, "iapPayload"));	// set default or saved text
			ParameterListScene::tfArea_inappv4_purchase_iapPayload = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inappv4_purchase_iapPayload.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPPV4_PURCHASE_IAPPAYLOAD;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_INAPPV4_RESTORE_TYPE : { // HIVE 1.18.4
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPV4_RESTORE, "type"));	// set default or saved text
			ParameterListScene::tfArea_inappv4_restore_type = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inappv4_restore_type.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPPV4_RESTORE_TYPE;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_INAPPV4_TRANSACTION_FINISH_PID : { // HIVE 1.18.4
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPV4_TRANSACTION_FINISH, "pid"));	// set default or saved text
			ParameterListScene::tfArea_inappv4_transaction_finish_pid = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inappv4_transaction_finish_pid.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPPV4_TRANSACTION_FINISH_PID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		case TAG_TF_PLIST_INAPPV4_SHOW_INAPP_MESSAGES_CATEGORY_ID : {
			textField->setString(DataManager::getParamValue(TAG_APIACTION_INAPPV4_SHOW_INAPP_MESSAGES, "categoryId"));	// set default or saved text
			ParameterListScene::tfArea_inappv4_showInAppMessages_categoryId = textField->getBoundingBox();	// change this

			touchListener->onTouchBegan = [](cocos2d::Touch* touch, cocos2d::Event * event) -> bool {
				try {
					CCPoint point = touch->getLocationInView();
					point = Director::sharedDirector()->convertToGL(point);

					if(ParameterListScene::tfArea_inappv4_showInAppMessages_categoryId.containsPoint(point)
							) {	// change this
						// Show the on screen keyboard
						ParameterListScene::focusedTextFieldState = TAG_TF_PLIST_INAPPV4_SHOW_INAPP_MESSAGES_CATEGORY_ID;	// change this
						auto textField_ = dynamic_cast<TextFieldTTF *>(event->getCurrentTarget());
						textField_->attachWithIME();
					}
					return true;
				}
				catch(std::bad_cast * err) {
					return true;
				}
			};
			break;
		}
		default : {
			log("### ParameterListScene::createTextField(...) error ###");
			break;
		}
	}
	this->_eventDispatcher->addEventListenerWithSceneGraphPriority(touchListener, textField);
}

void ParameterListScene::update_popupButtons(int tag)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	auto popupBtn = Menu::create();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);

	switch(tag) {
		case TAG_BTN_MODULE_LIST_PUSH_REGISTER : {			// push
			log("### ParameterListScene : create popupButtons(push_register) ###");
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushRegister_type),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST);
			layer->addChild(popupBtn);
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_UNREGISTER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_DESCRIPTION : {
			log("### ParameterListScene : create popupButtons(push_description) ###");
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushDescription_usePush),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_USEPUSH);
			layer->addChild(popupBtn);
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushDescription_sound),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_SOUND);
			layer->addChild(popupBtn);
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushDescription_vib),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_VIB);
			layer->addChild(popupBtn);
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushDescription_operGcm),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_OPERGCM);
			layer->addChild(popupBtn);
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushDescription_operLoc),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_OPERLOC);
			layer->addChild(popupBtn);
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushDescription_notice),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_NOTICE);
			layer->addChild(popupBtn);
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_pushDescription_night),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 6))));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_NIGHT);
			layer->addChild(popupBtn);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_HIVE : {			// sns_user
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_FACEBOOK : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_DELETE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_HIVE : {			// sns_post
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_FACEBOOK : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_GOOGLEPLUS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICE : {		// promotion
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FOCRED_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FORCED_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER_IMAGE_BANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_OFFERWALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_CUSTOMWEBVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_REVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_MOREGAMES : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICE : {		// promotion_info
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_CUSTOMWEBVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_CUSTOMWEBVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETOFFERWALLSTATE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GAME : {		// invite_friends
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_OTHER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_ALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_RECEIVEDINVITE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_SESSION : {
			/*
			log("### ParameterListScene : create popupButtons(push_register) ###");
			popupBtn = Menu::create(
					ParameterListScene::createPopupButtons(ParameterListScene::popValue_snsSession_service),
					NULL);
			popupBtn->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ParameterListScene::ui_paramLabel_y));
			//popupBtn->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			popupBtn->setTag(TAG_POP_PARAMETER_LIST);
			*/
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_PREPARE : {				// inapp
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_REQUESTBALANCE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_PURCHASE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_RESTORE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_FINISH : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEHOME : {			// Hive webview
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEUSER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVECAFE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_EDITPROFILE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_FINDFRIENDS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_INQUIRY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_CHATBOT : {			// HIVE 1.18.1
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_TERMS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_EVENT : {					// Tracker
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_SETENABLE : {
			break;
		}
		//
		default : {
			log("### ParameterListScene::update_popupButtons(int tag) error ###");
			break;
		}
	}

	// function 'update_popupButtons' End
}

MenuItemFont* ParameterListScene::createPopupButtons(int tag) {
	MenuItemFont::setFontSize(15);
	switch (tag) {
		case TAG_POP_PLIST_PUSHREGISTER_TYPE_BAR: {
			auto button_ = MenuItemFont::create("[ bar ]",
					CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHREGISTER_TYPE);
			return button_;
		}case TAG_POP_PLIST_PUSHREGISTER_TYPE_POPUP: {
			auto button_ = MenuItemFont::create("[ popup ]",
					CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHREGISTER_TYPE);
			return button_;
		}case TAG_POP_PLUST_PUSHREGISTER_TYPE_BARPOPUP: {
			auto button_ = MenuItemFont::create("[ bar.popup ]",
					CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHREGISTER_TYPE);
			return button_;
		}case TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_NA: {
			auto button_ = MenuItemFont::create("[ N/A ]",
					CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE);
			return button_;
		}case TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_FB: {
			auto button_ = MenuItemFont::create("[ facebook ]",
					CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE);
			return button_;
		}
		// Push Description
		case TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_TRUE: {
			auto button_ = MenuItemFont::create("[ true ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_FALSE: {
			auto button_ = MenuItemFont::create("[ false ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_NULL: {
			auto button_ = MenuItemFont::create("[ null ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_TRUE: {
			auto button_ = MenuItemFont::create("[ true ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_SOUND);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_FALSE: {
			auto button_ = MenuItemFont::create("[ false ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_SOUND);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_NULL: {
			auto button_ = MenuItemFont::create("[ null ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_SOUND);
			return button_;
		}
		//
		case TAG_POP_PLIST_PUSHDESCRIPTION_VIB_TRUE: {
			auto button_ = MenuItemFont::create("[ true ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_VIB);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_VIB_FALSE: {
			auto button_ = MenuItemFont::create("[ false ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_VIB);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_VIB_NULL: {
			auto button_ = MenuItemFont::create("[ null ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_VIB);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_TRUE: {
			auto button_ = MenuItemFont::create("[ true ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_FALSE: {
			auto button_ = MenuItemFont::create("[ false ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_NULL: {
			auto button_ = MenuItemFont::create("[ null ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM);
			return button_;
		}
		//
		case TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_TRUE: {
			auto button_ = MenuItemFont::create("[ true ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_FALSE: {
			auto button_ = MenuItemFont::create("[ false ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_NULL: {
			auto button_ = MenuItemFont::create("[ null ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_TRUE: {
			auto button_ = MenuItemFont::create("[ true ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_FALSE: {
			auto button_ = MenuItemFont::create("[ false ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_NULL: {
			auto button_ = MenuItemFont::create("[ null ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE);
			return button_;
		}
		//
		case TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_TRUE: {
			auto button_ = MenuItemFont::create("[ true ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_FALSE: {
			auto button_ = MenuItemFont::create("[ false ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT);
			return button_;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_NULL: {
			auto button_ = MenuItemFont::create("[ null ]",
												CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			button_->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT);
			return button_;
		}
		default: {
			auto button_ = MenuItemFont::create("[ error ]",
					CC_CALLBACK_1(ParameterListScene::showPopupEvent, this));
			button_->setColor(ccc3(0, 0, 255));
			return button_;
		}
	}
}

void ParameterListScene::showPopupEvent(Ref *sender)
{
	if(ParameterListScene::ui_isOpenedWindow == true)
		return;

	auto mItem = (MenuItem*) sender;

	switch (mItem->getTag()) {
		case TAG_POP_PLIST_PUSHREGISTER_TYPE: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ bar ]",
					CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHREGISTER_TYPE_BAR);
			auto button_2 = MenuItemFont::create("[ popup ]",
					CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHREGISTER_TYPE_POPUP);
			auto button_3 = MenuItemFont::create("[ bar.popup ]",
					CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLUST_PUSHREGISTER_TYPE_BARPOPUP);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		case TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ N/A ]",
					CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_NA);
			auto button_2 = MenuItemFont::create("[ facebook ]",
					CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_FB);
			auto Popup_1 = Menu::create(button_1, button_2, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		// Push Description
		case TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ true ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_TRUE);
			auto button_2 = MenuItemFont::create("[ false ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_FALSE);
			auto button_3 = MenuItemFont::create("[ null ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_NULL);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		case TAG_POP_PLIST_PUSHDESCRIPTION_SOUND: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ true ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_TRUE);
			auto button_2 = MenuItemFont::create("[ false ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_FALSE);
			auto button_3 = MenuItemFont::create("[ null ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_NULL);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		case TAG_POP_PLIST_PUSHDESCRIPTION_VIB: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ true ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_VIB_TRUE);
			auto button_2 = MenuItemFont::create("[ false ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_VIB_FALSE);
			auto button_3 = MenuItemFont::create("[ null ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_VIB_NULL);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		//
		case TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ true ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_TRUE);
			auto button_2 = MenuItemFont::create("[ false ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_FALSE);
			auto button_3 = MenuItemFont::create("[ null ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_NULL);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		case TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ true ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_TRUE);
			auto button_2 = MenuItemFont::create("[ false ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_FALSE);
			auto button_3 = MenuItemFont::create("[ null ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_NULL);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		case TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ true ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_TRUE);
			auto button_2 = MenuItemFont::create("[ false ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_FALSE);
			auto button_3 = MenuItemFont::create("[ null ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_NULL);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		//
		case TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT: {
			// (Beta) Display Pop-up
			Size visibleSize = Director::getInstance()->getVisibleSize();
			auto popup_layer = LayerColor::create(Color4B(0, 125, 125, 255));
			popup_layer->setContentSize(Size(visibleSize.width * 0.90, visibleSize.height * 0.2));
			popup_layer->setPosition(Point(visibleSize.width * 0.05, visibleSize.height * 0.05));
			popup_layer->setTag(-10000);
			this->addChild(popup_layer);

			MenuItemFont::setFontSize(15);
			auto button_1 = MenuItemFont::create("[ true ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_1->setColor(ccc3(255, 255, 255));
			button_1->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_TRUE);
			auto button_2 = MenuItemFont::create("[ false ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_2->setColor(ccc3(255, 255, 255));
			button_2->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_FALSE);
			auto button_3 = MenuItemFont::create("[ null ]",
												 CC_CALLBACK_1(ParameterListScene::closePopupEvent, this));
			button_3->setColor(ccc3(255, 255, 255));
			button_3->setTag(TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_NULL);
			auto Popup_1 = Menu::create(button_1, button_2, button_3, NULL);
			Popup_1->alignItemsVerticallyWithPadding(visibleSize.height * 0.015);
			Popup_1->setPosition(Point(visibleSize.width * 0.45, visibleSize.height * 0.1));
			popup_layer->addChild(Popup_1);
			ParameterListScene::ui_isOpenedWindow = true;
			break;
		}
		default:
			break;
	}
}

void ParameterListScene::closePopupEvent(Ref *sender)
{
	auto mItem = (MenuItem*) sender;
	Size visibleSize = Director::getInstance()->getVisibleSize();

	// remove
	Layer *layer = (Layer *) this->getChildByTag(TAG_LAYER_PARAMETER_LIST);
	this->removeChildByTag(-10000, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_USEPUSH, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_SOUND, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_VIB, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_OPERGCM, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_OPERLOC, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_NOTICE, true);
	layer->removeChildByTag(TAG_POP_PARAMETER_LIST_PUSHDESCRIPTION_NIGHT, true);

	ParameterListScene::ui_isOpenedWindow = false;
	// toss data
	switch (mItem->getTag()) {
		case TAG_POP_PLIST_PUSHREGISTER_TYPE_BAR : {
			ParameterListScene::popValue_pushRegister_type = TAG_POP_PLIST_PUSHREGISTER_TYPE_BAR;
			break;
		}case TAG_POP_PLIST_PUSHREGISTER_TYPE_POPUP : {
			ParameterListScene::popValue_pushRegister_type = TAG_POP_PLIST_PUSHREGISTER_TYPE_POPUP;
			break;
		}case TAG_POP_PLUST_PUSHREGISTER_TYPE_BARPOPUP : {
			ParameterListScene::popValue_pushRegister_type = TAG_POP_PLUST_PUSHREGISTER_TYPE_BARPOPUP;
			break;
		}case TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_NA : {
			ParameterListScene::popValue_snsSession_service = TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_NA;
			break;
		}case TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_FB : {
			ParameterListScene::popValue_snsSession_service = TAG_POP_PLIST_SNSSESSION_SESSION_SERVICE_FB;
			break;
		}
		// Push Description
		case TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_TRUE : {
			ParameterListScene::popValue_pushDescription_usePush = TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_TRUE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_FALSE : {
			ParameterListScene::popValue_pushDescription_usePush = TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_FALSE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_NULL : {
			ParameterListScene::popValue_pushDescription_usePush = TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_NULL;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_TRUE : {
			ParameterListScene::popValue_pushDescription_sound = TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_TRUE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_FALSE : {
			ParameterListScene::popValue_pushDescription_sound = TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_FALSE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_NULL : {
			ParameterListScene::popValue_pushDescription_sound = TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_NULL;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_VIB_TRUE : {
			ParameterListScene::popValue_pushDescription_vib = TAG_POP_PLIST_PUSHDESCRIPTION_VIB_TRUE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_VIB_FALSE : {
			ParameterListScene::popValue_pushDescription_vib = TAG_POP_PLIST_PUSHDESCRIPTION_VIB_FALSE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_VIB_NULL : {
			ParameterListScene::popValue_pushDescription_vib = TAG_POP_PLIST_PUSHDESCRIPTION_VIB_NULL;
			break;
		}
		//
		case TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_TRUE : {
			ParameterListScene::popValue_pushDescription_operGcm = TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_TRUE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_FALSE : {
			ParameterListScene::popValue_pushDescription_operGcm = TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_FALSE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_NULL : {
			ParameterListScene::popValue_pushDescription_operGcm = TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_NULL;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_TRUE : {
			ParameterListScene::popValue_pushDescription_operLoc = TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_TRUE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_FALSE : {
			ParameterListScene::popValue_pushDescription_operLoc = TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_FALSE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_NULL : {
			ParameterListScene::popValue_pushDescription_operLoc = TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_NULL;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_TRUE : {
			ParameterListScene::popValue_pushDescription_notice = TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_TRUE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_FALSE : {
			ParameterListScene::popValue_pushDescription_notice = TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_FALSE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_NULL : {
			ParameterListScene::popValue_pushDescription_notice = TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_NULL;
			break;
		}
		//
		case TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_TRUE : {
			ParameterListScene::popValue_pushDescription_night = TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_TRUE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_FALSE : {
			ParameterListScene::popValue_pushDescription_night = TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_FALSE;
			break;
		}case TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_NULL : {
			ParameterListScene::popValue_pushDescription_night = TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_NULL;
			break;
		}

		default :
			break;
	}
	// re-draw
	ParameterListScene::update_popupButtons(DataManager::getCurrentParameter());
}

// 체크 박스 생성
void ParameterListScene::update_checkboxes(int tag)
{
	Size visibleSize = Director::getInstance()->getVisibleSize();
	Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);

	auto checkbox = Menu::create();

	switch(tag) {
		case TAG_BTN_MODULE_LIST_PUSH_REGISTER : {			// push
			log("### ParameterListScene::update_checkboxes(push_register) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_UNREGISTER : {
			log("### ParameterListScene::update_checkboxes(push_unregister) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_DESCRIPTION : {
			log("### ParameterListScene::update_checkboxes(push_description) ###");
//			// (1)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PUSHDESCRITPTION_USEPUSH), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0))));
//			layer->addChild(checkbox);
//			// (2)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PUSHDESCRITPTION_SOUND), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1))));
//			layer->addChild(checkbox);
//			// (3)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PUSHDESCRITPTION_VIBRATE), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2))));
//			layer->addChild(checkbox);
//			// (4)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PUSHDESCRITPTION_OPERATIONGCM), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3))));
//			layer->addChild(checkbox);
//			// (5)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PUSHDESCRITPTION_OPERATIONLOCAL), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4))));
//			layer->addChild(checkbox);
//			// (6)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PUSHDESCRITPTION_USENOTICE), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5))));
//			layer->addChild(checkbox);
//			// (7)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PUSHDESCRITPTION_USENIGHT), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 6))));
//			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_HIVE : {			// sns_user
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_FACEBOOK : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_DELETE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_HIVE : {			// sns_post
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_FACEBOOK : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_GOOGLEPLUS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICE : {		// promotion
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FOCRED_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FORCED_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER_IMAGE_BANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_OFFERWALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_CUSTOMWEBVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_REVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_MOREGAMES : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICE : {		// promotion_info
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_CUSTOMWEBVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_CUSTOMWEBVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETOFFERWALLSTATE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GAME : {		// invite_friends
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_OTHER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_ALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_RECEIVEDINVITE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_MESSAGE : {
			log("### ParameterListScene::update_checkboxes(sns_message hive message) ###");
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_VIDUID), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0))));
			layer->addChild(checkbox);
			// (2)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_USEPUSH), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 5))));
			layer->addChild(checkbox);
			// (3)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_INVITE), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 6))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_SESSION : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_PREPARE : {				// inapp
			log("### ParameterListScene::update_checkboxes(inapp_lebi prepare) ###");

			// (2)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_INAPP_LEBI_PREPARE_SHOWLOG), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2))));
			layer->addChild(checkbox);
			// (3)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_INAPP_LEBI_PREPARE_AUTOVERIFY), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_REQUESTBALANCE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_PURCHASE : {
			log("### ParameterListScene::update_checkboxes(inapp purchase) ###");
			/*
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_INAPP_PURCHASE_RESTORE), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0))));
			layer->addChild(checkbox);
			// (2)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_INAPP_PURCHASE_FINISH), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1))));
			layer->addChild(checkbox);
			*/
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_RESTORE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_FINISH : {
			log("### ParameterListScene::update_checkboxes(inapp finish) ###");
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_INAPP_FINISH_PURCHASESUCCESS), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEHOME : {			// Hive webview
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEUSER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVECAFE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_EDITPROFILE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_FINDFRIENDS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_INQUIRY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_CHATBOT : {			// HIVE 1.18.1
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_TERMS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_EVENT : {					// Tracker
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_SETENABLE : {
			// (1)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_TRACKER_SETENABLE_MAT), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 0))));
//			layer->addChild(checkbox);
			// (2)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_TRACKER_SETENABLE_ADJUST), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 1))));
			layer->addChild(checkbox);
			// (3)
//			checkbox = Menu::create(
//					ParameterListScene::createCheckboxes(TAG_CB_PLIST_TRACKER_SETENABLE_PARTYTRACK), NULL);
//			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
//										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 2))));
//			layer->addChild(checkbox);
			// (4)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_TRACKER_SETENABLE_SINGULAR), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 3))));
			layer->addChild(checkbox);
			// (5)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_TRACKER_SETENABLE_APPSFLYER), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * (ParameterListScene::ui_paramLabel_y - (ParameterListScene::ui_paddingSize_y * 4))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_LINKSHARE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHARE : {
			log("### ParameterListScene::update_checkboxes(HIVE LINK SHARE) ###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHAREPLUSMESSAGE : {
			log("### ParameterListScene::update_checkboxes(HIVE LINK SHARE + Message) ###");
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_VIDUID), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 2))));
			layer->addChild(checkbox);
			// (2)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_USEPUSH), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 7))));
			layer->addChild(checkbox);
			// (3)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_INVITE), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 8))));
			layer->addChild(checkbox);
			// (4)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_LINKSHARE), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 9))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NEWS : {
			log("### ParameterListScene::update_checkboxes(HIVE Promotion News) ###");
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_HIVEPROMOTION_NEWS_FORCED), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 2))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_FULLBANNER : {
			log("### ParameterListScene::update_checkboxes(HIVE Promotion FullBanner) ###");
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_HIVEPROMOTION_BANNER_FORCED), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 2))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NOTICE : {
			log("### ParameterListScene::update_checkboxes(HIVE Promotion Notice) ###");
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_HIVEPROMOTION_NOTICE_FORCED), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
					visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
							- ((ParameterListScene::ui_paddingSize_y - 0.01) * 2))));
			layer->addChild(checkbox);
			break;
		}
		case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETGAMEINFO : {
			log("### ParameterListScene::update_checkboxes(SetGameInfo) ###");
			// (1)
			checkbox = Menu::create(
					ParameterListScene::createCheckboxes(TAG_CB_PLIST_SETGAMEINFO_EMERGENCY_MODE), NULL);
			checkbox->setPosition(Point(visibleSize.width * ParameterListScene::ui_textField_x,
										visibleSize.height * ((ParameterListScene::ui_paramLabel_y + 0.05)
															  - ((ParameterListScene::ui_paddingSize_y - 0.01) * 3.5))));
			layer->addChild(checkbox);
			break;
		}
		default : {
			log("### ParameterListScene::update_labels(int tag) error ###");
			break;
		}
	}
}

MenuItemToggle* ParameterListScene::createCheckboxes(int tag)
{
	auto checkbox_usePush_on_1 = Sprite::create("check_box_active.png");
	auto checkbox_usePush_on_2 = Sprite::create("check_box_active_press.png");
	auto checkbox_usePush_on = MenuItemSprite::create(checkbox_usePush_on_1, checkbox_usePush_on_2);
	auto checkbox_usePush_off_1 = Sprite::create("check_box_normal.png");
	auto checkbox_usePush_off_2 = Sprite::create("check_box_normal_press.png");
	auto checkbox_usePush_off = MenuItemSprite::create(checkbox_usePush_off_1, checkbox_usePush_off_2);
	auto checkboxItem = MenuItemToggle::createWithCallback(
			CC_CALLBACK_1(ParameterListScene::ToggleEvent, this),
			checkbox_usePush_off, checkbox_usePush_on, NULL);
	checkboxItem->setTag(tag);
	checkboxItem->setSelectedIndex(ParameterListScene::setCheckbox(tag));
	checkboxItem->setScale(1.5f);
	return checkboxItem;
}

void ParameterListScene::ToggleEvent(Ref* sender)
{
	auto checkbox = (MenuItemToggle*) sender;

	switch(checkbox->getTag()) {
		case TAG_CB_PLIST_PUSHDESCRITPTION_USEPUSH : {	// (7)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_pushDescription_usePush = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_pushDescription_usePush = true;
			}
			break;
		}case TAG_CB_PLIST_PUSHDESCRITPTION_SOUND : {	// (8)
			if(checkbox->getSelectedIndex() == 0) {
				log("sound is false");
				ParameterListScene::ui_checkbox_pushDescription_sound = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				log("sound is true");
				ParameterListScene::ui_checkbox_pushDescription_sound = true;
			}
			break;
		}case TAG_CB_PLIST_PUSHDESCRITPTION_VIBRATE : {	// (9)
			if(checkbox->getSelectedIndex() == 0) {
				log("vibrate is false");
				ParameterListScene::ui_checkbox_pushDescription_vibrate = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				log("vibrate is true");
				ParameterListScene::ui_checkbox_pushDescription_vibrate = true;
			}
			break;
		}case TAG_CB_PLIST_PUSHDESCRITPTION_OPERATIONGCM : {	// (10)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_pushDescription_operationGCM = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_pushDescription_operationGCM = true;
			}
			break;
		}case TAG_CB_PLIST_PUSHDESCRITPTION_OPERATIONLOCAL : {	// (11)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_pushDescription_operationLocal = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_pushDescription_operationLocal = true;
			}
			break;
		}case TAG_CB_PLIST_PUSHDESCRITPTION_USENOTICE : {	// (12)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_pushDescription_useNotice = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_pushDescription_useNotice = true;
			}
			break;
		}case TAG_CB_PLIST_PUSHDESCRITPTION_USENIGHT : {	// (12)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_pushDescription_useNight = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_pushDescription_useNight = true;
			}
			break;
		}case TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_VIDUID : {	// (28)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_snsMessage_viduid = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_snsMessage_viduid = true;
			}
			break;
		}case TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_USEPUSH : {	// (33)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_snsMessage_usePush = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_snsMessage_usePush = true;
			}
			break;
		}case TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_INVITE : {	// (34)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_snsMessage_invite = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_snsMessage_invite = true;
			}
			break;
		}case TAG_CB_PLIST_INAPP_LEBI_PREPARE_SHOWLOG : {	// (38)
			if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_inappPrepare_showLog = false;
			}
			else if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_inappPrepare_showLog = true;
			}
			break;
		}case TAG_CB_PLIST_INAPP_LEBI_PREPARE_AUTOVERIFY : {	// (40)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_inappPrepare_autoVerify = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_inappPrepare_autoVerify = true;
			}
			break;
		}case TAG_CB_PLIST_INAPP_PURCHASE_RESTORE : {	// (42)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_inappPurchase_Restore = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_inappPurchase_Restore = true;
			}
			break;
		}case TAG_CB_PLIST_INAPP_PURCHASE_FINISH : {	// (43)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_inappPurchase_Finish = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_inappPurchase_Finish = true;
			}
			break;
		}case TAG_CB_PLIST_INAPP_FINISH_PURCHASESUCCESS : {	// (47)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_inappFinish_isPurchaseSuccess = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_inappFinish_isPurchaseSuccess = true;
			}
			break;
		}case TAG_CB_PLIST_TRACKER_SETENABLE_MAT : {	// (47)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_trackerSetEnable_MAT = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_trackerSetEnable_MAT = true;
			}
			break;
		}case TAG_CB_PLIST_TRACKER_SETENABLE_ADJUST : {	// (47)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_trackerSetEnable_Adjust = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_trackerSetEnable_Adjust = true;
			}
			break;
		}case TAG_CB_PLIST_TRACKER_SETENABLE_PARTYTRACK : {	// (47)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_trackerSetEnable_Partytrack = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_trackerSetEnable_Partytrack = true;
			}
			break;
		}case TAG_CB_PLIST_TRACKER_SETENABLE_SINGULAR : {	// added 1.14.1
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_trackerSetEnable_Singular = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_trackerSetEnable_Singular = true;
			}
			break;
		}case TAG_CB_PLIST_TRACKER_SETENABLE_APPSFLYER : {	// added 1.14.1
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_trackerSetEnable_AppsFlyer = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_trackerSetEnable_AppsFlyer = true;
			}
			break;
		}case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_VIDUID : {	// (61)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_viduid = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_viduid = true;
			}
			break;
		}case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_USEPUSH : {	// (62)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_usePush = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_usePush = true;
			}
			break;
		}case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_INVITE : {	// (63)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_invite = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_invite = true;
			}
			break;
		}case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_LINKSHARE : {	// (64)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_linkShare = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_linkShare = true;
			}
			break;
		}case TAG_CB_PLIST_HIVEPROMOTION_NEWS_FORCED : {	// (HIVE 1.12.0)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_hivePromotion_news_forced = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_hivePromotion_news_forced = true;
			}
			break;
		}case TAG_CB_PLIST_HIVEPROMOTION_BANNER_FORCED : {	// (HIVE 1.12.0)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_hivePromotion_banner_forced = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_hivePromotion_banner_forced = true;
			}
			break;
		}case TAG_CB_PLIST_HIVEPROMOTION_NOTICE_FORCED : {	// (HIVE 1.12.0)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_hivePromotion_notice_forced = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_hivePromotion_notice_forced = true;
			}
			break;
		}case TAG_CB_PLIST_SETGAMEINFO_EMERGENCY_MODE : {	// (Hive KS 1.19.4)
			if(checkbox->getSelectedIndex() == 0) {
				ParameterListScene::ui_checkbox_setGameInfo_emergencyMode = false;
			}
			else if(checkbox->getSelectedIndex() == 1) {
				ParameterListScene::ui_checkbox_setGameInfo_emergencyMode = true;
			}
		}


		default :
			break;
	}
}

int ParameterListScene::setCheckbox(int tag)
{
	//MenuItemToggle *checkbox = (MenuItemToggle *)this->getChildByTag(tag);
	log("### ParameterListScene::setCheckbox ###");

	switch (tag) {
		case TAG_CB_PLIST_PUSHDESCRITPTION_USEPUSH : {
			if(DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "usePush")) {
				log("########## USEPUSH TRUE!!!! ##########");
				return 1;
			} else {
				log("########## USEPUSH FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PUSHDESCRITPTION_SOUND : {
			if(DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "sound")) {
				log("########## SOUND TRUE!!!! ##########");
				return 1;
			} else {
				log("########## SOUND FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PUSHDESCRITPTION_VIBRATE : {
			if(DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "vibrate")) {
				log("########## VIBRATE TRUE!!!! ##########");
				return 1;
			} else {
				log("########## VIBRATE FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PUSHDESCRITPTION_OPERATIONGCM : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "operationGCM")) {
#ifdef __ANDROID__
				log("########## OPERATIONGCM TRUE!!!! ##########");
#else
				log("########## OPERATIONREMOTE TRUE!!!! ##########");
#endif
				return 1;
			} else {
#ifdef __ANDROID__
				log("########## OPERATIONGCM FALSE!!!! ##########");
#else
				log("########## OPERATIONREMOTE FALSE!!!! ##########");
#endif
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PUSHDESCRITPTION_OPERATIONLOCAL : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "operationLocal")) {
				log("########## OPERATIONLOCAL TRUE!!!! ##########");
				return 1;
			} else {
				log("########## OPERATIONLOCAL FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PUSHDESCRITPTION_USENOTICE : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "useNotice")) {
				log("########## USENOTICE TRUE!!!! ##########");
				return 1;
			} else {
				log("########## USENOTICE FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PUSHDESCRITPTION_USENIGHT : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "useNight")) {
				log("########## USENIGHT TRUE!!!! ##########");
				return 1;
			} else {
				log("########## USENIGHT FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_VIDUID : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SNSMESSAGE, "viduid")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_USEPUSH : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SNSMESSAGE, "usePush")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_SNSMESSAGE_HIVEMESSAGE_INVITE : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SNSMESSAGE, "invite")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_INAPP_LEBI_PREPARE_SHOWLOG : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_PREPARE, "showLog")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_INAPP_LEBI_PREPARE_AUTOVERIFY : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_PREPARE, "autoVerify")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_INAPP_PURCHASE_RESTORE : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_INAPPPURCHASE, "Restore")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_INAPP_PURCHASE_FINISH : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_INAPPPURCHASE, "Finish")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_INAPP_FINISH_PURCHASESUCCESS : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_INAPPFINISH, "isPurchaseSuccess")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_TRACKER_SETENABLE_MAT : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "MAT")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_TRACKER_SETENABLE_ADJUST : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "Adjust")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_TRACKER_SETENABLE_PARTYTRACK : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "Partytrack")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_TRACKER_SETENABLE_SINGULAR : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "Singular")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_TRACKER_SETENABLE_APPSFLYER : {
			if (DataManager::getParamValue_bool(TAG_APIACTION_SETENABLE, "AppsFlyer")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_VIDUID : { // add(HIVE 1.9.0)
			if (DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "vidoruid")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_USEPUSH : { // add(HIVE 1.9.0)
			if (DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "usePush")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_INVITE : { // add(HIVE 1.9.0)
			if (DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "invite")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_PROMOACQUISITION_INVITELINK_LINKSHARE : { // add(HIVE 1.9.0)
			if (DataManager::getParamValue_bool(TAG_APIACTION_USERACQUISITION, "linkShare")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_HIVEPROMOTION_NEWS_FORCED : {    // add(HIVE 1.12.0)
			if (DataManager::getParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_HIVEPROMOTION_BANNER_FORCED : {    // add(HIVE 1.12.0)
			if (DataManager::getParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_HIVEPROMOTION_NOTICE_FORCED : {    // add(HIVE 1.12.0)
			if (DataManager::getParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		case TAG_CB_PLIST_SETGAMEINFO_EMERGENCY_MODE : {    // add(HIVE KS 1.19.4)
			if (DataManager::getParamValue_bool(TAG_APIACTION_SETGAMEINFO_SETGAMEINFO,
												"emergencyMode")) {
				log("########## TRUE!!!! ##########");
				return 1;
			} else {
				log("########## FALSE!!!! ##########");
				return 0;
			}
			break;
		}
		default :
			break;
	}
	return 2;
}

void ParameterListScene::update_postbox_show() {

	if(Parameter::paramInitialize.postboxV4Login == true) {
		// 우편함 정보 받기
		Postbox::posts([=](const Postbox::Posts *posts, Postbox::Error error) {
			if (posts != nullptr) {
//			Logger::log("callback hive postbox");

				//Post BOX!!
				postboxV1lists = posts->post_list;
				if (postboxV1lists.size() > 0) {
					log("### update_postbox_show, postboxV1list consumable more then 0 ###");
					postV1list.clear();
				} else {
					log("### update_postbox_show, postboxV1list consumable is empty ###");
					postV1list.clear();
//				postV1list.push_back("empty");
				}

				for (auto post:postboxV1lists) {
					if (post.character_key.size() > 0) {
						postV1list.push_back(
								"character:" + post.character_key + "[" + post.post_id + "][" +
								post.date_added + "]");
						log("### update_postbox_show, postboxV1list consumable set character postV1list ###");
					} else {
						postV1list.push_back("[" + post.post_id + "][" + post.date_added + "]");
						log("### update_postbox_show, postboxV1list consumable not set character postV1list ###");
					}
				}
//			changeComboboxList(toCharlist(postV1list), 0, COMBOBOX_POSTBOX);

				//Subscription BOX!!
				subscriptionboxV1lists = posts->subscription_list;
				if (subscriptionboxV1lists.size() > 0) {
					log("### update_postbox_show, subscriptionboxV1lists sub more then 0 ###");
					subscriptionV1list.clear();
				} else {
					log("### update_postbox_show, subscriptionboxV1lists sub is empty ###");
					subscriptionV1list.clear();
//				subscriptionV1list.push_back("empty");
				}

				for (auto subs:subscriptionboxV1lists) {
					if (subs.character_key.size() > 0) {
						subscriptionV1list.push_back(
								"character:" + subs.character_key + "[" + subs.product_id + "][" +
								subs.start_date + "]");
						log("### update_postbox_show, postboxV1list subscription set character subscriptionV1list ###");
					} else {
						subscriptionV1list.push_back(
								"[" + subs.product_id + "][" + subs.start_date + "]");
						log("### update_postbox_show, postboxV1list subscription not set character subscriptionV1list ###");
					}
				}
//			changeComboboxList(toCharlist(subscriptionlist), 0, COMBOBOX_SUBSCRIPTIONBOX);

			} else {
//			ShowPostboxErrorMessage(error);

				MessageBox("Postbox posts[우편함 목록 가져오기] 실패", "Postbox posts[우편함 목록 가져오기] 실패");
			}
//		EndActivityIndicator();

			ParameterListScene::update_postbox_show_ui();
		});
	}
}

void ParameterListScene::update_postbox_show_ui() {
	log("### update_postbox_show_ui, consumable button set ###");

	// 우편함 내용 그리기
	Size visibleSize = Director::getInstance()->getVisibleSize();

	int fontSize = 15;
	MenuItemFont::setFontSize(fontSize);

	Vector<MenuItem*> _stageMainMenu;
	for (int i = 0; i < postboxV1lists.size(); i++) {
		log("### update_postbox_show_ui, consumable button set ###");
		auto temp_text = MenuItemFont::create(postV1list.at(i), CC_CALLBACK_1(ParameterListScene::postBoxBtnEvent, this));
		temp_text->setColor(ccc3(0, 128, 0));
		temp_text->setTag(i);			// consumable 범위
		_stageMainMenu.pushBack(temp_text);
	}
	for (int j = 0; j < subscriptionboxV1lists.size(); j++) {
		log("### update_postbox_show_ui, subscription button set ###");
		auto temp_text = MenuItemFont::create(subscriptionV1list.at(j), CC_CALLBACK_1(ParameterListScene::postBoxBtnEvent, this));
		temp_text->setColor(ccc3(0, 128, 0));
		temp_text->setTag(j+100);		// subscription 범뤼
		_stageMainMenu.pushBack(temp_text);
	}
	log("### update_postbox_show_ui, consumable button set 333 ###");

	if(_stageMainMenu.size() > 0) {
		auto btns = Menu::createWithArray(_stageMainMenu);
		btns->alignItemsVerticallyWithPadding(visibleSize.width * 0.015);

		log("### update_postbox_show_ui, consumable button set 444 ###");

		Layer *layer = (Layer *)this->getChildByTag(TAG_LAYER_PARAMETER_LIST);
		layer->addChild(btns);
	} else {
		MessageBox("우편함 로그인, 구매상태를 확인해주세요!", "Postbox posts[우편함 목록 가져오기] 우편함에 아이템이 없습니다.");
	}
}

void ParameterListScene::postBoxBtnEvent(Ref *sender) {
	auto eventTag = (MenuItem *) sender;
	if(eventTag->getTag() >= 0 && eventTag->getTag() < 100) {
		// consumable
		std::vector<const char*> usePostIds;
		usePostIds.push_back(postboxV1lists[eventTag->getTag()].post_id.c_str());

		Postbox::postReceive(usePostIds, [=](const Postbox::PostsReceive * r, Postbox::Error e){
			if(e.result_code != "200") {
				MessageBox("Postbox receive[아이템 사용] 실패", "Postbox receive[아이템 사용] 실패");
			}else{
				MessageBox("우편함 화면을 나갔다가 돌아오면 내용이 갱신됩니다!", "Postbox receive[아이템 사용] 성공");

                Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]()->void{
                    auto scene = TransitionFadeTR::create(1.0, ModuleListScene::createScene());
                    Director::getInstance()->replaceScene(scene);
                });
			}
		});
	} else {
		// subscription
		// consumable
		std::vector<const char*> usePostIds;

		MessageBox("Postbox receive[아이템 사용] 구독 아이템입니다.", "Postbox receive[아이템 사용] 구독 아이템입니다.");
	}
}

void ParameterListScene::saveParamValue(int tag)
{
	switch(tag) {
		case TAG_BTN_MODULE_LIST_PUSH_REGISTER : {			// 푸시 등록
			std::string strTemp;
			// push Id
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PUSHREGISTER_PUSHID);
			strTemp = temp_tf->getString();
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			} else {
				DataManager::setParamValue_int(
						TAG_APIACTION_PUSHREGISTER, "pushId", atoi(temp_tf->getString().c_str()));
			}
			// push Title
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PUSHREGISTER_TITLE);
			strTemp = temp_tf->getString();
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			} else {
				DataManager::setParamValue_string(
						TAG_APIACTION_PUSHREGISTER, "title", temp_tf->getString());
			}
			// push Message
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PUSHREGISTER_MESSAGE);
			strTemp = temp_tf->getString();
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			} else {
				DataManager::setParamValue_string(
						TAG_APIACTION_PUSHREGISTER, "message", temp_tf->getString());
			}
			// push After
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PUSHREGISTER_AFTER);
			strTemp = temp_tf->getString();
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			} else {
				DataManager::setParamValue_int(
						TAG_APIACTION_PUSHREGISTER, "after", atoi(temp_tf->getString().c_str()));
			}
			// push Type //
			if(ParameterListScene::popValue_pushRegister_type == TAG_POP_PLIST_PUSHREGISTER_TYPE_BAR) {
				strTemp = "bar";
			} else if(ParameterListScene::popValue_pushRegister_type == TAG_POP_PLIST_PUSHREGISTER_TYPE_POPUP) {
				strTemp = "popup";
			} else if(ParameterListScene::popValue_pushRegister_type == TAG_POP_PLUST_PUSHREGISTER_TYPE_BARPOPUP) {
				strTemp = "bar,popup";
			}
			DataManager::setParamValue_string(TAG_APIACTION_PUSHREGISTER, "type", strTemp);
			// push groupId
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PUSHREGISTER_GROUP_ID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(TAG_APIACTION_PUSHREGISTER, "groupId", temp_tf->getString());

			log("### saveParamValue(Push_Register) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_UNREGISTER : {		// 푸시 해제
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PUSHUNREGISTER_PUSHID);
			DataManager::setParamValue_int(
					TAG_APIACTION_PUSHUNREGISTER, "pushId", atoi(temp_tf->getString().c_str()));
			log("### saveParamValue(Push_Unregister) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PUSH_DESCRIPTION : {		// 푸시 설정
			log("saveparam usepush : %d", ParameterListScene::ui_checkbox_pushDescription_usePush);
//			DataManager::setParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "usePush",
//					ParameterListScene::ui_checkbox_pushDescription_usePush);
//			DataManager::setParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "sound",
//					ParameterListScene::ui_checkbox_pushDescription_sound);
//			DataManager::setParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "vibrate",
//					ParameterListScene::ui_checkbox_pushDescription_vibrate);
//			DataManager::setParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "operationGCM",
//					ParameterListScene::ui_checkbox_pushDescription_operationGCM);
//			DataManager::setParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "operationLocal",
//					ParameterListScene::ui_checkbox_pushDescription_operationLocal);
//			DataManager::setParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "useNotice",
//					ParameterListScene::ui_checkbox_pushDescription_useNotice);
//			DataManager::setParamValue_bool(TAG_APIACTION_PUSHDESCRIPTION, "useNight",
//					ParameterListScene::ui_checkbox_pushDescription_useNight);
			// Description //
			int tempValue;
			if(ParameterListScene::popValue_pushDescription_usePush == TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_TRUE) {
				tempValue = 1;
			} else if(ParameterListScene::popValue_pushDescription_usePush == TAG_POP_PLIST_PUSHDESCRIPTION_USEPUSH_FALSE) {
				tempValue = 2;
			} else
				tempValue = 0;
			DataManager::setParamValue_int(TAG_APIACTION_PUSHDESCRIPTION, "usePush", tempValue);
			if(ParameterListScene::popValue_pushDescription_sound == TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_TRUE) {
				tempValue = 1;
			} else if(ParameterListScene::popValue_pushDescription_sound == TAG_POP_PLIST_PUSHDESCRIPTION_SOUND_FALSE) {
				tempValue = 2;
			} else
				tempValue = 0;
			DataManager::setParamValue_int(TAG_APIACTION_PUSHDESCRIPTION, "sound", tempValue);
			if(ParameterListScene::popValue_pushDescription_vib == TAG_POP_PLIST_PUSHDESCRIPTION_VIB_TRUE) {
				tempValue = 1;
			} else if(ParameterListScene::popValue_pushDescription_vib == TAG_POP_PLIST_PUSHDESCRIPTION_VIB_FALSE) {
				tempValue = 2;
			} else
				tempValue = 0;
			DataManager::setParamValue_int(TAG_APIACTION_PUSHDESCRIPTION, "vib", tempValue);
			if(ParameterListScene::popValue_pushDescription_operGcm == TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_TRUE) {
				tempValue = 1;
			} else if(ParameterListScene::popValue_pushDescription_operGcm == TAG_POP_PLIST_PUSHDESCRIPTION_OPERGCM_FALSE) {
				tempValue = 2;
			} else
				tempValue = 0;
			DataManager::setParamValue_int(TAG_APIACTION_PUSHDESCRIPTION, "operGcm", tempValue);
			//
			if(ParameterListScene::popValue_pushDescription_operLoc == TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_TRUE) {
				tempValue = 1;
			} else if(ParameterListScene::popValue_pushDescription_operLoc == TAG_POP_PLIST_PUSHDESCRIPTION_OPERLOC_FALSE) {
				tempValue = 2;
			} else
				tempValue = 0;
			DataManager::setParamValue_int(TAG_APIACTION_PUSHDESCRIPTION, "operLoc", tempValue);
			if(ParameterListScene::popValue_pushDescription_notice == TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_TRUE) {
				tempValue = 1;
			} else if(ParameterListScene::popValue_pushDescription_notice == TAG_POP_PLIST_PUSHDESCRIPTION_NOTICE_FALSE) {
				tempValue = 2;
			} else
				tempValue = 0;
			DataManager::setParamValue_int(TAG_APIACTION_PUSHDESCRIPTION, "notice", tempValue);
			if(ParameterListScene::popValue_pushDescription_night == TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_TRUE) {
				tempValue = 1;
			} else if(ParameterListScene::popValue_pushDescription_night == TAG_POP_PLIST_PUSHDESCRIPTION_NIGHT_FALSE) {
				tempValue = 2;
			} else
				tempValue = 0;
			DataManager::setParamValue_int(TAG_APIACTION_PUSHDESCRIPTION, "night", tempValue);
			log("### saveParamValue(Push_Description) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_HIVE : {			// sns_user
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSUSER_VID);
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			}

			/*
			// tokenize // 아직 사용할 필요가 없습니다.. json 데이터가 ','로 알아서 리스트로 분리!
			std::string delimiter = ",";
			std::vector<std::string> vids;
			size_t pos = 0;
			std::string token;
			while((pos = temp_tf->getString().find(delimiter)) != std::string::npos) {
				token = s.substr(0, pos);
				vids.push_back(token);
				s.erase(0, pos + delimiter.length());
			}
			*/

			DataManager::setParamValue_string(
					TAG_APIACTION_SNSUSER, "vid", temp_tf->getString());
			log("### saveParamValue(Sns_User) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_FACEBOOK : {
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSUSER_FACEBOOKID);
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			}

			DataManager::setParamValue_string(
					TAG_APIACTION_SNSUSER, "facebookId", temp_tf->getString());
			log("### saveParamValue(Sns_User) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_USER_DELETE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_HIVE : {			// sns_post
			// 보류된 기능 (하이브 포스팅)
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_FACEBOOK : {
			// HIVE SDK 1.12.1 부터 페이스북 포스팅시 메시지, 타이틀, 이미지url 파라미터 삭제
//			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSPOST_FB_MESSAGE);
//			DataManager::setParamValue_string(
//					TAG_APIACTION_SNSPOSTING, "message", temp_tf->getString());
//			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSPOST_FB_TITLE);
//			DataManager::setParamValue_string(
//					TAG_APIACTION_SNSPOSTING, "title", temp_tf->getString());
//			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSPOST_FB_IMAGE);
//			DataManager::setParamValue_string(
//					TAG_APIACTION_SNSPOSTING, "image", temp_tf->getString());
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSPOST_FB_APPLINKURL);
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSPOSTING, "appLinkURL", temp_tf->getString());
			log("### saveParamValue(Sns_Posting Facebook) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_SNS_POST_GOOGLEPLUS : {
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSPOST_GPLUS_MESSAGE);
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSPOSTING, "message", temp_tf->getString());
			log("### saveParamValue(Sns_Posting Google+) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICE : {		// promotion
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FOCRED_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FORCED_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_FULLBANNER_IMAGE_BANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_OFFERWALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_CUSTOMWEBVIEW : {
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOSHOW_CUSTOM_VIEWID);
			DataManager::setParamValue_int(
					TAG_APIACTION_PROMOTIONSHOW, "viewId",  atoi(temp_tf->getString().c_str()));
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_REVIEW : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTION_MOREGAMES : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICE : {		// promotion_info
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_BADGE_CUSTOMWEBVIEW : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOINFO_BADGE_CUSTOM_VIEWID);
			strTemp = temp_tf->getString();
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			} else {	// not blank
				DataManager::setParamValue_int(
						TAG_APIACTION_PROMOTIONINFO, "viewId", atoi(strTemp.c_str()));
			}
			log("### saveParamValue(PromotionInfo) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_FULLBANNER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_EVENT : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_NOTICEONLY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_VIEW_CUSTOMWEBVIEW : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOINFO_VIEW_CUSTOM_VIEWID);
			strTemp = temp_tf->getString();
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			} else {	// not blank
				DataManager::setParamValue_int(
						TAG_APIACTION_PROMOTIONINFO, "viewId", atoi(strTemp.c_str()));
			}
			log("### saveParamValue(PromotionInfo) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETOFFERWALLSTATE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_GAME : {		// invite_friends
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_OTHER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_ALL : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_RECEIVEDINVITE : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSFRIENDS_FBRECEIVED_LIMIT);
			strTemp = temp_tf->getString();
			// textfield blank test
			if(temp_tf->getString() == "") {
				log("### textfield is ===> blank ###");
			} else {	// not blank
				DataManager::setParamValue_int(
						TAG_APIACTION_SNSFRIENDS, "limit", atoi(strTemp.c_str()));
			}
			log("### saveParamValue(Sns_Friends) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_FACEBOOK_MESSAGE : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSMESSAGE_FBMESSAGE_MESSAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSMESSAGE, "message", strTemp);
			log("### saveParamValue(Sns_Message) success###");
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_MESSAGE : {
			DataManager::setParamValue_bool(TAG_APIACTION_SNSMESSAGE, "viduid",
					ParameterListScene::ui_checkbox_snsMessage_viduid);
			DataManager::setParamValue_bool(TAG_APIACTION_SNSMESSAGE, "usePush",
					ParameterListScene::ui_checkbox_snsMessage_usePush);
			DataManager::setParamValue_bool(TAG_APIACTION_SNSMESSAGE, "invite",
					ParameterListScene::ui_checkbox_snsMessage_invite);

			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_VID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSMESSAGE, "vid", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_MESSAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSMESSAGE, "message", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_IMAGEURL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSMESSAGE, "imageURL", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSMESSAGE_HIVEMESSAGE_THUMBNAILURL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSMESSAGE, "thumbnailURL", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_INVITEFRIENDS_HIVE_SESSION : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_PREPARE : {				// inapp

			DataManager::setParamValue_bool(TAG_APIACTION_PREPARE, "showLog",
					ParameterListScene::ui_checkbox_inappPrepare_showLog);
			DataManager::setParamValue_bool(TAG_APIACTION_PREPARE, "autoVerify",
					ParameterListScene::ui_checkbox_inappPrepare_autoVerify);

			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPP_LEBI_PREPARE_PIDLIST);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_PREPARE, "pidList", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPP_LEBI_PREPARE_INAPPID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_PREPARE, "inappId", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_LEBI_REQUESTBALANCE : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPP_LEBI_REQUEST_UID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_REQUESTBALANCE, "uid", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_PURCHASE : {
			/*
			DataManager::setParamValue_bool(TAG_APIACTION_INAPPPURCHASE, "Restore",
					ParameterListScene::ui_checkbox_inappPurchase_Restore);
			DataManager::setParamValue_bool(TAG_APIACTION_INAPPPURCHASE, "Finish",
					ParameterListScene::ui_checkbox_inappPurchase_Finish);
					*/

			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPP_PURCHASE_PID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPPURCHASE, "pid", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPP_PURCHASE_QUANTITY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_int(
					TAG_APIACTION_INAPPPURCHASE, "quantity", atoi(strTemp.c_str()) );
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPP_PURCHASE_ADDINFO);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPPURCHASE, "additionalInfo", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_RESTORE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_INAPP_PLATFORM_FINISH : {
			DataManager::setParamValue_bool(TAG_APIACTION_INAPPFINISH, "isPurchaseSuccess",
					ParameterListScene::ui_checkbox_inappFinish_isPurchaseSuccess);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEHOME : {			// Hive webview
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVEUSER : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_HIVECAFE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_EDITPROFILE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_FINDFRIENDS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_INQUIRY : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_CHATBOT : {			// HIVE 1.18.1
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SNSSHOW_CHATBOT_ADDITIONALINFO);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SNSSHOW, "additionalInfo", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_TERMS : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_MESSAGE : {
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_ADULTAUTH : {			// HIVE 1.10.0
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SOCIALSHOW_ADULTAUTH_GAMELANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SOCIALSHOW, "gameLanguage", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICE : {			// HIVE 1.10.0
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEWEBVIEW_GETNOTICEINFO : {		// HIVE 1.10.0
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_EVENT : {					// Tracker
			std::string strTemp;
			// event
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_TRACKER_SENDEVENT_EVENT);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SENDEVENT, "event", strTemp);
			/*
			// title
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_TRACKER_SENDEVENT_TITLE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SENDEVENT, "title", strTemp);
			// description
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_TRACKER_SENDEVENT_DESCRIPTION);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SENDEVENT, "description", strTemp);
			// currency
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_TRACKER_SENDEVENT_CURRENCY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SENDEVENT, "currency", strTemp);
			// price
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_TRACKER_SENDEVENT_PRICE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_SENDEVENT, "price", strTemp);
			// itemCount
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_TRACKER_SENDEVENT_ITEMCOUNT);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_int(
					TAG_APIACTION_SENDEVENT, "itemCount", atoi(strTemp.c_str()) );
					*/
			break;
		}
		case TAG_BTN_MODULE_LIST_TRACKER_SETENABLE : {
			DataManager::setParamValue_bool(TAG_APIACTION_SETENABLE, "MAT",
					ParameterListScene::ui_checkbox_trackerSetEnable_MAT);
			DataManager::setParamValue_bool(TAG_APIACTION_SETENABLE, "Adjust",
					ParameterListScene::ui_checkbox_trackerSetEnable_Adjust);
			DataManager::setParamValue_bool(TAG_APIACTION_SETENABLE, "Partytrack",
					ParameterListScene::ui_checkbox_trackerSetEnable_Partytrack);
			DataManager::setParamValue_bool(TAG_APIACTION_SETENABLE, "Singular",
					ParameterListScene::ui_checkbox_trackerSetEnable_Singular);
			DataManager::setParamValue_bool(TAG_APIACTION_SETENABLE, "AppsFlyer",
					ParameterListScene::ui_checkbox_trackerSetEnable_AppsFlyer);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_INFO : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INFO_ADDITIONALINFO);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "additionalInfo", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHARE : {    // add(HIVE 1.9.0)
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "message", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "linkShareURL", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_PROMOTIONACQUISITION_HIVELINKSHAREPLUSMESSAGE : {
			// checkbox
			DataManager::setParamValue_bool(TAG_APIACTION_USERACQUISITION, "vidoruid",
					ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_viduid);
			DataManager::setParamValue_bool(TAG_APIACTION_USERACQUISITION, "usePush",
					ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_usePush);
			DataManager::setParamValue_bool(TAG_APIACTION_USERACQUISITION, "invite",
					ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_invite);
			DataManager::setParamValue_bool(TAG_APIACTION_USERACQUISITION, "linkShare",
					ParameterListScene::ui_checkbox_promoAcquisition_hiveInviteLink_linkShare);
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_VID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "vid", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_MESSAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "message", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_IMAGEURL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "imageURL", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_THUMBNAILURL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "thumbnailURL", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOACQUISITION_INVITELINK_LINKSHAREURL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_USERACQUISITION, "linkShareURL", strTemp);
			break;
		}
		// HIVE IAP (HIVE 1.10.0)
		case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_ITEM : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_INFO_ITEM_LOCATIONCODE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_INFO, "locationCode", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_INFO_ITEM_WORLDNAME);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_INFO, "worldName", strTemp );
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_INFO_ITEM_GAMELANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_INFO, "gameLanguage", strTemp );
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_INFO_BADGE : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_INFO_BADGE_LOCATIONCODE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_INFO, "locationCode", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_INFO_BADGE_WORLDNAME);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_INFO, "worldName", strTemp );
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_INFO_BADGE_GAMELANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_INFO, "gameLanguage", strTemp );
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_GOOGLELEBISELECT : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_SHOW_GOOGLELEBISELECT_GAMELANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_SHOW, "gameLanguage", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEIAP_SHOW_LEBICHARGE : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_SHOW_LEBICHARGE_GAMELANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_SHOW, "gameLanguage", strTemp);
			break;
		}
		case TAG_BTN_MODULE_LIST_HIVEIAP_PURCHASE : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_PURCHASE_PID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_PURCHASE, "pid", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEIAP_PURCHASE_ADDITIONALINFO);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEIAP_PURCHASE, "additionalInfo", strTemp);
			break;
		}
		// Engagement (HIVE 1.10.0)
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_GETEVENTS : {
			break;
		}case TAG_BTN_MODULE_LIST_ENGAGEMENT_CONSUMECOUPON : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_COUPONID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON, "couponId", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_LANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON, "language", strTemp );
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_ENGAGEMENT_CONSUMECOUPON_ADDITIONALINFO);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_ENGAGEMENT_CONSUMECOUPON, "additionalInfo", strTemp );
			break;
		}
		case TAG_BTN_MODULE_LIST_ENGAGEMENT_SETREADY : {
			break;
		}
		// HIVE Promotion Show (HIVE 1.12.0)
		case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NEWS : {
			// checkbox
			DataManager::setParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced",
					ParameterListScene::ui_checkbox_hivePromotion_news_forced);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_FULLBANNER : {
			// checkbox
			DataManager::setParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced",
					ParameterListScene::ui_checkbox_hivePromotion_banner_forced);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_NOTICE : {
			// checkbox
			DataManager::setParamValue_bool(TAG_APIACTION_HIVEPROMOTION_SHOW, "forced",
					ParameterListScene::ui_checkbox_hivePromotion_notice_forced);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMVIEW : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_view", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_CUSTOMBOARD : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_board", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_SPOT : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_spot", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_DIRECT : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_direct", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_OFFERWALL : {
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_REVIEW : {
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTION_EXIT : {
			break;
		}
		// HIVE Promotion Info (HIVE 1.12.0)
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BADGEINFO : {
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_VIEWINFO : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMVIEW_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_view", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_BOARDINFO : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_CUSTOMBOARD_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_board", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SPOTINFO : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_SPOT_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_spot", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_DIRECTINFO : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTION_DIRECT_CONTENTKEY);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_SHOW, "contentKey_direct", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_SETADDITIONALINFO : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTIONINFO_ADDITIONALINFO);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_INFO, "addtionalInfo", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETGAMEINFO : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_SERVERID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INITIALIZE, "serverId", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_GAMELANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INITIALIZE, "gameLanguage", strTemp);
//			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_VID);
//			strTemp = temp_tf->getString();
//			DataManager::setParamValue_string(
//					TAG_APIACTION_INITIALIZE, "vid", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_SETGAMEINFO_SETGAMEINFO_CHANNEL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INITIALIZE, "channel", strTemp);
			// checkbox
			DataManager::setParamValue_bool(TAG_APIACTION_SETGAMEINFO_SETGAMEINFO, "emergencyMode",
											ParameterListScene::ui_checkbox_setGameInfo_emergencyMode);
			break;
		}case TAG_BTN_MODULE_LIST_SETGAMEINFO_SETCHANNEL : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *) this->getChildByTag(
					TAG_TF_PLIST_SETGAMEINFO_SETCHANNEL_CHANNEL);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INITIALIZE, "channel", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_SERVERID : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *) this->getChildByTag(
					TAG_TF_PLIST_SETGAMEINFO_UPDATE_SERVERID_SERVERID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INITIALIZE, "serverId", strTemp);
			break;
		}case TAG_BTN_MODULE_LIST_SETGAMEINFO_UPDATE_GAMELANGUAGE : {
			// textfield
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *) this->getChildByTag(
					TAG_TF_PLIST_SETGAMEINFO_UPDATE_GAMELANGUAGE_GAMELANGUAGE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INITIALIZE, "gameLanguage", strTemp);
			break;
        }case TAG_BTN_MODULE_LIST_SETGAMEINFO_SEND_DATA : {
            // funnelsId TextField 값 저장
            std::string strTemp;
            TextFieldTTF *temp_tf = (TextFieldTTF *) this->getChildByTag(TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_FUNNELS_ID);
            strTemp = temp_tf->getString();
            DataManager::setParamValue_string(TAG_APIACTION_SETGAMEINFO_SEND_DATA, "funnelsId", strTemp);

            // optionTag TextField 값 저장
            temp_tf = (TextFieldTTF *) this->getChildByTag(TAG_TF_PLIST_SETGAMEINFO_SEND_DATA_OPTION_TAG);
            strTemp = temp_tf->getString();
            DataManager::setParamValue_string(TAG_APIACTION_SETGAMEINFO_SEND_DATA, "optionTag", strTemp);
            break;
        }
		case TAG_BTN_MODULE_LIST_PROMOTIONINFO_GETBANNERINFO : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOTIONINFO_CAMPAIGN_TYPE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_PROMOTION_GETBANNERINFO, "campaignType", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_PROMOTIONINFO_BANNER_TYPE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_PROMOTION_GETBANNERINFO, "bannerType", strTemp);
			break;
		} 
		case TAG_BTN_MODULE_LIST_HIVEPROMOTIONINFO_GETBANNERINFO : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTIONINFO_CAMPAIGN_TYPE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO, "campaignType", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_HIVEPROMOTIONINFO_BANNER_TYPE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_HIVEPROMOTION_GETBANNERINFO, "bannerType", strTemp);
			break;
		}
		// InApp V4
		case TAG_TYPE_MODULE_LIST_INAPPV4_ITEMINFO : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPPV4_ITEMINFO_TYPE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPV4_ITEMINFO, "type", strTemp);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_PURCHASE : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPPV4_PURCHASE_TYPE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPV4_PURCHASE, "type", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPPV4_PURCHASE_PID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPV4_PURCHASE, "pid", strTemp);
			temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPPV4_PURCHASE_IAPPAYLOAD);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPV4_PURCHASE, "iapPayload", strTemp);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_RESTORE : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPPV4_RESTORE_TYPE);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPV4_RESTORE, "type", strTemp);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_TRANSACTION_FINISH : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPPV4_TRANSACTION_FINISH_PID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPV4_TRANSACTION_FINISH, "pid", strTemp);
			break;
		}
		case TAG_TYPE_MODULE_LIST_INAPPV4_SHOW_INAPP_MESSAGES : {
			std::string strTemp;
			TextFieldTTF *temp_tf = (TextFieldTTF *)this->getChildByTag(TAG_TF_PLIST_INAPPV4_SHOW_INAPP_MESSAGES_CATEGORY_ID);
			strTemp = temp_tf->getString();
			DataManager::setParamValue_string(
					TAG_APIACTION_INAPPV4_SHOW_INAPP_MESSAGES, "categoryId", strTemp);
			break;
		}
		default : {
			log("### ParameterListScene::saveParamValue(int tag) error ###");
			break;
		}
	}

	//showDialogMsg("설정 저장 완료!");
}

void ParameterListScene::onKeyReleased( cocos2d::EventKeyboard::KeyCode keycode, cocos2d::Event *event )
{
    if (keycode == EventKeyboard::KeyCode::KEY_ESCAPE) {
    	/*
    	log("### back button ###");
        if(ParameterListScene::isFocusedTextField == true) {
        	ParameterListScene::isFocusedTextField = false;
        	ParameterListScene::ui_isOpenedWindow = false;
        	log("### onKeyReleased : isFocused(%d), isOpenedWindow(%d)",
        			ParameterListScene::isFocusedTextField, ParameterListScene::ui_isOpenedWindow);
        }
        */
    }
}

// ********** Touch Event (TextField) ********** ********** ********** **********
bool ParameterListScene::onTextFieldAttachWithIME(TextFieldTTF *sender) {
	//log("### onTextFieldAttachWithIME  ###");
	//ParameterListScene::ui_isOpenedWindow = true;
	//ParameterListScene::isFocusedTextField = true;
	return TextFieldDelegate::onTextFieldAttachWithIME(sender);
}

bool ParameterListScene::onTextFieldDetachWithIME(TextFieldTTF *sender) {
	//log("### onTextFieldDetachWithIME  ###");
	//ParameterListScene::ui_isOpenedWindow = false;
	return TextFieldDelegate::onTextFieldDetachWithIME(sender);
}

bool ParameterListScene::onTextFieldInsertText(TextFieldTTF *sender,
		const char *text, size_t nLen) {
	return TextFieldDelegate::onTextFieldInsertText(sender, text, nLen);
}

bool ParameterListScene::onTextFieldDeleteBackward(
		TextFieldTTF *sender, const char *delText, size_t nLen) {
	return TextFieldDelegate::onTextFieldDeleteBackward(sender, delText, nLen);
}
// ********** ********** ********** ********** ********** ********** ********** ********** **********
